Package: seqinr
Title: Biological Sequences Retrieval and Analysis
Version: 4.2-44
Depends: R (>= 2.10.0)
Imports: ade4,segmented
Authors@R: c(person("Delphine", "Charif", role = "aut"),
             person("Olivier", "Clerc", role = "ctb"),
             person("Carolin", "Frank", role = "ctb"),
             person(c("Jean", "R."), "Lobry", role = c("aut", "cph")),
             person("Anamaria", "Necşulea", role = "ctb"),
             person("Leonor", "Palmeira", role = "ctb"),
             person("Simon", "Penel", role = "cre", email = "simon.penel@univ-lyon1.fr"),
             person("Guy", "Perrière", role = "ctb"))
Maintainer: Simon Penel <simon.penel@univ-lyon1.fr>
License: GPL (>= 2)
Description: Exploratory data analysis and data visualization
  for biological sequence (DNA and protein) data. Seqinr includes
  utilities for sequence data management under the ACNUC system
  described in Gouy, M. et al. (1984) Nucleic Acids Res.
  12:121-127 <doi:10.1093/nar/12.1Part1.121>.
URL: https://github.com/lbbe-software/seqinr
BugReports: https://github.com/lbbe-software/seqinr/issues
SystemRequirements: zlib headers and library.
NeedsCompilation: yes
Encoding: UTF-8
Packaged: 2026-04-28 07:45:02 UTC; simon
Author: Delphine Charif [aut],
  Olivier Clerc [ctb],
  Carolin Frank [ctb],
  Jean R. Lobry [aut, cph],
  Anamaria Necşulea [ctb],
  Leonor Palmeira [ctb],
  Simon Penel [cre],
  Guy Perrière [ctb]
Repository: CRAN
Date/Publication: 2026-04-28 08:30:02 UTC

# Export all names
useDynLib(seqinr, .registration = TRUE,.fixes = "C_")
exportPattern("^[^C_]")
importFrom("ade4", "dudi.coa")
importFrom("grDevices", "col2rgb", "grey", "rainbow", "rgb")
importFrom("graphics", "abline", "axis", "box", "dotchart", "hist",
             "image", "legend", "lines", "mtext", "par", "plot",
             "plot.new", "plot.window", "points", "polygon", "rect",
             "segments", "text", "title")
importFrom("stats", "as.dist", "complete.cases", "cor", "density",
             "dnorm", "integrate", "kruskal.test", "lm", "nlm",
             "optimize", "runif", "splinefun", "t.test")
importFrom("utils", "data", "download.file", "packageDescription",
             "read.table", "str", "tail")
S3method(as.matrix, alignment)
S3method(getAnnot, SeqAcnucWeb)
S3method(getAnnot, SeqFastaAA)
S3method(getAnnot, SeqFastadna)
S3method(getAnnot, default)
S3method(getAnnot, list)
S3method(getAnnot, logical)
S3method(getAnnot, qaw)
S3method(getFrag, SeqAcnucWeb)
S3method(getFrag, SeqFastaAA)
S3method(getFrag, SeqFastadna)
S3method(getFrag, SeqFrag)
S3method(getFrag, character)
S3method(getFrag, default)
S3method(getFrag, list)
S3method(getFrag, logical)
S3method(getFrag, qaw)
S3method(getKeyword, SeqAcnucWeb)
S3method(getKeyword, default)
S3method(getKeyword, list)
S3method(getKeyword, logical)
S3method(getKeyword, qaw)
S3method(getLength, SeqAcnucWeb)
S3method(getLength, SeqFastaAA)
S3method(getLength, SeqFastadna)
S3method(getLength, SeqFrag)
S3method(getLength, character)
S3method(getLength, default)
S3method(getLength, list)
S3method(getLength, logical)
S3method(getLength, qaw)
S3method(getLocation, SeqAcnucWeb)
S3method(getLocation, default)
S3method(getLocation, list)
S3method(getLocation, logical)
S3method(getLocation, qaw)
S3method(getName, SeqAcnucWeb)
S3method(getName, SeqFastaAA)
S3method(getName, SeqFastadna)
S3method(getName, SeqFrag)
S3method(getName, default)
S3method(getName, list)
S3method(getName, logical)
S3method(getName, qaw)
S3method(getSequence, SeqAcnucWeb)
S3method(getSequence, SeqFastaAA)
S3method(getSequence, SeqFastadna)
S3method(getSequence, SeqFrag)
S3method(getSequence, character)
S3method(getSequence, default)
S3method(getSequence, list)
S3method(getSequence, logical)
S3method(getSequence, qaw)
S3method(getTrans, SeqAcnucWeb)
S3method(getTrans, SeqFastadna)
S3method(getTrans, SeqFrag)
S3method(getTrans, character)
S3method(getTrans, default)
S3method(getTrans, list)
S3method(getTrans, logical)
S3method(getTrans, qaw)
S3method(plot, SeqAcnucWeb)
S3method(print, SeqAcnucWeb)
S3method(print, qaw)
S3method(summary, SeqFastaAA)
S3method(summary, SeqFastadna)

###################################################################################################
#                                                                                                 #
#                                       alllistranks                                              #
#                                                                                                 #
# ==>   alllistranks                                                                              #
# <==  count=xx&n1,n2,...                                                                         #
# Returns the count of existing lists and all their ranks separated by commas.                    #
#                                                                                                 #
###################################################################################################

alllistranks <- function(socket = autosocket(), verbose = FALSE) {
    #
    # Make empty result
    #
    result <- list(count = NA, ranks = NA)
    #
    # Check arguments:
    #
    if(verbose) cat("I'm checking the arguments...\n")
    
    if( !inherits(socket, "sockconn") ) stop(paste("argument socket = ", socket, "is not a socket connection."))
    if(verbose) cat("... and everything is OK up to now.\n")
    
    #
    # Send request to server:
    #
    if(verbose) cat("I'm sending query to server...\n")
    request <- "alllistranks"
    writeLines(request, socket, sep = "\n")
    res <- readLines(socket, n = 1)
    #
    # Check for non empty answer from server:
    #
    if(verbose) cat(paste("... answer from server is:", res, "\n"))
    if(length(res) == 0){
        if(verbose) cat("... answer from server is empty!\n")
        while(length(res) == 0){
            if(verbose) cat("... reading again.\n")
            res <- readLines(socket, n = 1)
        }
    }
    #
    # Analysing answer from server:
    #
    if(verbose) cat("I'm trying to analyse answer from server...\n")
    if(res == "code=1"){
        stop("Server returns an error (code=1)")
    }
    if(res == "count=0"){
        if(verbose) cat("Note: there are no list on server (count=0)\n")
        result$count <- 0
    } else {
        #remove "count=" from res
        res <- substr(x = res, start = 7, stop = nchar(res))
        result$count <- as.numeric(unlist(strsplit(res, split = "&"))[1])
        result$ranks <- as.numeric(unlist(strsplit(unlist(strsplit(res, split = "&"))[2], split = ",")))
    }
    return(result)
}

alr <- alllistranks

readBins <- function(file, 
                     colnames = c("allele.name", "size.bp", "minus.bp", "plus.bp")){
    src <- readLines(file)
    iPanel <- which(substr(src, start = 1, stop = 11) == "Panel Name\t")
    mycon <- textConnection(src[1:3])
    infos <- utils::read.table(mycon, sep = "\t", fill = TRUE, header = FALSE)
    close(mycon)
    result <- list(infos = infos)
    
    starts <- iPanel + 1
    stops  <- c(iPanel[-1] - 1, length(src))
    for(i in seq_len(length(iPanel))){
        locsrc <- src[starts[i]:stops[i]]
        iMark <- which(substr(locsrc, start = 1, stop = 12) == "Marker Name\t")
        locres <- vector(mode = "list", length = length(iMark))
        locstarts <- iMark + 1
        locstops <- c(iMark[-1] - 1, length(locsrc))
        for(j in seq_len(length(iMark))){
            mycon <- textConnection(locsrc[locstarts[j]:locstops[j]])
            locres[[j]] <- utils::read.table(mycon, sep = "", fill = TRUE) # changed
            colnames(locres[[j]])[1:length(colnames)] <- colnames
            close(mycon)
            names(locres)[j] <- unlist(strsplit(locsrc[iMark[j]], split = "\t"))[2]
        }
        #
        # Check that the number of columns is 4 for all loci:
        #
        ncols <- sapply(locres, ncol)
        if(any((ncols != 4))){
            warning("A problem may have occur during importation")
        }
        result[[i+1]] <- locres
        names(result)[i+1] <- unlist(strsplit(src[iPanel[i]], split = "\t"))[2]
    }
    return(result)
}

#
# To get sequence names
#

getName <-  function(object, ...)  UseMethod("getName")

getName.default <- function(object, ...)
    stop(paste("no getName method for objects of class:", class(object)))

getName.list <- function(object, ...)
    sapply(seq_len(length(object)), function(i) getName(object[[i]], ...))

getName.SeqFastadna <- function(object, ...) attr(object,"name")
getName.SeqFastaAA <- getName.SeqFastadna

getName.SeqAcnucWeb <- function(object, ...) as.character(object)

getName.qaw <- function(object, ...) getName(object$req, ...)

getName.logical <- function (object, ...) object # so that NA is returned for virtual lists

getName.SeqFrag <- function(object, ...) attr(object, "seqMother")

cai <- function(seq, w, numcode = 1, zero.threshold = 0.0001, zero.to = 0.01){
    stops <- which("Stp" == aaa(translate(s2c(c2s(words())), numcode = numcode)))
    singulets <- which(sapply(syncodons(words(), numcode = numcode), length) == 1)
    exclude <- c(stops, singulets)
    w <- w[-exclude]
    w[w < zero.threshold] <- zero.to # if value is effectively zero make it 0.01
    nncod <- uco(seq)
    nncod <- nncod[-exclude]
    sigma <- nncod %*% log(w)
    exp(sigma/sum(nncod))
}

peakabif <- function(abifdata, 
                     chanel, 
                     npeak, 
                     thres = 400/yscale, 
                     fig = TRUE,
                     chanel.names = c(1:4,105),
                     DATA = paste("DATA", chanel.names[chanel], sep = "."),
                     tmin = 1/tscale,
                     tmax = abifdata$Data[["SCAN.1"]]/tscale,
                     tscale = 1000, 
                     yscale = 1000,
                     irange = (tmin*tscale):(tmax*tscale),
                     y = abifdata$Data[[DATA]][irange]/yscale,
                     method = "monoH.FC",
                     maxrfu = 1000, ...) {
    
    y[y < thres] <- 0
    heights <- surfaces <- maxis <- starts <- stops <- numeric(npeak)
    
    innoise <- TRUE
    pkidx <- 1
    for (i in 1:length(y)) {
        if (y[i] > 0) {
            if (innoise) {
                starts[pkidx] <- i
                innoise <- FALSE
            }
        } else {
            if (!innoise) {
                stops[pkidx] <- i - 1
                innoise <- TRUE
                pkidx <- pkidx + 1
            }
        }
    }
    
    if (fig) graphics::par(mfrow = c(4, 4), mar = c(2, 2, 0, 0) + 0.2, oma = c(0,0,2,0))
    
    for (i in 1:npeak) {
        x <- starts[i]:stops[i]
        if(length(x) <= 2){
            maxis[i] <- NA
            warning("Not all requested peaks were assigned")
            next
        }
        spfun <- stats::splinefun(x, y[x], method = method)
        maxis[i] <- stats::optimize(spfun, interval = range(x), maximum = TRUE)$maximum
        heights[i] <- spfun(maxis[i])
        surfaces[i] <- stats::integrate(spfun, starts[i], stops[i])$value
        if (fig) {
            xx <- (x-1)/tscale + tmin
            graphics::plot(xx, y[x], type = "p", las = 1, ylim = range(y), ...)
            graphics::abline(h = thres, col = "red")
            graphics::lines(xx, spfun(x), col = "blue")
            graphics::abline(v = (maxis[i]-1)/tscale + tmin, col = "grey")
        }
    }
    #
    # Compute baseline:
    #
    baseline <- baselineabif(abifdata$Data[[DATA]][irange], maxrfu = maxrfu)
    baseline <- baseline/yscale
    
    if(fig) graphics::mtext(paste(deparse(substitute(abifdata)), ",",
                        DATA, ", tmin =", tmin, ", tmax =", tmax, ", thres =", thres, ", npeak =", npeak, ", yscale = ", yscale), side = 3, outer = TRUE)
    
    invisible(list(maxis = (maxis-1) + tmin*tscale, heights = yscale*heights, surfaces = yscale*surfaces, baseline = baseline))
}

readPanels <- function(file,
                       colnames = c("marker", "dye.col", "min.bp", "max.bp", "exp.pcg", "repeat.bp",
                                    "stutter.pc", "uknw", "allele names")){
    src <- readLines(file)
    iPanel <- which(substr(src, start = 1, stop = 6) == "Panel\t")
    
    infos <- src[1:(iPanel[1] - 1)]
    result <- list(infos = infos)
    
    starts <- iPanel + 1
    stops  <- c(iPanel[-1] - 1, length(src))
    
    for(i in seq_len(length(iPanel))){
        toimport <- src[starts[i]:stops[i]]
        # Change all runs of tabulations by a single one:
        toimport <- gsub("\t{2,}", "\t", toimport)
        mycon <- textConnection(toimport)
        result[[i+1]] <- utils::read.table(mycon, sep = "\t", quote = "")
        close(mycon)
        # remove empty columns
        # (I guess this is no more necessary now that runs of
        # tabulation are preprocessed)
        tokeep <- rep(TRUE, ncol(result[[i+1]]))
        for(j in 1:ncol(result[[i+1]])){
            if(all(is.na(result[[i+1]][,j]))){
                tokeep[j] <- FALSE
            }
        }
        result[[i+1]] <- result[[i+1]][, tokeep]
        # There must be 9 columns
        if(ncol(result[[i+1]]) != 9) stop("wrong column number")
        colnames(result[[i+1]]) <- colnames
        
        headeritems <- unlist(strsplit(src[iPanel[i]], split = "\t"))
        # remove empty elements
        if(any(nchar(headeritems) == 0)){
            headeritems <- headeritems[-which(nchar(headeritems) == 0)]
        }
        names(result)[i+1] <- headeritems[2]
    }
    return(result)
}

# ==>  prep_getannots&nl=xx
# key_name{|subkey_name} \n       nl such lines sent to server
# ....     \n
# <== code=0 \n
# This command must be used before using the getannots or the modifylist&type=scan commands to specify 
# what sorts of annotation records will be returned by the getannots command or will be scanned.
# nl: announces the number of key names that follow.
# key_name: an annotation key name. 
# subkey_name: optionally, an annotation sub-item name (e.g., CDS when key_name = FT)
# For the EMBL/SWISSPROT format, keys are: ALL, AC, DT, KW, OS, OC, OG, OH, 
# RN, RC, RP, RX, RA, RG, RT, RL, DR, AH, AS, CC, FH, FT, SQ, SEQ.
# For GenBank: ALL, ACCESSION, VERSION, KEYWORDS, SOURCE, ORGANISM, REFERENCE, AUTHORS, CONSRTM, 
# TITLE, JOURNAL, PUBMED, REMARK, COMMENT, FEATURES, ORIGIN, SEQUENCE. Names of annotation subitems 
# (e.g.,  JOURNAL) must be entered with their 2 leading space characters.
# For FT(embl,swissprot) and FEATURES(GenBank), one or more specific feature keys can be specified
# using lines with only uppercase and such as
# FEATURES|CDS
# FT|TRNA
# Keys ALL and SEQ/SEQUENCE stand for all annotation and sequence lines, respectively.
# For the scan operation, key ALL stand for the DE/DEFINITION lines, 
# and SEQ/SEQUENCE cannot be used (annotations but not sequence are scanned).


prepgetannots <- function(what = "all",
                          setfor = c("scan", "getannots"),
                          socket = autosocket(), verbose = FALSE){
    #
    # Default is to set for scan :
    #
    setfor <- setfor[1]
    if(!(setfor %in% c("scan", "getannots"))) stop("Wrong setfor argument")
    if(verbose) cat(paste("setfor is", setfor, "\n"))
    #
    # Get annotation lines names for current database:
    #
    annotlines <- cfl(socket = socket)$annotlines
    if(verbose) cat("annotlines:\n", annotlines, "\n")
    annotlines <- toupper(annotlines)
    #
    # Building the list of annotation lines:
    #
    if(what == "all"){
        if(verbose) cat("what == all, turning all to true\n")
        if(setfor == "scan"){
            # For scan all but the first ("ALL") and the last ("SEQ*")
            todo <- annotlines[2:(length(annotlines) - 1)]
        } else {
            # For getannots all but the first ("ALL")
            todo <- annotlines[2:(length(annotlines))]
        }  
    } else { 
        if(verbose) cat("what != all, user supplied list of annotation lines\n")
        todo <- toupper(what)
    }  	  	
    #
    # Sending request to server:
    #  
    if(verbose) cat("todo:\n", todo, "\n")
    request <- paste(paste("prep_getannots&nl=", length(todo), "\n", sep = ""),
                     paste(todo, collapse = "\n"), sep = "")
    if(verbose) cat("Sending:\n", request)
    writeLines(request, socket)
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    if(verbose) cat("... answer from server is:", answerFromServer, "\n")
    resitem <- parser.socket(answerFromServer)
    if(resitem[1] != "0"){
        stop(paste("error code returned by server :", resitem[1]))
    }
    if(verbose) cat("... everything is OK up to now\n")
    invisible(todo)
}

pga <- prepgetannots

dotPlot <- function(seq1, seq2, wsize = 1, wstep = 1, nmatch = 1, shift = 0, col = c("white", "black"), 
                    xlab = deparse(substitute(seq1)), ylab = deparse(substitute(seq2)), ...){
    #
    # Check arguments:
    #
    if(nchar(seq1[1]) > 1) stop("seq1 should be provided as a vector of single chars")
    if(nchar(seq2[1]) > 1) stop("seq2 should be provided as a vector of single chars")
    if(wsize < 1) stop("non allowed value for wsize")
    if(wstep < 1) stop("non allowed value for wstep")
    if(nmatch < 1) stop("non allowed value for nmatch")
    if(nmatch > wsize) stop("nmatch > wsize is not allowed")
    if(shift >= wsize ) stop("shift >= wsize is not allowed")
    
    #
    # sliding window on sequences:
    #
    mkwin <- function(seq, start,wsize, wstep){
        sapply(seq(from = start, to = length(seq) - wsize + 1, by = wstep), function(i) c2s(seq[i:(i + wsize - 1)]))
    }
    wseq1 <- mkwin(seq1,1, wsize, wstep)
    wseq2 <- mkwin(seq2,1 + shift, wsize, wstep)
    if( nmatch == wsize ){
        # perfect match case
        xy <- outer(wseq1, wseq2, "==")
    } else {
        # partial match case
        "%==%" <- function(x, y) colSums(sapply(x, s2c) == sapply(y, s2c)) >= nmatch
        xy <- outer(wseq1, wseq2, "%==%")
    }
    graphics::image(x = seq(from = 1, to = length(seq1), length = length(wseq1)), 
          y = seq(from = 1, to = length(seq2), length = length(wseq2)),
          z = xy, col = col, xlab = xlab, ylab = ylab, ...)
    graphics::box()
}

syncodons <- function(codons, numcode = 1) 
{
    #
    # Check argument:
    #
    if( any(nchar(codons) != 3)) stop("vector of three character string elements expected")
    
    #
    # Force to lower case:
    #
    alph <- unlist(lapply(codons, s2c))
    if(any(alph %in% LETTERS)) codons <- tolower(codons)
    
    #
    # Get the genetic code map:
    #
    allaminos <- sapply(words(), function(x) translate(s2c(x), numcode = numcode))
    
    getsyn <- function(c) names(allaminos[allaminos == allaminos[[c]]])
    synonymous <- lapply(codons, getsyn)
    names(synonymous) <- codons
    return(synonymous)
}

synsequence <- function (sequence, numcode = 1, ucoweight = NULL) 
{
    tra = translate(sequence, numcode = numcode)
    cod = splitseq(sequence)
    if (is.null(ucoweight)) {
        for (a in unique(tra)) {
            pos = which(tra == a)
            if (length(pos) > 1) {
                newcod = sample(cod[pos])
                cod[pos] = newcod
            }
        }
    }
    else {
        for (a in unique(tra)) {
            pos = which(tra == a)
            urne = rep(names(ucoweight[[a]]), ucoweight[[a]] * 
                           length(pos))
            if (length(urne) > 1) {
                newcod = sample(urne, length(pos))
            }
            else if (length(urne) == 1) {
                newcod = urne
            }
            else {
                print(a)
                stop("bad codon usage content")
            }
            cod[pos] = newcod
        }
    }
    newseq = s2c(c2s(cod))
    return(newseq)
}

ucoweight <- function (sequence, numcode = 1) 
{
    allaminos = s2c(c2s(SEQINR.UTIL$CODES.NCBI$CODES[numcode]))
    allcodons = splitseq(as.vector(t(cbind(rep(s2c("tcag"), each = 16), 
                                           rep(s2c("tcag"), each = 4), rep(s2c("tcag"), 4)))))
    syncodons = lapply(seq(21), function(a) {
        which(allaminos == unique(allaminos)[a])
    })
    usage = uco(sequence)[allcodons] #re-order according to NCBI
    weight = lapply(seq(21), function(b) {
        usage[syncodons[b][[1]]]
    })
    names(weight) = unique(allaminos)
    return(weight)
}

###################################################################################################
#                                                                                                 #
#                                       readsmj                                                   #
#                                                                                                 #
#                                                                                                 #
# ==>   readsmj&num=xx&nl=xx                                                                      #
# <==  code=xx&nl=xx                                                                              #
#     recnum=xx&name="xx"&plong=xx{&libel="xx"}                                                   #
#     ... a series of nl lines like that ...                                                      #
# Returns data from nl consecutive records starting from rank num of file SMJYT including label   #
# if not empty.                                                                                   #
# Code != 0 indicates error.                                                                      #
#                                                                                                 #
###################################################################################################

readsmj <- function(socket = autosocket(), num = 2, nl = 10, recnum.add = FALSE, nature.add = TRUE,
                    plong.add = FALSE, libel.add = FALSE, sname.add = FALSE, all.add = FALSE)
{ 
    #
    # Turn all flags to TRUE when requested:
    #
    if(all.add) sname.add <- libel.add <- plong.add <- nature.add <- recnum.add <- TRUE
    
    
    #
    # Build the request:
    #
    request <- paste("readsmj&num=", num, "&nl=", nl, sep = "", collapse = "")
    
    #
    # Send request:
    #
    
    writeLines(request, socket, sep = "\n") 
    #
    # Read answer from server:
    #
    s <- readLines(socket, n = 1)
    rep <- parser.socket(s)
    
    #
    # check answer from server:
    #
    if(rep[1] != "0") stop("Error from server")
    
    #
    # read answer from server:
    #
    n <- as.numeric(rep[2])
    ans <- readLines(socket, n = n)
    
    #
    # Put answer into a data.frame:
    #
    name <- character(n) # the only mandatory one
    if(recnum.add) recnum <- numeric(n)
    if(nature.add) nature <- factor(character(n), levels = c("00","01","02","03","04","05","06","07"))
    if(plong.add) plong <- numeric(n)
    if(libel.add) libel <- character(n)
    if(sname.add) sname <- character(n)
    for(i in seq_len(n)){
        tmp <- parser.socket(ans[[i]])
        name[i] <- substr(tmp[2], 2, nchar(tmp[2]) - 1)
        if(name[i] == "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"){
            name[i] <- NA
            next
        }
        if(sname.add) sname[i] <- substr(name[i], 3, nchar(name[i]))
        if(recnum.add) recnum[i] <- tmp[1]
        if(nature.add) nature[i] <- substr(name[i], 1, 2)
        if(plong.add) plong[i] <- tmp[3]
        if(libel.add){
            if(length(tmp) == 4){
                libel[i] <- substr(tmp[4], 2, nchar(tmp[4]) - 1)
            } else {
                libel[i] <- NA
            }
        }
    }
    df <- data.frame(list(name = I(name)))
    if(sname.add)  df$sname <- sname
    if(recnum.add) df$recnum <- recnum
    if(nature.add){
        levels(nature) <- c("status", "molecule", "journal", "year", "type", "organelle", "division", "dbstrucinfo")
        df$nature <- nature
    }
    if(plong.add) df$plong <- plong
    if(libel.add) df$libel <- libel
    
    return(df)
}

translate <- function(seq, frame = 0, sens = "F", numcode = 1, NAstring = "X",
                      ambiguous = FALSE, force.first.aa.to.Met = FALSE)
{
    
    if(any(seq%in%LETTERS)){
        seq <- tolower(seq)
    }
    #
    # Take the reverse complementary strand when required:
    #
    
    if(sens == "R") seq <- comp(rev(seq), ambiguous = ambiguous)
    
    #
    # Transform the sequence in its numerical encoding equivalent
    # with textbook order, that is t = 0, c = 1, a = 2, g = 3
    #
    
    seqn <- s2n(seq, levels = s2c("tcag"))
    
    #
    # Compute the length of the sequence when its length in codons
    # is an integer:
    #
    
    l <- 3*((length(seq) - frame) %/% 3)
    
    #
    # Compute the indices for the first codon positions:
    #
    
    c1 <- seq(from = frame + 1, to = frame + l, by = 3)
    
    #
    # Compute the indices of codons in the translation table:
    #
    
    tra <-  16*seqn[c1] + 4*seqn[c1 + 1] + seqn[c1 + 2] + 1
    
    #
    # Get the translation table:
    #
    
    code <- s2c(SEQINR.UTIL$CODES.NCBI$CODES[numcode])
    
    #
    # Translate the sequence:
    #
    
    result <- code[tra]
    
    #
    # Replace missing values by the string for missing amino-acids:
    #
    
    result[is.na(result)] <- NAstring
    
    #
    # More work is required if ambiguous bases are handled:
    #
    
    if(ambiguous){
        toCheck <- which(result == NAstring)
        for( i in toCheck ){
            codon <- seq[c1[i]:(c1[i]+2)]
            allcodons <- as.vector(outer(as.vector(outer(amb(codon[1]), amb(codon[2]), paste, sep = "")), amb(codon[3]), paste, sep = ""))
            allaminoacids <- sapply(allcodons, function(x) translate(s2c(x), numcode = numcode, ambiguous = FALSE))
            if( all(allaminoacids == allaminoacids[1])) result[i] <- allaminoacids[1]
        }
    }
    if (force.first.aa.to.Met) {
        result[1] <- "M"
    }
    return( result )
}

###################################################################################################
#                                                                                                 #
#                                       getlistrank                                               #
#                                                                                                 #
# ==>   getlistrank&name="xx"                                                                     #
# <==  lrank=xx                                                                                   #
# Returns the rank of list, or 0 if no list with name exists.                                     #
#                                                                                                 #
###################################################################################################

getlistrank <- function(listname, socket = autosocket(), verbose = FALSE) {
    
    #
    # Check arguments:
    #
    if(verbose) cat("I'm checking the arguments...\n")
    
    if( !inherits(socket, "sockconn") ) stop(paste("argument socket = ", socket, "is not a socket connection."))
    if(verbose) cat("... and everything is OK up to now.\n")
    
    #
    # Send request to server:
    #
    if(verbose) cat("I'm sending query to server...\n")
    request <- paste("getlistrank&name=\"", listname, "\"", sep = "")
    writeLines(request, socket, sep = "\n")
    res <- readLines(socket, n = 1)
    #
    # Check for non empty answer from server:
    #
    if(verbose) cat(paste("... answer from server is:", res, "\n"))
    if(length(res) == 0){
        if(verbose) cat("... answer from server is empty!\n")
        while(length(res) == 0){
            if(verbose) cat("... reading again.\n")
            res <- readLines(socket, n = 1)
        }
    }
    #
    # Analysing answer from server:
    #
    if(verbose) cat("I'm trying to analyse answer from server...\n")
    result <- as.numeric( unlist(strsplit(res, split = "="))[2] )
    return(result)
}

glr <- getlistrank

########################
# char to string
########################

c2s <- function( chars = c("m","e","r","g","e","d") )
{
    return( paste( chars, collapse = "" ) )
}

###########################
# string to char
############################

s2c <- function (string) 
{
    if(is.character(string) && length(string) == 1){
        return(.Call("s2c", string, PACKAGE = "seqinr"))
    } else {
        warning("Wrong argument type in s2c(), NA returned")
        return(NA)
    }
}



###########################
# Conversion of the numeric encoding of a DNA sequence into
# a vector of chars
############################

n2s <- function(nseq, levels = c("a", "c", "g", "t"), base4 = TRUE)
{
    if( base4 )
        levels[nseq + 1]
    else
        levels[nseq]
}



##########################################
# Convert one-letter code to 3-letters code for amino-acids
##########################################

aaa <- function( aa )
{
    aa3 <- c("Stp", "Ala", "Cys", "Asp", "Glu", "Phe", "Gly", "His", "Ile",
             "Lys", "Leu", "Met", "Asn", "Pro", "Gln", "Arg", "Ser", "Thr",
             "Val", "Trp", "Tyr") # One letter code order
    if(missing(aa)) return(aa3)
    aa1 <- a()
    
    convert <- function( x )
    {
        if( all( x != aa1 ) )
        { 
            warning("Unknown one letter code for aminoacid")
            return( NA )
        }
        else
        {
            return( aa3[which( x == aa1 )] )
        }
    }
    return( as.vector(unlist(sapply( aa, convert ) ) ) )
}

##########################################
# Conversion 3-letters code to one letter code for amino-acids
##########################################

a <- function( aa )
{
    aa1 <- s2c("*ACDEFGHIKLMNPQRSTVWY")
    if(missing(aa)) return(aa1)
    aa3 <- aaa()
    
    convert <- function( x )
    {
        if( all( x != aa3 ) )
        { 
            warning("Unknown 3-letters code for aminoacid")
            return( NA )
        }
        else
        {
            return( aa1[which( x == aa3 )] )
        }
    }
    return( as.vector(unlist(sapply( aa, convert ) ) ) )
}

crelistfromclientdata <- function(listname, file, type, socket = autosocket(), invisible = TRUE, verbose = FALSE, 
                                  virtual = FALSE) {
    #
    # Check arguments:
    #
    if(verbose) cat("I'm checking the arguments...\n")
    
    if(!file.exists(file)) stop(paste("input file", file, "doesn't exist."))
    if( ! type %in% c("SQ", "AC", "SP", "KW") ) stop("wrong value for type argument.")
    
    if( !inherits(socket, "sockconn") ) stop(paste("argument socket = ", socket, "is not a socket connection."))
    if( !is.logical(invisible) ) stop(paste("argument invisible = ", invisible, "should be TRUE or FALSE."))
    if( is.na(invisible) ) stop(paste("argument invisible = ", invisible, "should be TRUE or FALSE."))
    if(verbose) cat("... and everything is OK up to now.\n")
    
    #
    # Check the status of the socket connection:
    #
    if(verbose) cat("I'm checking the status of the socket connection...\n")
    #
    # Ca marche pas: summary.connection leve une exception et on ne va pas plus loin
    #
    if(!isOpen(socket)) stop(paste("socket:", socket, "is not opened."))
    if(!isOpen(socket, rw = "read")) stop(paste("socket:", socket, "can not read."))
    if(!isOpen(socket, rw = "write")) stop(paste("socket:", socket, "can not write."))
    if(verbose) cat("... and everything is OK up to now.\n")
    
    #
    # Read user file:
    #
    infile <- file(description = file, open = "r")
    data <- readLines(infile)
    close(infile)
    nl <- length(data)
    #
    # Send request to server:
    #
    if(verbose) cat("I'm sending query to server...\n")
    request <- paste("crelistfromclientdata&type=", type, "&nl=", nl, sep = "")
    if(verbose) writeLines(c(request, data))
    writeLines(c(request, data), socket, sep = "\n")
    res <- readLines(socket, n = 1)
    #
    # Check for non empty answer from server:
    #
    if(verbose) cat(paste("... answer from server is:", res, "\n"))
    if(length(res) == 0){
        if(verbose) cat("... answer from server is empty!\n")
        while(length(res) == 0){
            if(verbose) cat("... reading again.\n")
            res <- readLines(socket, n = 1)
        }
    }
    #
    # Analysing answer from server:
    #
    if(verbose) cat("I'm trying to analyse answer from server...\n")
    p <- parser.socket(res)
    if(p[1] != "0"){
        if(verbose) cat("... and I was able to detect an error.\n") 
        if( p[1] == "3" ) stop("no list creation is possible")
        if( p[1] == "4" ) stop("EOF while reading the nl lines from client")
        stop(paste("unknown error code from server:", p[1]))
    }
    if(verbose) cat("... and everything is OK up to now.\n")
    
    if(verbose){
        cat("listname is:", p[2], "\n")
        cat("list rank is:", p[3], "\n")
        cat("list count of elements is:", p[4], "\n")
    }
    #
    # set ACNUC list name with user suplied parameters:
    #
    resstl <- setlistname(lrank = p[3], name = listname)
    if(resstl != 0) stop(paste("problem with setlistname, code : ", resstl))
    #
    # Put results into workspace
    #
    if(invisible){
        invisible(query(listname = listname, query = listname, socket = socket, invisible = TRUE, 
                        verbose = verbose, virtual = virtual))
    } else {
        return(query(listname = listname, query = listname, socket = socket, invisible = FALSE, 
                     verbose = verbose, virtual = virtual))
    }
}

clfcd <- crelistfromclientdata

###########################################################################
# 
#                                choosebank
#
# To select an ACNUC database or to get the list of available databases
# from an ACNUC server.
# 
###########################################################################

.seqinrEnv <- new.env()
choosebank <- function(bank = NA,
                       host = "pbil.univ-lyon1.fr",
                       port = 5558,
                       server = FALSE,
                       blocking = TRUE,
                       open = "a+",
                       encoding = "",
                       verbose = FALSE,
                       timeout = 5,
                       infobank = FALSE,
                       tagbank = NA){
    #
    # Print parameter values if verbose mode is on:
    #
    if(verbose){ 
        cat("Verbose mode is on, parameter values are:\n")
        cat(paste("  bank = ", deparse(substitute(bank)), "\n"))
        cat(paste("  host = ", deparse(substitute(host)), "\n"))
        cat(paste("  port = ", deparse(substitute(port)), "\n"))
        cat(paste("  timeout = ", deparse(substitute(timeout)), "seconds \n"))
        cat(paste("  infobank = ", deparse(substitute(infobank)), "\n"))
        cat(paste("  tagbank = ", deparse(substitute(tagbank)), "\n"))
    }
    
    #
    # Check parameter values (to be completed):
    #
    if( !is.na(tagbank) ){
        if(verbose) cat("I'm checking the tagbank parameter value...\n")
        if( !(tagbank %in% c("TEST", "TP", "DEV")) ){
            if(verbose) cat("... and I was able to detect an error.\n")
            stop("non allowed value for tagbank parameter.\n")
        } else {
            if(verbose) cat("... and everything is OK up to now.\n")
        }  
    }
    
    #
    # Check that sockets are available:
    #
    if(verbose) cat("I'm ckecking that sockets are available on this build of R...\n")
    if( !capabilities("sockets") ){
        stop("Sockets are not available on this build of R.")
    } else {
        if(verbose) cat("... yes, sockets are available on this build of R.\n")
    }
    
    # 
    # Try to open socket connection:
    #
    if(verbose) cat("I'm trying to open the socket connection...\n")
    oldtimeout <- getOption("timeout")
    options(timeout = timeout)
    socket <- try( socketConnection( host = host, port = port, server = server,
                                     blocking = blocking, open = open, encoding = encoding))
    options(timeout = oldtimeout)
    if(inherits(socket, "try-error")) {
        errmess <- paste("I wasn't able to open the socket connection:\n",
                         "  o Check that your are connected to the internet.\n",
                         "  o Check that port", port, "is not closed by a firewall.\n",
                         "  o Try to increase timeout value (current is", timeout, "seconds).\n")
        stop(errmess)
    } else {
        if(verbose) cat("... yes, I was able to open the socket connection.\n")
    }
    
    #
    # Read the answer from server:
    #
    if(verbose) cat("I'm trying to read answer from server...\n")
    rep1 <- readLines(socket, n = 1)
    if(verbose) cat(paste("... answer from server is:", rep1, "\n"))
    
    #
    # Send client ID to server:
    #
    clientid(socket = socket, verbose = verbose)
    
    ###############################################################################
    #
    # If no bank name is given, return the list of available banks from server:
    #
    ###############################################################################
    resdf <- kdb(tag = tagbank, socket = socket)
    nbank <- nrow(resdf)
    
    if( is.na(bank) ){
        close(socket) # No more needed
        if(verbose) cat("No bank argument was given...\n")
        if( !infobank ){
            if(verbose) cat("infobank parameter is FALSE, I'm just returning bank names\n")
            return(resdf$bank)
        } else {
            if(verbose) cat("infobank parameter is TRUE, I'm returning all bank infos\n")
            return(resdf) 
        }
    } else {
        
        ###############################################################################
        #
        # If a bank name is given, try to open it from server:
        #
        ###############################################################################
        
        # 
        # Try to open bank from server:
        #
        if(verbose) cat("I'm trying to open the bank from server...\n")
        resacnucopen <- acnucopen(bank, socket)
        if(verbose) cat("... and everything is OK up to now.\n")
        
        #
        # Try to get informations from HELP file: 
        #
        if(verbose) cat("I'm trying to get information on the bank...\n")
        bankhelp <- ghelp(item = "CONT", file = "HELP", socket = socket, catresult = FALSE)
        bankrel <- bankhelp[2]
        if(verbose) cat("... and everything is OK up to now.\n")
        
        #
        # Try to get status info:
        #
        status <- "unknown"
        for(i in seq_len(nbank)){
            if (resdf[i,1] == bank) status <- resdf[i,2]
        }
        
        #
        # Build result and assign it in the global environment:
        #
        res <- list(socket = socket,
                    bankname = bank,
                    banktype = resacnucopen$type,
                    totseqs = resacnucopen$totseqs,
                    totspecs = resacnucopen$totspecs,
                    totkeys = resacnucopen$totkeys,
                    release = bankrel,
                    status = status,
                    details = bankhelp)
        assign("banknameSocket", res, .seqinrEnv)
        invisible(res)
    }
} 

stresc <- function(strings)
{
    #
    # For some reason I don't remember, the objects "fromchar" and "tochar" were
    # originally arguments of the function to allow for more flexibillity but
    # are now hard-encoded within the function.
    #
    fromchar <- s2c("\\{}$^_%#&~[]|")
    tochar <- c("$\\backslash$", "\\{", "\\}", "\\$", "\\^{}", "\\_", "\\%", "\\#", "\\&", "\\~{}",
                "\\lbrack{}", "\\rbrack{}","\\textbar{}")
    #
    # Definition of the function to escape LaTeX character in one string:
    #
    f <- function(string){
        c2s( sapply(s2c(string), function(x) ifelse(x %in% fromchar, tochar[which(x == fromchar)], x)))
    }
    #
    # Now apply it to all elements of vector string:
    #
    sapply(strings, f, USE.NAMES = FALSE)
}

consensus <- function(matali, method = c( "majority", "threshold", "IUPAC", "profile"), threshold = 0.60,
                      warn.non.IUPAC = FALSE, threshold.IUPAC = FALSE,  type = c("DNA", "RNA")){

    if(inherits(matali, "alignment")) matali <- as.matrix(matali)
    if(!is.matrix(matali)) stop("matrix or alignment object expected")
    if(storage.mode(matali) != "character") stop("matrix of characters expected")

    method <- match.arg(method)

    if(method == "IUPAC"){
        type <- match.arg(type)
        res <- apply(matali, 2, bma, warn.non.IUPAC = warn.non.IUPAC, type = type)
        names(res) <- NULL
        return(res)
    }

    if(method == "majority"){
        majority <- function(x) names(which.max(table(x)))
        res <- apply(matali, 2, majority)
        names(res) <- NULL
        return(res)
    }

    if(method == "profile"){
        obsvalue <- levels(factor(matali))
        nrow <- length(obsvalue)
        row.names(matali)<-NULL
        res <- apply(matali, 2, function(x) table(factor(x, levels = obsvalue)))
        return(res)
    }

    if(method == "threshold"){
        profile <- consensus(matali, method = "profile")
        profile.rf <- apply(profile, 2, function(x) x/sum(x))
        res <- rownames(profile.rf)[apply(profile.rf, 2, which.max)]
        type <- match.arg(type)
        resiupac <- apply(matali, 2, bma, warn.non.IUPAC = warn.non.IUPAC, type = type)
        names(resiupac) <- NULL
        if (threshold.IUPAC) {
          res <- ifelse(apply(profile.rf, 2, max) >= threshold, res, resiupac)
        }
        else {
          res <- ifelse(apply(profile.rf, 2, max) >= threshold, res, NA)
          }
        names(res) <- NULL
        return(res)
    }
}

con <- consensus

write.fasta <- function(sequences, names, file.out, open = "w", nbchar = 60, 
                        as.string = FALSE){
    #
    # Open output file:
    #
    outfile <- file(description = file.out, open = open)
    
    #
    # Function to write one sequence in output file:
    #
    write.oneseq <- function(sequence, name, nbchar, as.string){
        writeLines(paste(">", name, sep = ""), outfile)
        if(as.string) sequence <- s2c(sequence)
        l <- length(sequence)
        q <- floor(l/nbchar)
        r <- l - nbchar*q
        if(q > 0){
            sapply(seq_len(q), function(x) writeLines(c2s(sequence[(nbchar*(x - 1) + 1):(nbchar*x)]), outfile))
        }
        if(r > 0){
            writeLines(c2s(sequence[(nbchar*q + 1):l]), outfile)
        }
    }
    
    #
    # Write all sequences in output file:
    #
    if(!is.list(sequences)){
        write.oneseq(sequence = sequences, name = names, nbchar = nbchar, as.string = as.string)
    } else {
        n.seq <- length(sequences)
        sapply(seq_len(n.seq), function(x) write.oneseq(sequence = as.character(sequences[[x]]), 
                                                        name = names[x], nbchar = nbchar, as.string = as.string))
    }
    #
    # Close output file:
    #
    close(outfile)
}

dia.bactgensize <- function(
        fit = 2, p = 0.5, m1 = 2000, sd1 = 600, m2 = 4500, sd2 = 1000, p3 = 0.05,
        m3 = 9000, sd3 = 1000, maxgensize = 20000,
        source = c("https://pbil.univ-lyon1.fr/datasets/seqinr/data/goldtable15Dec07.txt"))
{
    #
    # Use local source by default:
    #
    source <- source[1]
    #
    # Build source of data string:
    #
    
    sodtxt <- "Source of data: GOLD (Genomes OnLine Database) 15 Dec 2007"
    
    #
    # Read data from GOLD:
    #
    alldata <- utils::read.table(source, header = TRUE, sep = "\t",
                          comment.char = "", quote = "")
    SUPERKINGDOM <- 1 # col number
    kingdom <- alldata[, SUPERKINGDOM]
    prodata <- alldata[ kingdom == "Archaea" | kingdom == "Bacteria", ]
    data <- prodata[, c("GENUS", "SPECIES", "SIZE.kb.")]
    names(data) <- c("genus", "species", "gs")
    data <- data[stats::complete.cases(data), ]
    #
    # Remove data > maxgensize:
    #
    data <- data[data$gs <= maxgensize, ]
    #
    # Use Kb scale
    #
    sizeKb <- data$gs
    n <- length(sizeKb)
    #
    # Graphics
    #
    x <- seq( min(sizeKb), max(sizeKb), le=200)
    mybreaks <- seq(min(sizeKb),max(sizeKb),length=15)
    vscale <- diff(mybreaks)[1]*n
    
    if(fit == 0)
    {
        hst <- graphics::hist(sizeKb, freq = TRUE,
                    breaks = mybreaks,
                    main=paste("Genome size distribution for", n, "bacterial genomes"),
                    xlab="Genome size [Kb]",
                    ylab="Genome count",
                    col="lightgrey")
        
        dst <- stats::density(sizeKb)
        graphics::lines(x=dst$x, y=vscale*dst$y)
        graphics::legend(x = max(sizeKb)/2, y = 0.75*max(hst$counts), lty=1,
               "Gaussian kernel density estimation")
        
        graphics::mtext(sodtxt)
    }
    ##########################################
    #
    # Fitting a mixture of two normal distributions
    #
    ###########################################
    if(fit == 2)
    {
        logvraineg <- function(param, obs)
        {
            p <- param[1]
            m1 <- param[2]
            sd1 <- param[3]
            m2 <- param[4]
            sd2 <- param[5]
            
            -sum(log(p*stats::dnorm(obs,m1,sd1)+(1-p)*stats::dnorm(obs,m2,sd2)))
        }
        
        nlmres <- suppressWarnings(stats::nlm(logvraineg, c(p, m1, sd1, m2, sd2), obs=sizeKb))
        estimate <- nlmres$estimate
        
        y1 <- vscale*estimate[1]*stats::dnorm(x, estimate[2], estimate[3])
        y2 <- vscale*(1-estimate[1])*stats::dnorm(x, estimate[4], estimate[5])
        dst <- stats::density(sizeKb)
        
        hst <- graphics::hist(sizeKb, plot = FALSE, breaks = mybreaks)
        ymax <- max(y1, y2, hst$counts, vscale*dst$y)
        
        
        graphics::hist(sizeKb, freq = TRUE, ylim=c(0,ymax),
             breaks = mybreaks,
             main=paste("Genome size distribution for", n, "bacterial genomes"),
             xlab="Genome size [Kb]",
             ylab="Genome count",
             col="lightgrey")
        
        graphics::lines(x, y1, col="red", lwd=2)
        graphics::lines(x, y2, col="blue", lwd=2)
        
        graphics::text(x = max(sizeKb)/2, y = ymax, pos=4, "Maximum likelihood estimates:")
        
        graphics::text(x = max(sizeKb)/2, y = 0.95*ymax, col="red", pos = 4, cex=1.2,
             substitute(hat(p)[1] == e1~~hat(mu)[1] == e2~~hat(sigma)[1] == e3,
                        list(e1 = round(estimate[1],3),
                             e2 = round(estimate[2],1),
                             e3 = round(estimate[3],1))))
        
        graphics::text(x = max(sizeKb)/2, y = 0.90*ymax, col="blue", pos = 4, cex=1.2,
             substitute(hat(p)[2] == q~~hat(mu)[2] == e4~~hat(sigma)[2] == e5,
                        list(q = round(1 - estimate[1],3),
                             e4 = round(estimate[4],1),
                             e5 = round(estimate[5],1))))
        
        graphics::lines(x=dst$x, y=vscale*dst$y)
        graphics::legend(x = max(sizeKb)/2, y = 0.75*ymax, lty=1,
               "Gaussian kernel density estimation")
        
        graphics::mtext(sodtxt)
    }
    ##########################################
    #
    # Fitting a mixture of three normal distributions
    #
    ###########################################
    if(fit == 3)
    {
        logvraineg <- function(param, obs)
        {
            p <- param[1]
            m1 <- param[2]
            sd1 <- param[3]
            m2 <- param[4]
            sd2 <- param[5]
            p3 <- param[6]
            m3 <- param[7]
            sd3 <- param[8]
            
            -sum(log(p*stats::dnorm(obs,m1,sd1)
                     +(1-p-p3)*stats::dnorm(obs,m2,sd2)
                     +p3*stats::dnorm(obs,m3,sd3)))
        }
        
        nlmres <- suppressWarnings(stats::nlm(logvraineg, c(p, m1, sd1, m2, sd2, p3, m3, sd3), obs=sizeKb))
        estimate <- nlmres$estimate
        
        y1 <- vscale*estimate[1]*stats::dnorm(x, estimate[2], estimate[3])
        y2 <- vscale*(1-estimate[1]-estimate[6])*stats::dnorm(x, estimate[4], estimate[5])
        y3 <- vscale*estimate[6]*stats::dnorm(x, estimate[7], estimate[8])
        
        hst <- graphics::hist(sizeKb, plot = FALSE, breaks = mybreaks)
        ymax <- max(y1, y2, y3, hst$counts)
        
        graphics::hist(sizeKb, freq = TRUE, ylim=c(0,ymax),
             breaks = mybreaks,
             main=paste("Genome size distribution for", n, "bacterial genomes"),
             xlab="Genome size [Kb]",
             ylab="Genome count",
             col="lightgrey")
        
        graphics::lines(x, y1, col="red", lwd=2)
        graphics::lines(x, y2, col="blue", lwd=2)
        graphics::lines(x, y3, col="green3", lwd=2)
        
        graphics::text(x = max(sizeKb)/2, y = ymax, pos=4, "Maximum likelihood estimates:")
        
        graphics::text(x = max(sizeKb)/2, y = 0.95*ymax, col="red", pos = 4, cex=1.2,
             substitute(hat(p)[1] == e1~~hat(mu)[1] == e2~~hat(sigma)[1] == e3,
                        list(e1 = round(estimate[1],3),
                             e2 = round(estimate[2],1),
                             e3 = round(estimate[3],1))))
        
        graphics::text(x = max(sizeKb)/2, y = 0.90*ymax, col="blue", pos = 4, cex=1.2,
             substitute(hat(p)[2] == q~~hat(mu)[2] == e4~~hat(sigma)[2] == e5,
                        list(q = round(1 - estimate[1]-estimate[6],3),
                             e4 = round(estimate[4],1),
                             e5 = round(estimate[5],1))))
        
        graphics::text(x = max(sizeKb)/2, y = 0.85*ymax, col="green3", pos = 4, cex=1.2,
             substitute(hat(p)[3] == p3~~hat(mu)[3] == e7~~hat(sigma)[3] == e8,
                        list(p3 = round(estimate[6],3),
                             e7 = round(estimate[7],1),
                             e8 = round(estimate[8],1))))
        
        dst <- stats::density(sizeKb)
        graphics::lines(x=dst$x, y=vscale*dst$y)
        graphics::legend(x = max(sizeKb)/2, y = 0.75*ymax, lty=1,
               "Gaussian kernel density estimation")
        
        graphics::mtext(sodtxt)
    }
    #
    # Return invisibly the dataset
    #
    invisible(data)
}

# ==>   isenum&[name=xx|access=xx]
# <==  number=xx{&length=xx&frame=xx&gencode=xx&ncbigc=xx}{&otheraccessmatches}
# Finds the acnuc number of a sequence from its name (name= argument) or its accession number (access= argument).
# The name= and access= arguments are case-insensitive.
# Reply gives number (or 0 if does not exist), length, reading frame (0, 1, or 2), and 
# genetic code ids of the corresponding sequence (gencode= gives acnuc's genetic code, 0 means universal; 
# ncbigc= gives ncbi's genetic code id, 1 means universal).
# When &otheraccessmatches appears in reply, it means that several sequences are attached to the given accession no., 
# and that only the acnuc number of the first attached sequence is given in the number= argument.


isenum <- function(what, idby = c("name", "access"), socket = autosocket()){
    #
    # Default is by name:
    #
    idby <- idby[1]
    if(!(idby %in% c("name", "access"))) stop("Wrong idby agument")
    #
    # Make default return value:
    #
    result <- list(number = NA, length = NA, frame = NA, gencode = NA, ncbigc = NA, otheraccessmatches = NA)
    #
    # Build request:
    #
    request <- paste("isenum&", idby, "=", what, sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Build result:
    #
    resitem <- parser.socket(answerFromServer)
    number <-  as.numeric(resitem[1])
    if(number == 0){
        return(result) # sequence doesn't exist, NA returned
    } else {
        result$number <- number
    }
    result$length <- as.numeric(resitem[2])
    if( resitem[length(resitem)] == "otheraccessmatches"){
        result$otheraccessmatches <- TRUE
    } else {
        result$otheraccessmatches <- FALSE
    }
    if( length(resitem) <= 3) return(result) # Mother sequence
    
    result$frame <- as.numeric(resitem[3])
    result$gencode <- as.numeric(resitem[4])
    result$ncbigc <- as.numeric(resitem[5])
    
    return(result)
}

isn <- function(what, ...) isenum(what, ...)$number

#
# getNumber.socket (deprecated as from seqinR 1.1-3)
#
getNumber.socket <- function(socket, name){
    warning("getNumber.socket is deprecated, use isn() instead")
    isn(what = name, socket = socket)
}

#
# getAttributsocket (deprecated as from seqinR 1.1-3)
#
getAttributsocket <- function( socket, name){
    warning("getAttributsocket is deprecated, use isenum instead.")
    request <- paste("isenum&name=", name, sep = "")
    writeLines( request, socket, sep = "\n")
    res <- readLines(socket, n = 1)
    p <- parser.socket(res)
    return( list(length = as.numeric(p[2]), frame = as.numeric(p[3]), gencode = as.numeric(p[4])) )
}

acnucopen <- function(db, socket, challenge = NA){
    #
    # Check arguments:
    #
    if(!is.na(challenge) ) stop("password protection not implemented yet")
    #
    # Build request:
    #
    request <- paste("acnucopen&db=", db, sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        close(socket)
        stop("Empty answer from server")
    }
    res <- parser.socket(answerFromServer)
    #
    # Check that no error is returned:
    #
    if(res[1] != "0"){
        close(socket)
        if( res[1] == "1" ){
            stop("unrecognized command") # should not happen
        }
        if( res[1] == "2" ){
            stop("missing db= argument") # should not happen
        }
        if( res[1] == "3" ){
            stop(paste("Database with name -->", db, "<-- is not known by server.\n", sep = ""))
        }
        if( res[1] == "4" ){
            stop(paste("Database with name -->", db, "<-- is currently off for maintenance, please try again later.\n", sep = ""))
        }
        if( res[1] == "5" ){
            stop("A database is currently opened and has not been closed.\n")
        }
        if( res[1] == "6" ){
            stop(paste("Database with name -->", db, "<-- is protected by a password (unimplemented).\n", sep = ""))
        }
        stop(paste("I don't know what this error code means for acnucopen:", res[1]))
    }
    return(list(type = res[2], totseqs = as.numeric(res[3]), totspecs = as.numeric(res[4]),
                totkeys = as.numeric(res[5]), ACC_LENGTH = as.numeric(res[6]),
                L_MNEMO = as.numeric(res[7]), WIDTH_KW = as.numeric(res[8]),
                WIDTH_SP = as.numeric(res[9]), WIDTH_SMJ = as.numeric(res[10]),
                WIDTH_AUT = as.numeric(res[11]), WIDTH_BIB = as.numeric(res[12]),
                lrtxt = as.numeric(res[13]), SUBINLNG = as.numeric(res[14])))
}

##########################################################################
#
# SeqFastadna:
#

as.SeqFastadna <- function(object, name = NULL, Annot = NULL){
    attributes(object) <- list(name = name, Annot = Annot)
    class(object) <- "SeqFastadna"
    return(object)
}

is.SeqFastadna <- function(object) inherits(object, "SeqFastadna")

summary.SeqFastadna <- function(object, alphabet = s2c("acgt"), ...){
    length <- getLength(object)
    if(nchar(object[1]) > 1) {
        compo <- count(s2c(object), 1, alphabet = alphabet)
        return(list(length = length , composition = compo, GC = GC(s2c(object))))
    }
    else {
        compo <- count(object, 1, alphabet = alphabet)
        return(list(length = length , composition = compo, GC = GC(object)))
    }
}

#
# SeqFastaAA:
#

as.SeqFastaAA <- function(object, name = NULL, Annot = NULL){
    attributes(object) <- list(name = name, Annot= Annot)
    class(object) <- "SeqFastaAA"
    return(object)
}

is.SeqFastaAA <- function(object) inherits(object, "SeqFastaAA")

summary.SeqFastaAA <- function(object,...){
    length <- getLength(object)
    if(nchar(object[1]) > 1) {
        compo <- table(factor(s2c(object), levels = levels(SEQINR.UTIL$CODON.AA$L)))
        return(list(length = length, composition=compo/length, AA.Property=AAstat(s2c(object),plot=FALSE)[[2]]))
    }
    else {
        compo <- table(factor(object, levels = levels(SEQINR.UTIL$CODON.AA$L)))
        return(list(length = length, composition=compo/length, AA.Property=AAstat(object,plot=FALSE)[[2]]))
    }
    
}


#
# SeqAcnucWeb:
#

as.SeqAcnucWeb <- function(object, length, frame, ncbigc){
    attributes(object) <- list(length = as.numeric(length),
                               frame = as.numeric(frame), ncbigc = as.numeric(ncbigc))
    class(object) <- "SeqAcnucWeb"
    return(object)
}

is.SeqAcnucWeb <- function(object) inherits(object, "SeqAcnucWeb")


print.SeqAcnucWeb <- function(x, ...)
{
    res <- c(x, attr(x, "length"), attr(x, "frame"), attr(x, "ncbigc"))
    names(res) <- c("name", "length", "frame", "ncbigc")
    print(res, ...)
}

#
# SeqFrag:
#


as.SeqFrag <- function(object, begin, end, name){
    attr(object, "seqMother") <- name
    attr(object, "begin") <- begin
    attr(object,"end") <- end
    class(object) <- "SeqFrag"
    return(object)
}

is.SeqFrag <- function(object) inherits(object, "SeqFrag")

#
# Query Acnuw Web (qaw class)
#

print.qaw <- function(x, ...)
{
    cat(x$nelem, x$type, "for", list1$call$query)
}

#==>  prettyseq&num=xx{&bpl=xx}{&translate=[T|F]}
#<==   code=0\n
#line1
#line2
#...
#prettyseq END.\n
#To get a text representation of sequence of rank num and of its subsequences,
#with bpl bases per line (default = 60), and with optional translation of 
#protein-coding subsequences.

prettyseq <- function(num, bpl = 60, translate = TRUE, socket = autosocket()){
    #
    # Build request:
    #
    request <- paste("prettyseq&num=", formatC(num, format = "d"),
                     "&bpl=", bpl, "&translate=", ifelse(translate,"T", "F"), sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Check that no error code is returned by server:
    #
    if( !substr(x = answerFromServer, start = 6, stop = 6) == "0"){
        warning(paste("Server returned error code:", answerFromServer))
        return(NA)
    }
    #
    # Extract sequence from server:
    #
    result <- readLines(socket)
    #
    # Check the end:
    #
    if( result[length(result)] != "prettyseq END."){
        warning("Incomplete answer from server")
        return(NA)
    }
    result <- result[-length(result)] # remove last line
    cat(result, sep = "\n")
    invisible(result)
}

#
# computePI: To Compute the Theoretical Isoelectric Point
#
# seq is a protein sequence as a vector of single characters in upper case,
# note that there is no argument checking here.
#

computePI <- function(seq){
    #
    # Remove stop codons translated as the character '*' :
    #
    if(length(which(seq == "*")) != 0) seq <- seq[- which(seq == "*")]
    
    compoAA <- table(factor(seq, levels = LETTERS))
    nTermR <- which(LETTERS == seq[1])
    cTermR <- which(LETTERS == seq[length(seq)])
    
    computeCharge <- function(pH, compoAA, pK, nTermResidue, cTermResidue){
        cter <- 10^(-pK[cTermResidue,1]) / (10^(-pK[cTermResidue,1]) + 10^(-pH))	
        nter <- 10^(-pH) / (10^(-pK[nTermResidue,2]) + 10^(-pH))
        carg <- as.vector(compoAA['R'] * 10^(-pH) / (10^(-pK['R',3]) + 10^(-pH)))
        chis <- as.vector(compoAA['H'] * 10^(-pH) / (10^(-pK['H',3]) + 10^(-pH)))
        clys <- as.vector(compoAA['K'] * 10^(-pH) / (10^(-pK['K',3]) + 10^(-pH)))
        casp <- as.vector(compoAA['D'] * 10^(-pK['D',3]) /(10^(-pK['D',3]) + 10^(-pH)))
        cglu <- as.vector(compoAA['E'] * 10^(-pK['E',3]) / (10^(-pK['E',3]) + 10^(-pH)))
        ccys <- as.vector(compoAA['C'] * 10^(-pK['C',3]) / (10^(-pK['C',3]) + 10^(-pH)))
        ctyr <- as.vector(compoAA['Y'] * 10^(-pK['Y',3]) / (10^(-pK['Y',3]) + 10^(-pH)))
        charge <- carg + clys + chis + nter - (casp + cglu + ctyr + ccys + cter)
        return(charge)
    }
    
    critere <- function( p1, p2, p3, p4, p5){ 
        computeCharge(pH = p1, compoAA = p2, pK = p3, nTermResidue = p4, cTermResidue = p5)^2
    }
    
    nlmres <- suppressWarnings(stats::nlm(critere, 7, p2 = compoAA, p3 = SEQINR.UTIL$pk, p4 = nTermR, p5 = cTermR))
    #
    # If minimum is not zero, try whith a different guess:
    #
    while( ! identical(all.equal( nlmres$minimum, 0 ), TRUE))
    {
        nlmres <- suppressWarnings(stats::nlm(critere, stats::runif(1, 0, 14), p2 = compoAA, p3 = SEQINR.UTIL$pk, p4 = nTermR, p5 = cTermR))
    }
    return(nlmres$estimate)
}

draw.oriloc <- function(ori, main = "Title",
                        xlab = "Map position in Kb",
                        ylab = "Cumulated combined skew in Kb", las = 1, las.right = 3,
                        ta.mtext = "Cumul. T-A skew", ta.col = "pink", ta.lwd = 1,
                        cg.mtext = "Cumul. C-G skew", cg.col = "lightblue", cg.lwd = 1,
                        cds.mtext = "Cumul. CDS skew", cds.col = "lightgreen", cds.lwd = 1,
                        sk.col = "black", sk.lwd = 2,
                        add.grid = TRUE, ...){
    
    #
    # Get data and use Kb units for skews and map positions:
    #
    ta <- ori$x/1000          # Cumulated T-A skew in Kb
    cg <- ori$y/1000          # Cumulated C-G skew in Kb
    skew <- ori$skew/1000     # Cumulated combined skew in Kb
    cdsskew <- ori$CDS.excess # Cumulated CDS orientation bias
    start.kb <- ori$start.kb
    end.kb <- ori$end.kb
    #
    # This is to deal with CDS that wrapp around the genome:
    #
    wrapped <- which(abs(ori$start.kb - ori$end.kb) >= 50)
    
    if(length(wrapped)!=0){
        if(wrapped == length(cdsskew)){
            start.kb[wrapped] <- max(start.kb[wrapped], end.kb[wrapped])
            end.kb[wrapped] <- max(start.kb[wrapped], end.kb[wrapped])
        }
        if(wrapped == 1){
            end.kb[wrapped] <- min(start.kb[wrapped], end.kb[wrapped])
            start.kb[wrapped] <- min(start.kb[wrapped], end.kb[wrapped])
        }
    }
    #
    # Use CDS midpoints as x-coordinates:
    #
    meancoord <- (start.kb + end.kb)/2
    
    ymin <- min(ta, cg, skew)
    ymax <- max(ta, cg, skew)
    xmin <- min(meancoord)
    xmax <- max(meancoord)
    
    ticks <- pretty(cdsskew)
    
    ticks.y <- (ymax-ymin)/(max(cdsskew) - min(cdsskew))*(ticks - min(cdsskew)) + ymin
    cds.y   <- (ymax-ymin)/(max(cdsskew) - min(cdsskew))*(cdsskew - min(cdsskew)) + ymin
    
    graphics::plot(meancoord, cg, type="l", xlab = xlab,
         ylab = ylab, xlim = c(xmin, xmax), ylim = c(ymin, ymax),
         cex.lab = 1.35, col = cg.col, main = main, lwd = cg.lwd, las = las, ...)
    
    graphics::axis(side = 4, at = ticks.y, labels = ticks, col = cds.col, las = las.right)
    
    #
    # Add vertical grid when required:
    #
    if(add.grid){
        tmp <- pretty(meancoord)
        graphics::abline(v = tmp, col = "grey", lty=3)
        tmp <- tmp[-length(tmp)] + diff(tmp)/2
        graphics::abline(v = tmp, col = "grey", lty=3)
    }
    
    graphics::lines(meancoord, ta, col = ta.col, lwd = ta.lwd)
    graphics::lines(meancoord, skew, col = sk.col, lwd = sk.lwd)
    graphics::lines(meancoord, cds.y, col = cds.col, lwd = cds.lwd)
    
    graphics::mtext(ta.mtext, col = ta.col, adj = 0)
    graphics::mtext(cg.mtext, col = cg.col)
    graphics::mtext(cds.mtext, col = cds.col, adj=1)
    
}

#
# To get the location of subsequences from an ACNUC server
#

getLocation <- function(object, ...) UseMethod("getLocation")

getLocation.list <- function(object, ...)
    lapply(seq_len(length(object)), function(i) getLocation(object[[i]], ...))

getLocation.default <- function(object, ...)
    stop(paste("no getLocation method for objects of class:", class(object)))

getLocation.SeqAcnucWeb <- function(object, ..., socket = autosocket()){
    getLocationSocket <- function( socket, name){
        
        writeLines(paste("isenum&name=",name,sep=""),socket,sep="\n")
        res = readLines( socket , n=1 )
        number = parser.socket(res)[1] 
        
        writeLines(paste("readsub&num=",number,sep=""),socket,sep="\n")
        res2 = readLines( socket , n=1 ) 
        rr = parser.socket(res2)
        
        # Test si subsequence           
        
        l=list() 
        if(as.numeric(rr[5]) != 0){
            warning("It's a parent sequence\n")
            return( NA )
        }
        else {
            i=1
            writeLines(paste("readext&num=",rr[6],sep=""),socket,sep="\n")    
            res3 = readLines( socket , n=1 )
            r = parser.socket(res3)
            l[[i]] = as.numeric(c(r[3],r[4]))
            n=r[5] 
        }
        while(as.numeric(n) != 0){
            i=i+1
            writeLines(paste("readext&num=",n,sep=""),socket,sep="\n")   
            res4 = readLines( socket , n=1 )
            rrr = parser.socket(res4)
            l[[i]] = as.numeric(c(rrr[3],rrr[4]))
            n=rrr[5]
        }
        return(l)
    } 
    
    unlist(getLocationSocket(socket, name = object))
}

getLocation.qaw <- function(object, ...) getLocation(object$req, ...)

getLocation.logical <- function (object, ...)
    object # so that NA is returned for virtual lists

#
# Pairwise Distances from Aligned Protein or DNA/RNA Sequences
#

dist.alignment <- function(x, matrix = c("identity", "similarity"),gap = FALSE )
{
    #
    # Check arguments:
    #
    if (!inherits(x, "alignment")) stop("Object of class 'alignment' expected")
    #
    # Match arguments:
    #
    matrix <- match.arg(matrix)
    #
    # Compute arguments for the C distance function:
    #
    sequences <- toupper(x$seq)
    nbseq <- x$nb
    matNumber <-ifelse(matrix == "similarity", 1, 2)
    #
    # The following shouldn't be hard encoded, an argument for full
    # user control should be added.
    #
    seqtype <- as.numeric(.Call("is_a_protein_seq", sequences[1], PACKAGE = "seqinr") >= 0.8)
    #
    # Call the C distance function:
    #
    if (gap == TRUE) {
        dist <- .Call("distance", sequences, nbseq, matNumber, seqtype,1, PACKAGE = "seqinr")
    }
    else {
        dist <- .Call("distance", sequences, nbseq, matNumber, seqtype,0, PACKAGE = "seqinr")
    }
    #
    # Convert the result in a object of class dist:
    #
    mat <- matrix(dist, nbseq, nbseq, byrow = TRUE)
    dimnames(mat) <- list(x$nam, x$nam)
    return( stats::as.dist(mat) )
}

#
# Returns the socket to the last opened database if any.
#
autosocket <- function(){
    #
    # Check that global variable "banknameSocket" exists:
    #
    if(!exists(x = "banknameSocket", envir = .seqinrEnv)){
        stop("banknameSocket not found, try choosebank() first")
    }
    #
    # Check that "banknameSocket" belongs to the sockconn class:
    #
    socket <- get("banknameSocket", .seqinrEnv)$socket
    if(!inherits(socket, "sockconn")){
        stop("banknameSocket$socket is not a sockconn")
    }
    #
    # Check that the socket connection status is OK:
    #
    status <- summary(socket)
    if(status[["class"]] != "sockconn"){
        #
        # for backward compatibility: in R 2.6.2 the result was "socket",
        # so "socket" instead of "sockconn" is temporarilly allowed with
        # a warning.
        #
        if(status[["class"]] != "socket"){
            stop("socket is not a sockconn")
        } else {
            warning("backward compatibility patch used, upgrade your R version asap")
        }
    }
    if(status[["opened"]] != "opened") stop("socket is not openend")
    if(status[["can read"]] != "yes") stop("can't read on socket")
    if(status[["can write"]] != "yes") stop("can't write on socket")
    #
    # Iff everything is OK return the socket:
    #
    return(socket)
}

#
# To get annotations corresponding to sequences
#
getAnnot <- function(object, ...) UseMethod("getAnnot")

getAnnot.default <- function(object, ...)
    stop(paste("no getAnnot method for objects of class:", class(object)))

getAnnot.list <- function(object, ...)
    lapply(seq_len(length(object)), function(i) getAnnot(object[[i]], ...))

getAnnot.SeqFastadna <- function(object, ...) attr(object, "Annot")
getAnnot.SeqFastaAA <- getAnnot.SeqFastadna

getAnnot.SeqAcnucWeb <- function(object, ..., nbl = 100, socket = autosocket()){
    #
    # Check arguments:
    #
    if(nbl <= 0){
        warning("Negative or zero value for argument nbl, forced to 1.")
        nbl <- 1
    }
    #
    # Build request:
    #
    request <- paste("read_annots&name=", object, "&nl=", nbl, sep = "")
    writeLines(request , socket, sep="\n")
    #
    # Read result from server:
    #  
    res <- readLines(socket , n = nbl)
    #
    # Remove the "nl=xx&" answer from server on first line:
    #
    newfirstline <- unlist(strsplit(res[1], "&"))[2]
    res[1] <- newfirstline
    return(res)
}

getAnnot.qaw <- function(object, ...) getAnnot(object$req, ...)

getAnnot.logical <- function (object, ...)
    object # so that NA is returned for virtual lists

#
# To get sequence data
#

getSequence <- function(object, as.string = FALSE, ...) UseMethod("getSequence")

getSequence.default <- function(object, as.string = FALSE, ...)
    stop(paste("no getSequence method for objects of class:", class(object)))

getSequence.list <- function(object, as.string = FALSE, ...)
    lapply(seq_len(length(object)), function(i) getSequence(object[[i]], as.string = as.string, ...))

getSequence.character <- function(object, as.string = FALSE, ...){
    is.single.string <- function(x) length(x) == 1 && nchar(x) > 1
    if(is.single.string(object)){
        if(as.string) return(as.list(object)) else return(s2c(object))
    } else {
        if(as.string) return(as.list(c2s(object))) else return(object)
    }
}

getSequence.SeqFastadna <- function(object, as.string = FALSE, ...){
    attributes(object) <- NULL # not needed here
    getSequence.character(object, as.string, ...)
}

getSequence.SeqFrag <- getSequence.SeqFastaAA <- getSequence.SeqFastadna

getSequence.SeqAcnucWeb <- function(object, as.string = FALSE, ..., socket = autosocket()){
    #
    # Should call gfrag directly... need to implement as.string for this
    #
    getSequenceSocket <- function(socket, name, start, length, as.string = FALSE){
        request <- paste("gfrag&name=", name, "&start=", formatC(start, format = "d"),
                         "&length=", formatC(length, format = "d"), sep = "")
        writeLines(request, socket, sep = "\n")
        answerFromServer <- readLines(socket, n = 1)
        
        #
        # Check that there is an answer from server:
        #
        if(length(answerFromServer) == 0){
            warning(paste("Empty answer from server with sequence name:", name))
            return(NA)
        } else {
            #
            # Check that no error code is returned by server:
            #
            if(substr(x = answerFromServer, start = 1, stop = 5) == "code="){
                warning(paste("Server returned error code:", answerFromServer, "with sequence name:", name))
                return(NA)
            }
            #
            # Extract sequence from server answer:
            #
            sequence <- unlist(strsplit(answerFromServer, split = "&"))[2]
            #
            # Returns the sequence either as a string or as a vector of single chars:
            #
            if( as.string ){
                return(sequence)
            } else {
                return(s2c(sequence))
            }
        }
    }
    
    getSequenceSocket(socket, object, start = 1, length = attr(object, "length"), as.string = as.string)
}
getSequence.qaw <- function(object, as.string = FALSE, ...) getSequence(object$req, ...)

getSequence.logical <- function (object, as.string = FALSE, ...)
    object # so that NA is returned for virtual lists

# ==>   ghelp&file=xx&item=xx
# <==  nl=xx&...1 or several lines...
# Reads one item of information from specified help file.
# File can be HELP or HELP_WIN, item is the name of the desired help item
# Reply :	nl is 0 if any problem, or announces the number of help lines returned.

ghelp <- function(item = c("GENERAL", "SELECT", "SPECIES", "KEYWORD"), 
                  file = c("HELP", "HELP_WIN"), socket = autosocket(),
                  catresult = TRUE){
    #
    # Default is "HELP" file and "GENERAL":
    #
    item <- item[1]
    file <- file[1]
    if(!(file %in% c("HELP", "HELP_WIN"))) stop("Wrong file agument")
    #
    # Build request:
    #
    request <- paste("ghelp&file=", file, "&item=", item, sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # cat result:
    #
    answerFromServer[1] <- unlist(strsplit(answerFromServer[1], split = "&"))[2]
    if(catresult) cat(answerFromServer, sep = "\n")
    invisible(answerFromServer)
}

words.pos <- function(pattern, text, ignore.case = FALSE,
                      perl = TRUE, fixed = FALSE, useBytes = TRUE, ...)
{
    position <- regexpr(pattern, text, ignore.case, perl, fixed, useBytes, ...)[1]
    result <- numeric(0)
    while(position != -1 )
    {
        result <- c(result, position )
        text <- substr(text, position + 1, nchar(text))
        position <- regexpr(pattern, text, ignore.case, perl, fixed, useBytes, ...)[1]
    }
    return(cumsum(result))
}

###################################################################################################
#                                                                                                 #
#                                         getType                                                 #
#                                                                                                 #
#                                                                                                 #
#                      To get available subsequence types in an opened ACNUC database             #
#                                                                                                 #
###################################################################################################

getType <- function(socket = autosocket()){
    #
    # Get the number of records in SMJYT index file:
    #
    nl <- readfirstrec(type = "SMJ")
    
    #
    # Read the SMJYT index file:
    #
    
    smj <- readsmj(libel.add = TRUE, sname.add = TRUE, nl = nl)
    
    #
    # Return available type:
    #
    ntype <- sum(smj$nature == "type", na.rm = TRUE)
    if( is.na(ntype) || ntype == 0 ){
        return(NA)
    } else {
        return( smj[!is.na(smj$nature) & smj$nature == "type", c("sname","libel")] ) 
    }
}

# ==>  knowndbs{&tag=xx}
# <== nl=.. \n
# dbname | on/off | db description \n      nl such lines
# Returns, for each database known by the server, its name (a valid value for the db= argument 
# of the acnucopen command), availability (off means temporarily unavailable), and description.
# When the optional tag= argument is used, only databases tagged with the given string are listed;
# without this argument, only untagged databases are listed.
# The tag argument thus allows to identify series of special purpose (tagged) databases, 
# in addition to default (untagged) ones. The full list of untagged and tagged databases is here.

knowndbs <- function(tag = c(NA, "TP", "TEST", "DEV"), socket = autosocket()){
    #
    # Use default tag:
    #
    tag <- tag[1]
    #
    # Build request:
    #
    if( !is.na(tag) ){
        askforbank <- paste("knowndbs&tag=", tag, sep = "")
    } else {
        askforbank <- "knowndbs"
    }
    writeLines(askforbank, socket, sep = "\n")
    rep <- readLines(socket, n = 1)
    nbank <- as.numeric(parser.socket(rep))  
    #
    # Read bank infos from server:
    #
    res <- readLines(socket, n = nbank)
    #
    # Build result:
    #
    resdf <- as.data.frame(list(bank = I(rep("NAbank", nbank)), 
                                status = I(rep("NAstatus", nbank)), 
                                info = I(rep("NAinfo", nbank))))
    for(i in seq_len(nbank))
        resdf[i, ] <- unlist(strsplit(res[i], split = "\\|"))[1:3]
    for(i in seq_len(nbank))
        for(j in seq_len(3))
            resdf[i, j] <- trimSpace(resdf[i, j])   
    #
    # Return result:
    #
    return(resdf)
}

kdb <- knowndbs

# ==>   countfreelists
# <==  code=xx&free=xx&annotlines="xx"
# Returns the number of free lists available.
# code: 0 iff OK
# free: number of free lists available
# annotlines: list of names of annotation lines in the opened database separated by |

countfreelists <- function(socket = autosocket()){
    writeLines("countfreelists", socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Build result:
    #
    resitem <- parser.socket(answerFromServer)
    if(resitem[1] != "0"){
        stop(paste("error code returned by server :", resitem[1]))
    }
    free <- as.numeric(resitem[2])
    tmp <- substr(resitem[3], 2, nchar(resitem[3]) - 1)
    annotlines <- unlist(strsplit(tmp, split = "|", fixed = TRUE))
    return(list(free = free, annotlines = annotlines))
}

cfl <- countfreelists

draw.rearranged.oriloc <- function(rearr.ori,breaks.gcfw=NA,breaks.gcrev=NA,breaks.atfw=NA,breaks.atrev=NA){
    
    rearat=cumsum(rearr.ori$atskew.rear)
    reargc=cumsum(rearr.ori$gcskew.rear)
    strand.rear=rearr.ori$strand.rear
    cds.rear=rep(1,length(strand.rear))
    cds.rear[strand.rear=="reverse"]=-1
    rearcds=cumsum(cds.rear)
    meancoord.rear=rearr.ori$meancoord.rear
    
    ymin <- min(rearat,reargc)
    ymax <- max(rearat,reargc)
    xmin <- min(meancoord.rear)
    xmax <- max(meancoord.rear)
    
    ticksrear <- pretty(rearcds)
    
    ticks.yrear <- (ymax-ymin)/(max(rearcds)-min(rearcds))*(ticksrear - min(rearcds)) + ymin
    cds.yrear   <- (ymax-ymin)/(max(rearcds)-min(rearcds))*(rearcds - min(rearcds)) + ymin
    
    graphics::plot(meancoord.rear,reargc, type="l", xlab="Map position (gene index)",
         ylab = "Cumulated normalized skew",xlim=c(xmin,xmax),ylim=c(ymin,ymax),cex.lab=1.35,col="blue",main="Rearranged nucleotide skews",lwd=2,cex.main=1.4)
    
    graphics::abline(v=sum(strand.rear=="forward"),col="black",lwd=2)
    
    graphics::axis(side = 4, at = ticks.yrear, labels = ticksrear, col = "black", col.axis ="black")
    
    tmp <- pretty(meancoord.rear)
    graphics::abline(v=tmp, col="grey", lty=3,lwd=1.5)
    tmp <- tmp[-length(tmp)] + diff(tmp)/2
    graphics::abline(v=tmp, col="grey", lty=3,lwd=1.5)
    
    graphics::lines(meancoord.rear,rearat, col="red",lwd=2)
    
    graphics::lines(meancoord.rear,cds.yrear, col="black",lwd=2)
    
    graphics::mtext("Cumul. A-T skew", col="red", adj=0,cex=1.1)
    graphics::mtext("Cumul. G-C skew", col="blue",cex=1.1)
    graphics::mtext("Cumul. CDS skew", col="black", adj=1,cex=1.1)
    
    if(sum(is.na(breaks.gcfw))==0){
        graphics::segments(x0=meancoord.rear[breaks.gcfw],y0=reargc[breaks.gcfw]-(ymax-ymin)/30,x1=meancoord.rear[breaks.gcfw],y1=reargc[breaks.gcfw]+(ymax-ymin)/30,col="blue",lwd=2,lty=1)
    }
    
    if(sum(is.na(breaks.gcrev))==0){
        graphics::segments(x0=meancoord.rear[breaks.gcrev],y0=reargc[breaks.gcrev]-(ymax-ymin)/30,x1=meancoord.rear[breaks.gcrev],y1=reargc[breaks.gcrev]+(ymax-ymin)/30,col="blue",lwd=2,lty=1)
    }
    
    if(sum(is.na(breaks.atfw))==0){
        graphics::segments(x0=meancoord.rear[breaks.atfw],y0=rearat[breaks.atfw]-(ymax-ymin)/30,x1=meancoord.rear[breaks.atfw],y1=rearat[breaks.atfw]+(ymax-ymin)/30,col="red",lwd=2,lty=1)
    }
    
    if(sum(is.na(breaks.atrev))==0){
        graphics::segments(x0=meancoord.rear[breaks.atrev],y0=rearat[breaks.atrev]-(ymax-ymin)/30,x1=meancoord.rear[breaks.atrev],y1=rearat[breaks.atfw]+(ymax-ymin)/30,col="red",lwd=2,lty=1)
    }
    
}

##
# This function tests if a region located between two stop codons could be a putative CDS
#
# Data used are the factor scores of the CA computed on the windows by recstat function
##
#v.18.08.2011
test.co.recstat <- function(rec, fac = 1, length.min = 150, stop.max = 0.2, win.lim = 0.8, direct = TRUE, level = 0.01) 
{
    if (fac < 0 | 4 < fac) 
    { # test if factor is between 1 and 4
        print("Factor number is not in 1:4.")
        return()
    }
    seq <- rec[[1]] # recovery of elements of list n
    sizewin <- rec[[2]]
    shift <- rec[[3]]
    seqsize <- rec[[4]]
    vstopd <- rec[[8]]
    vstopr <- rec[[9]]
    resd <- rec[[12]]
    resr <- rec[[13]]
    recd <- rec[[14]]
    recr <- rec[[15]]
    if (seqsize < length.min)
    {
        print("Seqence length is shorter than minimum distance between two Stop codons.")
        return()
    }
    table.recstat <- function(vstop) 
    {
        tabCDS <- numeric() # initialization
        j <- 0
        for (i in 2:length(vstop)) 
        { # for each stop codons positions vector
            if ((vstop[i] - vstop[i - 1]) > length.min) 
            { # test if space between codons is above the threshold
                # in each case gets the p-values between each stop codon and range it in vector seg
                seg <- pvalvec[which((vstop[i - 1] - pvalvec[, 2])/(sizewin + 2) <= stop.max &
                                         (vstop[i] - pvalvec[, 2])/(sizewin + 2) >= (1 - stop.max)), 1]
                # create a table with calculation on those vectors seg then go to next space inter-codon, each row correspond to a space inter-stop codon
                k <- 0
                for (l in 1:length(seg)) 
                {
                    if (seg[l] < level) 
                    {
                        k <- k + 1
                    }     
                    if (k/length(seg) > win.lim) 
                    {
                        result <- 1
                    } 
                    else 
                    {
                        result <- 0
                    }
                }
                tabCDS <- c(tabCDS, vstop[i - 1]+3, vstop[i]+2, result)
                j <- j + 1
            }
        }
        tabCDS <- matrix(tabCDS, nrow = j, ncol = 3, byrow = TRUE) # conversion list to table
        return(tabCDS)
    }
    ##
    ##direct strand##
    ##
    if (direct) 
    { 
        vstopdindphase <- numeric()
        if (length(vstopd) > 0) 
        { # test if vector is not empty because problem with modulo
            vstopdindphase <- sapply(1:length(vstopd), function(x)
            { # index vector of reading frame of vector vstopd
                if (vstopd[x]%%3 == 1) 
                {
                    vstopdindphase <- c(vstopdindphase, 1)
                } 
                else 
                {
                    if (vstopd[x]%%3 == 2) 
                    {
                        vstopdindphase <- c(vstopdindphase, 2)
                    } 
                    else 
                    {
                        vstopdindphase <- c(vstopdindphase, 3)
                    }
                }
            })
        }
        vstop1 <- vstopd[vstopdindphase == 1] # vector with only stop codons in reading frame 1
        vstop2 <- vstopd[vstopdindphase == 2] # vector with only stop codons in reading frame 2
        vstop3 <- vstopd[vstopdindphase == 3] # vector with only stop codons in reading frame 3
        vstop1 <- c(vstop1, 1-3, seqsize-(seqsize%%3)-2) # add start and end positions, "-3" and "-2" because of table.recstat()
        vstop2 <- c(vstop2, 2-3, seqsize-((seqsize-1)%%3)-2)
        vstop3 <- c(vstop3, 3-3, seqsize-((seqsize-2)%%3)-2)
        vstop1 <- sort(unique(vstop1)) # sort of the vector
        vstop2 <- sort(unique(vstop2))
        vstop3 <- sort(unique(vstop3))
        tab <- numeric()
        for (i in 1:dim(resd)[1]) 
        {
            if (sum(resd[i, ]) == sizewin/3) 
            {
                for (j in 1:64) 
                {
                    tab <- c(tab, rep(recd$co[j, 1], resd[i, j]))
                }
            } 
        }
        tab <- matrix(unlist(tab), byrow = TRUE, ncol = sizewin/3)
        seqisize <- floor((dim(tab)[1])/3)
        phase <- c(rep(1, sizewin/3), rep(2, sizewin/3), rep(3, sizewin/3))
        phase <- as.factor(phase)
        pvalvec <- numeric()
        for (i in 1:seqisize) 
        {
            v1 <- tab[i,]
            v2 <- tab[seqisize + i,]
            v3 <- tab[2*seqisize + i,]
            v <- c(v1, v2, v3)
            x <- stats::kruskal.test(v ~ phase)$p.value
            pvalvec <- c(pvalvec, x, (i - 1)*shift + 1)
        }
        pvalvec <- matrix(unlist(pvalvec), byrow = TRUE, ncol = 2)
        #    	plot((sizewin/2) + (0:(seqisize - 1))*shift + 1, pvalvec[,1], type = "l")
        tab1 <- table.recstat(vstop1)
        colnames(tab1) <- c("Start", "End", "CDS") # definition of table headings
        tab2 <- table.recstat(vstop2)
        colnames(tab2) <- c("Start", "End", "CDS")
        tab3 <- table.recstat(vstop3)
        colnames(tab3) <- c("Start", "End", "CDS")
        return(list(tab1, tab2, tab3))
    }
    ##
    ##reverse strand##
    ##
    if (!direct) 
    { 
        vstoprindphase <- numeric()
        if (length(vstopr) > 0) 
        { 
            vstoprindphase <- sapply(1:length(vstopr), function(x)
            { 
                if (vstopr[x]%%3 == 1) 
                {
                    vstoprindphase <- c(vstoprindphase, 1)
                } 
                else 
                {
                    if (vstopr[x]%%3 == 2) 
                    {
                        vstoprindphase <- c(vstoprindphase, 2)
                    } 
                    else 
                    {
                        vstoprindphase <- c(vstoprindphase, 3)
                    }
                }
            })
        }
        vstop1 <- vstopr[vstoprindphase == 1] 
        vstop2 <- vstopr[vstoprindphase == 2] 
        vstop3 <- vstopr[vstoprindphase == 3] 
        vstop1 <- c(vstop1, 1-3, seqsize-(seqsize%%3)-2) # add start and end positions
        vstop2 <- c(vstop2, 2-3, seqsize-((seqsize-1)%%3)-2)
        vstop3 <- c(vstop3, 3-3, seqsize-((seqsize-2)%%3)-2)
        vstop1 <- sort(unique(vstop1)) 
        vstop2 <- sort(unique(vstop2))
        vstop3 <- sort(unique(vstop3))
        tab <- numeric()
        for (i in 1:dim(resr)[1]) 
        {
            if (sum(resr[i, ]) == sizewin/3) 
            {
                for (j in 1:64) 
                {
                    tab <- c(tab, rep(recr$co[j, 1], resr[i, j]))
                }
            } 
        }
        tab <- matrix(unlist(tab), byrow = TRUE, ncol = sizewin/3)
        seqisize <- floor((dim(tab)[1])/3)
        phase <- c(rep(1, sizewin/3), rep(2, sizewin/3), rep(3, sizewin/3))
        phase <- as.factor(phase)
        pvalvec <- numeric()
        for (i in 1:seqisize) 
        {
            v1 <- tab[i,]
            v2 <- tab[seqisize + i,]
            v3 <- tab[2*seqisize + i,]
            v <- c(v1, v2, v3)
            x <- stats::kruskal.test(v ~ phase)$p.value
            pvalvec <- c(pvalvec, x, (i - 1)*shift + 1)
        }
        pvalvec <- matrix(unlist(pvalvec), byrow = TRUE, ncol = 2)
        tab1 <- table.recstat(vstop1)
        colnames(tab1) <- c("Start", "End", "CDS") # definition of table headings
        tab2 <- table.recstat(vstop2)
        colnames(tab2) <- c("Start", "End", "CDS")
        tab3 <- table.recstat(vstop3)
        colnames(tab3) <- c("Start", "End", "CDS")
        return(list(tab1, tab2, tab3))
    }
}

dotchart.uco <- function(x, numcode = 1, aa3 = TRUE, pt.cex = 0.7, 
                         alphabet = s2c("tcag"), pch = 21, gpch = 20, bg = par("bg"), cex = 0.7,
                         color = "black", gcolor = "black", lcolor = grey(0.9), xlim, 
                         offset = 0.4, ...)
{
    if( is.null(names(x)) ) names(x) <- words( alphabet = alphabet )
    bcknames <- names(x)
    x <- as.numeric(x)
    names(x) <- bcknames
    #
    # General sorting 
    #
    x <- sort(x)
    labels <- names(x)
    stringlabel = paste(labels, sep = "", collapse = "")
    groups <- as.factor(translate(s2c(stringlabel), numcode =  numcode))
    gdata <- sapply(split(x, groups), sum)
    #
    # Now, sorting by aa order
    #
    gordered <- rank(gdata)
    xidx <- numeric(64)
    
    for( i in seq_len(64) )
    {
        xidx[i] <- -0.01*i + gordered[groups[i]]
    }
    
    x <- x[order(xidx)]
    labels <- names(x)
    stringlabel = paste(labels, sep = "", collapse = "")
    aa <- translate(s2c(stringlabel), numcode =  numcode)
    groups <- factor(aa, levels = unique(aa))
    gdata <- sapply(split(x, groups), sum)
    
    if( missing(xlim) ) xlim <- c(0, max(gdata))
    if( aa3 ) levels(groups) <- aaa(levels(groups))
    
    graphics::dotchart(x = x, labels = labels, groups = groups, gdata = gdata,
             pt.cex = pt.cex, pch = pch, gpch = gpch, bg = bg, color = color,
             gcolor = gcolor, lcolor = lcolor, cex = cex, xlim = xlim, 
             offset = offset, ...)
    #
    # Return invisibly for further plots
    #
    result <- list(0)
    #
    # Sorting according to groups for nicer results
    #
    aordered = rank(groups)
    x <- x[order(aordered)]
    labels <- labels[order(aordered)]
    groups <- groups[order(aordered)]
    
    result$x <- x
    result$labels <- labels
    result$groups <- groups
    result$gdata <- gdata
    
    ypg <- numeric( length(levels(groups)) )
    i <- 1
    for( aa in levels(groups) )
    {
        ypg[i] <- length(which(groups == aa)) + 2
        i <- i + 1
    }
    ypg <- rev(cumsum(rev(ypg))) - 1
    names(ypg) <- levels(groups)
    result$ypg <- ypg
    
    ypi <- numeric( length(x) )
    for( i in seq_len(length(x)) )
    {
        ypi[i] <- ypg[groups[i]]
    }
    antirank <- function(x) 
    {
        return( seq(length(x),1,by=-1 ))
    }
    ypi <- ypi - unlist(sapply(split(x, groups),antirank))
    names(ypi) <- labels
    result$ypi <- ypi
    
    return( invisible(result) ) 
}

#
# Genetic code table as in Text Books
#

tablecode <- function(numcode = 1, urn.rna = s2c("TCAG"), dia = FALSE,
                      latexfile = NULL, label = latexfile, size = "normalsize", caption = NULL,
                      preaa = rep("", 64), postaa = rep("", 64), 
                      precodon = preaa, postcodon = postaa)
{
    aa1 <- a()
    aa3 <- aaa()
    codename <- SEQINR.UTIL$CODES.NCBI[numcode, "ORGANISMES"]
    urn <- s2c("tcag") # internal
    #
    # Make default caption for LaTeX table:
    #
    if( is.null(caption) ){
        caption <- paste("\\caption{Genetic code number ", 
                         numcode, ": ", codename, ".}", sep = "")
    }
    #
    # As a LaTex table:
    #  
    if( ! is.null(latexfile) ) {
        Tfile <- file(latexfile, open = "w")
        cat("\\begin{table}", file = Tfile, sep = "
")
        cat("\\begin{center}", file = Tfile, sep = "
")
        #
        # Character size:
        #
        cat(paste("{\\", size, sep = ""), file = Tfile, sep = "
")
        
        cat("\\begin{tabular}{*{13}{l}}", file = Tfile, sep = "
")
        cat("\\hline", file = Tfile, sep = "
")
        cat("\\\\", file = Tfile, sep = "
")
        
        ncodon <- 1 # codon rank as in
        #paste(paste(rep(s2c("tcag"), each = 16), s2c("tcag"), sep = ""), rep(s2c("tcag"), each = 4), sep = "")
        for( i in 0:3 )
        {
            for( j in 0:3 )
            {
                for( k in 0:3 )
                {
                    codon <- c(urn[i+1], urn[k+1], urn[j+1])
                    codon.urn <- paste(urn.rna[i+1], urn.rna[k+1], urn.rna[j+1], sep = "", collapse = "")
                    codon.urn <- paste(precodon[ncodon], codon.urn, postcodon[ncodon], sep = "")
                    
                    aminoacid <- aa3[which(aa1 == translate(codon, numcode = numcode))]
                    aminoacid <- paste(preaa[ncodon], aminoacid, postaa[ncodon], sep = "")
                    
                    cat(paste(codon.urn, aminoacid, " &", sep = " & "), file = Tfile, sep = "
")
                    ncodon <- ncodon + 1
                }
                cat("\\\\", file = Tfile, sep = "
")
            }
            cat("\\\\", file = Tfile, sep = "
")
        }
        cat("\\hline", file = Tfile, sep = "
")
        cat("\\end{tabular}", file = Tfile, sep = "
")
        #
        # Caption:
        #
        cat(caption, file = Tfile, sep = "
")
        #
        # LaTeX label:
        #
        cat(paste("\\label{", label, "}", sep = ""), file = Tfile, sep = "
")
        #
        # End character size:
        #
        cat("}", file = Tfile, sep = "
")
        
        cat("\\end{center}", file = Tfile, sep = "
")
        cat("\\end{table}", file = Tfile, sep = "
")
        close(Tfile)
        return(invisible(NULL))
    }
    #
    # END LATEX
    #
    if( dia )
    {  
        op <- graphics::par(no.readonly = TRUE)
        graphics::par(bg = "blue")
        graphics::par(fg = "yellow")
        graphics::par(col = "yellow")
        graphics::par(col.axis = "yellow")
        graphics::par(col.lab = "yellow")
        graphics::par(col.main = "yellow")
        graphics::par(col.sub = "yellow")
    }
    
    graphics::plot.new()
    graphics::plot.window(xlim=c(0,100),ylim=c(0,100))
    
    graphics::segments( 0, 102, 100, 102, lwd = 2)
    graphics::segments( 0, 0, 100, 0, lwd = 2)
    graphics::segments( 0, 97, 100, 97)
    
    
    graphics::text(x=0, y = 98.5, font = 2, adj = c(0, 0),
         lab = paste("Genetic code", numcode,":",codename))
    
    urn <- c("t","c","a","g") # internal
    for( i in 0:3 )
    {
        for( j in 0:3 )
        {
            for( k in 0:3 )
            {
                codon <- c(urn[i+1], urn[j+1], urn[k+1])
                
                graphics::text( x = 100*j/4, y = 95 - 100*i/4 -5*k, adj = c(-0.5,1.5),
                      lab = urn.rna[i+1] )
                
                graphics::text( x = 100*j/4 + 3, y = 95 - 100*i/4 -5*k, adj = c(-0.5,1.5),
                      lab = urn.rna[j+1] )
                
                graphics::text( x = 100*j/4 + 6, y = 95 - 100*i/4 -5*k, adj = c(-0.5,1.5),
                      lab = urn.rna[k+1] )
                
                aminoacid <- aa3[which(aa1 == translate(codon, numcode = numcode))]
                graphics::text( x = 100*j/4 + 12, y = 95 - 100*i/4 -5*k, adj = c(-0.5,1.5),
                      lab =  aminoacid )
            }
        }
    }
    if(dia)
        graphics::par(op)
}

###################################################################################################
#                                                                                                 #
#                              readfirstrec                                                       #
#                                                                                                 #
#                Returns the record count of the specified ACNUC index file.                      #                                                                                                 #
#                                                                                                 #
# ==>   readfirstrec&type=[AUT|BIB|ACC|SMJ|SUB|LOC|KEY|SPEC|SHRT|LNG|EXT|TXT]                     #
# <==  code=xx&count=xx                                                                           #
# Returns the record count of the specified ACNUC index file.                                     #
# Code != 0 indicates error.                                                                      #
#                                                                                                 #
###################################################################################################

readfirstrec <- function(socket = autosocket(), type)
{
    allowedtype <- c("AUT", "BIB", "ACC", "SMJ", "SUB", "LOC", "KEY", "SPEC", 
                     "SHRT", "LNG", "EXT", "TXT")
    if(missing(type)){
        return(allowedtype)
    }
    #
    # Build the request:
    #
    request <- paste("readfirstrec&type=", type, sep = "", collapse = "")
    #
    # Send request:
    #
    writeLines(request, socket, sep = "\n") 
    #
    # Read answer from server:
    #
    
    s <- readLines(socket, n = 1)
    rep <- parser.socket(s)
    
    #
    # Check answer from server:
    #
    if(rep[1] != "0"){
        warning("Server returns an error")
        return(NA)
    } else {
        return(as.numeric(rep[2]))
    }
}

kaks <- function(x, verbose = FALSE, debug = FALSE, forceUpperCase = TRUE, rmgap = TRUE){
    #
    # Check argument class:
    #
    if(attr(x,"class") != "alignment") stop("object x must be of class alignment")
    if(debug){
        cat("<--- Argument x storage is --->\n")
        print(utils::str(x))
        cat("<--- Argument x storage is --->\n")
    }
    #
    # Check that there are at least two sequences in the alignment:
    #
    if(x$nb < 2){
        warning("there should be at least two sequences in the alignment")
        return(NA)
    }
    #
    # Check that all sequences are of the same length:
    #
    lseqs <- nchar(x$seq)
    if( !all(lseqs == lseqs[1])) {
        warning("all sequences should be the same length in an alignment")
        return(NA)
    }
    #
    # Check that the length of sequences is a mutiple of 3 since we are dealing
    # with coding sequences here:
    #
    if( lseqs[1] %% 3 != 0){
        warning("sequence lengths are not a multiple of 3")
        return(NA)
    }
    #
    # Force sequences characters to upper case letters when at least one
    # one 'a', 'c', 'g', or 't' is found in the sequences:
    #
    if(forceUpperCase){
        if( length(grep("[acgt]", x$seq)) != 0){
            x$seq <- toupper(x$seq)
        }
    }
    #
    # Choose option for gap removal
    #
    if(rmgap) {
        gaprm = 0 # positions with at least one gap are removed
    } else {
        gaprm = 1 # only all gap positions are removed
    }
    #
    # Call internal C function:
    #
    l <- .Call("kaks", x$seq, x$nb, debug, gaprm, PACKAGE = "seqinr")
    if(debug){
        cat("<--- Result l storage is --->\n")
        print(utils::str(l))
        print (l)
        cat("<--- Result l storage is --->\n")
    }
    #
    # If the sequences names are missing, we call them seq1, seq2, and so on:
    #
    if( is.null(x$nam) ) x$nam <- paste("seq", seq_len(x$nb), sep = "")
    
    #
    # This is to compute the list of results:
    #
    mkresult <- function(k){
        tmp <- matrix( k, x$nb, x$nb, byrow = TRUE, dimnames = list(x$nam, x$nam))
        stats::as.dist(t(tmp))
    }
    #result <- lapply(l[seq_len(4)], mkresult)
    if (verbose)	
    {
        result <- lapply(l[seq_len(13)], mkresult)
        check <- result[[5]] + result[[6]] +  result[[7]]
        result[[14]] <-check
        names(result) <- c("ka", "ks", "vka", "vks","l0","l2","l4","a0","a2","a4", "b0","b2","b4","checksuml")
        return(result)
    }
    else
    {
        result <- lapply(l[seq_len(4)], mkresult)
        names(result) <- c("ka", "ks", "vka", "vks")
        return(result)
    }
}

plotladder <- function(abifdata, chanel, calibr, allele.names = "identifiler", npeak = NULL, ...){
    old.par <- graphics::par(no.readonly = TRUE)
    on.exit(graphics::par(old.par))
    
    utils::data(list = allele.names,envir=environment())
    tmp <- get(allele.names)[chanel]
    
    if(is.null(npeak)) npeak <- length(unlist(tmp))
    x <- calibr(peakabif(abifdata, chanel, npeak = npeak, ...)$maxis)
    n <- length(x)
    
    graphics::par(mfrow = c(1,1), mar = c(5,0,4,0)+0.1)
    
    labels <- unlist(tmp)
    col <-  rep("black", n)
    col[grep("\\.", labels)] <- "red"
    y <- rep(1.1, n)
    y[grep("\\.", labels)] <- 1.3
    
    dyn <- abifdata$Data[[paste("DyeN", chanel, sep = ".")]]
    main <- paste(abifdata$Data[["RunN.1"]], "\nwith fluorochrome", dyn)
    main <- paste("Observed allelic ladder for", main)
    
    graphics::plot(x, y, type = "h", ylim = c(0,1.5), col = col, yaxt = "n", ylab = "",
         xlab = "Observed size [bp]", main = main)
    graphics::text(x, y + 0.1, labels, srt = 90, col = col)
    
    nlocus <- unlist(lapply(tmp, length))
    nallploc <- unlist(lapply(tmp,function(x) sapply(x,length)))
    loc.pos <- c(1, cumsum(nallploc[1:(nlocus-1)])+1)
    locnames <- unlist(lapply(tmp, names))
    graphics::rect(x[loc.pos], rep(0.4, nlocus), x[cumsum(nallploc)], rep(0.6, nlocus), col = "lightblue")
    graphics::text(x[loc.pos], 0.5, locnames, pos = 4)
    invisible(x)
}

########################################################################
#                        get.ncbi
#
# Try to connect to ncbi to get a list of complete bacterial genomes.
# Returns an n by 5 dataframe with 
#   species names
#   accesion number
#   size in bp
#   type (chromosome or plasmid)
#   Last update time
#
#########################################################################
get.ncbi <- function(repository = "ftp://ftp.ncbi.nih.gov/genomes/Bacteria/"  )
{
  #
  # First of all, check that this computer is not off the net:
  #
  if( ! capabilities("http/ftp") )
    stop("capabilities(\"http/ftp\") is not TRUE") 

#  
# BEGIN Proxy problem
#
# I have a problem here: the ftp connection apparently does
# not work when there is a proxy. I have fixed the bug
# this way, but this is a rather crude and unsatisfactory
# solution.
#
  ftp.proxy.bck <- Sys.getenv("ftp_proxy")

  if( ftp.proxy.bck != "" ) # there is a proxy
  {
    warning("I'am trying to neutralize proxies")
    Sys.setenv("no_proxy" = "") 
  }
#
# END Proxy problem
#  

  #
  # Try to get list of folder in ncbi repository. Note that R build-in ftp
  # does not allow to do this directly, so we rely on a system call that
  # will run only under Unix systems. Moreover, not all ftp client supports
  # this syntax. 
  #
  sysinfo <- Sys.info()[1]

  if( sysinfo == "Darwin" )
  {
    cmd <- sprintf("echo \"ls\" | ftp %s", repository)
    brut <- readLines(pipe(cmd))
  }
  else if( sysinfo == "SunOS" )
  {
    #
    # Build command file for ftp connection
    #
    tmpname <- tempfile(pattern="getncbi")
    tmpcmdfile <- file(tmpname, open="w")
    writeLines("user anonymous seqteam@biomserv.univ-lyon1.fr", tmpcmdfile)
    writeLines("cd genomes/Bacteria", tmpcmdfile)
    writeLines("dir", tmpcmdfile)
    writeLines("bye", tmpcmdfile)
    close(tmpcmdfile)
    #
    hostname <- unlist(strsplit(repository,split="/"))[3]
    cmd <- sprintf("ftp -v -n %s < %s", hostname, tmpname)
    brut <- readLines(pipe(cmd))
  }
  else if( sysinfo == "Linux" ){
    #
    # Build command file for ftp connection
    #
    tmpname <- tempfile(pattern="getncbi")
    tmpcmdfile <- file(tmpname, open="w")
    writeLines("user anonymous seqteam@biomserv.univ-lyon1.fr", tmpcmdfile)
    writeLines("cd genomes/Bacteria", tmpcmdfile)
    writeLines("dir", tmpcmdfile)
    writeLines("bye", tmpcmdfile)
    close(tmpcmdfile)
    #
    hostname <- unlist(strsplit(repository,split="/"))[3]
    cmd <- sprintf("ftp -v -n %s < %s", hostname, tmpname)
    brut <- readLines(pipe(cmd))

  }
  else
  {
    stop("Unimplemented platform")
  } 

  #
  # Keep only lines corresponding to folders:
  #
  brut <- brut[grep("dr-xr-xr-x", brut)]


  #
  # Now there should be a vector of chr in "brut", each line looking like:
  #
  # "dr-xr-xr-x   2 ftp      anonymous     4096 Jul 15 15:41 Aeropyrum_pernix"
  #

  brut <- sapply( brut, strsplit, split=" ")
  names(brut) <- NULL

  #
  # Now each element in "brut" should be splited as in:
  #
  # [1] "dr-xr-xr-x"       ""                 ""                 "2"               
  # [5] "ftp"              ""                 ""                 ""                
  # [9] ""                 ""                 "anonymous"        ""                
  # [13] ""                 ""                 ""                 "4096"            
  # [17] "Jul"              "15"               "15:41"            "Aeropyrum_pernix"
  #

  get.last <- function( vector )
  {
    return( vector[length(vector)] )
  }
  brut <- sapply( brut, get.last)
  if(length(grep("CLUSTERS",brut))!=0){
    brut<-brut[-grep("CLUSTERS",brut)]  # we remove the CLUSTERS folder, since it doesn't contain any annotated bacterial genomes
  }
  
  #
  # Now "brut" should contains folders names as in:
  # > brut[1:5]
  # [1] "Aeropyrum_pernix"                     
  # [2] "Agrobacterium_tumefaciens_C58_Cereon" 
  # [3] "Agrobacterium_tumefaciens_C58_UWash"  
  # [4] "Aquifex_aeolicus"                     
  # [5] "Archaeoglobus_fulgidus"               
  #

  #
  # Set vector types for results:
  #
  
  species <- character(0)
  accession <- character(0)
  size.bp <- integer(0)
  type <- character(0)
  lastupdate <- character(0)

  #
  # Main loop on folders to see what's inside
  #
  for( folder in brut )
  {
    if( sysinfo == "Darwin" )
    {
      where <- paste(repository, folder, "/", sep="", collapse="")
      cmd <- sprintf("echo \"ls\" | ftp %s", where)
      whatsin <- readLines(pipe(cmd))
      closeAllConnections()
    }
    else if( sysinfo == "SunOS" )
    {
      # Build command file for ftp connection:
      tmpname <- tempfile(pattern="getncbi")
      tmpcmdfile <- file(tmpname, open="w")
      writeLines("user anonymous seqteam@biomserv.univ-lyon1.fr", tmpcmdfile)
      writeLines(sprintf("cd genomes/Bacteria/%s", folder), tmpcmdfile)
      writeLines("dir", tmpcmdfile)
      writeLines("bye", tmpcmdfile)
      close(tmpcmdfile)
      #
      hostname <- unlist(strsplit(repository,split="/"))[3]
      cmd <- sprintf("ftp -v -n %s < %s", hostname, tmpname)
      whatsin <- readLines(pipe(cmd))
    }
    else if( sysinfo=="Linux"){
      # Build command file for ftp connection:
      tmpname <- tempfile(pattern="getncbi")
      tmpcmdfile <- file(tmpname, open="w")
      writeLines("user anonymous seqteam@biomserv.univ-lyon1.fr", tmpcmdfile)
      writeLines(sprintf("cd genomes/Bacteria/%s", folder), tmpcmdfile)
      writeLines("dir", tmpcmdfile)
      writeLines("bye", tmpcmdfile)
      close(tmpcmdfile)
      #
      hostname <- unlist(strsplit(repository,split="/"))[3]
      cmd <- sprintf("ftp -v -n %s < %s", hostname, tmpname)
      whatsin <- readLines(pipe(cmd))
    }
    else
    {
      stop("unimplemented platform")
    }
    whatsin <- whatsin[ grep("\\.gbk", whatsin)] # Keep only files with ".gbk" extension
    #
    # Remove backup files with % extension:
    #
    for( i in seq_len(length(whatsin)) )
      if( substr(whatsin[i], nchar(whatsin[i]), nchar(whatsin)[i]) == "%" )
        is.na(whatsin[i]) <- TRUE
    whatsin <- whatsin[!is.na(whatsin)]
    
    for( i in seq(from=1, to=length(whatsin), by=1 )) # Loop on sequences data
    {
      #
      # Try to get the accession number of this entry:
      #
      accname <- unlist(strsplit(whatsin[i], split=" "))
      accname <- accname[length(accname)]
      accname <- unlist(strsplit(accname, split="\\."))
      accname <- accname[1] # The accession number should be in this variable
      #
      # Try to get the size of this entry:
      #
      entry <- paste(repository, folder, "/", accname, ".gbk", sep="", collapse="")
      header <- readLines(entry, n=2)
      closeAllConnections()
      bp <- unlist(strsplit(header[1], split=" "))
      bp <- bp[nchar(bp) > 0]
      bp <- bp[3] # size in bp should be there
      #
      # Try to get the last update date of this entry
      #
      last <- unlist(strsplit(header[1], split=" "))
      last <- last[nchar(last) > 0]
      last <- last[length(last)] # last update time should be there

      #
      # Try to get the type (chromosome versus plasmid) of this entry:
      #
      if( length(grep("plasmid", tolower(header[2]))) != 0 )
        def <- "plasmid"
      else if(length(grep("chromosome", tolower(header[2]))) != 0)
        def <- "chromosome"
      else if(length(grep("genome", tolower(header[2]))) != 0)
        def <- "chromosome"
      else
        def <- NA
      #
      # Begin the human curated part:
      #
      if( accname == "NC_002528" ) def <- "chromosome"
      if( accname == "NC_003454" ) def <- "chromosome"
      if( accname == "NC_001732" ) def <- "plasmid"
      if( accname == "NC_001733" ) def <- "plasmid"
      if( accname == "NC_005042" ) def <- "chromosome"
      if( accname == "NC_005072" ) def <- "chromosome"
      if( accname == "NC_004631" ) def <- "chromosome"
      if( accname == "NC_004344" ) def <- "chromosome"
      if( accname == "NC_003902" ) def <- "chromosome"
      if( accname == "NC_005957" ) def <- "chromosome"
      if( accname == "NC_007984" ) def <- "chromosome"
      if( accname == "NC_002937" ) def <- "chromosome"
      if( accname == "NC_005863" ) def <- "plasmid"
      if( accname == "NC_008054" ) def <- "chromosome"
      if( accname == "NC_002942" ) def <- "chromosome"
      if( accname == "NC_005823" ) def <- "chromosome"
      if( accname == "NC_005824" ) def <- "chromosome"
      if( accname == "NC_000916" ) def <- "chromosome"
      if( accname == "NC_007633" ) def <- "chromosome"
      if( accname == "NC_006855" ) def <- "plasmid"
      if( accname == "NC_006856" ) def <- "plasmid"
      if( accname == "NC_006905" ) def <- "chromosome"
      if( accname == "NC_006511" ) def <- "chromosome"
      if( accname == "NC_003198" ) def <- "chromosome"
      if( accname == "NC_007350" ) def <- "chromosome"
      if( accname == "NC_007351" ) def <- "plasmid"
      if( accname == "NC_007352" ) def <- "plasmid"
      if( accname == "NC_003425" ) def <- "plasmid"
      if( accname == "NC_006833" ) def <- "chromosome"
      if( accname == "NC_006810" ) def <- "chromosome"
      if( accname == "NC_008529" ) def <- "chromosome"
      if( accname == "NC_008531" ) def <- "chromosome"
      if( accname == "NC_008346" ) def <- "chromosome"
      if( accname == "NC_008800" ) def <- "chromosome"
            
            

      
      #
      # Concatenate results:
      #
      species <- c(species, folder)
      accession <- c( accession, accname)
      size.bp <- c(size.bp, as.integer(bp))
      lastupdate <- c(lastupdate, last)
      type <- c(type, def)
      cat("\n",folder,accname,bp,def,last,"\n")
    }
  }

# shouldn't ftp_proxy be restored there ?
  return(data.frame(I(species), I(accession), size.bp, type, I(lastupdate)))
}




########################################################################
#             ncbi.fna.url 
#
#  Try to build urls to access complete genome sequences data
#  in fasta format from get.ncbi() output
#
########################################################################

ncbi.fna.url <- function( get.ncbi.out = get.ncbi() )
{
  build.url <- function( x )
  {
    ficname <- unlist(strsplit(x[2],"\\.")) # split prefix and suffix
    ficname <- ficname[1] # keep prefix
    ficname <- paste( ficname, ".fna", collapse="", sep="")
    urlname <- paste("ftp://ftp.ncbi.nih.gov/genomes/Bacteria/", x[1],
                 "/",ficname, collapse="", sep="")
    return(urlname)
  }
  apply( get.ncbi.out, 1, build.url )  
}

########################################################################
#
#  Try to build urls to access complete genome sequences data
#  in genbank format from get.ncbi() output
#
########################################################################

ncbi.gbk.url <- function( get.ncbi.out = get.ncbi() )
{
  build.url <- function( x )
  {
    urlname <- paste("ftp://ftp.ncbi.nih.gov/genomes/Bacteria/", x[1],
                 "/",x[2], collapse="", sep="")
    return(urlname)
  }
  apply( get.ncbi.out, 1, build.url )  
}
########################################################################
#  Try to build urls to access complete genome sequences data
#  file *.ptt from get.ncbi() output
#
########################################################################

ncbi.ptt.url <- function( get.ncbi.out = get.ncbi() )
{
  build.url <- function( x )
  {
    ficname <- unlist(strsplit(x[2],"\\.")) # split prefix and suffix
    ficname <- ficname[1] # keep prefix
    ficname <- paste( ficname, ".ptt", collapse="", sep="")
    urlname <- paste("ftp://ftp.ncbi.nih.gov/genomes/Bacteria/", x[1],
                 "/",ficname, collapse="", sep="")
    return(urlname)
  }
  apply( get.ncbi.out, 1, build.url )  
}

########################################################################
#
# Try to get the number of cds and genome size
#
########################################################################

ncbi.stats <- function( get.ncbi.out = get.ncbi() )
{
  gbkurls <- ncbi.gbk.url( get.ncbi.out )
  ptturls <- ncbi.ptt.url( get.ncbi.out )
  get.genome.size <- function( url )
  {
    header <- readLines( url, n = 1 )
    tmp <- unlist(strsplit(header, split=" "))
    tmp <- tmp[nchar(tmp)>0]
    tmp <- tmp[3]
    as.integer(tmp)
  }
  get.n.prot <- function( url )
  {
    lines <- readLines( url, n = 3 )
    lines <- lines[3]
    lines <- unlist(strsplit(lines, split=" "))
    print(lines[1])
    as.integer(lines[1])
  }

  gsize <- sapply( gbkurls, get.genome.size)
  nprot <- sapply( ptturls, get.n.prot )
  data <- data.frame( cbind(get.ncbi.out[,1], gsize, nprot) )
  return( data )
}

##############################################################################
#
# simple numerical encoding of a DNA sequence that by default
# is independent of locale.
#
##############################################################################

s2n <- function(seq, levels = s2c("acgt"), base4 = TRUE, forceToLower = TRUE)
{
    #
    # Check that sequence is a vector of chars:
    #
    if(!is.na(seq[1])){
        if(nchar(seq[1]) > 1) stop("sequence is not a vector of chars")
    }
    #
    # Force to lower-case letters if requested:
    #
    if(forceToLower) seq <- tolower(seq)
    
    if( base4 )
        unclass(factor(seq, levels = levels ) ) - 1
    else
        unclass(factor(seq, levels = levels ) )
}

"permutation" <-
    function (sequence, modele = "base", frame = 0, replace = FALSE, 
              prot = FALSE, numcode = 1, ucoweight = NULL) 
    {
        if (modele == "base") { #modele 1 : permute toutes les bases entre elles
            new <- sample(sequence, replace = replace)
        }
        else if (modele == "position") { #modele 2 : permute les bases en conservant position
            CDSseq <- sequence[(frame + 1):length(sequence)]
            if (length(CDSseq)%%3 != 0) {
                stop("sequence could not be subdivided in codons")
            }
            else {
                seqI <- CDSseq[seq(1, length(CDSseq), by = 3)]
                seqII <- CDSseq[seq(2, length(CDSseq), by = 3)]
                seqIII <- CDSseq[seq(3, length(CDSseq), by = 3)]
                newCDSseq <- as.vector(t(cbind(sample(seqI, replace = replace), 
                                               sample(seqII, replace = replace), sample(seqIII, 
                                                                                        replace = replace))))
            }
            new <- c(sequence[0:frame], newCDSseq)
        }
        else if (modele == "codon") { #modele 3 : permute tous les codons entre eux
            split <- splitseq(sequence, frame) #split in codons (frame=starting position of CDS)
            if (prot == FALSE) {
                new <- c(sequence[0:frame], s2c(c2s(sample(split, 
                                                           replace = replace))), utils::tail(sequence, (length(sequence) - 
                                                                                                     frame)%%3))
            }
            else { #"prot==TRUE" = garder Met et STOP
                l <- length(split)
                new <- c(sequence[0:frame], s2c(c2s(c(split[1], sample(split[2:(l - 
                                                                                    1)], replace = replace), split[l]))), utils::tail(sequence, 
                                                                                                                               (length(sequence) - frame)%%3))
            }
        }
        else if (modele == "syncodon") { #modele 4 : permute/remplace les codons synonymes
            CDSseq <- sequence[(frame + 1):length(sequence)]
            newCDSseq <- synsequence(CDSseq, numcode = numcode, ucoweight = ucoweight)
            new <- c(sequence[0:frame], newCDSseq, utils::tail(sequence, 
                                                        (length(sequence) - frame)%%3))
        }
        return(new)
    }

##
# This function tests if a region located between two stop codons could be a putative CDS
#
# Data used are the factor scores of the CA computed on the windows by recstat function
##
#v.18.08.2011
test.li.recstat <- function(rec, fac = 1, length.min = 150, stop.max = 0.2, direct = TRUE, level = 0.05)
{
    if (fac < 0 | 4 < fac)
    { # test if factor is between 1 and 4
        print("Factor number is not in 1:4.")
        return()
    }
    seq <- rec[[1]] # recovery of elements of list n
    sizewin <- rec[[2]]
    shift <- rec[[3]]
    seqsize <- rec[[4]]
    vdep <- rec[[6]]
    vind <- rec[[7]]
    vstopd <- rec[[8]]
    vstopr <- rec[[9]]
    recd <- rec[[14]]
    recr <- rec[[15]]
    if (seqsize < length.min)
    {
        print("Seqence length is shorter than minimum distance between two Stop codons.")
        return()
    }
    table.recstat <- function(vstop, rec, frame)
    {
        tabCDS <- numeric() # initialization
        j <- 0
        for (i in 2:length(vstop))
        { # for each stop codons positions vector
            if ((vstop[i] - vstop[i - 1]) > length.min)
            { # test if space between codons is above the threshold
                # in each case gets the values between each stop codon for the 3 reading frames and range it in 3 vector seg
                seg1 <- rec$li[which((vstop[i - 1] - vdep[1:seqisize1])/sizewin <= stop.max &
                                         (vstop[i] - vdep[1:seqisize1])/sizewin >= (1 - stop.max)), fac]
                seg2 <- rec$li[(which((vstop[i - 1] - vdep[(seqisize1 + 1):(seqisize1 + seqisize2)])/sizewin <= stop.max
                                      & (vstop[i] - vdep[(seqisize1 + 1):(seqisize1 + seqisize2)])/sizewin >= (1 - stop.max)) + seqisize1), fac]
                seg3 <- rec$li[(which((vstop[i - 1] - vdep[(seqisize1 + seqisize2 + 1):(length(vdep))])/sizewin <= stop.max
                                      & (vstop[i] - vdep[(seqisize1 + seqisize2 + 1):(length(vdep))])/sizewin >= (1 - stop.max)) + seqisize1 + seqisize2), fac]
                # create a table with calculation on those vectors seg then go to next space
                # inter-codon, each row correspond to a space inter-stop codon
                if (frame == 1)
                {
                    test1 <- stats::t.test(seg1, seg2)$p.value
                    test2 <- stats::t.test(seg1, seg3)$p.value
                }
                if (frame == 2)
                {
                    test1 <- stats::t.test(seg2, seg1)$p.value
                    test2 <- stats::t.test(seg2, seg3)$p.value
                }
                if (frame == 3)
                {
                    test1 <- stats::t.test(seg3, seg1)$p.value
                    test2 <- stats::t.test(seg3, seg2)$p.value
                }
                if (test1 < level & test2 < level)
                {
                    result <- 1
                }
                else
                {
                    result <- 0
                }
                tabCDS <- c(tabCDS, vstop[i-1]+3, vstop[i]+2, mean(seg1), mean(seg2), mean(seg3), test1, test2, result)
                j <- j + 1
            }
        }
        tabCDS <- matrix(tabCDS, nrow = j, ncol = 8, byrow = TRUE) # conversion list to table
        return(tabCDS)
    }
    seqisize <- floor((dim(recd$li)[1])/3) # number of window by reading frame, we take the integer part
    if ((dim(recd$li)[1])%%3 == 1) # adaptation of number of window between each reading frame
    {
        seqisize1 <- seqisize + 1 # for fr1
        seqisize2 <- seqisize # for fr2
    }
    if ((dim(recd$li)[1])%%3 == 2)
    {
        seqisize1 <- seqisize + 1
        seqisize2 <- seqisize + 1
    }
    if ((dim(recd$li)[1])%%3 == 0)
    {
        seqisize1 <- seqisize
        seqisize2 <- seqisize
    }
    ##
    ##direct strand##
    ##
    if (direct)
    { 
        vstopdindphase <- numeric()
        if (length(vstopd) > 0)
        { # test if vector is not empty because problem with modulo
            vstopdindphase <- sapply(1:length(vstopd), function(x) { # index vector of reading frame of vector vstopd
                if (vstopd[x]%%3 == 1)
                {
                    vstopdindphase <- c(vstopdindphase, 1)
                }
                else
                {
                    if (vstopd[x]%%3 == 2)
                    {
                        vstopdindphase <- c(vstopdindphase, 2)
                    }
                    else
                    {
                        vstopdindphase <- c(vstopdindphase, 3)
                    }
                }
            })
        }
        vstop1 <- vstopd[vstopdindphase == 1] # vector with only stop codons in reading frame 1
        vstop2 <- vstopd[vstopdindphase == 2] # vector with only stop codons in reading frame 2
        vstop3 <- vstopd[vstopdindphase == 3] # vector with only stop codons in reading frame 3
        vstop1 <- c(vstop1, 1-3, seqsize-(seqsize%%3)-2) # add start and end positions, "-3" and "-2" because of table.recstat()
        vstop2 <- c(vstop2, 2-3, seqsize-((seqsize-1)%%3)-2)
        vstop3 <- c(vstop3, 3-3, seqsize-((seqsize-2)%%3)-2)
        vstop1 <- sort(unique(vstop1)) # sort of the vector
        vstop2 <- sort(unique(vstop2))
        vstop3 <- sort(unique(vstop3))
        tab1 <- table.recstat(vstop1, recd, 1)
        colnames(tab1) <- c("Start", "End", "Mean 1", "Mean 2", "Mean 3", "t(1,2)", "t(1,3)", "CDS")
        tab2 <- table.recstat(vstop2, recd, 2)
        colnames(tab2) <- c("Start", "End", "Mean 1", "Mean 2", "Mean 3", "t(2,1)", "t(2,3)", "CDS")
        tab3 <- table.recstat(vstop3, recd, 3)
        colnames(tab3) <- c("Start", "End", "Mean 1", "Mean 2", "Mean 3", "t(3,1)", "t(3,2)", "CDS")
        return(list(tab1, tab2, tab3))
    }
    ##
    ##reverse strand##
    ##
    if (!direct)
    { 
        vstoprindphase <- numeric()
        if (length(vstopr) > 0)
        { 
            vstoprindphase <- sapply(1:length(vstopr), function(x)
            { 
                if (vstopr[x]%%3 == 1)
                {
                    vstoprindphase <- c(vstoprindphase, 1)
                }
                else
                {
                    if (vstopr[x]%%3 == 2)
                    {
                        vstoprindphase <- c(vstoprindphase, 2)
                    }
                    else
                    {
                        vstoprindphase <- c(vstoprindphase, 3)
                    }
                }
            })
        }
        vstop1 <- vstopr[vstoprindphase == 1] 
        vstop2 <- vstopr[vstoprindphase == 2] 
        vstop3 <- vstopr[vstoprindphase == 3] 
        vstop1 <- c(vstop1, 1-3, seqsize-(seqsize%%3)-2) # add start and end positions
        vstop2 <- c(vstop2, 2-3, seqsize-((seqsize-1)%%3)-2)
        vstop3 <- c(vstop3, 3-3, seqsize-((seqsize-2)%%3)-2)
        vstop1 <- sort(unique(vstop1)) 
        vstop2 <- sort(unique(vstop2))
        vstop3 <- sort(unique(vstop3))
        tab1 <- table.recstat(vstop1, recr, 1)
        colnames(tab1) <- c("Start", "End", "Mean 1", "Mean 2", "Mean 3", "t(1,2)", "t(1,3)", "CDS")
        tab2 <- table.recstat(vstop2, recr, 2)
        colnames(tab2) <- c("Start", "End", "Mean 1", "Mean 2", "Mean 3", "t(2,1)", "t(2,3)", "CDS")
        tab3 <- table.recstat(vstop3, recr, 3)
        colnames(tab3) <- c("Start", "End", "Mean 1", "Mean 2", "Mean 3", "t(3,1)", "t(3,2)", "CDS")
        return(list(tab1, tab2, tab3))
    }
}

gbk2g2.euk <- function(
        gbkfile = system.file("sequences/ame1.gbk", package = "seqinr"), g2.coord = "g2.coord")
{
    input <- readLines(gbkfile)
    outfile <- file( description = g2.coord, open ="w+")
    
    
    #
    # Keep lines with annotation flag:
    #
    
    cds <- which(substring(input,1,8) == "     CDS")
    
    features <- which(substr(input,6,6)!=" ")
    
    features <- c(features,length(input))
    
    genes <- which(substr(input,22,26)=="/gene")
    
    genes.cds <- character(length(cds))
    
    for(i in seq_len(length(cds))){
        print(i)
        this.gene=genes[which(genes>cds[i])[1]]
        
        nextfeat=features[which(features>cds[i])[1]]
        
        if(this.gene<nextfeat){
            genes.cds[i]=unlist(strsplit(input[this.gene],split="\""))[2]
            
        }
        else{
            print(paste("no id for cds #",i))
        }
        
    }
    
    
    #
    # Extract boundaries strings
    #
    get.boundaries <- function( index.line )
    {
        
        join <- grep("join",input[index.line])
        
        if(length(join)>0){ ## there are introns !!
            
            
            end.par <- grep("\\)",input[index.line])
            
            
            if(length(end.par)==0){ ## the exons are written on more than one line
                
                next.end.par <-grep("\\)",input)
                next.end.par <-next.end.par[which(next.end.par>index.line)[1]] ## we take the first ending parenthesis
                exons <- paste(input[index.line],paste(substr(input[(index.line+1):next.end.par],22,nchar(input[(index.line+1):next.end.par])),sep="",collapse=""),collapse="",sep="")
            }
            else{
                exons <- input[index.line]
            }
            
            
            
            
            complement <- grep("complement",exons)
            
            if(length(complement)==0){
                
                exons=unlist(strsplit(exons, split="\\("))[2]
                exons=unlist(strsplit(exons, split="\\)"))[1]
                
                exons=unlist(strsplit(exons,split=","))
                exons.begin=unlist(lapply(exons, function(x) unlist(strsplit(x, split="\\.\\."))[1]))
                exons.end=unlist(lapply(exons, function(x) unlist(strsplit(x, split="\\.\\."))[2]))
                
                
                
            }
            
            else{
                exons=unlist(strsplit(exons, split="\\("))[3]
                exons=unlist(strsplit(exons, split="\\)"))[1]
                
                exons=unlist(strsplit(exons,split=","))
                exons.end=unlist(lapply(exons, function(x) unlist(strsplit(x, split="\\.\\."))[1]))
                exons.begin=unlist(lapply(exons, function(x) unlist(strsplit(x, split="\\.\\."))[2]))
                
                
                
            }
        }
        else{
            complement <- grep("complement",input[index.line])
            
            exons=unlist(strsplit(input[index.line],split=" "))
            exons=exons[exons!=""]
            exons=exons[2]
            
            if(length(complement)==0){
                exons.begin=unlist(strsplit(exons, split="\\.\\."))[1]
                exons.end=unlist(strsplit(exons, split="\\.\\."))[2]
                
            }
            else{
                exons=unlist(strsplit(exons, split="\\("))[2]
                exons=unlist(strsplit(exons, split="\\)"))[1]
                exons.begin=unlist(strsplit(exons, split="\\.\\."))[2]
                exons.end=unlist(strsplit(exons, split="\\.\\."))[1]
            }
            
        }
        
        
        return(list(exons.begin,exons.end))
        
        
    }
    
    
    
    
    
    
    already=character(0)
    
    if(length(cds)>0){
        for(i in seq_len(length(cds))){
            
            boundaries=get.boundaries(cds[i])
            exons.begin=boundaries[[1]]
            exons.end=boundaries[[2]]
            
            
            
            for(j in seq_len(length(exons.begin))){
                phrase=paste(genes.cds[i],exons.begin[j],exons.end[j])
                
                if(!phrase%in%already){
                    writeLines(paste(genes.cds[i],exons.begin[j],exons.end[j],sep=" "),outfile)
                    already=c(already,phrase)
                }
            }
        }
        
    } 
    
    
    
    close(outfile)
    
}

# ==>  savelist&lrank=xx{&type=[N|A]}
# <==  code=0\n
# list element names or acc nos on successive lines
# savelist END.\n
# To obtain names of all elements of a bit list sent on socket on successive lines;
# for sequence lists, option &type=A, will give accession numbers instead of seq names;
# end of series of lines is when savelist END.\n appears
# lrank : rank of bitlist
# type: A gives accession numbers, N (default) gives seq names; useful for seq lists only

savelist <- function(lrank, type = c("N", "A"),
                     filename = paste(gln(lrank), ifelse(type == "N", "mne", "acc"), sep = "."),
                     socket = autosocket(), warnme = TRUE){
    #
    # Check argument:
    #
    if(!is.finite(lrank)) stop("wrong lrank argument")
    if(getliststate(lrank)$type != "SQ") stop("wrong ACNUC list type, should be SQ for sequences")
    #
    # Default is "N":
    #
    type <- type[1]
    if( !(type %in% c("N", "A"))) stop("wrong type argument")
    #
    # Build request:
    #
    request <- paste("savelist&lrank=", lrank, "&type=", type, sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Check that no error is returned:
    #
    if(parser.socket(answerFromServer[1])[1] != "0"){
        warning(paste("error code from server:", answerFromServer[1]))
        return(NA)
    }
    #
    # Remove first line (code=0):
    #
    answerFromServer <- answerFromServer[-1]
    #
    # Check completness of answer:
    #
    if( answerFromServer[length(answerFromServer)] != "savelist END."){
        warning("incomplete answer from server")
        return(NA)
    }
    #
    # Remove last line and dump to file:
    #
    answerFromServer <- answerFromServer[-length(answerFromServer)]
    writeLines(answerFromServer, con = filename)
    #
    # Say it's over
    #
    if(warnme){
        if(type == "N"){
            cat(paste(length(answerFromServer), "sequence mnemonics written into file:", filename), sep = "\n")
        } else {
            cat(paste(length(answerFromServer), "sequence accession numbers written into file:", filename), sep = "\n")
        }
    }
}

##
# This function draws two graphics, one of the CA of a DNA sequence, and one of
# start/stop codons positions in the three reading frames. This for the direct or 
# the reverse strand.
##
#v.18.08.2011
draw.recstat <- function(rec, fac = 1, direct = TRUE, xlim = c(1, seqsize), col = c("red", "blue", "purple"))
{
    if (fac < 0 | 4 < fac)
    { # test if factor is between 1 and 4
        print("Factor number is not in 1:4.")
        return()
    }
    seq <- rec[[1]] # recovery of elements of list rec
    sizewin <- rec[[2]]
    shift <- rec[[3]]
    seqsize <- rec[[4]]
    seqname <- rec[[5]]
    vstopd <- rec[[8]]
    vstopr <- rec[[9]]
    vinitd <- rec[[10]]
    vinitr <- rec[[11]]
    recd <- rec[[14]]
    recr <- rec[[15]]
    if (xlim[1] < 1 | xlim[1] > seqsize)
    {
        xlim <- c(1, xlim[2])
    }
    if (seqsize < xlim[2] | 1 > xlim[2])
    {
        xlim <- c(xlim[1], seqsize)
    }
    graphics::par(mfrow = c(2, 1), mar = c(0, 4, 4, 2) + 0.1) # division of the window for a closer between plots
    graphics::par(xaxs = "i")
    seqisize <- floor((dim(recd$li)[1])/3) # number of window by reading frame, we take the integer part
    if ((dim(recd$li)[1])%%3 == 1) # adaptation of number of window between each reading frame
    {
        seqisize1 <- seqisize + 1 # for fr1
        seqisize2 <- seqisize # for fr2
    }
    if ((dim(recd$li)[1])%%3 == 2)
    {
        seqisize1 <- seqisize + 1
        seqisize2 <- seqisize + 1
    }
    if ((dim(recd$li)[1])%%3 == 0)
    {
        seqisize1 <- seqisize
        seqisize2 <- seqisize
    }
    ##
    ##direct strand##
    ##
    if (direct)
    { 
        graphics::plot((sizewin/2) + (0:(seqisize1 - 1))*shift, recd$li[1:seqisize1, fac], type = "l", lty = 1,
             col = col[1], xlim = xlim, ylim = c(min(recd$li[, fac]), max(recd$li[, fac])),
             main = "Direct strand", xlab = "", ylab = "Factor scores", bty = 'l') # reading frame 1
        graphics::lines((sizewin/2) + (0:(seqisize2 - 1))*shift + 1, recd$li[(seqisize1 + 1):(seqisize1 + seqisize2), fac],
              lty = 2, col = col[2], ylab = "2") # reading frame 2
        graphics::lines((sizewin/2) + (0:(seqisize - 1))*shift + 2, recd$li[(seqisize1 + seqisize2 + 1):(dim(recd$li)[1]), fac],
              lty = 3, col = col[3], ylab = "3") # reading frame 3
        graphics::legend("topleft", legend = c(paste("Sequence name:", seqname), paste("Sequence length:", seqsize, "bp")),
               inset = c(-0.15, -0.2), bty = "n", xpd = TRUE)
        vstopdindphase <- numeric()
        if (length(vstopd) > 0)
        { # test if vector is not empty because problem with modulo
            vstopdindphase <- sapply(1:length(vstopd), function(x)
            { # index vector of reading frame of vector vstopd
                if (vstopd[x]%%3 == 1)
                {
                    vstopdindphase <- c(vstopdindphase, 2.5)
                }
                else
                {
                    if (vstopd[x]%%3 == 2)
                    {
                        vstopdindphase <- c(vstopdindphase, 1.5)
                    }
                    else
                    {
                        vstopdindphase <- c(vstopdindphase, 0.5)
                    }
                }
            })
        }
        vinitdindphase <- numeric()
        if (length(vinitd) > 0)
        { # test if vector is not empty because problem with modulo
            vinitdindphase <- sapply(1:length(vinitd), function(x)
            { # index vector of reading frame of vector vinitd
                if (vinitd[x]%%3 == 1)
                {
                    vinitdindphase <- c(vinitdindphase, 3)
                }
                else
                {
                    if (vinitd[x]%%3 == 2)
                    {
                        vinitdindphase <- c(vinitdindphase, 2)
                    }
                    else
                    {
                        vinitdindphase <- c(vinitdindphase, 1)
                    }
                }
            })
        }
        graphics::par(mar = c(5, 4, 3, 2) + 0.1)
        graphics::plot(vstopd, vstopdindphase, pch = 25, cex = 0.7, xlim = xlim, ylim = c(0.25, 3), axes = TRUE,
             ann = TRUE, tcl = -0.5, bty = 'l', yaxt = 'n', xlab = "Start/Stop positions (bp)",
             ylab = '', xpd = FALSE) # stop codons positions
        graphics::points(vinitd, vinitdindphase, pch = 24, bg = "slategray", cex = 0.7, col = 'slategray') # start codons positions
        graphics::abline(h = c(3.1, 2.4, 2.1, 1.4,  1.1, 0.4), col = c(col[1], col[1], col[2], col[2], col[3], col[3]),
               lty = c(1, 1, 2, 2, 3, 3))
        graphics::text(x = (xlim[1]-(xlim[2]-xlim[1])*0.75/6), pos = 4, y = c(2.75, 1.75, 0.75), labels = paste("Ph. ", c(0, 1, 2)), xpd = TRUE)
    }
    ##
    ##reverse strand##
    ##
    if (!direct)
    {    
        graphics::plot((sizewin/2) + (0:(seqisize1 - 1))*shift, recr$li[1:seqisize1, fac], type = "l", lty = 1,
             col = col[1], xlim = xlim, ylim = c(min(recr$li[, fac]), max(recr$li[, fac])),
             main = "Reverse strand", xlab = "", ylab = "Factor scores", bty = 'l') # reading frame 1
        graphics::lines((sizewin/2) + (0:(seqisize2-1))*shift + 1, recr$li[(seqisize1 + 1):(seqisize1 + seqisize2), fac],
              lty = 2, col = col[2], ylab="2") # reading frame 2
        graphics::lines((sizewin/2) + (0:(seqisize - 1))*shift + 2, recr$li[(seqisize1 + seqisize2 + 1):(dim(recr$li)[1]), fac],
              lty = 3, col = col[3], ylab = "3") # reading frame 3
        graphics::legend("topleft", legend = c(paste("Sequence name:", seqname), paste("Sequence length:", seqsize, "bp")),
               inset = c(-0.15, -0.2), bty = "n", xpd = TRUE)
        vstoprindphase <- numeric()
        if (length(vstopr) > 0)
        { # test if vector is not empty because problem with modulo
            vstoprindphase <- sapply(1:length(vstopr), function(x)
            { # index vector of reading frame of vector vstopr
                if (vstopr[x]%%3 == 1)
                {
                    vstoprindphase <- c(vstoprindphase, 2.5)
                }
                else
                {
                    if (vstopr[x]%%3 == 2)
                    {
                        vstoprindphase <- c(vstoprindphase, 1.5)
                    }
                    else
                    {
                        vstoprindphase <- c(vstoprindphase, 0.5)
                    }
                }
            })
        }
        vinitrindphase <- numeric()
        if (length(vinitr) > 0)
        { # test if vector is not empty because problem with modulo
            vinitrindphase <- sapply(1:length(vinitr), function(x)
            { # index vector of reading frame of vector vinitr
                if (vinitr[x]%%3 == 1)
                {
                    vinitrindphase <- c(vinitrindphase, 3)
                }
                else
                {
                    if (vinitr[x]%%3 == 2)
                    {
                        vinitrindphase <- c(vinitrindphase, 2)
                    }
                    else
                    {
                        vinitrindphase <- c(vinitrindphase, 1)
                    }
                }
            })
        }
        graphics::par(mar = c(5, 4, 3, 2) + 0.1)
        graphics::plot(vstopr, vstoprindphase, pch = 25, cex = 0.7, xlim = xlim, ylim = c(0.25, 3), axes = TRUE,
             ann = TRUE, tcl = -0.5, bty = 'l', yaxt = 'n', xlab = "Start/Stop positions (bp)",
             ylab = '', xpd = FALSE) # stop codons positions
        graphics::points(vinitr, vinitrindphase, pch = 24, bg = "slategray", cex = 0.7, col = 'slategray') # start codons positions
        graphics::abline(h = c(3.1, 2.4, 2.1, 1.4,  1.1, 0.4), col = c(col[1], col[1], col[2], col[2], col[3], col[3]),
               lty = c(1, 1, 2, 2, 3, 3))
        graphics::text(x = (xlim[1]-(xlim[2]-xlim[1])*0.75/6), pos = 4, y = c(2.75, 1.75, 0.75), labels = paste("Ph. ", c(0, 1, 2)), xpd = TRUE)
    }
}

extract.breakpoints <- function(rearr.ori,type=c("atfw","atrev","gcfw","gcrev"),nbreaks,gridsize=100,it.max=500){
    
    if(length(type)==0){
        stop("You must specify the type of skew: atfw, atrev, gcfw or gcrev. See ?extract.breakpoints for more details.")
    }
    if(sum(!type%in%c("atfw","atrev","gcfw","gcrev"))!=0){
        stop("The type of skew must be one of the following: atfw, atrev, gcfw or gcrev. See ?extract.breakpoints for more details.")
    }
    
    result=list()
    
    for(t in type){
        
        if(t=="gcfw"){
            print("Extracting breakpoints for GC-skew, forward-encoded genes")
            x.breaks=rearr.ori$meancoord.rear[rearr.ori$strand.rear=="forward"]
            y.breaks=cumsum(rearr.ori$gcskew.rear[rearr.ori$strand.rear=="forward"])
        }
        if(t=="gcrev"){
            print("Extracting breakpoints for GC-skew, reverse-encoded genes")
            x.breaks=rearr.ori$meancoord.rear[rearr.ori$strand.rear=="reverse"]
            y.breaks=cumsum(rearr.ori$gcskew.rear[rearr.ori$strand.rear=="reverse"])
        }
        if(t=="atfw"){
            print("Extracting breakpoints for AT-skew, forward-encoded genes")
            x.breaks=rearr.ori$meancoord.rear[rearr.ori$strand.rear=="forward"]
            y.breaks=cumsum(rearr.ori$atskew.rear[rearr.ori$strand.rear=="forward"])
        }
        if(t=="atrev"){
            print("Extracting breakpoints for AT-skew, reverse-encoded genes")
            x.breaks=rearr.ori$meancoord.rear[rearr.ori$strand.rear=="reverse"]
            y.breaks=cumsum(rearr.ori$atskew.rear[rearr.ori$strand.rear=="reverse"])
        }
        
        assign("x.breaks",x.breaks,envir=.seqinrEnv)
        assign("y.breaks",y.breaks,envir=.seqinrEnv)
        
        rss=numeric(0)
        starts=list()
        
        i=0
        while(i<gridsize){
            border=(max(x.breaks)-min(x.breaks))*0.05
            initpsi = stats::runif(nbreaks[which(type == t)], min = (min(x.breaks)+border),max = (max(x.breaks)- border))
            if(exists("seg")){
                rm(seg)
            }
            
            #try(seg <- segmented::segmented(lm(y.breaks~x.breaks),x.breaks,psi=initpsi,it.max=it.max), silent = TRUE)
            try(seg <- segmented::segmented(stats::lm(y.breaks~ x.breaks),~x.breaks, psi = initpsi, it.max = it.max), silent = TRUE)
            
            if(exists("seg")){
                starts[[length(starts)+1]]=initpsi
                rss=c(rss, sum(seg$residuals^2))
                i=i+1
            }
            
            gc()
        }
        
        wmin=which.min(rss)
        
        
        starts=starts[[wmin]]
        
        #seg=seg <- segmented::segmented(lm(y.breaks~x.breaks),x.breaks,psi=starts,it.max=it.max)
        seg = seg <- segmented::segmented(stats::lm(y.breaks~ x.breaks),~x.breaks, psi = starts, it.max = it.max)
        breaks=round(seg$psi[,2])
        
        breaks=breaks[order(breaks)]
        
        sl=c(x.breaks[1],breaks,x.breaks[length(x.breaks)])-x.breaks[1]+1
        
        
        slopes=numeric(length(sl)-1)
        
        for(i in seq_len(length(sl)-1)){
            u=(sl[i]:sl[i+1])+x.breaks[1]-1
            slopes[i]=summary(stats::lm(y.breaks[sl[i]:sl[i+1]]~u))$coefficients[2,1]
        }
        
        slopes.left=slopes[-length(slopes)]
        slopes.right=slopes[-1]
        
        result[[t]]=list()
        
        result[[t]]$breaks=breaks
        result[[t]]$slopes.left=slopes.left
        result[[t]]$slopes.right=slopes.right
        
        real.coord=rearr.ori$meancoord.real[breaks]
        result[[t]]$real.coord=real.coord
        
        
    }
    
    return(result)
    
}

#########################################################################
#
#                                 gbk2g2
#
# Conversion of a genbank format into a run-glimmer2 like format
#
#
#########################################################################

gbk2g2 <- function(
        gbkfile =  "https://pbil.univ-lyon1.fr/datasets/seqinr/data/ct.gbk",
        g2.coord = "g2.coord")
{
    input <- readLines(gbkfile)
    
    outfile = file( description = g2.coord, open ="w")
    #
    # Keep lines with CDS flag:
    #
    input <- input[ substring(input,1,8) == "     CDS"]
    
    #
    # Extract boudaries strings
    #
    get.boundaries <- function( line )
    {
        line <- unlist(strsplit(line, split = " "))
        line <- line[nchar(line) > 1]
        return(line[2])
    }
    input <- sapply(input, get.boundaries)
    names(input) <- NULL
    
    #
    # Look for 5' partial genes:
    #
    idx5p <- grep(">", input)
    if( length( idx5p != 0 ) )
        warning("5' partial genes encountered (no output):", idx5p)
    
    #
    # Look for 3' partial genes:
    #
    idx3p <- grep("<", input)
    if( length( idx3p != 0 ) )
        warning("3' partial genes encountered (no output):", idx3p)
    
    #
    # Look for join in features:
    #
    idxjoin <- grep("join", input)
    if( length( idxjoin != 0 ) )
        warning("join encountered (no output):", idxjoin)
    
    #
    # Define partials and join:
    #
    censored <-  c(idx5p, idx3p, idxjoin)
    
    #
    # Extract boundaries:
    #
    for( i in seq(from = 1, to = length(input), by = 1 ) )
    {
        if( i %in% censored )
            next
        
        tmp <- unlist( strsplit(input[i], split="\\.\\.") )
        if( length( grep("complement", input[i]) ) == 1 )
        {
            end <- as.integer( substring(tmp[1], first = 12 ) ) + as.integer(3)
            start <- as.integer( substring(tmp[2], first = 1, last = nchar(tmp[2]) - 1 ))
            line <- sprintf(fmt = "%d %d %d", as.integer(i), start, end)
        }
        else #direct strand
        {
            start <- as.integer(tmp[1])
            end   <- as.integer(tmp[2]) + as.integer(-3)
            line <- sprintf(fmt = "%d %d %d", as.integer(i), start, end)
        }
        writeLines( line, con = outfile )
    }
    close(outfile)
    invisible(input)
}

#
# To translate sequences:
#

getTrans <- function(object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE, ...)
    UseMethod("getTrans")

getTrans.default <- function(object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE, ...)
    stop(paste("no getTrans method for objects of class:", class(object)))

getTrans.list <- function(object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE, ...)
    lapply(seq_len(length(object)),
           function(i) getTrans(object[[i]], sens = sens, NAstring = NAstring, ambiguous = ambiguous,
                                force.first.aa.to.Met = force.first.aa.to.Met, ...))

getTrans.character <- function(object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE,
                               ..., frame = 0, numcode = 1)
    translate(seq = object, frame = frame, sens = sens, numcode = numcode, NAstring = NAstring, ambiguous = ambiguous,
              force.first.aa.to.Met = force.first.aa.to.Met)

getTrans.SeqFastadna <- function(object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE,
                                 ..., frame = 0, numcode = 1){
    dnaseq <- getSequence(object, as.string = FALSE)
    translate(seq = dnaseq, frame = frame, sens = sens, numcode = numcode, NAstring = NAstring, ambiguous = ambiguous, 
              force.first.aa.to.Met = force.first.aa.to.Met)
}
getTrans.SeqFrag <- getTrans.SeqFastadna

getTrans.SeqAcnucWeb <- function(object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE,
                                 ..., frame = "auto", numcode = "auto"){
    dnaseq <- getSequence(object, as.string = FALSE)
    if(numcode == "auto") numcode <- attr(object, "ncbigc")
    if(frame == "auto") frame <- attr(object, "frame")
    translate(seq = dnaseq, frame = frame, sens = sens, numcode = numcode, NAstring = NAstring, ambiguous = ambiguous, 
              force.first.aa.to.Met = force.first.aa.to.Met) 
}

getTrans.qaw <- function(object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE, ...) 
                getTrans(object$req, force.first.aa.to.Met = force.first.aa.to.Met, ...)

getTrans.logical <- function (object, sens = "F", NAstring = "X", ambiguous = FALSE, force.first.aa.to.Met = FALSE, ...)
    object # so that NA is returned for virtual lists

# ==>  modifylist&lrank=..&type=[length|date|scan]&operation=".."
# <== code=0&lrank=..&name=".."&count=..{&processed=..}
# code=3   if impossible to create a new list
# code=2   if incorrect syntax, possibly in operation
# lrank:   (input) rank of bitlist to be modified
#         (output) rank of created bitlist containing result of modify operation
# type:    indicates what kind of modification is to be performed.
# operation: for length, as in  "> 10000"    or    "< 500"
#         for date, as in   "> 1/jul/2001"   or   "< 30/AUG/98"
#         for scan, specify the string to be searched for
#                   prep_getannots must be used before using modifylist&type=scan
#                   the client can interrupt the scan operation by sending the escape character on the socket
# name: name of created bitlist
# count: number of elements in created bitlist
# processed: only for scan operation, number of list elements scanned until completion or interruption


modifylist <- function(listname, modlistname = listname,
                       operation, type = c("length", "date", "scan"),
                       socket = autosocket(), virtual = FALSE,
                       verbose = FALSE){
    #
    # Default is by length:
    #
    type <- type[1]
    if(!(type %in% c("length", "date", "scan"))) stop("Wrong type agument")
    #
    # Build request:
    #
    request <- paste("modifylist&lrank=", glr(listname, verbose = verbose), "&type=", type, "&operation=\"", operation, "\"", sep = "")
    if(verbose) cat("-->", request, "<--\n")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Build result:
    #
    if(verbose) cat("Answer from server:", answerFromServer, "\n")
    resitem <- parser.socket(answerFromServer)
    if(resitem[1] != "0"){
        stop(paste("error code returned by server :", resitem[1]))
    }
    mlrank <- as.numeric(resitem[2])
    mlcount <- as.numeric(resitem[4])
    #
    # Set list name on server:
    #
    suppressWarnings(ressetlistname <- setlistname(lrank = mlrank, name = modlistname, socket = socket))
    if(is.na(ressetlistname)) stop("Empty answer from server in setlistname")
    if(ressetlistname == "4") stop("No list of rank mlrank exists")
    #
    # Get full list informations:
    #
    if( !virtual ){
        writeLines(paste("nexteltinlist&lrank=", mlrank, "&first=1&count=", mlcount, sep = ""), socket, sep = "\n")
        res <- readLines(socket, n = mlcount, ok = FALSE)
        if( length(res) != mlcount )
        {
            stop(paste("only", length(res), "list elements were send by server out of", mlcount, "expected.\n")) 
        }
        #
        # Extracting info
        #
        req <- vector(mode = "list", length = mlcount)
        for(i in seq_len(mlcount)){
            x <- parser.socket(res[i])
            req[[i]] <- as.SeqAcnucWeb(substr(x[2], 2, nchar(x[2]) - 1), x[3], x[6], x[7])
        }
        #
        # Virtual list case:
        #
    } else {
        req <- NA
    }
    #
    # Assign results in workspace:
    #    use getliststate for typelist when avail
    #
    result <- list(call = match.call(), name = modlistname, nelem = mlcount, typelist = NA, 
                   req = req, socket = socket)
    class(result) <- c("qaw")
    assign(modlistname, result, envir = .seqinrEnv)
}

#
# To get Keywords associated with a sequence.
#

getKeyword <- function(object, ...) UseMethod("getKeyword")

getKeyword.default <- function(object, ...)
    stop(paste("no getKeyword method for objects of class:", class(object)))

getKeyword.list <- function(object, ...)
    lapply(seq_len(length(object)), function(i) getKeyword(object[[i]], ...))

getKeyword.SeqAcnucWeb <- function(object, ..., socket = autosocket()){
    getKeywordsocket <- function(socket, name){
        #modif simon
        writeLines(paste("isenum&name=", name, sep = ""), socket, sep = "\n")
        res <- readLines(socket, n = 1)
        number <- parser.socket(res)[1] 
        
        writeLines(paste("readsub&num=", number, sep = ""), socket, sep = "\n")
        res2 <- readLines(socket, n = 1) 
        rr <- parser.socket(res2)
        
        writeLines(paste("readshrt&num=", rr[7], sep = ""), socket, sep = "\n")
        res3 <- readLines(socket, n = 1)
        #modif simon   
        
        # Get the nb of kw (not used here)
        # nbkws <- parser.socket(res3)[2]
        
        #recupere la liste de paires val, next 
        tmpl <- unlist(strsplit(res3, "&"))
        #transforme en liste
        tmpl <- unlist(strsplit(tmpl[3],","))
        kwl <- unlist(tmpl)[c(TRUE, FALSE)]
        
        lapply(kwl, function(x){
            writeLines(paste("readkey&num=", x, sep = ""), socket, sep = "\n")  
            res4 <- readLines(socket, n = 1)
            res <-parser.socket(res4)[2]
            substring(res[1], 2, nchar(res[1]) - 1)
        })
        
    } 
    unlist(getKeywordsocket(socket, name = object))
}

getKeyword.qaw <- function(object, ...) getKeyword(object$req, ...)

getKeyword.logical <- function (object, ...)
    object # so that NA is returned for virtual lists

bma <- function(nucl, warn.non.IUPAC = TRUE, type = c("DNA", "RNA")){
    if(nchar(nucl[1]) != 1) stop("vector of single chars expected")
    type <- match.arg(type)
    nucl <- tolower(nucl)
    nucl <- unlist(sapply(nucl, amb, checkBase = FALSE))
    iupac <- sapply(amb(), amb)
    if(type == "DNA"){
        iupac$u <- NULL
    } else {
        iupac$t <- NULL
    }
    idx <- unlist(lapply(iupac, setequal, nucl))
    if(all(idx == FALSE)){
        if(warn.non.IUPAC){
            warning(paste("Undefined IUPAC symbol with:", paste(nucl, collapse = " ")))
        }
        return(NA)
    }
    return(names(iupac)[idx])
}

circle <- function(x = 0, y = 0, r = 1, theta = c(0, 360), n = 100, ...){
    a <- seq(theta[1], theta[2], length = n)
    xx <- x + r*cos(a*2*pi/360)
    yy <- y + r*sin(a*2*pi/360)
    if(!identical(theta, c(0, 360))){
        xx <- c(xx, x)
        yy <- c(yy, y)
    }
    graphics::polygon(xx, yy, ...)
}

where.is.this.acc <- function(acc, stopAtFirst = TRUE, ...){
    #
    # Argument check:
    #
    if(!is.character(acc)) stop("string expected for argument acc")
    #
    result <- character(0)
    #
    cat("Looking for available databases\n")  
    banks <- choosebank(...)
    nbanks <- length(banks)
    cat(paste("Looking for sequence with accession number", acc,
              "in the following ACNUC databases:\n"))
    print(banks)
    #
    # Looping over banks:
    #
    for(i in seq_len(nbanks)){
        cat(paste("\nTrying to open bank with name --->", banks[i], 
                  "<--- ...", sep = ""))
        bkopenres <- try(choosebank(banks[i]))
        if(inherits(bkopenres, "try-error")){
            cat("... opening not OK, skipping this bank.\n")
        } else {
            cat("... and opening was OK.\n")
            cat(paste("==> Trying to find sequence", acc, "in bank", 
                      banks[i], "..."))
            resquery <- try(query(".tmpquery", paste("AC=", acc)), silent = TRUE)
            if(inherits(resquery, "try-error")){
                cat("... not found here.\n")
            } else {
                cat("... *** FOUND *** here.\n")
                result <- c(result, banks[i])
            }
            closebank()
            if(length(result) != 0 && stopAtFirst){
                return(invisible(result))
            }
        }
    }
    #
    # Print result summary:
    #
    cat("\n\n")
    if(length(result) == 0){
        cat(paste("Sequence with accesion number", acc, 
                  "was not found in available databases.\n Are you sure this is an accession number and not a sequence name?"))
    } else {
        cat(paste("Sequence with accesion number", acc, 
                  "was found in the following database(s):\n"))
        print(result)
    }
    invisible(result)
}

########################################################################
#
#                                   gb2fasta
#
#                   single entry genbank to fasta conversion
#
########################################################################
gb2fasta <- function(source.file, destination.file)
{
    input <- readLines(source.file)
    head <- input[1]
    head <- unlist(strsplit(head, split=" "))
    head <- head[nchar(head) > 0]
    seqname <- head[2]
    seqsize <- as.integer(head[3])
    outheader <- sprintf(">%s %d bp", seqname, seqsize)
    
    confile <- file(destination.file, open="w")
    writeLines(outheader, confile)
    #
    # Look for sequence position:
    #
    debut <- which(substring(input,1,6) == "ORIGIN") + 1
    if( length( debut ) > 1 )
        stop("Multiple entries not yet implemented !")
    fin <- which(substring(input,1,2) == "//") - 1
    if( length( fin ) > 1 )
        stop("Multiple entries not yet implemented !")
    
    input <- input[debut:fin]
    input <- sapply(input, function(x) {
        return(paste(substr(x,11,20),substr(x,22,31),substr(x,33,42),substr(x,44,53),
                     substr(x,55,64),substr(x,66,75),sep="",collapse="")) } )
    names(input)<-NULL
    writeLines(input, confile )
    close(confile)
}

trimSpace <- function(x, leading = TRUE, trailing = TRUE, space = "[:space:]"){
    if(leading){
        pattern <- paste("^[", space, "]*", sep = "", collapse = "")
        x <- sub(pattern = pattern, replacement =  "", x = x)
    }
    if(trailing){
        pattern <- paste("[", space, "]*$", sep = "", collapse = "")
        x <- sub(pattern = pattern, replacement =  "", x = x)
    }
    return(x)
}

# ==>   residuecount&lrank=xx
# <==  code=xx&count=xx
# Computes the total number of residues (nucleotides or aminoacids) in
# all sequences of the list of specified rank.
# Code != 0 indicates error.


residuecount <- function(lrank, socket = autosocket()){
    #
    # Build request:
    #
    request <- paste("residuecount&lrank=", lrank, sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Build result:
    #
    resitem <- parser.socket(answerFromServer)
    if(resitem[1] != "0"){
        warning(paste("error code returned by server :", resitem[1]))
        return(NA)
    } else {
        return(as.numeric(resitem[2]))
    }
}

# ==> acnucclose
# <==  code=xx
# To close the currently opened acnuc db.
# code : 0 if OK 
#       3 if no database was opened by the server

acnucclose <- function(socket){
    #
    # Build request:
    #
    writeLines("acnucclose", socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        stop("Empty answer from server")
    }
    res <- parser.socket(answerFromServer)
    #
    # Check that no error is returned:
    #
    if(res[1] != "0"){
        if( res[1] == "3" ){
            stop("no database was opened by the server")
        }
        stop("I don't know what this error code means for acnucclose, please contact package maintener.\n")
    }
}

plotabif <- function(abifdata, 
                     chanel = 1, 
                     tmin = 1/tscale, 
                     tmax = abifdata$Data[["SCAN.1"]]/tscale, 
                     tscale = 1000, 
                     yscale = 1000, type = "l", las = 1, 
                     xlab = paste("Time", tscale, sep = "/"),
                     ylab = paste("RFU", yscale, sep = "/"), 
                     irange = (tmin*tscale):(tmax*tscale),
                     x = irange/tscale,
                     xlim = c(tmin, tmax),
                     chanel.names = c(1:4,105),
                     DATA = paste("DATA", chanel.names[chanel], sep = "."),
                     y = abifdata$Data[[DATA]][irange]/yscale,
                     ylim = c(min(y), max(y)),
                     dyn = abifdata$Data[[paste("DyeN", chanel, sep = ".")]],
                     main = paste(deparse(substitute(abifdata)), chanel, dyn, sep = " ; "),
                     calibr = NULL,
                     ladder.bp = NULL,
                     allele.names = "identifiler",
                     ladder.lab = TRUE,
                     ...){
    
    old.par <- graphics::par(no.readonly = TRUE)
    on.exit(graphics::par(old.par))
    if(is.null(calibr)){
        graphics::plot(x, y, type = type, las = las, 
             xlab = xlab, ylab = ylab, xlim = xlim, ylim = ylim, main = main, ...)
    } else {
        x <- calibr(irange)
        xlim <- range(x)
        graphics::plot(x, y, type = type, las = las, 
             xlab = "Size [bp]", ylab = ylab, xlim = xlim, ylim = ylim, main = main, ...)
        tps <- pretty(irange)
        graphics::par(cex=0.5)
        graphics::axis(1, at = calibr(tps), tps/tscale, line = 0.4, col = grDevices::grey(0.5))
        graphics::par(cex=1)
        if(!is.null(ladder.bp)){ # Allelic ladder add
            utils::data(list = allele.names,envir=environment())
            tmp <- get(allele.names)[chanel]
            n <- length(ladder.bp)
            labels <- unlist(tmp)
            col <-  rep("black", n)
            col[grep("\\.", labels)] <- "red"
            graphics::abline(v = ladder.bp, col = col)
            if(ladder.lab){
                graphics::text(ladder.bp, y = graphics::par("usr")[4], labels, xpd = NA, 
                     pos = 3, srt = 45, col = col, cex = 0.8)
            }
        }
    }
    locpar <- graphics::par(no.readonly = TRUE)
    invisible(locpar)
}

# ==>   getliststate&lrank=xx
# <==  code=xx&type=[SQ|KW|SP]&name="xx"&count=xx{&locus=[T|F]}
# Asks for information about the list of specified rank.
# Reply gives the type of list, its name, the number of elements it contains,
# and, for sequence lists, says whether the list contains only parent seqs (locus=T).
# Reply gives code != 0 if error.

getliststate <- function(lrank, socket = autosocket()){
    #
    # Build request:
    #
    request <- paste("getliststate&lrank=", lrank)
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Build result:
    #
    resitem <- parser.socket(answerFromServer)
    if(resitem[1] != "0"){
        warning(paste("error code returned by server :", resitem[1]))
        return(NA)
    }
    return(list(type = resitem[2],
                name = substr(x = resitem[3], start = 2, stop = nchar(resitem[3]) - 1),
                count = as.numeric(resitem[4]),
                locus = as.logical(resitem[5])))
}

gls <- getliststate

gln <- function(lrank, ...) getliststate(lrank, ...)$name

closebank <- function(socket = autosocket(), verbose = FALSE){
    #
    # Send "acnucclose" to server:
    #
    if(verbose) cat("I'm trying to send an acnucclose message to server...\n")
    acnucclose(socket)
    if(verbose) cat("... and everything is OK up to now.\n")
    #
    # Send "quit" to server:
    #
    if(verbose) cat("I'm trying to send a quit message to server...\n")
    quitacnuc(socket)
    if(verbose) cat("... and everything is OK up to now.\n")
    #
    # Close connection:
    #
    if(verbose) cat("I'm trying to close connection...\n")
    res <- try(close.connection(socket))
    if( inherits(res, "try-error") ){
        if(verbose) cat("I was able to detect an error while closing connection.\n")
        stop("problem while closing connection.\n")
    } else {
        if(verbose) cat("... and everything is OK up to now.\n")
    }
}

read.abif <- function(filename, max.bytes.in.file = file.info(filename)$size, 
                      pied.de.pilote = 1.2, verbose = FALSE){
    #
    # Suppress warnings when reading strings with internal nul character:
    #
    RTC <- function(x, ...) suppressWarnings(rawToChar(x, ...))
    #
    # Define some shortcuts:
    #
    SInt32 <- function(f, ...) readBin(f, what = "integer", signed = TRUE, endian = "big", size = 4, ...)
    SInt16 <- function(f, ...) readBin(f, what = "integer", signed = TRUE, endian = "big", size = 2, ...)
    SInt8 <- function(f, ...) readBin(f, what = "integer", signed = TRUE, endian = "big", size = 1, ...)
    UInt32 <- function(f, ...) readBin(f, what = "integer", signed = FALSE, endian = "big", size = 4, ...)
    UInt16 <- function(f, ...) readBin(f, what = "integer", signed = FALSE, endian = "big", size = 2, ...)
    UInt8 <- function(f, ...) readBin(f, what = "integer", signed = FALSE, endian = "big", size = 1, ...)
    f32 <- function(f, ...) readBin(f, what = "numeric", size = 4,endian="little", ...)
    f64 <- function(f, ...) readBin(f, what = "numeric", size = 8, endian="little",...)
    #
    # Load raw data in memory:
    #
    fc <- file(filename, open = "rb")
    rawdata <- readBin(fc, what = "raw", n = pied.de.pilote*max.bytes.in.file,endian="little")
    if(verbose) print(paste("number of bytes in file", filename, "is", length(rawdata)))
    close(fc)
    #
    # Make a list to store results:
    #
    res <- list(Header = NULL, Directory = NA, Data = NA)
    #
    # Header section is 128 bytes long, located at a fixed position at the
    # beginning of the file. We essentially need the number of item and dataoffset
    #
    res$Header$abif <- RTC(rawdata[1:4])
    if(res$Header$abif != "ABIF") stop("file not in ABIF format")
    if(verbose) print("OK: File is in ABIF format")
    
    res$Header$version <- SInt16(rawdata[5:6])
    if(verbose) print(paste("File in ABIF version", res$Header$version/100))
    
    res$Header$DirEntry.name <- rawdata[7:10]
    if(verbose) print(paste("DirEntry name: ", RTC(res$Header$DirEntry.name)))
    
    res$Header$DirEntry.number <- SInt32(rawdata[11:14])
    if(verbose) print(paste("DirEntry number: ", res$Header$DirEntry.number))
    
    res$Header$DirEntry.elementtype <- SInt16(rawdata[15:16])
    if(verbose) print(paste("DirEntry elementtype: ", res$Header$DirEntry.elementtype))
    
    res$Header$DirEntry.elementsize <- SInt16(rawdata[17:18])
    if(verbose) print(paste("DirEntry elementsize: ", res$Header$DirEntry.elementsize))
    
    # This one is important:
    res$Header$numelements <- SInt32(rawdata[19:22])
    if(verbose) print(paste("DirEntry numelements: ", res$Header$numelements))
    
    # This one is important too:
    res$Header$dataoffset <- SInt32(rawdata[27:30])
    if(verbose) print(paste("DirEntry dataoffset: ", res$Header$dataoffset))
    dataoffset <- res$Header$dataoffset + 1 # start position is 1 in R vectors
    
    res$Header$datahandle <- SInt32(rawdata[31:34])
    if(verbose) print(paste("DirEntry datahandle: ", res$Header$datahandle))
    
    res$Header$unused <- SInt16(rawdata[35:128], n = 47)
    # Should be ingnored and set to zero
    res$Header$unused[1:length(res$Header$unused)] <- 0
    if(verbose) print(paste("DirEntry unused: ", length(res$Header$unused), "2-byte integers"))
    
    #
    # The directory is located at the offset specified in the header,
    # and consist of an array of directory entries.
    # We scan the directory to put values in a data.frame:
    #
    dirdf <- data.frame(list(name = character(0)))
    dirdf$name <- as.character(dirdf$name) # force to characters
    
    for(i in seq_len(res$Header$numelements)){
        deb <- (i-1)*res$Header$DirEntry.elementsize + dataoffset
        direntry <- rawdata[deb:(deb + res$Header$DirEntry.elementsize)]
        dirdf[i, "name"] <- RTC(direntry[1:4])
        dirdf[i, "tagnumber"] <- SInt32(direntry[5:8])
        dirdf[i, "elementtype"] <- SInt16(direntry[9:10])
        dirdf[i, "elementsize"] <- SInt16(direntry[11:12])
        dirdf[i, "numelements"] <- SInt32(direntry[13:16])
        dirdf[i, "datasize"] <- SInt32(direntry[17:20])
        dirdf[i, "dataoffset"] <- SInt32(direntry[21:24])
    }
    if(verbose){
        print("Element found:")
        print(dirdf$name)
    }
    #
    # Save Directory and make a list to store data:
    #
    res$Directory <- dirdf
    res$Data <- vector("list", nrow(dirdf))
    names(res$Data) <- paste(dirdf$name, dirdf$tagnumber, sep = ".")
    #
    # Data extraction:
    #
    for(i in seq_len(res$Header$numelements)){
        deb <- (i-1)*res$Header$DirEntry.elementsize + dataoffset
        # Short data are stored in dataoffset directly:
        if(dirdf[i, "datasize"] > 4){
            debinraw <- dirdf[i, "dataoffset"] + 1
        } else {
            debinraw <- deb + 20
        }
        elementtype <- dirdf[i, "elementtype"]
        numelements <- dirdf[i, "numelements"]
        elementsize <- dirdf[i, "elementsize"]
        data <- rawdata[debinraw:(debinraw + numelements*elementsize)]
        # unsigned 8 bits integer:
        if(elementtype == 1) res$Data[[i]] <- UInt8(data, n = numelements)
        # char or signed 8 bits integer
        if(elementtype == 2){
            res$Data[[i]] <- tryCatch(RTC(data),finally=paste(rawToChar(data,multiple=TRUE),collapse=""),error=function(er){cat(paste("an error was detected with the following  message:",er," but this error was fixed\n",sep=" "))})
        }
        
        # unsigned 16 bits integer:
        if(elementtype == 3) res$Data[[i]] <- UInt16(data, n = numelements)
        # short:
        if(elementtype == 4) res$Data[[i]] <- SInt16(data, n = numelements)
        # long:
        if(elementtype == 5) res$Data[[i]] <- SInt32(data, n = numelements)
        # float:
        if(elementtype == 7) res$Data[[i]] <- f32(data, n = numelements)
        # double:
        if(elementtype == 8) res$Data[[i]] <- f64(data, n = numelements)
        # date:
        if(elementtype == 10)
            res$Data[[i]] <- list(year = SInt16(data, n = 1), 
                                  month = UInt8(data[-(1:2)], n = 1), day = UInt8(data[-(1:3)], n = 1))
        # time:
        if(elementtype == 11)
            res$Data[[i]] <- list(hour = UInt8(data, n = 1), 
                                  minute = UInt8(data[-1], n = 1), second = UInt8(data[-(1:2)], n = 1),
                                  hsecond = UInt8(data[-(1:3)], n = 1))
        # pString:
        if(elementtype == 18){
            n <- SInt8(rawdata[debinraw])
            pString <- RTC(rawdata[(debinraw+1):(debinraw+n)])
            res$Data[[i]] <- pString
        }
        # cString:
        if(elementtype == 19) res$Data[[i]] <- RTC(data[1:(length(data) - 1) ])
        # user:
        if(elementtype >= 1024) res$Data[[i]] <- data
        # legacy:
        if(elementtype %in% c(12, 13)) 
            warning("unimplemented legacy type found in file")
        if(elementtype %in% c(6, 9, 14, 15, 16, 17, 20, 128, 256, 384))
            warning("unsupported legacy type found in file")
    }
    return(res)
}

rot13 <- function(string){
    if(!is.character(string)) stop("character string expected")
    old <- c2s(c(letters, LETTERS))
    new <- c2s(c(letters[14:26], letters[1:13], LETTERS[14:26], LETTERS[1:13]))
    chartr(old = old, new = new, x = string)
}

# ==>   countsubseqs&lrank=xx
# <==  code=xx&count=xx
# Returns the number of subsequences in list of rank lrank.
# Code != 0 indicates error.

countsubseqs <- function(lrank, socket = autosocket()){
    #
    # Check argument:
    #
    if(!is.finite(lrank)) stop("wrong lrank argument")
    #
    # Build request:
    #
    request <- paste("countsubseqs&lrank=", lrank, sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Check that no error is returned:
    #
    resitem <- parser.socket(answerFromServer)
    if(resitem[1] != "0"){
        warning(paste("error code from server:", answerFromServer))
        return(NA)
    }
    #
    return(as.numeric(resitem[2]))
}

css <- countsubseqs

rho <- function (sequence, wordsize = 2, alphabet = s2c("acgt"))
{
    wordcount <- count(sequence, wordsize, freq = FALSE, alphabet = alphabet)
    uni <- count(sequence, 1, freq = TRUE, alphabet = alphabet)
    
    expected_wordfreq <- function (wordsize, uni) 
    {
        if (wordsize == 1) 
            return(uni)
        else kronecker(uni, expected_wordfreq(wordsize - 1, uni))
    }
    
    expected_wordcount <- sum(wordcount)*expected_wordfreq(wordsize, uni)
    
    return(wordcount/expected_wordcount)
}

swap <- function(x, y){
    x.sub <- substitute(x)
    y.sub <- substitute(y)
    x.val <- x
    e <- parent.frame()
    do.call("<-", list(x.sub, y.sub), envir = e)
    do.call("<-", list(y.sub, x.val), envir = e)
}

utils::data(sysdata, envir=environment())
AAstat <- function(seq, plot = TRUE){
    #
    # seq is a protein sequence as a vector of (upper case) chars.
    #
    AAP <- SEQINR.UTIL$AA.PROPERTY
    tutu <- lapply(names(AAP), function(x) which(seq %in% AAP[[x]]))
    names(tutu) <- names(AAP)
    
    n.items <- length(tutu) # Number of physoco-chemical properties
    n.res <- length(seq)    # Number of residues in the protein
    
    if(plot == TRUE){
        coul <- grDevices::rainbow(n.items)
        graphics::plot(c(0, n.res), c(0, n.items + 1), type = "n", axes = FALSE, 
             ann = FALSE, xlim = c(0, n.res + 1))
        graphics::title(xlab = "Position of the residues along the sequence")
        graphics::axis(2, at = seq(1.5, 10, 1), labels = names(tutu), col.lab = "blue", las = 1, cex.axis = 0.8)
        graphics::axis(1, at = seq(0, n.res, 15), labels = seq(0, n.res, 15), col.axis = "blue")
        lapply(seq_len(n.items), function(x){
            graphics::segments(tutu[[x]], x, tutu[[x]], x + 1, col = coul[x], lwd = 2)
            graphics::rect(0, x, n.res, 1, lwd = 2)
        })
        graphics::rect(0, n.items + 1, n.res, 1, lwd = 2)
    }
    
    res1 <- lapply(tutu,function(x){length(x)/n.res})
    res2 <- table(factor(seq, levels = levels(SEQINR.UTIL$CODON.AA$L)))
    res3 <- computePI(seq)
    return(list(Compo = res2, Prop = res1, Pi = res3))
}

###############################################################################
#                                                                               #
#                                         query                                 #
#                                                                               #
###############################################################################

query <- function(listname, query, socket = autosocket(), invisible = TRUE, verbose = FALSE, virtual = FALSE) 
{
    #
    # Use list1 as listname if the argument is missing:
    #
    if(missing(query)){
        query <- listname
        listname <- "list1"
    }
    #
    # Check arguments:
    #
    if(verbose) cat("I'm checking the arguments...\n")
    
    if( !inherits(socket, "sockconn") ) stop(paste("argument socket = ", socket, "is not a socket connection."))
    if( !is.character(listname) ) stop(paste("argument listname = ", listname, "is not a character string."))
    if( !is.character(query) ) stop(paste("argument query = ", query, "is not a character string."))
    if( !is.logical(invisible) ) stop(paste("argument invisible = ", invisible, "should be TRUE or FALSE."))
    if( is.na(invisible) ) stop(paste("argument invisible = ", invisible, "should be TRUE or FALSE."))
    if(verbose) cat("... and everything is OK up to now.\n")
    
    #
    # Check the status of the socket connection:
    #
    if(verbose) cat("I'm checking the status of the socket connection...\n")
    #
    # Ca marche pas: summary.connection leve une exception et on ne va pas plus loin
    #
    if(!isOpen(socket)) stop(paste("socket:", socket, "is not opened."))
    if(!isOpen(socket, rw = "read")) stop(paste("socket:", socket, "can not read."))
    if(!isOpen(socket, rw = "write")) stop(paste("socket:", socket, "can not write."))
    if(verbose) cat("... and everything is OK up to now.\n")
    
    #
    # Send request to server:
    #
    if(verbose) cat("I'm sending query to server...\n")
    request <- paste("proc_requete&query=\"", query, "\"&name=\"", listname, "\"", sep = "")
    writeLines(request, socket, sep = "\n")
    res <- readLines(socket, n = 1)
    #
    # C'est ici qu'il y a un probleme de timeout. Suit un patch pas beau
    #
    
    if(verbose) cat(paste("... answer from server is:", res, "\n"))
    if(length(res) == 0){
        if(verbose) cat("... answer from server is empty!\n")    
        # Modif de Simon suite au mail de Augusto Ribas
        maxIter <- 10
        attemptNumber <- 0
        while((length(res) == 0) & (attemptNumber < maxIter)) {
            if(verbose) cat("... reading again (",attemptNumber,").\n")
            res <- readLines(socket, n = 1) 
            attemptNumber <- attemptNumber+1
        }    
        if(length(res) == 0){
            stop(paste("Unable to get any answer from socket after ",attemptNumber , " trials."))
        }
    }
    #
    # Analysing answer from server:
    #
    if(verbose) cat("I'm trying to analyse answer from server...\n")
    p <- parser.socket(res)
    if(p[1] != "0"){
        if(verbose) cat("... and I was able to detect an error.\n") 
        stop(paste("invalid request:", p[2], sep = ""))
    }
    
    if(verbose) cat("... and everything is OK up to now.\n")
    lrank <- p[2]
    if(verbose) cat(paste("... and the rank of the resulting list is:", lrank, ".\n"))
    nelem <- as.integer(p[3])
    if(verbose) cat(paste("... and there are", nelem, "elements in the list.\n"))
    typelist <- p[4]
    if(verbose) cat(paste("... and the elements in the list are of type", typelist, ".\n"))
    if(typelist == "SQ"){
        if(p[5] == "T"){
            if(verbose) cat("... and there are only parent sequences in the list.\n")
        } else {
            if(verbose) cat("... and there are *not* only parent sequences in the list.\n")
        }
    }
    
    #
    # Get full list informations: 
    #
    if( !virtual ){
        if(verbose) cat("I'm trying to get the infos about the elements of the list...\n")
        writeLines(paste("nexteltinlist&lrank=", lrank, "&first=1&count=", nelem, sep = ""), socket, sep = "\n")
        res <- readLines(socket, n = nelem, ok = FALSE)
        if( length(res) != nelem )
        {
            if(verbose) cat("... and I was able to detect an error...\n")
            stop(paste("only", length(res), "list elements were send by server out of", nelem, "expected.\n")) 
        } else {
            if(verbose) cat(paste("... and I have received", nelem, "lines as expected.\n"))
        }
        #
        # Extracting info
        #
        req <- vector(mode = "list", length = nelem)
        for(i in seq_len(nelem)){
            x <- parser.socket(res[i])
            req[[i]] <- as.SeqAcnucWeb(substr(x[2], 2, nchar(x[2]) - 1), x[3], x[6], x[7])
        }
        #
        # Virtual list case:
        #
    } else {
        if(verbose) cat("I'am *not* trying the infos about the elements of the list since virtual is TRUE.\n")
        req <- NA
    }
    #
    # Assign results in user workspace:
    #
    result <- list(call = match.call(), name = listname, nelem = nelem, typelist = typelist, 
                   req = req, socket = socket)
    class(result) <- c("qaw")
    assign(listname, result, envir = .seqinrEnv)
}

#
# Print method:
#

print.qaw <- function(x, ...)
{
    if(is.null(x$call$query)) x$call$query <- x$call$listname
    cat(x$nelem, x$type, "for", x$call$query)
}

########################################################################
#                         oriloc
#
# Prediction of replication boundaries in unannotated genomes
#
########################################################################

oriloc <- function(
        seq.fasta = system.file("sequences/ct.fasta.gz", package ="seqinr"),
        g2.coord = system.file("sequences/ct.predict", package = "seqinr"),
        glimmer.version = 3,
        oldoriloc = FALSE,
        gbk = NULL,
        clean.tmp.files = TRUE,
        rot = 0)
{
    aGBKfileWasGiven <- !missing(gbk) && !is.null(gbk)
    if(aGBKfileWasGiven) # Work directly with genbank file
    {
        tmpgbk <- tempfile(pattern = "orilocgbk")
        if(substr(gbk,1,7)=="http://" || substr(gbk,1,6)=="ftp://" || substr(gbk,1,7)=="file://"){
            utils::download.file( gbk, destfile = tmpgbk )
        }
        else{
            file.copy(from = gbk, to = tmpgbk)
        }
        seq.fasta <- tempfile(pattern = "orilocfasta")
        g2.coord <- tempfile(pattern = "orilocg2")
        
        gb2fasta( tmpgbk, seq.fasta )
        gbk2g2( tmpgbk, g2.coord )
        #
        # gbk2g2 yields glimmer version 2.0 files, so force to version 2.0 in this case:
        #
        glimmer.version <- 2
    } 
    #  
    # Get first sequence from fasta file:
    #
    seq <- read.fasta(file = seq.fasta, set.attributes = FALSE)[[1]]
    lseq <- length(seq)
    #
    # Read CDS coordinate file:
    #
    g2 <- readLines( g2.coord )
    #
    # Patch for glimmer3 version:
    #
    if( glimmer.version > 2 ){
        # remove first line:
        g2 <- g2[-1]
        # remove first three characters (i.e. orf)
        g2 <- sapply(g2, function(x) substr(x,4,nchar(x)), USE.NAMES = FALSE)
    }
    #
    # Extract info from g2.coord file
    #
    tokens <- function( string )
    {
        tmp <- unlist(strsplit( string, split = " "))
        tmp[nchar(tmp) > 0 ][seq_len(3)]
    }
    tmp <- sapply( g2, tokens )
    gnum  <- as.numeric(tmp[1, ]) # gene number in g2.coord
    start <- as.numeric(tmp[2, ]) # start positions in bp
    end   <- as.numeric(tmp[3, ]) # end position in bp
    
    if( length(start) != length(end) )
        stop("start and end vector must be the same length")
    #
    # Rotate the genome if required
    #
    if( rot != 0 )
    {
        #
        # Circular permutation of a vector
        #
        rotate <- function(x, rot = 0) 
        {
            n <- length(x)
            rot <- rot %% n
            if(rot == 0)
            {
                x
            } 
            else 
            {
                c(x[(rot+1):n],x[seq_len(rot)])
            }
        } 
        seq <- rotate(x  = seq, rot = rot )
        start <- start - rot
        end <- end - rot
        
        start[ start < 1 ] <- start[ start < 1 ] + lseq
        end[ end < 1] <- end[ end < 1 ] + lseq
        
        gnum <- gnum[order(start)]
        end <- end[order(start)]
        
        start <- sort(start)
    }
    #
    #
    #
    pos <- (start + end)/2000    # Mid gene position in Kb
    ncds <- length(pos)
    #
    # CDS that wrap around the genome
    #
    wrap <- abs(end-start) > lseq/2
    
    #
    # Compute the DNA walk gene by gene in third codon positions
    #
    x <- integer(ncds)
    y <- integer(ncds)
    skew <- numeric(ncds)
    CDS.excess <- integer(ncds)
    
    for( i in order(pos) )
    {
        # Look for third codon position
        
        if( !wrap[i] ) # regular cds that do not wrap around the genome
        {
            if( start[i] < end[i] ) # CDS 5'->3' direct strand
            {
                CDS.excess[i] <- 1
                tcp <- seq( from = start[i] + 2, to = end[i], by = 3)
            }
            else # complementary strand
            {
                CDS.excess[i] <- -1
                tcp <- seq( from = start[i] - 2, to = end[i], by = -3)
            }
        }
        else # a cds that wraps around the genome
        {
            if( start[i] > end[i] ) # CDS 5'->3' direct strand
            {
                CDS.excess[i] <- 1
                tcp <- seq( from = start[i] + 2, to = lseq + end[i], by = 3)
                tcp[ tcp > lseq ] <- tcp[ tcp > lseq ] - lseq
            }
            else # CDS 3'->5' complementary strand
            {
                CDS.excess[i] <- -1
                tcp <- seq( from = start[i] - 2, to = -(lseq-end[i]), by = -3)
                tcp[ tcp < 1 ] <- tcp[ tcp < 1 ] + lseq
            }
        }
        
        tcnucl <- seq[tcp]
        x[i] <- length(tcnucl[tcnucl=="t"]) - length(tcnucl[tcnucl=="a"])
        y[i] <- length(tcnucl[tcnucl=="c"]) - length(tcnucl[tcnucl=="g"])
    }
    x <- cumsum(x)
    y <- cumsum(y)
    CDS.excess <- cumsum(CDS.excess)
    #
    # Old oriloc program, direct from C without trying to vectorize.
    # To reproduce old results.
    #
    if( oldoriloc )
    {
        Regression <- function(x, y, Li)
        {
            a <- 0 ; b <- 0 ; c <- 0;
            for( m in seq_len(Li-1) ) # I think this should go to Li included
            {
                b <- b + y[m]^2
                a <- a + x[m]^2
                c <- c + x[m]*y[m]
            }
            alfa1 <- (atan(2*c/(a-b)))/2 
            alfa2 <- alfa1 - pi/2;
            derivate1 <- 2*(a-b)*cos(2*alfa1)+4*c*sin(2*alfa1)
            
            if(derivate1 < 0)
                return( tan(alfa2) )
            else
                return( tan(alfa1) )
        }
        
        slope <- Regression( x, y, ncds )
        
        for ( i in seq_len(ncds))
        {
            X.line <- ( y[i] + slope*x[i] )/(2*slope)
            Y.line <- slope*X.line        
            distance <- sqrt( Y.line^2 + X.line^2 )
            
            if( Y.line < 0 )
                distance <- -distance
            
            skew[i] <- distance
        }
    }
    else # New oriloc program
    {
        #
        # Project DNAwalk points (x,y) onto orthogonal regression line
        #
        pca <- ade4::dudi.pca( cbind(x,y), scann = FALSE, nf = 1, scale = FALSE, center = FALSE )
        rec <- ade4::reconst(pca)
        skew <- sign(rec$x)*sqrt(rec$x^2+rec$y^2)
    }
    #
    # Try to get get a correct orientation (same as GC skew)
    #
    if( stats::cor(skew, y ) < 0 )
        skew <- -skew
    #
    # Build result
    #
    result <- data.frame( cbind( gnum, start/1000, end/1000,
                                 CDS.excess, skew, x, y) )
    names(result) <- c("g2num", "start.kb", "end.kb", "CDS.excess",
                       "skew","x","y")
    #
    # Delete temporary files if requested:
    #
    if(aGBKfileWasGiven && clean.tmp.files)
    {
        file.remove(tmpgbk)
        file.remove(seq.fasta)
        file.remove(g2.coord)
    } 
    #
    # the end
    #
    return(result)
}

move <- function(from, to){
    noms <- as.list(match.call())
    if(noms$from != noms$to){
        eval.parent(parse(text = paste(noms$from, "->", noms$to)))
        eval.parent(parse(text = paste("rm(", noms$from, ")")))
    }
}

mv <- move

read.fasta <- function(file = system.file("sequences/ct.fasta.gz", package = "seqinr"), 
                       seqtype = c("DNA", "AA"), as.string = FALSE, forceDNAtolower = TRUE,
                       set.attributes = TRUE, legacy.mode = TRUE, seqonly = FALSE, strip.desc = FALSE,
                       whole.header = FALSE,
                       bfa = FALSE, sizeof.longlong = .Machine$sizeof.longlong,
                       endian = .Platform$endian, apply.mask = TRUE)
{
    
    seqtype <- match.arg(seqtype) # default is DNA
    
    ##############################
    #
    # Regular flat FASTA text file
    #
    ##############################
    if(!bfa){ # Regular text file
        #
        # Read the fasta file as a vector of strings:
        #
        lines <- readLines(file)
        #
        # Remove comment lines starting with a semicolon ';'
        #
        if(legacy.mode){
            comments <- grep("^;", lines)
            if(length(comments) > 0) lines <- lines[-comments]
        }
        #
        # Get the line numbers where sequences names are:
        #
        ind <- which(substr(lines, 1L, 1L) == ">")
        #
        # Compute the total number of sequences:
        #
        nseq <- length(ind)
        if(nseq == 0){
            stop("no line starting with a > character found")
        }
        #
        # Localize sequence data:
        #
        start <- ind + 1
        end <- ind - 1
        end <- c(end[-1], length(lines))
        #
        # Read sequences:
        #
        sequences <- lapply(seq_len(nseq), function(i) paste(lines[start[i]:end[i]], collapse = ""))
        if(seqonly) return(sequences)
        #
        # Read sequence names:
        #
        if(!whole.header){
            nomseq <- lapply(seq_len(nseq), function(i){
                firstword <- strsplit(lines[ind[i]], " ")[[1]][1]
                substr(firstword, 2, nchar(firstword))
            })
        } else {
            nomseq <- lapply(seq_len(nseq), function(i){
                substr(lines[ind[i]], 2, nchar(lines[ind[i]]))
            })  
        }
        #
        # Turn DNA sequences in lower case letters if required:
        #
        if(seqtype == "DNA"){
            if(forceDNAtolower){
                sequences <- as.list(tolower(sequences))
            }
        }
        #
        # Turn it into a vector of single chars if required:
        #
        if(as.string == FALSE) sequences <- lapply(sequences, s2c)
        #
        # Set sequence attributes when required:
        #
        if(set.attributes){
            for(i in seq_len(nseq)){
                Annot <- lines[ind[i]]
                if(strip.desc) Annot <- substr(Annot, 2L, nchar(Annot))
                attributes(sequences[[i]]) <- list(name = nomseq[[i]], 
                                                   Annot = Annot,
                                                   class = switch(seqtype, "AA" = "SeqFastaAA", "DNA" = "SeqFastadna"))
            }
        }
        #
        # Give the sequences names to the list elements:
        #
        names(sequences) <- nomseq
        return(sequences)
    }
    ##############################
    #
    # MAQ binary FASTA file
    #
    ##############################
    if(bfa){
        if(seqtype != "DNA") stop("binary fasta file available for DNA sequences only")
        # Open file in binary mode:
        mycon <- file(file, open = "rb")
        r2s <- words(4) # byte to tetranucleotide
        
        readOneBFARecord <- function(con, sizeof.longlong, endian, apply.mask){
            len <- readBin(con, n = 1, what = "int", endian = endian)
            if(length(len) == 0) return(NULL) # end of file 
            name <- readBin(con, n = 1, what = "character", endian = endian)
            ori_len <- readBin(con, n = 1, what = "int", endian = endian)
            len <- readBin(con, n = 1, what = "int", endian = endian)
            seq <- readBin(con, n = len*sizeof.longlong, what = "raw", size = 1, endian = endian)
            mask <- readBin(con, n = len*sizeof.longlong, what = "raw", size = 1, endian = endian)
            if(endian == "little"){
                neword <- sizeof.longlong:1 + 
                    rep(seq(0, (len - 1)*sizeof.longlong, by = sizeof.longlong), 
                        each = sizeof.longlong)
                # something like 8 7 6 5 4 3 2 1 16 15 14 13 12 11 10 9 ...
                seq <- seq[neword]
                mask <- mask[neword]
            }
            seq4 <- c2s(r2s[as.integer(seq) + 1])
            seq4 <- substr(seq4, 1, ori_len)
            if(apply.mask){
                mask4 <- c2s(r2s[as.integer(mask) + 1])
                mask4 <- substr(mask4, 1, ori_len)
                npos <- gregexpr("a", mask4, fixed = TRUE)[[1]]
                for(i in npos) substr(seq4, i, i + 1) <- "n"
            }
            return(list(seq = seq4, name = name))
        } # end readOneBFARecord
        
        sequences <- vector(mode = "list")
        nomseq <- vector(mode = "list")
        i <- 1
        repeat{
            res <- readOneBFARecord(mycon, sizeof.longlong, endian, apply.mask)
            if(is.null(res)) break
            sequences[[i]] <- res$seq
            nomseq[[i]] <- res$name
            i <- i + 1
        }
        close(mycon)
        nseq <- length(sequences)
        if(seqonly) return(sequences)
        if(as.string == FALSE) sequences <- lapply(sequences, s2c)
        if(set.attributes){
            for(i in seq_len(nseq)){
                if(!strip.desc) Annot <- c2s(c(">", nomseq[[i]]))
                attributes(sequences[[i]]) <- list(name = nomseq[[i]], 
                                                   Annot = Annot, class = "SeqFastadna")
            }
        }
        names(sequences) <- nomseq
        return(sequences)
    }
}

count <- function(seq, wordsize, start = 0, by = 1, freq = FALSE, alphabet = s2c("acgt"), frame = start){
    #
    # For backward compatibility:
    #
    if(!missing(frame)) start = frame
    #
    # istarts contains the first position of oligomers in the sequence (starting at 1)
    #
    istarts <- seq(from = 1 + start, to = length(seq), by = by)
    #
    # oligos contains the first character of oligomers:
    #
    oligos <- seq[istarts]
    #
    # oligos.levels contains all possible oligomers for a given alphabet:
    #
    oligos.levels <- levels(as.factor(words(wordsize, alphabet = alphabet)))
    #
    # For n-mers with n >= 2 we paste the following characters in the
    # sequence to build the observed set of all oligomers. Some NA are
    # generated at the end of the sequence and discarded when counting
    # them.
    #
    if (wordsize >= 2){
        for(i in 2:wordsize){
            oligos <- paste(oligos, seq[istarts + i - 1], sep = "")
        }
    }
    #
    # We count all oligomers, even missing ones, and discard NA
    #
    counts <- table(factor(oligos, levels = oligos.levels))
    #
    # Build result:
    #
    if(freq == TRUE) counts <- counts/sum(counts)
    return(counts)
}

pmw <- function(seqaa, Ar = c(C = 12.0107, H = 1.00794, O = 15.9994,
                              N = 14.0067, P = 30.973762, S = 32.065), gravity = 9.81,
                unit = "gram", checkseqaa = TRUE){
    #
    # Check arguments:
    #
    if( ! unit %in% c("gram", "N") ) stop("Non allowed unit argument") 
    if( any(Ar < 0)) stop("Negative Ar not allowed")
    if( gravity < 0 ) stop("Antigravity not allowed")
    if( nchar(seqaa[1]) > 1) stop("seqaa should be a vector of single chars")
    allowed <- s2c("*ACDEFGHIKLMNPQRSTVWY")
    if(checkseqaa) if(! all(seqaa %in% allowed) ) warning("Non allowed characters in seqaa")
    #
    # Compute aa frequencies:
    #
    comp <- table(factor(seqaa, levels = allowed))
    if( sum(comp[-which(names(comp) == "*")]) == 0) stop("Zero length protein not allowed")
    #
    # Compute the molecular weigth of one mol of an amino-acid from its composition:
    #
    aamw <- function(chonps){
        mw <- chonps[1]*Ar["C"] + chonps[2]*Ar["H"] + chonps[3]*Ar["O"] +
            chonps[4]*Ar["N"] + chonps[5]*Ar["P"] + chonps[6]*Ar["S"]
        if(unit == "gram"){
            return(mw*gravity/9.81)
        } else {
            return(mw*gravity/1000)
        }
    }
    
    #
    # Compute molecular weight:
    #
    mw <- comp["A"]*aamw(c(3,7,2,1,0,0)) +
        comp["C"]*aamw(c(3,7,2,1,0,1)) +
        comp["D"]*aamw(c(4,7,4,1,0,0)) +
        comp["E"]*aamw(c(5,9,4,1,0,0)) +
        comp["F"]*aamw(c(9,11,2,1,0,0)) +
        comp["G"]*aamw(c(2,5,2,1,0,0)) +
        comp["H"]*aamw(c(6,9,2,3,0,0)) +
        comp["I"]*aamw(c(6,13,2,1,0,0)) +
        comp["K"]*aamw(c(6,14,2,2,0,0)) +
        comp["L"]*aamw(c(6,13,2,1,0,0)) +
        comp["M"]*aamw(c(5,11,2,1,0,1)) +
        comp["N"]*aamw(c(4,8,3,2,0,0)) +
        comp["P"]*aamw(c(5,9,2,1,0,0)) +
        comp["Q"]*aamw(c(5,10,3,2,0,0)) +
        comp["R"]*aamw(c(6,14,2,4,0,0)) +
        comp["S"]*aamw(c(3,7,3,1,0,0)) +
        comp["T"]*aamw(c(4,9,3,1,0,0)) +
        comp["V"]*aamw(c(5,11,2,1,0,0)) +
        comp["W"]*aamw(c(11,12,2,2,0,0)) +
        comp["Y"]*aamw(c(9,11,3,1,0,0))
    #
    # Remove n - 1 water molecules:
    #
    mw <- mw - (sum(comp[-which(names(comp) == "*")]) - 1)*aamw(c(0,2,1,0,0,0))
    names(mw) <- NULL
    return(mw)
}

plotPanels <- function(kitname, data, xlim = NULL, cex = 0.75, alpha = 0.5){
    df <- data[[kitname]]
    df$marker <- as.character(df$marker)
    df[df$marker == "AMEL", "marker"] <- "A"
    dcoln <- unique(as.character(df$dye.col))
    ncol <- length(dcoln)
    bmin <- min(df$min.bp)
    bmax <- max(df$max.bp)
    if(is.null(xlim)) xlim <- c(bmin, bmax)
    graphics::plot.new()
    graphics::plot.window(xlim = xlim, ylim = c(0, ncol))
    yscale <- (ncol-1):0
    names(yscale) <- dcoln
    for(i in 1:nrow(df)){
        col <- as.character(df[i, "dye.col"])
        colalpha <- col2alpha(col, alpha)
        graphics::rect(df[i, "min.bp"], yscale[col] + 0.25, df[i, "max.bp"], yscale[col] + 0.5, col = colalpha)
        graphics::text(df[i, "min.bp"], yscale[col]+0.75, df[i, "marker"], pos = 4, cex = cex)
    }
    graphics::title(main = kitname, xlab = "Amplicon Size Ranges [bp]")
    graphics::axis(1)
}

reverse.align <- function(nucl.file,
                          protaln.file,
                          input.format = "fasta",
                          out.file,
                          output.format = "fasta",
                          align.prot = FALSE,
                          numcode = 1,
                          clustal.path = NULL,
                          forceDNAtolower = TRUE,
                          forceAAtolower = FALSE){
    #
    # Sequence import section
    #
    seq.nucl <- read.fasta(nucl.file, forceDNAtolower = forceDNAtolower)
    nseqs <- length(seq.nucl) # number of sequences
    
    if(!isTRUE(align.prot)){  ## the protein alignment file is provided 
        protaln <- read.alignment(protaln.file, format = input.format,
                                  forceToLower = forceAAtolower)
    } else { ## protein alignment file not provided, have to align with clustal 
        tmp <- tempfile(pattern = "clustal")
        protseq.file <- tempfile(pattern = "protein")
        write.fasta(sequences = lapply(seq.nucl, function(x)
            translate(x, numcode = numcode)), names = names(seq.nucl), file.out = protseq.file) 
        system(paste(clustal.path, " -outfile=", tmp ," -infile=", protseq.file, sep = ""))
        protaln <- read.alignment(tmp, format = "clustal", forceToLower = forceAAtolower)
        input.format <- "clustal"
    }
    #
    # Force sequences to be in the same order in the nucleic and protein
    # versions. Use the protein order.
    #
    ordername <- unlist(lapply(protaln$nam, function(x) which(names(seq.nucl) == x)))
    seq.nucl <- seq.nucl[ordername]
    #
    # The character used to represent gaps is function of the alignment file format.
    #
    gapchar <- NULL
    if(input.format %in% c("fasta", "clustal", "phylip", "mase")){
        gapchar <- "-"
    }
    if(input.format == "msf"){
        gapchar <- "."
    }
    if(is.null(gapchar)) stop("no known gap character for this alignment format")
    #
    # Memory allocation, cds.aln is the result to write in file.out
    #
    cds.aln <- vector(mode = "list", length = nseqs)
    names(cds.aln) <- protaln$nam
    #
    # index[[j]] is for current position in nucleic acid sequences number j
    # expressed in codon units.
    #
    index <- as.list(rep(0, nseqs))
    names(index) <- protaln$nam
    #
    # Main loop to build the reverse alignment.
    # "allaln" is a flag still TRUE if no gap was found in a column.
    #
    ncharprot <- nchar(protaln$seq[1]) # number of AA + gaps
    for(k in seq_len(ncharprot)){
        allaln <- TRUE
        for(j in seq_len(nseqs)){
            if(substr(protaln$seq[j], k, k) != gapchar){
                index[[j]] <- index[[j]] + 1
            } else {
                allaln <- FALSE
            }
        }
        if(allaln){
            #
            # There was no gap in this column, we include the corresponding codon
            # in the nucleic acid alignment:
            #
            for(j in seq_len(nseqs)){
                cds.aln[[j]] <- c(cds.aln[[j]], seq.nucl[[j]][(3*index[[j]]-2):(3*index[[j]])])
            }
        }
    }
    #
    # Write into output file the reverse alignment.
    #
    write.fasta(sequences = cds.aln, names = names(seq.nucl), file.out = out.file, open = "w")
    return(NULL)
}

# ==> quit
# <==  OK acnuc socket closed
# To close the socket and stop communication over it.

quitacnuc <- function(socket){
    writeLines("quit", socket, sep = "\n")
    rep <- readLines(socket, n = 1)
    if(rep != "OK acnuc socket stopped"){
        stop("I do not understand answer for quitacnuc from server, please contact package maintainer.\n")
    }  
}

baselineabif <- function(rfu, maxrfu = 1000){
    #
    # Check argument:
    #
    if(!is.numeric(rfu)) stop("numerical vector expected for rfu")
    #
    # Do not consider data above threshold maxrfu:
    #
    rfu[rfu >= maxrfu] <- NA
    #
    # Compute a kernel density estimate of data:
    #
    dst <- stats::density(rfu, na.rm = TRUE)
    #
    # Choose as baseline the most common value:
    #
    baseline <- dst$x[which.max(dst$y)]
    return(baseline)
}

#                 fastacc: Fast Allele in Common Count
#
# Computes the number of common alleles between a target and a database
#
fastacc <- function(target, database)
{
    #
    # Check arguments:
    #
    if(!is.raw(target)) stop("raw vector expected for target")
    noc <- length(target)
    if(noc < 1) stop("empty target")
    if(!is.raw(database)) stop("raw vector expected for database")
    if(length(database) %% noc != 0) stop("database length must be a multiple of target length")
    #
    # n is the total number of entries in DB
    #
    n <- length(database)/noc
    n <- as.integer(n)
    #
    # Pre-compute the table giving the number of bits per octet
    #
    bits_in_char <- sapply(as.raw(0:255), function(x) sum(as.integer(rawToBits(x))))
    bits_in_char <- as.integer(bits_in_char) # just to make sure
    
    res <- .Call("fastacc", bits_in_char, target, database, noc, n, PACKAGE = "seqinr")
    
    return(res)
}

# ==>   gfrag&[number=xx|name=xx]&start=xx&length=xx
# <==  length=xx&....sequence...
# Get length characters from sequence identified by name or by number 
# starting from position start (counted from 1).
# Reply gives the length read (may be shorter than asked for) and then the characters; 
# length can be 0 if any error.

gfrag <- function(what, start, length, idby = c("name", "number"), socket = autosocket()){
    #
    # Default is by name:
    #
    idby <- idby[1]
    if(!(idby %in% c("name", "number"))) stop("Wrong idby agument")
    #
    # Build request:
    #
    request <- paste("gfrag&", idby, "=", what, "&start=", formatC(start, format = "d"),
                     "&length=", formatC(length, format = "d"), sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Check that no error code is returned by server:
    #
    if(substr(x = answerFromServer, start = 1, stop = 5) == "code="){
        warning(paste("Server returned error code:", answerFromServer))
        return(NA)
    }
    #
    # Extract sequence from server:
    #
    n <- nchar(answerFromServer)
    for(i in seq_len(n)) if (substr(answerFromServer, start = i, stop = i) == "&") break
    result <- substr(answerFromServer, start = i + 1, stop = n)
    return(result)
}

#
# To get the length of sequences
#

getLength <-  function(object, ...)  UseMethod("getLength")

getLength.default <- function(object, ...)
    stop(paste("no getLength method for objects of class:", class(object)))

getLength.list <- function(object, ...)
    sapply(seq_len(length(object)), function(i) getLength(object[[i]], ...))

getLength.character <- function(object, ...){
    if(length(object) == 1)
    {
        return(length(s2c(object)))
    } 
    else 
    {
        return(sum(nchar(object)))
    }
}

getLength.SeqFastadna <- function(object, ...) length(getSequence(object, as.string = FALSE))
getLength.SeqFastaAA <- getLength.SeqFastadna

getLength.SeqAcnucWeb <- function(object, ...) attr(object, "length")

getLength.qaw <- function(object, ...) getLength(object$req, ...)

getLength.logical <- function (object, ...)
    object # so that NA is returned for virtual lists

getLength.SeqFrag <- function(object, ...) attr(object, "end") - (attr(object, "begin") + 1)

# ==> clientid&id="xxxxx"
# <==  code=0
# Sends the server an identification of the client, typically a program name.

clientid <- function(id = paste("seqinr_", packageDescription("seqinr")$Version, sep = ""), socket, verbose = FALSE){
    #
    # Client ID definition : seqinr + package version number
    #  (internal note: log file is: /mnt/users/ADE-User/racnuc/log)
    #
    request <- paste("clientid&id=", id, sep = "")
    if(verbose) cat(paste("clientid(): sending", request, "\n"))
    writeLines( request, socket, sep = "\n")
    rep <- readLines(socket, n = 1)
    if(verbose) cat(paste("... answer from server is:", rep, "\n"))
    res <- parser.socket(rep, verbose = verbose)
    if( res[1] != "0") {
        print(rep)
        stop("I don't know what this error code means for clientid, please contact package maintener.\n")
    }
}

################################
# G+C content
#################################

GC <- function(seq, forceToLower = TRUE, exact = FALSE, NA.GC = NA, oldGC = FALSE,  alphabet = s2c("acgtswmkryvhdb"))
{
    
    
    
    #
    # NA propagation:
    #
    if(length(seq) == 1 && is.na(seq)) return(NA)
    #
    # Check that sequence is a vector of chars:
    #
    if(nchar(seq[1]) > 1) stop("sequence is not a vector of chars")
    #
    # Force to lower-case letters if requested:
    #
    if(forceToLower) seq <- tolower(seq)
    
    seq <- seq[seq %in% alphabet]
    
    #
    # Compute the count of each base:
    #
    nc <- sum( seq == "c" )
    ng <- sum( seq == "g" )
    na <- sum( seq == "a" )
    nt <- sum( seq == "t" )
    
    #
    # oldGC case:
    #
    if(oldGC){
        warning("argument oldGC is deprecated")
        return( (nc + ng)/length(seq) )
    }
    
    #
    # General case:
    #
    if(! exact){
        if(na + nc + ng + nt == 0){
            result <- NA.GC
        } else {
            result <- (nc + ng)/(na + nc + ng + nt)
        }
    } else {
        #
        # We have our first estimate of GC vs. AT base counts:
        #
        ngc <- ng + nc
        nat <- na + nt
        
        #
        # weak and strong bases are 100% informative with respect
        # to the GC content, we just add them:
        #
        # s : Strong (g or c)
        # w : Weak (a or t)
        #
        ngc <- ngc + sum( seq == "s" )
        nat <- nat + sum( seq == "w" )
        
        ##########################
        # Ambiguous base section #
        ##########################
        
        #
        # m : Amino (a or c)
        #
        if(na + nc != 0){
            nm <- sum( seq == "m")
            ngc <- ngc + nm*nc/(na + nc)
            nat <- nat + nm*na/(na + nc)
        }
        
        #
        # k : Keto (g or t)
        #
        if(ng + nt != 0){
            nk <- sum( seq == "k" )
            ngc <- ngc + nk*ng/(ng + nt)
            nat <- nat + nk*nt/(ng + nt)
        }
        
        #
        # r : Purine (a or g)
        #
        if(ng + na != 0){
            nr <- sum( seq == "r" )
            ngc <- ngc + nr*ng/(ng + na)
            nat <- nat + nr*na/(ng + na)
        }
        
        #
        # y : Pyrimidine (c or t)
        #
        if(nc + nt != 0){
            ny <- sum( seq == "y" )
            ngc <- ngc + ny*nc/(nc + nt)
            nat <- nat + ny*nt/(nc + nt)
        }
        
        #
        # v : not t (a, c or g)
        #
        if(na + nc + ng != 0){
            nv <- sum( seq == "v" )
            ngc <- ngc + nv*(nc + ng)/(na + nc + ng)
            nat <- nat + nv*na/(na + nc + ng)
        }
        #
        # h : not g (a, c or t)
        #
        if(na + nc + nt != 0){
            nh <- sum( seq == "h" )
            ngc <- ngc + nh*nc/(na + nc + nt)
            nat <- nat + nh*(na + nt)/(na + nc + nt)
        }
        #
        # d : not c (a, g or t)
        #
        if(na + ng + nt != 0){
            nd <- sum( seq == "d" )
            ngc <- ngc + nd*ng/(na + ng + nt)
            nat <- nat + nd*(na + nt)/(na + ng + nt)
        }
        #
        # b : not a (c, g or t)
        #
        if(nc + ng + nt != 0){
            nb <- sum( seq == "b" )
            ngc <- ngc + nb*(nc + ng)/(nc + ng + nt)
            nat <- nat + nb*nt/(nc + ng + nt)
        }
        #
        # n : any (a, c, g or t) is not informative, so
        # we compute the G+C content as:
        #
        if( ngc + nat == 0){
            result <- NA.GC
        } else {
            result <- ngc/(ngc + nat)
        }
    }
    return(result)
}

######################
# GCpos		     #
######################

GCpos <- function(seq, pos, frame = 0, ...){
    if(nchar(seq[1]) > 1){
        warning("sequence is not a vector of chars, I'm trying to cast it into one")
        seq <- s2c(seq[1])
    }
    #
    # Take frame into account:
    #
    if(frame != 0) seq <- seq[(1 + frame):length(seq)]
    #
    # Return result:
    #
    GC(seq[seq(pos, length(seq), by = 3)], ...)
}

######################
# GC1		     #
######################

GC1 <- function(seq, frame = 0, ...) GCpos(seq = seq, pos = 1, frame = frame, ...)

######################
# GC2		     #
######################

GC2 <- function(seq, frame = 0, ...) GCpos(seq = seq, pos = 2, frame = frame, ...)

######################
# GC3		     #
######################

GC3 <- function(seq, frame = 0, ...) GCpos(seq = seq, pos = 3, frame = frame, ...)

splitseq <- function(seq, frame = 0, word = 3){
    #
    # Compute all start positions of words to be returned:
    #
    starts <- seq(from = frame + 1, to = length(seq), by = word)
    #
    # Extract them all:
    #
    res <- sapply(starts, function(x) c2s(seq[x:(x + word - 1)]))
    #
    # remove last one if uncorrect length:
    #
    if(nchar(res[length(res)]) != word) res <- res[-length(res)]
    return(res)
}

# Recuperation des sequences
# Simon Octobre 2006




##########################################################################################
#                                                                                                 #
#                                         extractseqs.socket                                       #
#                                                                                                 #
##########################################################################################

extractseqs <- function(listname, socket = autosocket(), format="fasta", operation="simple", feature="xx", bounds="xx", minbounds="xx", verbose = FALSE, nzlines=1000, zlib = FALSE){
    if (zlib == TRUE && .Platform$OS.type == "windows") {
        stop(paste("Zlib compressed sockets is not implemented for windows.\n"))
    }
    debug<-0
    if (verbose) debug <- 1
    
    if(verbose) cat("I'm checking the arguments...\n")
    
    if( !inherits(socket, "sockconn") ) stop(paste("argument socket = ", socket, "is not a socket connection."))
    if( !is.character(listname) ) stop(paste("argument listname = ", listname, "is not a character string."))
    if(verbose) cat("... and everything is OK up to now.\n")
    
    
    # Check arguments:
    # Check if  format is acnuc", "fasta", or "flat"
    
    if(verbose) cat("Format is ",format,"\n")
    if ((format != "fasta") &&  (format != "flat") && (format != "acnuc")) stop(paste("argument format = ", format, "is wrong. Format should be \"fasta\", \"flat\" or \"acnuc\"! "))
    
    
    # Check if operation "is simple", "translate", "fragment", "feature" or "region"
    
    if(verbose) cat("Operation is ",operation,"\n")
    if ((operation != "simple") && (operation != "translate") && (operation != "fragment") && (operation != "feature") && (operation != "region") ) {
        stop(paste("argument operation = ", operation, "is wrong. Operation should be \"simple\", \"translate\", \"fragment\", \"feature\" or \"region\"! "))
    }
    
    
    # Check optionals
    
    if ((feature != "xx") && (verbose))cat("feature = ", feature, ".\n")
    if ((bounds != "xx") && (verbose))  cat("bounds = ", bounds, ".\n")
    if ((minbounds != "xx") && (verbose))  cat("minbounds = ", minbounds, ".\n")
    
    
    if ((operation == "feature") && (feature =="xx")) stop(paste("You should specify a feature!\n"))
    
    if ((operation == "fragment") && (bounds =="xx")) stop(paste("You should specify bounds!\n"))
    
    if ((operation == "region") && ((bounds =="xx") || (feature =="xx"))) stop(paste("You should specify bounds and region!\n"))
    
    #
    # Build request:
    #
    # listname is a list
    
    lrank <- glr(listname)
    if(verbose) cat("The rank of the list ",listname, "is ",lrank,".\n")
    if (is.na(lrank)) {
        stop(paste("Problem in rank list!\n"))
    }
    
    request <- paste("extractseqs&lrank=", lrank, "&format=", format, "&operation=", operation, sep = "")
    if (feature != "xx") request <- paste(request,"&feature=", feature, sep = "")
    if (bounds != "xx") request <- paste(request,"&bounds=",bounds, sep = "")
    if (minbounds != "xx") request <- paste(request,"&minbounds=",minbounds, sep = "")
    
    if(zlib) {
        request <- paste(request,"&zlib=T", sep = "")
    }
    else {
        request <- paste(request,"&zlib=F", sep = "")
    }
    if(verbose) cat("request : ",request,"\n")
    
    # Write request into the socket:
    
    writeLines(request , socket, sep="\n")
    
    # Read result from server:
    
    if(zlib) {
        lastres <-  .Call("getzlibsock", socket, nzlines, debug,PACKAGE = "seqinr")
    }
    else {
        lastres <- readLines(socket)
    }
    if(zlib) {
        #
        # Remove empty lines at the end of lastres:
        #
        return( lastres[nchar(lastres) != 0] )
    }
    else {
        #
        # Remove flags from server:
        #
        lastres <- lastres[-1]                       # code=0
        lastres <- lastres[-length(lastres)]         # extractseqs END. 
        lastres <- lastres[-grep("count=", lastres)] # count=
        return(lastres)
    }
}

#
# Define a shorthcut for extractseqs
#
exseq <- extractseqs

#
# To extract a subsequence from a sequence
#

getFrag <-  function(object, begin, end, ...) UseMethod("getFrag")

getFrag.default <-  function(object, begin, end, ...)
    stop(paste("no getFrag method for objects of class:", class(object)))

getFrag.list <- function(object, begin, end, ...)
    lapply(seq_len(length(object)), function(i) getFrag(object[[i]], begin = begin, end = end, ...))

getFrag.character <- function(object, begin, end, ...){ 
    if(length(object) == 1) object <- s2c(object)	
    if(begin > length(object) || end > length(object) || begin > end) stop("borns are not correct")	
    return(object[begin:end])		
}

getFrag.SeqFastadna <- function(object, begin, end, ..., name = getName(object)){
    if(end > getLength(object)) stop("invalid end")	
    as.SeqFrag(getSequence(object, as.string = FALSE)[begin:end], begin = begin, end = end,
               name = name)
}
getFrag.SeqFastaAA <- getFrag.SeqFastadna

getFrag.SeqFrag <- function(object, begin, end, ..., name = getName(object)){
    if((end<begin) || (end>getLength(object)))  stop("invalid end")
    newBegin <-  attr(object, "begin") + begin - 1
    newEnd <- attr(object, "begin") + end - 1
    newSeq <- object[begin:end]
    as.SeqFrag(object = newSeq, begin = newBegin, end = newEnd, name = name)
}

getFrag.SeqAcnucWeb <- function(object, begin, end, ..., socket = autosocket(), name = getName(object)){
    lobj <- getLength(object)
    if(end > lobj) stop("end parameter is too large")
    if(begin > lobj) stop("begin parameter is too large")
    length <- end - begin + 1
    #  newSeq <- getSequenceSocket(socket, object, start = begin, length = length)
    newSeq <- gfrag(what = name, start = begin, length = length, idby = "name", socket = socket)
    as.SeqFrag(newSeq, begin = begin, end = end, name = name)
}

getFrag.qaw <- function(object, begin, end, ...) getFrag(object$req, begin, end, ...)

getFrag.logical <- function (object, begin, end, ...)
    object # so that NA is returned for virtual lists

# ==>   setlistname&lrank=xx&name="xx"
# <==  code=xx
# Sets the name of a list identified by its rank.
# Returned code : 0 if OK, 
#                 3 if another list with that name already existed and was deleted
#                 4 no list of rank exists

setlistname <- function(lrank, name = "list1", socket = autosocket()){
    #
    # Build request:
    #
    request <- paste("setlistname&lrank=", lrank, "&name=\"", name, "\"", sep = "")
    writeLines(request, socket, sep = "\n")
    answerFromServer <- readLines(socket, n = 1)
    #
    # Check that there is an answer from server:
    #
    if(length(answerFromServer) == 0){
        warning("Empty answer from server")
        return(NA)
    }
    #
    # Build result:
    #
    resitem <- parser.socket(answerFromServer)
    if(resitem[1] != "0"){
        warning(paste("code returned by server :", resitem[1]))
    }
    return(as.numeric(resitem[1]))
}

#############################################################################
#                        Rearranged oriloc                                  #  
#                                                                           #
# Detection of replication-associated effects on base composition asymmetry #
#                                                                           #
#############################################################################

rearranged.oriloc <- function(
        seq.fasta = system.file("sequences/ct.fasta.gz", package = "seqinr") ,
        g2.coord = system.file("sequences/ct.predict", package = "seqinr") )
{
    
    seq.fasta <- read.fasta(seq.fasta)[[1]]
    g2 <- readLines(g2.coord)
    g2 <- lapply(g2, function(x) unlist(strsplit(x, split=" ")))
    g2 <- lapply(g2, function(x) x[which(x!="")])
    
    start <-as.numeric(unlist(lapply(g2, function(x) x[2]))) 
    end <- as.numeric(unlist(lapply(g2, function(x) x[3])))
    strand <- rep("forward",length(start))
    strand[which(end<start)] <- "reverse"
    
    
    meancoord <- (start+end)/2
    
    ncds <- length(start)
    
    gcskew <- numeric(ncds)
    atskew <- numeric(ncds)
    
    for(i in seq_len(ncds)){
        
        cds=seq.fasta[start[i]:end[i]]
        
        g3=sum(cds[seq(from=3,to=length(cds),by=3)]%in%c("g","G"))
        c3=sum(cds[seq(from=3,to=length(cds),by=3)]%in%c("c","C"))
        t3=sum(cds[seq(from=3,to=length(cds),by=3)]%in%c("t","T"))
        a3=sum(cds[seq(from=3,to=length(cds),by=3)]%in%c("a","A"))
        
        gcskew[i]=(g3-c3)/(g3+c3)
        atskew[i]=(a3-t3)/(a3+t3)
        if(is.na(gcskew[i])){
            gcskew[i]=0
        }
        if(is.na(atskew[i])){
            atskew[i]=0
        }
        
    }
    
    neworder=c(which(strand=="forward"),which(strand=="reverse"))
    
    meancoord.rear <- seq_len(ncds)
    gcskew.rear=gcskew[neworder]
    atskew.rear=atskew[neworder]
    strand.rear=strand[neworder]
    meancoord.real=meancoord[neworder]
    data=data.frame(meancoord.rear,gcskew.rear,atskew.rear,strand.rear,neworder,meancoord.real)
    
    colnames(data)=c("meancoord.rearr","gcskew.rearr","atskew.rearr","strand.rearr","order","meancoord.real")
    
    return(data)
    
    
}

###############################################################################
#                                                                             #
#                             parser.socket                                   #
#                                                                             #
#          Utility function to parse answers from ACNUC server.               #
#                                                                             #
###############################################################################

parser.socket <- function(onelinefromserver, verbose = FALSE)
{
    if(verbose) cat(paste("parser.socket received: -->",
                          onelinefromserver,"<--\n", sep = ""))
    if(length(onelinefromserver) == 0){
        if(verbose) cat("character(0) detected returning NULL\n")
        return(NULL)
    }
    if(is.null(onelinefromserver)){
        if(verbose) cat("NULL detected returning NULL\n")
        return(NULL)
    }
    #
    # Answer from server looks like: "code=0&lrank=2&count=150513&type=SQ&locus=F"
    # 
    loc <- gregexpr("=[^=&]*", onelinefromserver)[[1]]
    substring(onelinefromserver, loc + 1, loc + attr(loc, "match.length") - 1)
}

al2bp <- function(allele.name, repeat.bp = 4, offLadderChars = "><", split = "\\."){
    allele.name <- as.character(allele.name)
    if(any(s2c(allele.name) %in% s2c(offLadderChars))) return(NA)	
    dec <- unlist(strsplit(allele.name, split = split))
    res <- repeat.bp*suppressWarnings(as.numeric(dec[1]))
    # NA are returned for X and Y at Amelogenin locus for instance
    if(length(dec) > 1) res <- res + as.numeric(dec[2])
    return(res)
}

get.db.growth <- function(where = "ftp://ftp.ebi.ac.uk/pub/databases/embl/doc/relnotes.txt" )
{
    if (!capabilities("http/ftp")) 
        stop("capabilities(\"http/ftp\") is not TRUE")
    ftp.proxy.bck <- Sys.getenv("ftp_proxy")
    if (ftp.proxy.bck != "") {
        warning("I'am trying to neutralize proxies")
        Sys.setenv("no_proxy" = "")
    }
    
    embl <- where
    tmp <- readLines( embl )
    idx <- grep("Release(.+) Month", tmp)
    tmp <- tmp[ (idx + 2):length(tmp) ]
    tmp <- strsplit( tmp, split = " " )
    not.empty <- function(x)
    {
        x <- x[nchar(x) > 0 ]
    }
    tmp <- sapply( tmp, not.empty )
    tmp <- data.frame( matrix(unlist(tmp), ncol = 4, byrow = TRUE) )
    names(tmp) <- c("Release", "Month", "Entries", "Nucleotides")
    
    tmp[,1] <- as.double( as.character(tmp[,1]))
    tmp[,3] <- as.double( as.character(tmp[,3]))
    tmp[,4] <- as.double( as.character(tmp[,4]))
    
    date  <- strsplit(as.character(tmp[,2]), split="/")
    date.to.num <- function(x)
    {
        x <- as.double( x )
        return( (x[1]-1)/12 + x[2] )
    }
    date <- sapply(date, date.to.num)
    tmp <- data.frame( cbind(tmp, date) )
    return(tmp)
}

dia.db.growth <- function( get.db.growth.out = get.db.growth(), 
                           Moore = TRUE, ... )
{
    embl <- "ftp://ftp.ebi.ac.uk/pub/databases/embl/doc/relnotes.txt"
    op <- graphics::par(no.readonly = TRUE)
    graphics::par( bg = "blue" )
    graphics::par( fg = "yellow" )
    graphics::par( col = "yellow" )
    graphics::par( col.axis = "yellow" )
    graphics::par( col.lab = "yellow" )
    graphics::par( col.main = "yellow" )
    graphics::par( col.sub = "yellow" )
    
    Nucleotides <- get.db.growth.out$Nucleotides
    Month <- get.db.growth.out$Month
    date <- get.db.growth.out$date
    
    graphics::plot( date, log10(Nucleotides) , pch = 20,
          main = paste("The exponential growth of the DDBJ/EMBL/Genbank content\n",
                       "Last update:", 
                       Month[nrow(get.db.growth.out)]),
          xlab = "Year", ylab = "Log10 number of nucleotides",
          sub = paste("Source:", embl),
          ... )
    graphics::abline(stats::lm(log10(Nucleotides)~date),col="yellow")
    lm1 <- stats::lm(log(Nucleotides)~date)
    mu <- lm1$coef[2] # slope
    dbt <- log(2)/mu # doubling time
    dbt <- 12*dbt # in months
    
    if( Moore )
    {
        x <- mean(date)
        y <- mean(log10(Nucleotides))
        a <- log10(2)/1.5
        b <- y - a*x
        
        for( i in seq(-10,10,by=0.5) )
            if( i != 0 )
                graphics::abline( coef=c(b+i, a), col="black" )
        graphics::legend( x = 1990, y = 7, legend= c(paste("Observed doubling time:", 
                                                 round(dbt,1),"months"),"Moore's doubling time : 18 months"), 
                lty = c(1,1), col = c("yellow","black"))
    }
    else
    {
        graphics::legend( x = 1990, y = 7, legend=paste("Observed doubling time:", 
                                              round(dbt,1), "months"), lty = 1, col = "yellow")
    }
    graphics::par( op )
} 

################################################################################
#
#                              plot.SeqAcnucWeb
#
################################################################################

plot.SeqAcnucWeb <- function(x, types = getType()$sname, socket = autosocket(), ...){
    verbose <- FALSE # a passer en argument si besoin est
    #
    # Check arguments:
    #
    if(!inherits(x, "SeqAcnucWeb")) stop("Sequence of class SeqAcnucWeb is needed")
    
    #
    # Save graphical parameters:
    #
    old.par <- graphics::par(no.readonly = TRUE)
    on.exit(graphics::par(old.par))
    
    if(verbose) cat(paste("types:", types, sep = "\n"))
    
    #
    # Get the parent sequence:
    #
    
    GiveMeTheMotherSequence <- paste("me n=", x, sep = "") 
    query(listname = "me", query = GiveMeTheMotherSequence, socket = socket)
    MotherLength <- as.numeric(getLength(get("me", .seqinrEnv)$req[[1]]))
    MotherName <- get("me", .seqinrEnv)$req[[1]]
    if(verbose) cat("\nMotherLength = ", MotherLength)
    
    #
    # Plot organization:
    #
    graphics::par(mar = c(2.1, 0.1, 4.1, 0.1), lend = "square", ljoin = "mitre")
    cx <- c(0, MotherLength)
    cy <- c(0, 1)
    graphics::plot(cx, cy, ann = FALSE, type = "n", axes = FALSE)
    graphics::axis(1)
    graphics::title(main = paste("Physical position of subsequences on the parent sequence",
                       MotherName, "(", MotherLength, "bp )", sep=" "))
    
    #
    # Look for subsequences:
    #
    
    GiveMeAllSubsequences <- paste("fi n=", MotherName, sep = "")
    query(listname = "filles", query = GiveMeAllSubsequences, socket = socket)
    
    n <- length(types) # number of potential subsequences types
    ispresent <- rep(FALSE, n) # will be TRUE if one or more subsequence of this type is found
    nb <- numeric(n) # count of subsequences for available types
    posi <- vector(mode = "list", length = n) # position of subsequences
    
    for(i in seq_len(n)){
        q <- paste("filles et t=", types[i], sep = "")
        if(verbose) cat("query = ", q, "\n")
        
        result <- try(query(socket = socket, listname = "tmp", query = q))
        if( inherits(result, "try-error")) next
        if(get("tmp", .seqinrEnv)$nelem == 0) next
        if(is.na(get("tmp", .seqinrEnv)$req[[1]])) next
        if(get("tmp", .seqinrEnv)$req[[1]] == x ) next
        
        ispresent[i] <- TRUE
        
        u <- lapply(get("tmp", .seqinrEnv)$req, getLocation)
        names(u) <- get("tmp", .seqinrEnv)$req
        nb[i] <- length(u)
        posi[[i]] <- u
    }
    
    #
    # Draw subsequences:
    #
    posi <- posi[ispresent]
    nb <- nb[ispresent]
    types <- types[ispresent]
    n <- length(types)
    for(i in seq_len(n)){
        for(j in seq_len(length(posi[[i]]))){
            xleft <- posi[[i]][[j]][1]
            ybottom <- (i - 1)/(n + 1)
            xright <- posi[[i]][[j]][2]
            ytop <- i/(n + 1)
            graphics::rect(xleft, ybottom, xright, ytop, col = i, border = "black", lend = "square", ljoin = "mitre" )
        }
    }
    
    #
    # Draw legend:
    #
    graphics::legend("top", legend = paste(types, "(", nb, ")", sep = ""), fill = seq_len(n), horiz = TRUE, bty = "n")
    
    resu <- lapply(posi,function(x){lapply(x,unlist)})
    names(resu) <- types
    
    #
    #  workspace cleanup
    #
    
    rm("me", pos = .seqinrEnv)
    rm("filles", pos = .seqinrEnv)
    rm("tmp", pos = .seqinrEnv)
    
    #
    # Return invisibly the result:
    #
    invisible(resu)
}

#
# Read files of aligned sequences in various formats
#
read.alignment <- function(file, format, forceToLower = TRUE,
                           seqtype = c("DNA", "AA"), oldclustal = FALSE, ...)
{
    seqtype <- match.arg(seqtype) # default is DNA
    if (seqtype == "AA") {
      forceToLower = FALSE;
    }
    #
    # Check if the file is an URL:
    #
    urlcheck = substr(file, 0,4)
    if (urlcheck == "http") {
        # Copy the contents to a tmpfile to be read later
        lines <- readLines(file)
        tmpaln <- tempfile(pattern = "readaln")
        writeLines(lines,tmpaln)
        file <-tmpaln
    }

    #
    # Check that we have read permission on the file:
    #
    file <- path.expand(file)
    if(file.access(file, mode = 4) != 0) stop(paste("File", file, "is not readable"))

    fasta2ali <- function(file, ...){
        tmp <- read.fasta(file, seqtype = seqtype, forceDNAtolower = forceToLower , as.string = TRUE, ...)
        list(length(tmp), getName(tmp), unlist(getSequence(tmp, as.string = TRUE)))
    }

    testReadClustalInR <- function(file, forceToLower = TRUE, ...){
      filecontent <- readLines(file, ...)
      firstline <- filecontent[1]
      if(substr(firstline, 1, 7) != "CLUSTAL"){
        stop("File not in CLUSTAL format!")
      }
      # skip firt line:
      filecontent <- filecontent[-1]

      # Remove empty lines:
      emptylines <- which(nchar(filecontent) == 0L)
      filecontent <- filecontent[-emptylines]

      # Remove consensus lines:
      conslines <- which(substr(filecontent, 1, 1) == " ")
      filecontent <- filecontent[-conslines]

      # Look for sequence start position: firt blank character followed
      # by a non-blank character
      characters <- s2c(filecontent[1])
      white <- characters[-length(characters)] == " "
      black <- characters[-1] != " "
      istart <- which(white & black)[1]
      # Get sequence names
      nam <- character()
      nseq <- 1
      while(TRUE){
        seqname <- substr(filecontent[nseq], 1, istart - 1)
        # remove trailling blanks
        seqname <- s2c(seqname)
        for(i in length(seqname):1){
          if(seqname[i] == " "){
            seqname <- seqname[-i]
          } else {
            break
          }
        }
        seqname <- c2s(seqname)
        if(seqname %in% nam){
          nseq <- nseq - 1
          break # alredy seen
        }
        # this happens with short alignments because seqname is never found
        # in mam
        if (seqname == 'NA')  {
          nseq <- nseq - 1
          break
        }
        nam[nseq] <- seqname
        nseq <- nseq + 1
      }

      # remove non sequences stuff
      for(i in 1:length(filecontent)){
        # Remove sequence name
        filecontent[i] <- substr(filecontent[i], istart + 1, nchar(filecontent[i]))
        # Look for sequence end position: first non-blank character followed
        # by a blank character after sequence start
        characters <- s2c(filecontent[i])
        black <- characters[-length(characters)] != " "
        white <- characters[-1] == " "
        iend <- which(black & white)[1]
        # Keep only sequence characters
        # (if the format present a number at the end of the line )
        if ('FALSE' %in% black) {
          filecontent[i] <- substr(filecontent[i], 1, iend)
        }
      }
      # Concatenation of sequence lines in a single string
      seq <- vector(mode = "list")
      for(iseq in seq_len(nseq)){
        ii <- seq(iseq, length(filecontent), by = nseq)
        seq[[iseq]] <- paste0(filecontent[ii], collapse = "")
        if(forceToLower) seq[[iseq]] <- tolower(seq[[iseq]])
      }
      return(as.alignment(nb = nseq, nam = nam, seq = seq, com = NA))
    }


    ali <- switch( tolower(format),
                   fasta = fasta2ali(file, ...),
                   mase = .Call("read_mase", file, PACKAGE = "seqinr"),
                   phylip = .Call("read_phylip_align", file, PACKAGE = "seqinr"),
                   msf = .Call("read_msf_align", file, PACKAGE = "seqinr"),
                   clustal = {
                      if (oldclustal == TRUE) {
                        .Call("read_clustal_align", file, PACKAGE = "seqinr")
                      }
                      else {
                        testReadClustalInR(file, ...)
                      }
                   },
                   stop("Wrong format name: Format available are fasta, mase, phylip, msf, clustal")
    )

    if ((oldclustal == FALSE) && tolower(format) == "clustal") {
      return(ali)
    }
    ali <- lapply(ali, as.character)
    #cleaning \r char
    ali <- lapply(ali, function (x ){gsub ('\r','',x)})

    #if(forceToLower) ali[[3]] <- lapply(ali[[3]], tolower)
    if(forceToLower) ali[[3]] <- unlist(lapply(ali[[3]], tolower))
    ali[[3]] <- as.list(ali[[3]])
    if(format == "mase"){
        ali <- list(nb = as.numeric(ali[[1]]), nam = ali[[2]], seq = ali[[3]], com = ali[[4]])
    } else {
        ali <- list(nb = as.numeric(ali[[1]]), nam = ali[[2]], seq = ali[[3]], com = NA)
    }
    class(ali) <- "alignment"
    return(ali)
}

##########################################
# complements a sequence
###########################################

comp <- function(seq, forceToLower = TRUE, ambiguous = FALSE){
    
    if(all(seq %in% LETTERS)){
        isUpper <- TRUE
    } else {
        isUpper <- FALSE
    }
    
    seq <- tolower(seq)
    
    result <- as.vector(n2s((3-s2n(seq))))
    #
    # More work is required if ambiguous bases are taken into account
    #
    
    if(ambiguous){
        result[which(seq == "b")] <- "v"
        result[which(seq == "d")] <- "h"
        result[which(seq == "h")] <- "d"
        result[which(seq == "k")] <- "m"
        result[which(seq == "m")] <- "k"
        result[which(seq == "s")] <- "s"
        result[which(seq == "v")] <- "b"
        result[which(seq == "w")] <- "w"
        result[which(seq == "n")] <- "n"
        result[which(seq == "y")] <- "r"
        result[which(seq == "r")] <- "y"
    }
    
    # Checking for N in the sequence, thanks to Jeremy Shearman.
    # Now this is done only with ambigous option, thanks to Suzuki Haruo
    # result[which(seq == "n")] <- "n"
    
    
    if(isUpper && !forceToLower){
        result <- toupper(result)
    }
    return(result)
}

as.matrix.alignment <- function(x, ...){
    nc <- nchar(x$seq[[1]])
    res <- matrix(data = sapply(x$seq, s2c), nrow = x$nb, ncol = nc,
                  byrow = TRUE)
    rownames(res) <- x$nam
    colnames(res) <- seq_len(nc)
    return(res)
}

##
# This function counts the number of each triplet in a sliding window,
# create a contingency table with triplet composition and then computes
# a correspondence analysis on this table
##
#v.18.08.2011
recstat <- function(seq, sizewin = 90, shift = 30, seqname = "no name")
{
    if (is.character(seq) == FALSE)
    { # class character if only one sequence, class list if more
        print("This file has more than one sequence or class is not character.")
        return()
    }
    if ((shift%%3) != 0)
    { # test if shift give the same reading frame
        print("The windows are not in the same reading frame, please change shift value to a multiple of 3.")
        return()
    }
    if (sizewin%%3 != 0) 
    { 
        print("The length of the window is not a multiple of 3, please change sizewin value.")
        return()
    }
    seqsize <- length(seq) # give the number of 1-mer in the sequence
    v1 <- seq(from = 1, to = seqsize, by = shift) # start vector of window in reading frame 1
    v1 <- v1[1:(which((v1 + sizewin) > seqsize)[1])] # suppression if more than one incomplete window
    v2 <- seq(from = 2, to = seqsize, by = shift)
    v2 <- v2[1:(which((v2 + sizewin)>seqsize)[1])]
    v3 <- seq(from = 3, to = seqsize, by = shift)
    v3 <- v3[1:(which((v3 + sizewin) > seqsize)[1])]
    vdep <- c(v1, v2, v3) # start vector in the 3 reading frames of direct/reverse strand
    vind <- c(rep(1, length(v1)), rep(2, length(v2)), rep(3, length(v3))) # index vector of reading frame for each window
    ##
    ##direct strand##
    ##
    cseq <- c2s(seq)
    vstopd <- c(words.pos("taa", cseq), words.pos("tag", cseq), words.pos("tga", cseq)) # vector of stop codons positions in direct strand
    vinitd <- c(words.pos("atg", cseq)) # vector of start codons positions in direct strand
    resd <- lapply(1:length(vdep), function(x)
    { # calculation on 3 reading frames of direct strand
        seq_tmp <- seq[(vdep[x]):(vdep[x] + sizewin - 1)] # temporary window
        count(seq_tmp, wordsize = 3, start = 0, by = 3) # counting of triplets
    })
    ##
    ##reverse strand##
    ##
    seq_reverse <- rev(comp(seq, ambiguous = TRUE)) # creation of reverse strand
    cseq_reverse <- c2s(seq_reverse)
    vstopr <- c(words.pos("taa", cseq_reverse), words.pos("tag", cseq_reverse), words.pos("tga", cseq_reverse)) # vector of stop codons positions in reverse strand
    vinitr <- c(words.pos("atg", cseq_reverse)) # vector of init codons positions in reverse strand    
    resr <- lapply(1:length(vdep), function(x)
    { # calculation on 3 reading frames of reverse strand
        seq_tmp <- seq_reverse[(vdep[x]):(vdep[x] + sizewin - 1)] # temporary window
        count(seq_tmp, wordsize = 3, start = 0, by = 3) # counting of triplets
    })
    resd <- matrix(unlist(resd), byrow = TRUE, ncol = 64) # conversion vector to contingency table
    resr <- matrix(unlist(resr), byrow = TRUE, ncol = 64)
    ##
    ##CA##
    ##
    resd.coa <- dudi.coa(resd, scannf = FALSE, nf = 4) # CA on direct strand
    resr.coa <- dudi.coa(resr, scannf = FALSE, nf = 4) # CA on reverse strand    
    rec <- list(seq, sizewin, shift, seqsize, seqname, vdep, vind, vstopd, vstopr, vinitd, vinitr, resd, resr, resd.coa, resr.coa)    
    return(rec)
}

amb <- function(base, forceToLower = TRUE, checkBase = TRUE,
                IUPAC = s2c("acgturymkswbdhvn"), u2t = TRUE){
    if(missing(base)) return(IUPAC)
    if(!is.character(base)) stop("Character expected")
    if(nchar(base) != 1) stop("Single character expected")
    if(forceToLower) base <- tolower(base)
    if(checkBase) if(!(base %in% IUPAC)) stop("IUPAC base expected")
    
    if(base == "r") return(s2c("ag")) # puRine
    if(base == "y") return(s2c("ct")) # pYrimidine
    
    if(base == "m") return(s2c("ac")) # aMino
    if(base == "k") return(s2c("gt")) # Keto
    
    if(base == "s") return(s2c("cg")) # Strong (3 H bonds)
    if(base == "w") return(s2c("at")) # Weak (2 H bonds)
    
    if(base == "b") return(s2c("cgt")) # Not A (A->B)
    if(base == "d") return(s2c("agt")) # Not C (C->D)
    if(base == "h") return(s2c("act")) # Not G (G->H)
    if(base == "v") return(s2c("acg")) # Not T (T->V)
    
    if(base == "n") return(s2c("acgt")) # aNy base
    #
    # Uracil case: Uracil in RNA instead of Thymine in DNA
    #  
    if(base == "u") if(u2t) return("t") else return("u")
    
    return(base)
}

#
# Constructor for class alignment
#
as.alignment <- function(nb = NULL, nam = NULL, seq = NULL, com = NULL){
    ali <- list(nb = as.numeric(nb), nam = nam, seq = seq, com = com)
    class(ali) <- "alignment"
    return(ali)
}

zscore <- function (sequence, simulations = NULL, modele, exact = FALSE, alphabet = s2c("acgt"), ... ){
    if (is.null(simulations)){
        if (modele=="base"){
            uni <- count(sequence, 1, freq = TRUE, alphabet = alphabet)
            di <- count(sequence, 2, freq = TRUE, alphabet = alphabet)
            rep1 <- rep(uni, 4)
            rep2 <- rep(uni, each = 4)
            rho <- di/(rep1*rep2)
            if (exact==FALSE){
                zscore <- ((rho-1)/sqrt(((1-rep1)*(1-rep2))/((length(sequence))*rep1*rep2)))
            }
            else if (exact==TRUE){
                rm(uni,di,rep1,rep2)
                uni <- count(sequence, 1, freq = FALSE, alphabet = alphabet)
                di <- count(sequence, 2, freq = FALSE, alphabet = alphabet)
                rep1 <- rep(uni, 4)
                rep2 <- rep(uni, each = 4)
                n <- length(sequence)
                e <- c(rep(c(0,rep(n/(n-1),4)),3),0)
                for (i in seq(1,4)){
                    e[1+5*(i-1)] <- (n*(uni[i]-1))/(uni[i]*(n-1))
                }
                v=NULL
                for (i in seq(1,16)){
                    if (i==1 | i==6 | i==11 | i==16){
                        v[i] <- ((n^2*(rep1[i]-1))/(rep1[i]^2*(n-1)^2))*(1-rep1[i]+(n/rep1[i])*(1+2*(rep1[i]-2)/(n-1)+((n-4)*(rep1[i]-2)*(rep1[i]-3))/((n-2)*(n-3))))
                    }
                    else{
                        v[i] <- ((n^3)/((n-1)^2*rep1[i]*rep2[i]-n^2/(n-1)^2+(n^3*(n-4)*(rep1[i]-1)*(rep2[i]-1))/(rep1[i]*rep2[i]*(n-2)*(n-3)*(n-1)^2)))
                    }
                }
                zscore <- ((rho-e)/sqrt(v))
            }
        }
        else if (modele=="codon"){
            split <- splitseq(sequence)
            n <- length(split)
            pos <- sort(c(seq(3,length(sequence)-1,by=3),seq(4,length(sequence),by=3))) #position3-1 codons
            xy <- table(factor(splitseq(sequence[pos],word=2),levels=words(2)))
            n1 <- sapply(s2c('acgt'), function(x){length(which(substring(split,3,3)==x))})
            n1 <- rep(n1,each=4)
            n2 <- sapply(s2c('acgt'), function(x){length(which(substring(split,1,1)==x))})
            n2 <- rep(n2,4)
            n3 <- sapply(s2c('acgt'), function (x){sapply(s2c('acgt'), function(y){length(which(substring(split,1,1)==y & substring(split,3,3)==x))})})
            n3 <- as.vector(n3)
            e <- (n1*n2-n3)/n
            v <- (e+((1/(n*(n-1)))*(2*n3*(n1+n2-n1*n2-1)+n1*n2*(n1-1)*(n2-1))))-e^2
            zscore <- ((xy-e)/sqrt(v))
        }
        else{
            stop("analytical solution not implemented for this model")
        }    
    }
    else { #simulations = nb d'iterations
        rhopermut <- sapply(seq(simulations),function(x){rho(permutation(sequence =
                                                                             sequence, modele = modele, ...))})
        mean <- sapply(seq(dim(rhopermut)[1]),function(x){mean(rhopermut[x,])})
        var <- sapply(seq(dim(rhopermut)[1]),function(x){stats::var(rhopermut[x,])})
        zscore <- ((rho(sequence)-mean)/sqrt(var))
    }
    return(zscore)
}

stutterabif <- function(abifdata, chanel, poswild, 
                        datapointbefore = 70, datapointafter = 20,
                        datapointsigma = 3.5,
                        chanel.names = c(1:4,105),
                        DATA = paste("DATA", chanel.names[chanel], sep = "."),
                        maxrfu = 1000,
                        method = "monoH.FC",
                        pms = 6,
                        fig = FALSE){
    
    xseq <- floor((poswild-datapointbefore):(poswild+datapointafter))
    yseq <- abifdata$Data[[DATA]][xseq]
    #
    # The baseline for the signal is taken as the most common value:
    #
    baseline <- baselineabif(yseq, maxrfu = maxrfu)
    #
    # Values below baseline are forced to baseline:
    #
    yseq[yseq < baseline] <- baseline
    #
    # Set baseline to zero:
    #
    yseq <- yseq - baseline
    #
    # First pass to fit a gaussian on wild allele:
    #
    ytheo.one <- function(p, x) p[1]*stats::dnorm(x, p[2], p[3])
    obj.one <- function(p) sum(( yseq - ytheo.one(p, xseq))^2)
    guess.one <- numeric(3)
    guess.one[1] <- datapointsigma*sqrt(2*pi)*max(yseq)
    guess.one[2] <- poswild
    guess.one[3] <- datapointsigma
    suppressWarnings(nlmres.one <- stats::nlm(obj.one, p = guess.one))
    #
    # Second pass to estimate stutter allele parameters. We do
    # not take into account wild peak allele data.
    #
    est <- nlmres.one$estimate
    censored <- floor(est[2] - 6*est[3]) # cut at mu - 6 sigma
    ytheo.two <- function(p, x) p[1]*stats::dnorm(x, p[2], p[3])
    used <- ( xseq < censored )
    obj.two <- function(p) sum(( yseq[used] - ytheo.two(p, xseq[used]))^2)
    guess.two <- numeric(3)
    guess.two[1] <- datapointsigma*sqrt(2*pi)*max(yseq[used])
    guess.two[2] <- xseq[which.max(yseq[used])]
    guess.two[3] <- datapointsigma
    suppressWarnings(nlmres.two <- stats::nlm(obj.two, p = guess.two))
    est2 <- nlmres.two$estimate
    #
    # Fit a spline:
    # 
    spfun <- stats::splinefun(xseq, yseq, method = method)
    xx <- seq(min(xseq), max(xseq), le = 500)
    yy <- spfun(xx)  
    #
    # Compute output result:
    #
    
    x1inf <- est2[2] - pms*est2[3]
    x1sup <- est2[2] + pms*est2[3]
    l1 <- stats::optimize(spfun, interval = c(x1inf, x1sup), maximum = TRUE)$maximum
    h1 <- spfun(l1)
    s1 <- stats::integrate(spfun, x1inf, x1sup)$value
    
    x2inf <- est[2] - pms*est[3]
    x2sup <- est[2] + pms*est[3]
    l2 <- stats::optimize(spfun, interval = c(x2inf, x2sup), maximum = TRUE)$maximum
    h2 <- spfun(l2)
    s2 <- stats::integrate(spfun, x2inf, x2sup)$value
    
    rh <- h1/h2
    rs <- s1/s2
    
    p <- list(p1 = est2[1], mu1 = est2[2], sd1 = est2[3],
              p2 = est[1], mu2 = est[2], sd2 = est[3],
              xseq = xseq, yseq = yseq)
    if(fig){
        graphics::plot(xseq, yseq,
             main = paste("rh = ", round(rh, 5), "rs =", round(rs, 5)),
             ylab = "RFU", las = 1,
             xlab = "Time in datapoint units")
        graphics::abline(h = 0, lty = 3)
        graphics::abline(v = c(l1, l2), lty=2, col = c("red", "blue"))
        graphics::abline(h = c(h1, h2), lty=2, col = c("red", "blue"))
        
        #lines(xx, yy, col = "red")
        #
        # Stutter:
        #
        xx <- seq(x1inf, x1sup, le = 500)
        yy <- spfun(xx)
        graphics::lines(xx, yy, col = "red", lwd = 2)
        #
        # Wild Allele:
        #
        xx <- seq(x2inf, x2sup, le = 500)
        yy <- spfun(xx)
        graphics::lines(xx, yy, col = "blue", lwd = 2)
        #
        # legend:
        #
        graphics::legend("topleft", inset = 0.01, legend = c("Stutter product",
                                                   "Corresponding allele"), lty = 1, lwd = 2, col = c("red", "blue"),
               bg = "white", title = "Datapoints used for:")
    }
    return(list(rh = rh, rs = rs, h1 = h1, h2 = h2, s1 = s1, s2 = s2, p = p))
}

uco <- function (seq, frame = 0, index = c("eff", "freq", "rscu"), 
                 as.data.frame = FALSE, NA.rscu = NA) 
{
    choice <- match.arg(index)
    
    if(any(seq%in%LETTERS)){
        seq <- tolower(seq)
    }
    sequence <- splitseq(seq = seq, frame = frame, word = 3)
    
    if( as.data.frame == FALSE ) {
        eff <- table(factor(sequence, levels = SEQINR.UTIL$CODON.AA$CODON))
        if(choice == "eff") return(eff)
        
        freq <- eff/(floor(length(seq)/3))
        if(choice == "freq") return(freq)
        
        T <- split(freq, SEQINR.UTIL$CODON.AA$AA)
        rscu <- lapply(T, function(x) {
            return(x/((1/length(x)) * sum(x)))
        })
        names(rscu) <- NULL
        rscu <- unlist(rscu)[as.character(SEQINR.UTIL$CODON.AA$CODON)]
        is.na(rscu[!is.finite(rscu)]) <- TRUE
        rscu[is.na(rscu)] <- NA.rscu
        return(rscu)
    } else { # return all indices in a data.frame
        eff <- table(factor(sequence, levels = SEQINR.UTIL$CODON.AA$CODON))
        freq <- eff/(floor(length(seq)/3))
        T <- split(freq, SEQINR.UTIL$CODON.AA$AA)
        rscu <- lapply(T, function(x) {
            return(x/((1/length(x)) * sum(x)))
        })
        names(rscu) <- NULL
        rscu <- unlist(rscu)[as.character(SEQINR.UTIL$CODON.AA$CODON)]
        is.na(rscu[!is.finite(rscu)]) <- TRUE
        rscu[is.na(rscu)] <- NA.rscu
        df <- data.frame(SEQINR.UTIL$CODON.AA$AA, eff = eff, freq = as.vector(freq), RSCU = rscu)
        names(df) = c("AA", "codon", "eff", "freq", "RSCU")
        return(df)
    }
}

\name{oriloc}
\alias{oriloc}
\title{ Prediction of origin and terminus of replication in bacteria.}
\description{
This program finds the putative origin and terminus of
replication in procaryotic genomes. The program discriminates
between codon positions.
}
\usage{
oriloc(seq.fasta = system.file("sequences/ct.fasta.gz", package = "seqinr"),
 g2.coord = system.file("sequences/ct.predict", package = "seqinr"),
 glimmer.version = 3,
oldoriloc = FALSE, gbk = NULL, clean.tmp.files = TRUE, rot = 0)
}
\arguments{
  \item{seq.fasta}{Character: the name of a file which contains the DNA sequence
    of a bacterial chromosome in fasta format. The default value,
   \code{system.file("sequences/ct.fasta.gz", package ="seqinr")} is
    the fasta file \code{ct.fasta.gz}. This is the file
    for the complete genome sequence of \emph{Chlamydia trachomatis}
    that was used in Frank and Lobry (2000). You can replace
    this by something like \code{seq.fasta = "myseq.fasta"} to work
    with your own data if the file \code{myseq.fasta} is present in
    the current working directory (see \code{\link{getwd}}), or give
    a full path access to the sequence file (see \code{\link{file.choose}}).}
  \item{g2.coord}{Character: the name of file which contains the output of
    glimmer program (\code{*.predict} in glimmer version 3)}
  \item{glimmer.version}{Numeric: glimmer version used, could be 2 or 3}
  \item{oldoriloc}{Logical: to be set at TRUE to reproduce the
(deprecated) outputs of previous (publication date: 2000) version
of the oriloc program.}
  \item{gbk}{Character: the URL of a file in GenBank format. When provided
    \code{oriloc} use as input a single GenBank file instead of the \code{seq.fasta}
    and the \code{g2.coord}. A local temporary copy of the GenBank file is
    made with \code{\link{download.file}} if \code{gbk} starts with
    \code{http://} or \code{ftp://} or \code{file://} and whith
    \code{\link{file.copy}} otherwise. The local copy is then used as
    input for \code{\link{gb2fasta}} and \code{\link{gbk2g2}} to produce
    a fasta file and a glimmer-like (version 2) file, respectively, to be used
    by oriloc instead of \code{seq.fasta} and \code{g2.coord} .}
  \item{clean.tmp.files}{Logical: if TRUE temporary files generated when
    working with a GenBank file are removed.}
  \item{rot}{Integer, with zero default value, used to permute circurlarly the genome. }
}
\details{
The method builds on the fact that there are compositional asymmetries between
the leading and the lagging strand for replication. The programs works only
with third codon positions so as to increase the signal/noise ratio.
To discriminate between codon positions, the program use as input either
an annotated genbank file, either a fasta file and a glimmer2.0 (or
glimmer3.0) output
file.
}
\value{
  A data.frame with seven columns: \code{g2num} for the CDS number in
the \code{g2.coord} file, \code{start.kb} for the start position of CDS
expressed in Kb (this is the position of the first occurence of a
nucleotide in a CDS \emph{regardless} of its orientation), \code{end.kb}
for the last position of a CDS, \code{CDS.excess} for the DNA walk for
gene orientation (+1 for a CDS in the direct strand, -1 for a CDS in
the reverse strand) cummulated over genes, \code{skew} for the cummulated
composite skew in third codon positions, \code{x} for the cummulated
T - A skew in third codon position, \code{y} for the cummulated C - G
skew in third codon positions.
}
\references{

The original paper for oriloc:\cr
Frank, A.C., Lobry, J.R. (2000) Oriloc: prediction of replication
boundaries in unannotated bacterial chromosomes. \emph{Bioinformatics},
\bold{16}:566-567.\cr
\doi{https://doi.org/10.1093/bioinformatics/16.6.560}\cr\cr

A simple informal introduction to DNA-walks:\cr
Lobry, J.R. (1999) Genomic landscapes. \emph{Microbiology Today},
\bold{26}:164-165.\cr
\url{https://seqinr.r-forge.r-project.org/MicrTod_1999_26_164.pdf}\cr\cr

An early and somewhat historical application of DNA-walks:\cr
Lobry, J.R. (1996) A simple vectorial representation of DNA sequences
for the detection of replication origins in bacteria. \emph{Biochimie},
\bold{78}:323-326.\cr

Glimmer, a very efficient open source software for the prediction of CDS from scratch
in prokaryotic genome, is decribed at \url{http://ccb.jhu.edu/software/glimmer/index.shtml}.\cr
For a description of Glimmer 1.0 and 2.0 see:\cr

Delcher, A.L., Harmon, D., Kasif, S., White, O., Salzberg, S.L. (1999)
Improved microbial gene identification with GLIMMER,
\emph{Nucleic Acids Research}, \bold{27}:4636-4641.\cr

Salzberg, S., Delcher, A., Kasif, S., White, O. (1998)
Microbial gene identification using interpolated Markov models,
\emph{Nucleic Acids Research}, \bold{26}:544-548.\cr

\code{citation("seqinr")}
}
\author{J.R. Lobry, A.C. Frank}
\seealso{ \code{\link{draw.oriloc}}, \code{\link{rearranged.oriloc}} }

\note{ The method works only for genomes having a single origin of replication
from which the replication is bidirectional. To detect the composition changes,
a DNA-walk is performed. In a 2-dimensional DNA walk, a C in the sequence
corresponds to the movement in the positive y-direction and G to a movement
in the negative y-direction. T and A are mapped by analogous steps along the
x-axis. When there is a strand asymmetry, this will form a trajectory that
turns at the origin and terminus of replication. Each step is the sum of
nucleotides in a gene in third codon positions. Then orthogonal regression is
used to find a line through this trajectory. Each point in the trajectory will
have a corresponding point on the line, and the coordinates of each are
calculated. Thereafter, the distances from each of these points to the origin
(of the plane), are calculated. These distances will represent a form of
cumulative skew. This permets us to make a plot with the gene position (gene
number, start or end position) on the x-axis and the cumulative skew (distance)
at the y-axis. Depending on where the sequence starts, such a plot will display
one or two peaks. Positive peak means origin, and negative means terminus.
In the case of only one peak, the sequence starts at the origin or terminus
site. }
\examples{
\dontrun{
#
# A little bit too long for routine checks because oriloc() is already
# called in draw.oriloc.Rd documentation file. Try example(draw.oriloc)
# instead, or copy/paste the following code:
#
out <- oriloc()
plot(out$st, out$sk, type = "l", xlab = "Map position in Kb",
    ylab = "Cumulated composite skew",
    main = expression(italic(Chlamydia~~trachomatis)~~complete~~genome))
#
# Example with a single GenBank file:
#
out2 <- oriloc(gbk="https://pbil.univ-lyon1.fr/datasets/seqinr/data/ct.gbk")
draw.oriloc(out2)
#
# (some warnings are generated because of join in features and a gene that
# wrap around the genome)
#
}
}

\name{G+C Content}
\alias{GC}
\alias{GC1}
\alias{GC2}
\alias{GC3}
\alias{GCpos}
\title{Calculates the fractional G+C content of nucleic acid sequences.}
\description{
  Calculates the fraction of G+C bases of the input nucleic acid
  sequence(s). It reads in nucleic acid sequences, sums the number of
  'g' and 'c' bases and writes out the result as the fraction (in the
  interval 0.0 to 1.0) to the total number of 'a', 'c', 'g' and 't' bases.
  Global G+C content \code{GC}, G+C in the first position of the codon bases
  \code{GC1}, G+C in the second position of the codon bases
  \code{GC2}, and G+C in the third position of the codon bases
  \code{GC3} can be computed. All functions can take ambiguous bases
  into account when requested.
}
\usage{
GC(seq, forceToLower = TRUE, exact = FALSE, NA.GC = NA, oldGC = FALSE,
alphabet = s2c("acgtswmkryvhdb"))
GC1(seq, frame = 0, ...)
GC2(seq, frame = 0, ...)
GC3(seq, frame = 0, ...)
GCpos(seq, pos, frame = 0, ...)
}
\arguments{
  \item{seq}{a nucleic acid sequence as a vector of single characters}
  \item{frame}{for coding sequences, an integer (0, 1, 2) giving the frame}
  \item{forceToLower}{logical. if \code{TRUE}  force sequence
  	characters in lower-case. Turn this to \code{FALSE} to save time
  	if your sequence is already in lower-case (cpu time is approximately
        divided by 3 when turned off)}
  \item{exact}{logical: if \code{TRUE} ambiguous bases are taken
  	into account when computing the G+C content (see details).
        Turn this to \code{FALSE} to save time if your you can neglect
        ambiguous bases in your sequence (cpu time is approximately
        divided by 3 when turned off)
}
  \item{NA.GC}{what should be returned when the GC is impossible to
    compute from data, for instance with NNNNNNN. This behaviour could
    be different when argument \code{exact} is \code{TRUE}, for instance
    the G+C content of WWSS is \code{NA} by default, but is 0.5 when
   \code{exact} is set to \code{TRUE}}
  \item{...}{arguments passed to the function \code{GC}}
  \item{pos}{for coding sequences, the codon position (1, 2, 3) that should be
    taken into account to compute the G+C content}
  \item{oldGC}{logical defaulting to \code{FALSE}: should the GC content computed
    as in seqinR <= 1.0-6, that is as the sum of 'g' and 'c' bases divided by
    the length of the sequence. As from seqinR >= 1.1-3, this argument is
    deprecated and a warning is issued.}
  \item{alphabet}{alphabet used. This allows you to choose ambiguous bases used
      during GC calculation.}
}
\details{
	When \code{exact} is set to \code{TRUE} the G+C content is estimated
	with ambiguous bases taken into account. Note that this is time expensive.
	A first pass is made on non-ambiguous bases to estimate the probabilities
	of the four bases in the sequence. They are then used to weight the
	contributions of ambiguous bases to the G+C content. Let note nx
	the total number of base 'x' in the sequence. For instance
	suppose that there are nb bases 'b'. 'b' stands for "not a", that
	is for 'c', 'g' or 't'. The contribution of 'b' bases to the GC base
	count will be:

	nb*(nc + ng)/(nc + ng + nt)

	The contribution of 'b' bases to the AT base count will be:

	nb*nt/(nc + ng + nt)

	All ambiguous bases contributions to the AT and GC counts are weighted
	is similar way and then the G+C content is computed as ngc/(nat + ngc).
}
\value{
  \code{GC} returns the fraction of G+C (in [0,1]) as a numeric vector of length one.
  \code{GCpos} returns GC at position \code{pos}.
  \code{GC1}, \code{GC2}, \code{GC3} are wrappers for \code{GCpos} with the
    argument \code{pos} set to 1, 2, and 3, respectively.
  \code{NA} is returned when \code{seq} is \code{NA}.
  \code{NA.GC} defaulting to \code{NA} is returned when the G+C content
    can not be computed from data.
}
\references{
  \code{citation("seqinr")}.

  The program codonW used here for comparison is available at
  \url{https://codonw.sourceforge.net/}.
}
\seealso{You can use \code{\link{s2c}} to convert a string into a vetor of single
character and \code{\link{tolower}} to convert upper-case characters into
lower-case characters. Do not confuse with \code{\link{gc}} for garbage collection.
}
\author{D. Charif, L. Palmeira, J.R. Lobry}
\examples{
   mysequence <- s2c("agtctggggggccccttttaagtagatagatagctagtcgta")
   GC(mysequence)  # 0.4761905
   GC1(mysequence) # 0.6428571
   GC2(mysequence) # 0.3571429
   GC3(mysequence) # 0.4285714
#
# With upper-case characters:
#
  myUCsequence <- s2c("GGGGGGGGGA")
  GC(myUCsequence) # 0.9
#
# With ambiguous bases:
#
  GC(s2c("acgt")) # 0.5
  GC(s2c("acgtssss")) # 0.5
  GC(s2c("acgtssss"), exact = TRUE) # 0.75
#
# Missing data:
#
  stopifnot(is.na(GC(s2c("NNNN"))))
  stopifnot(is.na(GC(s2c("NNNN"), exact = TRUE)))
  stopifnot(is.na(GC(s2c("WWSS"))))
  stopifnot(GC(s2c("WWSS"), exact = TRUE) == 0.5)
#
# Coding sequences tests:
#
  cdstest <- s2c("ATGATG")
  stopifnot(GC3(cdstest) == 1)
  stopifnot(GC2(cdstest) == 0)
  stopifnot(GC1(cdstest) == 0)
#
# How to reproduce the results obtained with the C program codonW
# version 1.4.4 writen by John Peden. We use here the "input.dat"
# test file from codonW (there are no ambiguous base in these
# sequences).
#
  inputdatfile <- system.file("sequences/input.dat", package = "seqinr")
  input <- read.fasta(file = inputdatfile) # read the FASTA file
  inputoutfile <- system.file("sequences/input.out", package = "seqinr")
  input.res <- read.table(inputoutfile, header = TRUE) # read codonW result file
#
# remove stop codon before computing G+C content (as in codonW)
#
  GC.codonW <- function(dnaseq, ...){
  	 GC(dnaseq[seq_len(length(dnaseq) - 3)], ...)
  }
  input.gc <- sapply(input, GC.codonW, forceToLower = FALSE)
  max(abs(input.gc - input.res$GC)) # 0.0004946237

  plot(x = input.gc, y = input.res$GC, las = 1,
  xlab = "Results with GC()", ylab = "Results from codonW",
  main = "Comparison of G+C content results")
  abline(c(0, 1), col = "red")
  legend("topleft", inset = 0.01, legend = "y = x", lty = 1, col = "red")
\dontrun{
# Too long for routine check
# This is a benchmark to compare the effect of various parameter
# setting on computation time
n <- 10
from <-10^4
to <- 10^5
size <- seq(from = from, to = to, length = n)
res <- data.frame(matrix(NA, nrow = n, ncol = 5))
colnames(res) <- c("size", "FF", "FT", "TF", "TT")
res[, "size"] <- size

for(i in seq_len(n)){
  myseq <- sample(x = s2c("acgtws"), size = size[i], replace = TRUE)
  res[i, "FF"] <- system.time(GC(myseq, forceToLower = FALSE, exact = FALSE))[3]
  res[i, "FT"] <- system.time(GC(myseq, forceToLower = FALSE, exact = TRUE))[3]
  	res[i, "TF"] <- system.time(GC(myseq, forceToLower = TRUE, exact = FALSE))[3]
  	res[i, "TT"] <- system.time(GC(myseq, forceToLower = TRUE, exact = TRUE))[3]
}

par(oma = c(0,0,2.5,0), mar = c(4,5,0,2) + 0.1, mfrow = c(2, 1))
plot(res$size, res$TT, las = 1,
xlab = "Sequence size [bp]",
ylim = c(0, max(res$TT)), xlim = c(0, max(res$size)), ylab = "")
title(ylab = "Observed time [s]", line = 4)
abline(lm(res$TT~res$size))
points(res$size, res$FT, col = "red")
abline(lm(res$FT~res$size), col = "red", lty = 3)
points(res$size, res$TF, pch = 2)
abline(lm(res$TF~res$size))
points(res$size, res$FF, pch = 2, col = "red")
abline(lm(res$FF~res$size), lty = 3, col = "red")


legend("topleft", inset = 0.01,
 legend = c("forceToLower = TRUE", "forceToLower = FALSE"),
  col = c("black", "red"), lty = c(1,3))
legend("bottomright", inset = 0.01, legend = c("exact = TRUE", "exact = FALSE"),
pch = c(1,2))

mincpu <- lm(res$FF~res$size)$coef[2]

barplot(
c(lm(res$FF~res$size)$coef[2]/mincpu,
  lm(res$TF~res$size)$coef[2]/mincpu,
  lm(res$FT~res$size)$coef[2]/mincpu,
  lm(res$TT~res$size)$coef[2]/mincpu),
horiz = TRUE, xlab = "Increase of CPU time",
col = c("red", "black", "red", "black"),
names.arg = c("(F,F)", "(T,F)", "(F,T)", "(T,T)"), las = 1)
title(ylab = "forceToLower,exact", line = 4)

mtext("CPU time as function of options", outer = TRUE, line = 1, cex = 1.5)
}
}
\keyword{manip}

\name{acnucopen}
\alias{acnucopen}
\alias{acnucclose}
\alias{clientid}
\alias{quitacnuc}
\title{open and close a remote access to an ACNUC database}
\description{
These are low level functions to start and stop a remote access to an ACNUC database.
}

\usage{
acnucopen(db, socket, challenge = NA)
acnucclose(socket)
clientid(id = paste("seqinr_",
 packageDescription("seqinr")$Version, sep = ""),
 socket, verbose = FALSE)
quitacnuc(socket)
}

\arguments{
  \item{db}{the remote ACNUC database name}
  \item{socket}{an object of class \code{sockconn} connecting to an ACNUC server}
  \item{challenge}{unimplemented yet}
  \item{id}{client ID definition defaulting to seqinr + package version number}
  \item{verbose}{logical, if TRUE mode verbose is on}
}

\details{
these low level functions are usually not used directly by the user.
Use \code{\link{choosebank}} to open a remote ACNUC database
and \code{\link{closebank}} to close it.
}

\value{
For \code{openacnuc} a list with the following
components: type : the type of database that was opened.
totseqs, totspec, totkey : total number of seqs, species, keywords in opened database.
ACC_LENGTH, L_MNEMO, WIDTH_KW, WIDTH_SP, WIDTH_SMJ, WIDTH_AUT,
WIDTH_BIB, lrtxt, SUBINLNG: max lengths of record keys in database.

}
\references{
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  \code{\link{choosebank}}, \code{\link{closebank}}
}

\examples{
 \dontrun{# Need internet connection
  mysocket <- socketConnection( host = "pbil.univ-lyon1.fr",
    port = 5558, server = FALSE, blocking = TRUE)
  readLines(mysocket, n = 1) # OK acnuc socket started
  acnucopen("emblTP", socket = mysocket) -> res
  expected <- c("EMBL", "14138095", "236401", "1186228", "8",
    "16", "40", "40", "20", "20", "40", "60", "504")
  stopifnot(all(unlist(res) == expected))
  tryalreadyopen <- try(acnucopen("emblTP", socket = mysocket))
  stopifnot(inherits(tryalreadyopen, "try-error"))
  # Need a fresh socket because acnucopen() close it if error:
  mysocket <- socketConnection( host = "pbil.univ-lyon1.fr",
    port = 5558, server = FALSE, blocking = TRUE)
  tryoff <-  try(acnucopen("off", socket = mysocket))
  stopifnot(inherits(tryoff, "try-error"))

  mysocket <- socketConnection( host = "pbil.univ-lyon1.fr",
    port = 5558, server = FALSE, blocking = TRUE)
  tryinexistent <-  try(acnucopen("tagadatagadatsointsoin", socket = mysocket))
  stopifnot(inherits(tryinexistent, "try-error"))

  mysocket <- socketConnection( host = "pbil.univ-lyon1.fr",
    port = 5558, server = FALSE, blocking = TRUE)
  trycloseunopened <- try(acnucclose(mysocket))
  stopifnot(inherits(trycloseunopened, "try-error"))

 }
}
\keyword{utilities}

\name{fasta}
     \docType{data}
     \alias{fasta}
     \title{Example of results obtained after a call to read.alignment}
     \description{This data set gives an example of a amino acids alignment obtained after a call to the function read.alignment on an alignment file in "fasta" format.}
     \usage{data(fasta)}
     \format{A List of class alignment}
     \source{https://pbil.univ-lyon1.fr/help/formats.html/}
     \references{Pearson W.R. and Lipman D.J. (1988) \emph{Improved tools for biological sequence comparison.}.Proc Natl Acad Sci U S A. 85(8):2444-8.}
     \keyword{datasets}

\name{getSequence}
\alias{getSequence}
\alias{getSequence.default}
\alias{getSequence.list}
\alias{getSequence.character}
\alias{getSequence.SeqFrag}
\alias{getSequence.SeqAcnucWeb}
\alias{getSequence.SeqFastadna}
\alias{getSequence.SeqFastaAA}
\alias{getSequence.qaw}
\alias{getSequence.logical}

\title{Generic function to get sequence data}
\description{
getSequence returns the sequence either as vector of single chararacters
or as a single string of multiple characters.
}
\usage{
getSequence(object, as.string = FALSE, ...)
\method{getSequence}{SeqAcnucWeb}(object, as.string = FALSE, ..., socket = autosocket())
}
\arguments{
  \item{object}{ an object of the class \code{\link{SeqAcnucWeb}}
    or \code{\link{SeqFastadna}}, or \code{\link{SeqFastaAA}} or \code{\link{SeqFrag}} or a list of these objects, or an object of class \code{qaw} created by \code{\link{query}} }
  \item{as.string}{if TRUE sequences are returned as strings of multiple characters
    instead of a vector of single characters}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{...}{further arguments passed to or from other methods}
}
\value{
  For a single sequence an object of class \code{character} containing the characters
  of the sequence, either of length 1 when \code{as.string} is TRUE, or of the length
  of the sequence when \code{as.string} is FALSE. For many sequences, a list of these.}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira} 
\seealso{
  \code{\link{SeqAcnucWeb}}, \code{\link{SeqFastadna}}, 
  \code{\link{SeqFastaAA}}, \code{\link{SeqFrag}}
}
\examples{
#
# List all available methods for getSequence generic function:
#
   methods(getSequence)
#
# SeqAcnucWeb class example:
#
  \dontrun{# Need internet connection
  choosebank("emblTP")
  fc <- query("fc", "sp=felis catus et t=cds et o=mitochondrion")
  getSequence(fc$req[[1]])
  getSequence(fc$req[[1]], as.string = TRUE)
  closebank()
  }
#
# SeqFastaAA class example:
#
  aafile <- system.file("sequences/seqAA.fasta", package = "seqinr")
  sfaa <- read.fasta(aafile, seqtype = "AA")
  getSequence(sfaa[[1]])
  getSequence(sfaa[[1]], as.string = TRUE)
#
# SeqFastadna class example:
#
  dnafile <- system.file("sequences/someORF.fsa", package = "seqinr")
  sfdna <- read.fasta(file = dnafile)
  getSequence(sfdna[[1]])
  getSequence(sfdna[[1]], as.string = TRUE)
#
# SeqFrag class example:
#
  sfrag <- getFrag(object = sfdna[[1]], begin = 1, end = 10)
  getSequence(sfrag)
  getSequence(sfrag, as.string = TRUE)
}
\keyword{ utilities }

\name{readPanels}
\alias{readPanels}
\title{Import GenMapper Panels configuration file}
\description{
In a Panel configuration file there is a description for a given identification
kit of the marker names, their dye label color, expected size range,
expected positive control genotypes, number of bases in core repeat,
stutter percentages, and allele names.
}
\usage{
readPanels(file,
  colnames = c("marker", "dye.col", "min.bp", "max.bp", "exp.pcg", "repeat.bp",
    "stutter.pc", "uknw", "allele names"))}
\arguments{
  \item{file}{The name of the Panel configuration file.}
  \item{colnames}{The names to be used for the columns of the data.frames.}
}
\value{
A list whose first element is the file header info and following elements
data.frames, one for each kit encountered in the file.
}
\details{
Number of bases in core repeat is set to 9 for Amelogenin locus.
}
\references{ 
\code{citation("seqinR")}
}
\author{J.R. Lobry}
\seealso{\code{\link{readBins}}, \code{\link{plotPanels}}.}
\examples{
#
# Check that we can read the 2 exemple files in the seqinR package:
#
path1 <- system.file("abif/AmpFLSTR_Panels_v1.txt", package = "seqinr")
res1 <- readPanels(path1)
path2 <- system.file("abif/Promega_Panels_v1.txt", package = "seqinr")
res2 <- readPanels(path2)
#
# Show the kits described in res1:
#
names(res1)
#
# Show some data for a given kit:
#
res1[["Identifiler_v1"]][, 1:7]
#
# Plot a simple summary of two kits:
#
par(mfrow = c(2,1))
plotPanels("Identifiler_v1", res1)
plotPanels("PowerPlex_16_v1", res2)

#
# Simple quality check since seqinR 2.0-4 with a file which containing
# a non constant number of tabulations as separator:
#
path3 <- system.file("abif/Prototype_PowerPlex_EP01_Pa.txt", package = "seqinr")
res3 <- readPanels(path3)
}

\name{gcO2}
\alias{gcO2}
\docType{data}
\title{GC content and aerobiosis in bacteria}
\description{
  This data set was used in Naya \emph{et al.} (2002) to study the relationship between the genomic G+C content of bacteria and whether they are (stricly) aerobes or anaerobes.
}
\format{
\code{gcO2} is a data frame.  
}
\source{
Naya, H., Romero, H., Zavala, A., Alvarez, B. and Musto, H. (2002) Aerobiosis increases the Genomic Guanine Plus Cytosine Content (GC%) in prokaryotes. \emph{Journal of Molecular Evolution}, \bold{55}:260-264.

Data imported into seqinr by J.R. Lobry on 09-OCT-2016. Original source location given in the article was \code{http://oeg.fcien.edu.uy/GCprok/} but is no more active. Data were copied at \url{http://pbil.univ-lyon1.fr/R/donnees/gcO2.txt} (\emph{cf.} section 2.1 in Lobry, J.R (2004) Life history traits and genome structure: aerobiosis and G+C content in bacteria. \emph{Lecture Notes in Computer Sciences}, \bold{3039}:679-686). Import was from this last ressource. There are 130 aerobic genera in this data set while fig. 1 in Naya \emph{et al.} (2002) gives 126. There is no way to track down the reason for this difference because the original data set was lost (Héctor Musto pers. comm.). The number of anaerobic genera (n = 69) is consistent between the present data set and fig. 1 in Naya \emph{et al.} (2002).
}
\references{
  \code{citation("seqinr")}
}
\examples{
data(gcO2)
}

\name{identifiler}
\alias{identifiler}
\docType{data}
\title{Identifiler allele names}
\description{
Names of the alleles in the Applied Biosystem identifiler allelic ladder.
}
\usage{data(identifiler)}
\format{
  A list with 4 components for the four fluorochromes.
  \describe{
    \item{FAM}{a list of 4 loci}
    \item{VIC}{a list of 5 loci}
    \item{NED}{a list of 4 loci}
    \item{PET}{a list of 3 loci}
  }
}

\examples{
data(identifiler)
op <- par(no.readonly = TRUE)
par(mar = c(3,8,4,2)+0.1)
allcount <- unlist(lapply(identifiler, function(x) lapply(x, length)))
barplot(allcount[order(allcount)], horiz = TRUE, las = 1,
main = "Allele count per locus", col = "lightblue")
par(op)
}

\name{s2n}
\alias{s2n}
\title{ simple numerical encoding of a DNA sequence.
 }
\description{
By default, if no \code{levels} arguments is provided, this function will
just code your DNA sequence in integer values following the lexical
order \code{(a > c > g > t)}, that is 0 for "a", 1 for "c", 2 for "g", 3 for
"t" and NA for ambiguous bases.
}
\usage{
s2n(seq, levels = s2c("acgt"), base4 = TRUE, forceToLower = TRUE)
}
\arguments{
  \item{seq}{ the sequence as a vector of single chars }
  \item{levels}{ allowed char values, by default a, c, g and t }
  \item{base4}{if TRUE the numerical encoding will start at O, if
FALSE at 1}
  \item{forceToLower}{if TRUE the sequence is forced to lower case caracters}
}
\value{
  a vector of integers
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry }
\note{
The idea of starting numbering at 0 by default is that it enforces 
a kind of isomorphism between the paste operator on DNA chars and 
the + operator on integer coding for DNA chars. By this way, you can
work either in the char set, either in the integer set, depending
on what is more convenient for your purpose, and then switch from one 
set to the other one as you like.
}
\seealso{ \code{\link{n2s}}, \code{\link{factor}}, \code{\link{unclass}} }
\examples{
##
## Example of default behaviour:
##
urndna <- s2c("acgt")
seq <- sample( urndna, 100, replace = TRUE ) ; seq
s2n(seq)
##
## How to deal with RNA:
##
urnrna <- s2c("acgt")
seq <- sample( urnrna, 100, replace = TRUE ) ; seq
s2n(seq)
##
## what happens with unknown characters:
##
urnmess <- c(urndna,"n")
seq <- sample( urnmess, 100, replace = TRUE ) ; seq
s2n(seq)
##
## How to change the encoding for unknown characters:
##
tmp <- s2n(seq) ; tmp[is.na(tmp)] <- -1; tmp
##
## Simple sanity check:
##
stopifnot(all(s2n(s2c("acgt")) == 0:3))
}
\keyword{ utilities }

\name{words.pos}
\alias{words.pos}
\title{ Positions of possibly degenerated motifs within sequences }
\description{
\code{word.pos} searches all the occurences of the motif \code{pattern}
within the sequence \code{text} and returns their positions. This
function is based on \code{regexp} allowing thus for complex motif searches.
The main difference with \code{\link{gregexpr}} is that non disjoint matches
are reported here.
}
\usage{
words.pos(pattern, text, ignore.case = FALSE,
                      perl = TRUE, fixed = FALSE, useBytes = TRUE, ...)
}
\arguments{
  \item{pattern}{character string containing a \link{regular expression} (or character string for \code{fixed = TRUE}) to be matched in the given character vector.}
  \item{text}{ a character vector where matches are sought. }
  \item{ignore.case}{if \code{FALSE}, the pattern matching is case sensitive and if \code{TRUE}, case is ignored during matching.}
  \item{perl}{logical. Should perl-compatible regexps be used if available?
Has priority over \code{extended}.}
  \item{fixed}{logical. If \code{TRUE}, pattern is a string to be matched as is. Overrides all conflicting arguments.}
  \item{useBytes}{logical. If \code{TRUE} the matching is done byte-by-byte rather than character-by-character.}
  \item{...}{arguments passed to \code{\link{regexpr}}.}
}
\details{
Default parameter values have been tuned for speed when working biological sequences.
}
\value{
a vector of positions for which the motif \code{pattern} was
found in the sequence \code{text}.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{regexpr}} }
\examples{
myseq <- "tatagaga"
words.pos("t", myseq)   # Should be 1 3
words.pos("tag", myseq) # Should be 3
words.pos("ga", myseq)  # Should be 5 7
# How to specify ambiguous base ? Look for YpR motifs by
words.pos("[ct][ag]", myseq) # Should be 1 3
#
# Show the difference with gregexpr:
#
words.pos("toto", "totototo")           # 1 3 5 (three overlapping matches)
unlist(gregexpr("toto",  "totototo")) # 1 5    (two disjoint matches)
}

\name{amb}
\alias{amb}
\title{Expansion of IUPAC nucleotide symbols}
\description{
This function returns the list of nucleotide matching a given IUPAC
nucleotide symbol, for instance \code{c("c", "g")} for \code{"s"}.
}
\usage{
amb(base, forceToLower = TRUE, checkBase = TRUE,
IUPAC = s2c("acgturymkswbdhvn"), u2t = TRUE)
}
\arguments{
  \item{base}{an IUPAC symbol for a nucleotide as a single character}
  \item{forceToLower}{if TRUE the base is forced to lower case}
  \item{checkBase}{if TRUE the character is checked to belong to the allowed IUPAC symbol list}
  \item{IUPAC}{the list of allowed IUPAC symbols}
  \item{u2t}{if TRUE "u" for uracil in RNA are changed into "t" for thymine in DNA}
}
\details{
Non ambiguous bases are returned unchanged (except for "u" when u2t is TRUE).
}
\value{
When base is missing, the list of IUPAC symbols is returned, otherwise
a vector with expanded symbols.
}
\references{ 

The nomenclature for incompletely specified bases in nucleic acid sequences
at: \url{https://pmc.ncbi.nlm.nih.gov/articles/PMC341218/}

\code{citation("seqinr")}
}
\author{J.R. Lobry}

\seealso{See \code{\link{bma}} for the reverse operation. 
Use \code{\link{tolower}} to change upper case letters into
lower case letters.}

\examples{
#
# The list of IUPAC symbols:
#

amb()

#
# And their expansion:
#

sapply(amb(), amb)

}
\keyword{utilities}

\name{choosebank}
\alias{choosebank}
\alias{.seqinrEnv}
\title{To select a database structured under ACNUC and located on the web}
\description{
  This function allows to select one of the databases structured under ACNUC and located on the web.
  Called without arguments, \code{choosebank()}, will return the list of available databases.
  Then, you can use \code{\link{query}} to make your query and get a list of sequence names.
  Remote access to ACNUC databases works by opening a socket connection on a port (for example
  on port number 5558 at pbil.univ-lyon1.fr) and by communicating on this socket following the protocol
  described in the section \code{references}.
}
\usage{
choosebank(bank = NA, host = "pbil.univ-lyon1.fr", port = 5558, server = FALSE,
                    blocking = TRUE, open = "a+", encoding = "", verbose = FALSE,
                    timeout = 5, infobank = FALSE, tagbank = NA)
}
\arguments{
  \item{bank}{string. The name of the bank. If NA, \code{choosebank} will return the names of all database known by the server.}
  \item{host}{string. Host name for port (see \code{\link{socketConnection}})}
  \item{port}{integer. The TCP port number (see \code{\link{socketConnection}})}
  \item{server}{logical. Should the socket be a client or a server? (see \code{\link{socketConnection}})}
  \item{blocking}{logical. (see \code{\link{socketConnection}})}
  \item{open}{string. A description of how to open the connection (see \code{\link{socketConnection}})}
  \item{encoding}{string. The name of the encoding to be used. (see \code{\link{socketConnection}})}
  \item{verbose}{logical. If TRUE, verbose mode is on}
  \item{timeout}{integer. The timeout in seconds for \code{socketConnection}. Default 5 seconds.}
  \item{infobank}{logical. If \code{infobank} is TRUE and \code{bank} is \code{NA}, a data.frame
                   with all database informations will be returned}
  \item{tagbank}{string. If \code{bank} is \code{NA} and \code{tagbank} is documented, the names
                  of special purposes databases are returned. Current allowed values are TP
                  for frozen databases (TP is an acronym for "travaux pratiques" which means practicals
                  in french, these databases are useful mainly for teaching so as to have stable results),
                  TEST for test databases, and DEV for databases under development (unstable).}
}
\details{
  When called without arguments, \code{choosebank()} returns a list of all the databases names known
  by the server, as a vector of string. When called with \code{choosebank(infobank = TRUE)}, a data.frame
  with more information is returned.The environment \code{.seqinrEnv} is used to save several variables
  such as socket and sequence list.
}
\value{
When called with a regular bank name, an (invisible) list with 6 components:

  \item{socket}{ an object of class \code{socket} }
  \item{bankname}{ the name of the bank }
  \item{banktype}{ the type of the bank (GENBANK, EMBL, SWISSPROT, NBRF)}
  \item{totseqs}{ the total number of sequences present in the opened database }
  \item{totspecs}{ the total number of species present in the opened database }
  \item{totkeys}{ the total number of keywords present in the opened database }

When called with bank = NA:

  \item{names}{ A vector of all available bank names.}

When called with bank = NA and infobank = TRUE, a data.frame with three columns:

  \item{bank}{ The name of the bank. }
  \item{status}{ The bank status (on/of). }
  \item{info}{ Short description of bank with last release date. }

}
\references{
For more information about the socket communication protocol with ACNUC please get at \url{https://doua.prabi.fr/databases/acnuc/remote_acnuc.html}.\cr
Gouy, M., Milleret, F., Mugnier, C., Jacobzone, M., Gautier,C. (1984) ACNUC: a nucleic acid sequence data base and analysis system.
\emph{Nucl. Acids Res.}, \bold{12}:121-127.\cr
Gouy, M., Gautier, C., Attimonelli, M., Lanave, C., Di Paola, G. (1985)
ACNUC - a portable retrieval system for nucleic acid sequence databases:
logical and physical designs and usage.
\emph{Comput. Appl. Biosci.}, \bold{3}:167-172.\cr
Gouy, M., Gautier, C., Milleret, F. (1985) System analysis and nucleic acid sequence banks.
\emph{Biochimie}, \bold{67}:433-436.\cr

\code{citation("seqinr")}
}
\note{
The invisible list returned when a database is opened is stored in the variable
\code{banknameSocket} in the global environment.
}
\author{D. Charif, J.R. Lobry}
\seealso{\code{\link{where.is.this.acc}} if you have a sequence accession number but you
don't know which database to open, \code{\link{query}} to make a query when a database
is opened, \code{\link{connection}}, \code{\link{socketConnection}} }
\examples{
  \dontrun{# Need internet connection
  # Show available databases:
  choosebank()
  # Show frozen databases:
  choosebank(tag = "TP")
  # Select a database:
  choosebank("emblTP", tag = "TP")
  # Do something with the database:
  myseq <- gfrag("LMFLCHR36", start = 1, length = 30)
  stopifnot(myseq == "cgcgtgctggcggcaatgaagcgttcgatg")
  # Close the database:
  closebank()}
}
\keyword{ manip }

\name{ucoweight}
\alias{ucoweight}
\title{Weight of each synonymous codon}
\description{
  Returns a list containing, for each of the 20 amino acids + STOP
  codon, the codon usage bias of each of the synonymous codon according
  to a given codon sequence.
}
\usage{ucoweight(sequence, numcode = 1)}
\arguments{
  \item{sequence}{ A nucleic acids sequence }
  \item{numcode}{ The genetic code number as in \code{translate} }
}
\value{
  a list containing, for each of the 20 amino acids and STOP
  codon (list tags), the weight of each synonymous codon (including the
  original one).
}
\references{
  \code{citation("seqinr")}
}
\author{L. Palmeira}
\seealso{ \code{\link{synsequence}} }
\examples{
  data(ec999)
  ucoweight(ec999[1][[1]])
}
\keyword{ utilities }

\name{a}
\alias{a}
\title{Converts amino-acid three-letter code into the one-letter one}
\description{
This is a vectorized function to convert three-letters amino-acid code
into the one-letter one, for instance "Ala" into "A".
}
\usage{
a(aa)
}
\arguments{
  \item{aa}{ A vector of string. All strings are 3 chars long.}
}
\details{
Allowed character values for \code{aa} are given by \code{aaa()}.
All other values will generate a warning and return NA.
Called without arguments, \code{a()} returns the list of all possible
output values.
}
\value{
A vector of single characters.
}
\references{
The IUPAC one-letter code for aminoacids is described at: 
\url{https://www.bioinformatics.org/sms/iupac.html}\cr
\code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry }
\seealso{\code{\link{aaa}}, \code{\link{translate}} }
\examples{
  #
  # Show all possible input values:
  #
  
  aaa()
  
  #
  # Convert them in one letter-code:
  #
  
  a(aaa())
  
  #
  # Check consistency of results:
  #
  
  stopifnot( aaa(a(aaa())) == aaa())
  
  #
  # Show what happens with non-allowed values:
  #
  
  a("SOS") # should be NA and a warning is generated
}
\keyword{ utilities }

\name{readfirstrec}
\alias{readfirstrec}
\title{Low level function to get the record count of the specified ACNUC
index file}
\description{
 Called without arguments, the list of available values for argument type is
 returned.
}
\usage{
readfirstrec(socket = autosocket(), type)
}
\arguments{
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{type}{the ACNUC index file}
}
\details{
Available index files are:

  \describe{
	\item{AUT}{AUTHOR one record for each author name (last name only, no initials)}
	\item{BIB}{BIBLIO one record for each reference}
	\item{ACC}{ACCESS one record for each accession number}
	\item{SMJ}{SMJYT one record for each status, molecule, journal, year, type,
			   organelle, division, and db structure information}
	\item{SUB}{SUBSEQ one record for each parent or sub-sequence}
	\item{LOC}{LOCUS one record for each parent sequence}
	\item{KEY}{KEYWORDS one record for each keyword}
	\item{SPEC}{SPECIES one record for each taxon}
	\item{SHRT}{SHORTL mostly, one record for each element of a short list}
	\item{LNG}{LONGL one record for each group of SUBINLNG elements of a long list}
	\item{EXT}{EXTRACT (for nucleotide databases only) one record for each exon of each subsequence}
	\item{TXT}{TEXT one lrtxt-character record for each label of a species, keyword, or SMJYT}
  }
}
\value{
  The record count of ACNUC index file, or NA if missing (typically when
  asking for type = EXT on a protein database).
}
\references{
  See ACNUC physical structure at
  \url{https://doua.prabi.fr/databases/acnuc/structure.html}.\cr

  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{choosebank}} }
\examples{
\dontrun{
# Need internet connection
  choosebank("genbank")
  allowedtype <- readfirstrec()
  sapply(allowedtype, function(x) readfirstrec(type = x))
  }
}
\keyword{utilities}

\name{as.matrix.alignment}
\alias{as.matrix.alignment}

\title{as.matrix.alignment}
\description{
Converts an alignment into a matrix of characters
}
\usage{
\method{as.matrix}{alignment}(x, ...)
}
\arguments{
  \item{x}{ an object of the class alignment.}
  \item{...}{additional arguments to be passed to or from methods.}
}
\value{
  A matrix of characters.
}
\author{J.R. Lobry} 
\seealso{
  \code{\link{read.alignment}}
}
\examples{
  phylip <- read.alignment(file = system.file("sequences/test.phylip",
   package = "seqinr"), format = "phylip")
  as.matrix(phylip)
}

\name{setlistname}
\alias{setlistname}
\title{Sets the name of an ACNUC list identified by its rank}
\description{
This is a low level function to set the name of a list from an ACNUC server.
It should not be used directly by end users.
}
\usage{
setlistname(lrank, name = "list1", socket = autosocket())
}
\arguments{
  \item{lrank}{the list rank on the ACNUC server}
  \item{name}{the name to use for this list}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}
\value{
A single numeric value corresponding to:

  \item{NA}{Empty answer from server.}
  \item{0}{OK.}
  \item{3}{if another list with that name already existed and was deleted.}
  \item{4}{no list of rank \code{lrank} exists.}
}

\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}}, \code{\link{glr}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "sp=felis catus et t=CDS", virtual = TRUE)
  # Change list name on server:
  setlistname(lrank = glr("mylist"), name = "feliscatus") # 0, OK.
  glr("mylist") # 0, list doesn't exist no more.
  glr("feliscatus") # 2, this list exists.
  # Note the danger here: the object mylist is still present in the user workspace
  # while the corresponding list was deleted from server.
  }
}
\keyword{ utilities }

\name{plotabif}
\alias{plotabif}
\title{Electrophoregram plot for ABIF data}
\description{
  Simple chromatogram plot for data imported with the \code{\link{read.abif}} function.
}
\usage{
plotabif(abifdata, 
  chanel = 1, 
  tmin = 1/tscale, 
  tmax = abifdata$Data[["SCAN.1"]]/tscale, 
  tscale = 1000, 
  yscale = 1000, type = "l", las = 1, 
  xlab = paste("Time", tscale, sep = "/"),
  ylab = paste("RFU", yscale, sep = "/"), 
  irange = (tmin*tscale):(tmax*tscale),
  x = irange/tscale,
  xlim = c(tmin, tmax),
  chanel.names = c(1:4,105),
  DATA = paste("DATA", chanel.names[chanel], sep = "."),
  y = abifdata$Data[[DATA]][irange]/yscale,
  ylim = c(min(y), max(y)),
  dyn = abifdata$Data[[paste("DyeN", chanel, sep = ".")]],
  main = paste(deparse(substitute(abifdata)), chanel, dyn, sep = " ; "),
  calibr = NULL,
  ladder.bp = NULL,
  allele.names = "identifiler",
  ladder.lab = TRUE,
  ...)
}
\arguments{
  \item{abifdata}{the result returned by \code{\link{read.abif}}}
  \item{chanel}{the dye number}
  \item{tmin}{scaled starting time for the time axis}
  \item{tmax}{scaled ending time for the time axis}
  \item{tscale}{scale factor for the time axis}
  \item{yscale}{scale factor for the y-axis (RFU)}
  \item{type}{type of line drawing forwarded to \code{\link{plot}}}
  \item{las}{orientation of axis labels forwarded to \code{\link{plot}}}
  \item{xlab}{x-axis label forwarded to \code{\link{plot}}}
  \item{ylab}{y-axis label forwarded to \code{\link{plot}}}
  \item{irange}{indices of data to be plotted}
  \item{x}{values used for the x-axis}
  \item{xlim}{limits for the x-axis forwarded to \code{\link{plot}}}
  \item{chanel.names}{numbers extensions used for the DATA}
  \item{DATA}{names of the DATA components}
  \item{y}{values used for the y-axis}
  \item{ylim}{limits for the y-axis forwarded to \code{\link{plot}}}
  \item{dyn}{dye name}
  \item{main}{title for the plot forwarded to \code{\link{plot}}}
  \item{calibr}{an optional calibration function to convert time into bp}
  \item{ladder.bp}{an optional ladder scale in bp (calibr must be provided)}
  \item{allele.names}{name of the dataset with allele names}
  \item{ladder.lab}{logical: should allele names be added on plot}
  \item{...}{arguments forwarded to \code{\link{plot}}}
}
\value{
 Returns invisibly its local graphical parameter settings.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  function \code{\link{read.abif}} to import files in ABIF format, 
  data \code{\link{gs500liz}} for internal size standards,
  data \code{\link{identifiler}} for allele names in the allelic ladder,
  data \code{\link{JLO}} for an example of an individual sample file,
  data \code{\link{ECH}} for an example of an allelic lader.
}
\examples{
data(ECH)
plotabif(ECH,chanel = 1, tmin = 3.2, tmax = 6.1)
}

\name{gcT}
\alias{gcT}
\docType{data}
\title{GC content and temperature in bacteria}
\description{
  This data set was used in Galtier and Lobry (1997) to study the relationship between the optimal growth temperature of bacteria and their G+C content at the genomic level and locally were selection is active to maintain secondary structures in the stems of RNAs.
}
\format{
 	\code{gcT} is a list containing the 9 following components:  
	\describe{	
 	\item{species}{is a data frame containing the optimal growth temperature and genomic G+C content for 772 bacterial species. Detailled explanations for this table and the following are available in the \code{README} component.}
 	\item{genus}{is a data frame containing the optimal growth temperature and genomic G+C content for 224 bacterial genus.}
 	\item{details}{is a data frame with more information, see \code{README}.}
 	\item{gc16S}{is a data frame containing the optimal growth temperature and stems G+C content for 16S RNA from 165 bacterial genus.}
 	\item{gctRNA}{is a data frame containing the optimal growth temperature and stems G+C content for tRNA from 51 bacterial genus.}
 	\item{gc23S}{is a data frame containing the optimal growth temperature and stems G+C content for 23S RNA from 38 bacterial genus.}
 	\item{gc5S}{is a data frame containing the optimal growth temperature and stems G+C content for 5S RNA from 71 bacterial genus.}
 	\item{README}{is the original README file from \code{ftp://biom3.univ-lyon1.fr/pub/datasets/JME97/} last updated 13-MAY-2002.}
 	\item{importgcT}{is the R script used to import data.}
  }
}
\source{
Galtier, N. & Lobry, J.R. (1997). Relationships between genomic G+C 
content, RNA secondary structures, and optimal growth temperature 
in prokaryotes. \emph{Journal of Molecular Evolution} \bold{44}:632-636.\cr

Data imported into seqinr with the R script given in the last component of the dataset by J.R. Lobry on 09-OCT-2016. 
}
\references{
  \code{citation("seqinr")}
}
\examples{
data(gcT)
}

\name{getKeyword}
\alias{getKeyword}
\alias{getKeyword.default}
\alias{getKeyword.list}
\alias{getKeyword.SeqAcnucWeb}
\alias{getKeyword.qaw}
\alias{getKeyword.logical}

\title{Generic function to get keywords associated to sequences}
\description{
Get keywords from an ACNUC server.
}
\usage{
getKeyword(object, ...)
\method{getKeyword}{SeqAcnucWeb}(object, ..., socket = autosocket())
}
\arguments{
  \item{object}{ an object of the class \code{\link{SeqAcnucWeb}}, or
                        a list of them, or the object resulting from \code{\link{query}}}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database by \code{\link{choosebank}}).}
  \item{...}{further arguments passed to or from other methods}
}
\value{
  \code{getKeyword} returns a vector of strings containing the keyword(s)
  associated to a sequence.
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira} 
\seealso{
  \code{\link{SeqAcnucWeb}}
}
\examples{
#
# List all available methods for getKeyword generic function:
#
   methods(getKeyword)
#
# Example of keyword extraction from an ACNUC server:
#
  \dontrun{
  # Need internet connection
  choosebank("emblTP")
  fc<-query("fc", "sp=felis catus et t=cds et o=mitochondrion")
  getKeyword(fc$req[[1]])
  # Should be: 
  # [1] "DIVISION ORG" "RELEASE 62"   "CYTOCHROME B" "SOURCE"       "CDS"
  closebank()  
}
}
\keyword{ utilities }

\name{pmw}
\alias{pmw}
\title{ Protein Molecular Weight }
\description{
  With default parameter values, returns the apparent molecular weight of one mole (6.0221415 e+23)
  of the input protein expressed in gram at see level on Earth with terrestrial
  isotopic composition.
}
\usage{
pmw(seqaa, Ar = c(C = 12.0107, H = 1.00794, O = 15.9994,
N = 14.0067, P = 30.973762, S = 32.065), gravity = 9.81,
unit = "gram", checkseqaa = TRUE)
}
\arguments{
  \item{seqaa}{ a protein sequence as a vector of single chars. Allowed values are
  "*ACDEFGHIKLMNPQRSTVWY", non allowed values are ignored. }
  \item{Ar}{ a named vector for the mean relative atomic masses of CHONPS atoms. Defaults
  values are from to the natural terrestrial sources according to the 43rd IUPAC 
  General Assembly in Beijing, China in August 2005 (See 
  \url{https://iupac.org/category/recent-releases/}
  for updates).}
  \item{gravity}{ gravitational field constant in standard units. Defaults to 9.81 m/s2, that
  is to the average value at see level on Earth. Negative values are not allowed. }
  \item{unit}{ a string that could be "gram" to get the result in grams (1 g = 0.001 kg) 
  or "N" to get the result in Newton units (1 N = 1 kg.m/s2). }
  \item{checkseqaa}{ if TRUE \code{pmw()} warns if a non-allowed character in seqaa is found.}
}
\details{
\describe{
\item{Algorithm}{Computing the molecular mass of a protein is close to a linear form on
  amino-acid frequencies, but not exactly since we have to remove n - 1 water 
  molecules for peptidic bound formation.}
\item{Cysteine}{All cysteines are supposed to be in reduced (-SH) form.}
\item{Methionine}{All methionines are supposed to be not oxidized.}
\item{Modifications}{No post-traductional modifications (such as phosphorylations) 
are taken into account.}
\item{Rare}{Rare amino-acids (pyrolysine and selenocysteine) are not handled.}
\item{Warning}{Do not use defaults values for Ar to compute the molecular mass
of alien's proteins: the isotopic composition for CHONPS atoms could be different
from terrestrial data in a xenobiotic context. Some aliens are easily offended, make
sure not to initiate one more galactic war by repporting wrong results. }
}
}
\value{
  The protein molecular weight as a single numeric value. 
}
\references{
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{s2c}}, \code{\link{c2s}}, \code{\link{aaa}}, \code{\link{a}} }

\examples{
allowed <- s2c("*ACDEFGHIKLMNPQRSTVWY") # All allowed chars in a protein
pmw(allowed)
all.equal(pmw(allowed), 2395.71366) # Should be true on most platforms
#
# Compute the apparent molecular weight on Moon surface:
#
pmw(allowed, g = 1.6)
#
# Compute the apparent molecular weight in absence of gravity:
#
pmw(allowed, g = 0) # should be zero
#
# Reports results in Newton units:
#
pmw(allowed, unit = "N")
#
# Compute the mass in kg of one mol of this protein:
#
pmw(allowed)/10^3
#
# Compute the mass for all amino-acids:
#
sapply(allowed[-1], pmw) -> aamw
names(aamw) <- aaa(names(aamw))
aamw
}
\keyword{ utilities }

\name{kaksTorture}
\alias{kaksTorture}
\docType{data}
\title{Expected numeric results for Ka and Ks in extreme cases}
\description{
This data set is what should be obtained when runing \code{kaks()}
on the test file kaks-torture.fasta in the sequences directory of the
seqinR package.
}
\usage{data(kaksTorture)}
\format{
  A list with 4 components of class dist.
  \describe{
    \item{ka}{Ka}
    \item{ks}{Ks}
    \item{vka}{variance for Ka}
    \item{vks}{variance for Ks}
  }
}
\source{
See comments in kaks-torture.fasta for R code used to produce it.
}
\references{
\code{citation("seqinr")}
}
\examples{
data(kaksTorture)
kaks.torture <- read.alignment(file = system.file("sequences/kaks-torture.fasta", 
  package = "seqinr"), format = "fasta")
#
# Failed on windows :
#
# stopifnot(identical(kaksTorture, kaks(kaks.torture)))
# stopifnot(identical(kaksTorture, kaks(kaks.torture, rmgap = FALSE)))
}
\keyword{datasets}

\name{query}
\alias{query}
\title{To get a list of sequence names from an ACNUC data base located on the web}
\description{
This is a major command of the package. It executes all sequence retrievals using any selection criteria the data base allows.  The sequences are coming from ACNUC data base located on the web and they are transfered by socket. The command produces the list of all sequence names that fit the required criteria. The sequence names belong to the class of sequence \code{SeqAcnucWeb}.
}
\usage{
query(listname, query, socket = autosocket(),
invisible = TRUE, verbose = FALSE, virtual = FALSE)
}
\arguments{
  \item{listname}{The name of the list as a quoted string of chars}
  \item{query}{A quoted string of chars containing the request with the syntax given in the details section}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{invisible}{if \code{FALSE}, the result is returned visibly.}
  \item{verbose}{if \code{TRUE}, verbose mode is on}
  \item{virtual}{if \code{TRUE}, no attempt is made to retrieve the information about
    all the elements of the list. In this case, the \code{req} component of the list is set to
    \code{NA}.}
}
\details{
The query language defines several selection criteria and operations between
lists of elements matching criteria. It creates mainly lists of sequences, but
also lists of species (or, more generally, taxa) and of keywords.
See \url{https://doua.prabi.fr/databases/acnuc/cfonctions.html#QUERYLANGUAGE}
for the last update of the description of the query language.\cr

Selection criteria (no space before the = sign) are:
\describe{
  \item{SP=taxon}{seqs attached to taxon or any other below in tree; @ wildcard possible}
  \item{TID=id}{seqs attached to given numerical NCBI's taxon id}
  \item{K=keyword}{seqs attached to keyword or any other below in tree; @ wildcard possible}
  \item{T=type}{seqs of specified type}
  \item{J=journalname}{seqs published in journal specified using defined journal code}
  \item{R=refcode}{seqs from reference specified such as in jcode/volume/page (e.g., JMB/13/5432)}
  \item{AU=name}{seqs from references having specified author (only last name, no initial)}
  \item{AC=accessionno}{seqs attached to specified accession number}
  \item{N=seqname}{seqs of given name (ID or LOCUS); @ wildcard possible}
  \item{Y=year}{seqs published in specified year; > and < can be used instead of =}
  \item{O=organelle}{seqs from specified organelle named following defined code (e.g., chloroplast)}
  \item{M=molecule}{seqs from specified molecule as named in ID or LOCUS annotation records}
  \item{ST=status}{seqs from specified data class (EMBL) or review level (UniProt)}
  \item{F=filename}{seqs whose names are in given file, one name per line (unimplemented use \code{\link{clfcd}} instead)}
  \item{FA=filename}{seqs attached to accession numbers in given file, one number per line (unimplemented use \code{\link{clfcd}} instead)}
  \item{FK=filename}{produces the list of keywords named in given file, one keyword per line (unimplemented use \code{\link{clfcd}} instead)}
  \item{FS=filename}{produces the list of species named in given file, one species per line (unimplemented use \code{\link{clfcd}} instead)}
  \item{listname}{the named list that must have been previously constructed}
  }
Operators (always followed and preceded by blanks or parentheses) are:
\describe{
  \item{AND}{intersection of the 2 list operands}
  \item{OR}{union of the 2 list operands}
  \item{NOT}{complementation of the single list operand}
  \item{PAR}{compute the list of parent seqs of members of the single list operand}
  \item{SUB}{add subsequences of members of the single list operand}
  \item{PS}{project to species: list of species attached to member sequences of the operand list}
  \item{PK}{project to keywords: list of keywords attached to member sequences of the operand list}
  \item{UN}{unproject: list of seqs attached to members of the species or keywords list operand}
  \item{SD}{compute the list of species placed in the tree below the members of the species list operand}
  \item{KD}{compute the list of keywords placed in the tree below the members of the keywords list operand}
  }
The query language is case insensitive.Three operators (AND, OR, NOT)
can be ambiguous because they can also occur within valid criterion values.
Such ambiguities can be solved by encapsulating elementary selection
criteria between escaped double quotes.
}

\value{
The result is directly assigned to the object \code{listname} in the user workspace.
This is an objet of class \code{qaw}, a list with the following 6 components:

  \item{call}{the original call}
  \item{name}{the ACNUC list name}
  \item{nelem}{the number of elements (for instance sequences) in the ACNUC list}
  \item{typelist}{the type of the elements of the list. Could be SQ for a list of
    sequence names, KW for a list of keywords, SP for a list of species names.}
  \item{req}{a list of sequence names that fit the required criteria or \code{NA} when
    called with parameter \code{virtual} is \code{TRUE}}
  \item{socket}{the socket connection that was used}
}
\references{
Gouy, M., Milleret, F., Mugnier, C., Jacobzone, M., Gautier,C. (1984) ACNUC: a nucleic acid sequence data base and analysis system.
\emph{Nucl. Acids Res.}, \bold{12}:121-127.\cr
Gouy, M., Gautier, C., Attimonelli, M., Lanave, C., Di Paola, G. (1985)
ACNUC - a portable retrieval system for nucleic acid sequence databases:
logical and physical designs and usage.
\emph{Comput. Appl. Biosci.}, \bold{3}:167-172.\cr
Gouy, M., Gautier, C., Milleret, F. (1985) System analysis and nucleic acid sequence banks.
\emph{Biochimie}, \bold{67}:433-436.\cr

\code{citation("seqinr")}
}
\author{J.R. Lobry, D. Charif}
\note{Most of the documentation was imported from ACNUC help
files written by Manolo Gouy}
\seealso{
  \code{\link{choosebank}},
  \code{\link{getSequence}},
  \code{\link{getName}},
  \code{\link{crelistfromclientdata}}
}
\examples{
 \dontrun{
 # Need internet connection
 choosebank("genbank")
 bb <- query("bb", "sp=Borrelia burgdorferi")
 # To get the names of the 4 first sequences:
 sapply(bb$req[1:4], getName)
 # To get the 4 first sequences:
 sapply(bb$req[1:4], getSequence, as.string = TRUE)
 }
}
\keyword{utilities}

\name{getFrag}
\alias{getFrag}
\alias{getFrag.default}
\alias{getFrag.list}
\alias{getFrag.character}
\alias{getFrag.SeqFrag}
\alias{getFrag.SeqAcnucWeb}
\alias{getFrag.SeqFastadna}
\alias{getFrag.SeqFastaAA}
\alias{getFrag.qaw}
\alias{getFrag.logical}

\title{Generic function to extract sequence fragments}
\description{
getFrag is used to extract the sequence fragment starting at the \code{begin} position
and ending at the \code{end} position.
}
\usage{
getFrag(object, begin, end, ...)
\method{getFrag}{SeqAcnucWeb}(object, begin, end, ..., socket = autosocket(), name = getName(object))
\method{getFrag}{SeqFastadna}(object, begin, end, ..., name = getName(object))
\method{getFrag}{SeqFastaAA}(object, begin, end, ..., name = getName(object))
\method{getFrag}{SeqFrag}(object, begin, end, ..., name = getName(object))

}
\arguments{
  \item{object}{ an object of the class \code{\link{SeqAcnucWeb}}
    or \code{\link{SeqFastadna}}, or \code{\link{SeqFastaAA}} or \code{\link{SeqFrag}} or a list of these objects }
  \item{begin}{ First position of the fragment to extract. This position is included. Numerotation starts at 1.}
  \item{end}{ Last position of the fragment to extract. This position is included. }
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database by \code{\link{choosebank}}).}
  \item{name}{the sequence name}
  \item{...}{further arguments passed to or from other methods}
}
\value{
  \code{getFrag} returns an object of class \code{\link{SeqFrag}}.
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira} 
\seealso{
  \code{\link{SeqAcnucWeb}}, \code{\link{SeqFastadna}}, \code{\link{SeqFastaAA}}, \code{\link{SeqFrag}}
}
\examples{
#
# List all available methods for getFrag generic function:
#
   methods(getFrag)
#
# Example with a DNA sequence from a FASTA file:
#
  dnafile <- system.file("sequences/malM.fasta", package = "seqinr")
  sfdna <- read.fasta(file = dnafile)
  myfrag <- getFrag(sfdna[[1]], begin = 1, end = 10)
  stopifnot(getSequence(myfrag, as.string = TRUE) == "atgaaaatga")
}
\keyword{ utilities }

\name{ghelp}
\alias{ghelp}
\title{Get help from an ACNUC server}
\description{
Reads one item of information in specified help file from an ACNUC server.
The are differences between ACNUC clients so that this help could be
confusing. However, the query language is common to all clients so that
the most recent documentation is most likely here.
}
\usage{
ghelp(item = c("GENERAL", "SELECT", "SPECIES", "KEYWORD"),
 file = c("HELP", "HELP_WIN"), socket = autosocket(), catresult = TRUE)

}
\arguments{
  \item{item}{the name of the desired help item}
  \item{file}{the name of the help file on server side.}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{catresult}{logical. If TRUE output is redirected to the console.}
}

\value{
A vector of string which is returned invisibly and "cated" to the console
by default.
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  ghelp()
  ghelp("SELECT")
  # To get info about current database:
  ghelp("CONT")
  }
}
\keyword{ utilities }

\name{lseqinr}
\alias{lseqinr}
\title{ To see what's inside the package seqinr }
\description{
  This is just a shortcut for \code{ls("package:seqinr")}
}
\usage{
lseqinr()
}
\value{
  The list of objects in the package \code{seqinr}  
}
\references{
  \code{citation("seqinr")}
}
\note{ 
Use \code{library(help=seqinr)} to have a summary of the functions available in the package.
}
\author{J.R. Lobry}
\examples{
lseqinr()
}
\keyword{utilities}

\name{plotPanels}
\alias{plotPanels}
\title{Representation of Amplicon Size Ranges of a STR kit.}
\description{Plot amplicon size ranges grouped by dye color.}
\usage{plotPanels(kitname, data, xlim = NULL, cex = 0.75, alpha = 0.5)}
\arguments{
  \item{kitname}{string of characters for the kit name.}
  \item{data}{an output from the \code{\link{readPanels}} function.}
  \item{xlim}{x-axis range.}
  \item{cex}{character expansion factor.}
  \item{alpha}{alpha transparency chanel for colors.}
}
\value{none}
\author{J.R. Lobry}

\seealso{ \code{\link{readPanels}}.}

\examples{
path1 <- system.file("abif/AmpFLSTR_Panels_v1.txt", package = "seqinr")
res1 <- readPanels(path1)

par(mfrow = c(2,1))
plotPanels("Identifiler_v1", res1)
plotPanels("SEfiler_v1", res1)

}

\name{parser.socket}
\alias{parser.socket}

\title{Utility function to parse answers from an ACNUC server}
\description{
Answers from server looks like : "code=0&lrank=2&count=150513&type=SQ&locus=F".
}
\usage{
parser.socket(onelinefromserver, verbose = FALSE)
}
\arguments{
  \item{onelinefromserver}{a string}
  \item{verbose}{logical, if TRUE mode verbose is on}
}
\value{
A vector of mode character or NULL if \code{onelinefromserver} is NULL
or if its length is 0.
}
\references{
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}} }
\examples{
stopifnot(all(parser.socket("code=0&lrank=2&count=150513&type=SQ&locus=F") 
                                     == c("0", "2", "150513", "SQ", "F")))
}
\keyword{ utilities }

\name{translate}
\alias{translate}
\title{ Translate nucleic acid sequences into proteins }
\description{
   This function translates nucleic acid sequences into the corresponding
   peptide sequence. It can translate in any of the 3 forward or three
   reverse sense frames. In the case of reverse sense, the reverse-complement
   of the sequence is taken. It can translate using the standard (universal)
   genetic code and also with non-standard codes. Ambiguous bases can also
   be handled.
}
\usage{
translate(seq, frame = 0, sens = "F", numcode = 1, NAstring = "X", ambiguous = FALSE,
          force.first.aa.to.Met = FALSE)
}
\arguments{
  \item{seq}{ the sequence to translate as a vector of single characters in lower case letters. }
  \item{frame}{ Frame(s) (0,1,2) to translate. By default the frame \code{0} is used. }
  \item{sens}{ Sense to translate: \code{F} for forward sense and \code{R} for reverse sense. }
  \item{numcode}{ The ncbi genetic code number for translation. By default the standard genetic code is used. }
  \item{NAstring}{ How to translate amino-acids when there are ambiguous bases in codons. }
  \item{ambiguous}{ If TRUE, ambiguous bases are taken into account so that for instance
  GGN is translated to Gly in the standard genetic code. }
  \item{force.first.aa.to.Met}{ If TRUE, the first codon in the sequence will be translated to
  Methionine regardless of the codon in order to treat rare start codons like TTG. }

}
\details{
 The following genetic codes are described here. The number preceding each code
 corresponds to \code{numcode}.
\describe{
  \item{1}{ standard }
  \item{2}{ vertebrate.mitochondrial }
  \item{3}{ yeast.mitochondrial }
  \item{4}{ protozoan.mitochondrial+mycoplasma }
  \item{5}{ invertebrate.mitochondrial }
  \item{6}{ ciliate+dasycladaceal }
  \item{9}{ echinoderm+flatworm.mitochondrial }
  \item{10}{ euplotid }
  \item{11}{ bacterial+plantplastid }
  \item{12}{ alternativeyeast }
  \item{13}{ ascidian.mitochondrial }
  \item{14}{ alternativeflatworm.mitochondrial }
  \item{15}{ blepharism }
  \item{16}{ chlorophycean.mitochondrial }
  \item{21}{ trematode.mitochondrial }
  \item{22}{ scenedesmus.mitochondrial }
  \item{23}{ thraustochytrium.mitochondria }
  \item{24}{Pterobranchia.mitochondrial}
  \item{25}{CandidateDivision.SR1+Gracilibacteria}
  \item{26}{Pachysolen.tannophilus}
}
}
\value{
  \code{translate} returns a vector of single characters containing the peptide sequence in
  the standard one-letter IUPAC code. Termination (STOP) codons are translated by
  the character '*'.
}
\references{
The genetic codes have been taken from the ncbi taxonomy database:
\url{https://www.ncbi.nlm.nih.gov/Taxonomy/Utils/wprintgc.cgi}.
Last update October 05, 2000.\cr
The IUPAC one-letter code for aminoacids is described at:
\url{https://www.bioinformatics.org/sms/iupac.html}

\code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{
Use \code{\link{tolower}} to change upper case letters into lower case letters.
For coding sequences obtained from an ACNUC server with \code{\link{query}} it's
better to use the function \code{\link{getTrans}} so that the relevant genetic
code and the relevant frame are automatically used.
The genetic codes are given in the object \code{\link{SEQINR.UTIL}}, a more
human readable form is given by the function \code{\link{tablecode}}.
Use \code{\link{aaa}} to get the three-letter code for amino-acids.}
\examples{
##
## Toy CDS example invented by Leonor Palmeira:
##
toycds <- s2c("tctgagcaaataaatcgg")
translate(seq = toycds) # should be c("S", "E", "Q", "I", "N", "R")
translate(seq = toycds, force.first.aa.to.Met = TRUE) # should be c("M", "E", "Q", "I", "N", "R")
##
## Toy CDS example with ambiguous bases:
##
toycds2 <- s2c("tcngarcarathaaycgn")
translate(toycds2) # should be c("X", "X", "X", "X", "X", "X")
translate(toycds2, ambiguous = TRUE) # should be c("S", "E", "Q", "I", "N", "R")
translate(toycds2, ambiguous = TRUE, numcode = 2) # should be c("S", "E", "Q", "X", "N", "R")
##
## Real CDS example:
##
realcds <- read.fasta(file = system.file("sequences/malM.fasta", package ="seqinr"))[[1]]
translate(seq = realcds)
# Biologically correct, only one stop codon at the end
translate(seq = realcds, frame = 3, sens = "R", numcode = 6)
# Biologically meaningless, note the in-frame stop codons

# Read from an alignment as suggested by Dr. H. Suzuki
fasta.res    <- read.alignment(file = system.file("sequences/Anouk.fasta", package = "seqinr"),
 format = "fasta")

AA1 <- seqinr::getTrans(s2c(fasta.res$seq[[1]]))
AA2 <- seqinr::translate(s2c(fasta.res$seq[[1]]))
identical(AA1, AA2)

AA1 <- lapply(fasta.res$seq, function(x) seqinr::getTrans(s2c(x)))
AA2 <- lapply(fasta.res$seq, function(x) seqinr::translate(s2c(x)))
identical(AA1, AA2)

\dontrun{
## Need internet connection.
## Translation of the following EMBL entry:
##
## FT   CDS             join(complement(153944..154157),complement(153727..153866),
## FT                   complement(152185..153037),138523..138735,138795..138955)
## FT                   /codon_start=1
## FT                   /db_xref="FLYBASE:FBgn0002781"
## FT                   /db_xref="GOA:Q86B86"
## FT                   /db_xref="TrEMBL:Q86B86"
## FT                   /note="mod(mdg4) gene product from transcript CG32491-RZ;
## FT                   trans splicing"
## FT                   /gene="mod(mdg4)"
## FT                   /product="CG32491-PZ"
## FT                   /locus_tag="CG32491"
## FT                   /protein_id="AAO41581.1"
## FT                   /translation="MADDEQFSLCWNNFNTNLSAGFHESLCRGDLVDVSLAAEGQIVKA
## FT                   HRLVLSVCSPFFRKMFTQMPSNTHAIVFLNNVSHSALKDLIQFMYCGEVNVKQDALPAF
## FT                   ISTAESLQIKGLTDNDPAPQPPQESSPPPAAPHVQQQQIPAQRVQRQQPRASARYKIET
## FT                   VDDGLGDEKQSTTQIVIQTTAAPQATIVQQQQPQQAAQQIQSQQLQTGTTTTATLVSTN
## FT                   KRSAQRSSLTPASSSAGVKRSKTSTSANVMDPLDSTTETGATTTAQLVPQQITVQTSVV
## FT                   SAAEAKLHQQSPQQVRQEEAEYIDLPMELPTKSEPDYSEDHGDAAGDAEGTYVEDDTYG
## FT                   DMRYDDSYFTENEDAGNQTAANTSGGGVTATTSKAVVKQQSQNYSESSFVDTSGDQGNT
## FT                   EAQVTQHVRNCGPQMFLISRKGGTLLTINNFVYRSNLKFFGKSNNILYWECVQNRSVKC
## FT                   RSRLKTIGDDLYVTNDVHNHMGDNKRIEAAKAAGMLIHKKLSSLTAADKIQGSWKMDTE
## FT                   GNPDHLPKM"
choosebank("emblTP")
trans <- query("trans", "N=AE003734.PE35")
trans1 <- getTrans(trans$req[[1]])
## Complex transsplicing operations, the correct frame and the correct
## genetic code are automatically used for translation into protein.
seq <- getSequence(trans$req[[1]])
identical(translate(seq),trans1)
#default frame and genetic code are correct
trans <- query("trans", "N=AB004237")
trans1 <- getTrans(trans$req[[1]])
## Complex transsplicing operations, the correct frame and the correct
## genetic code are automatically used for translation into protein.
seq <- getSequence(trans$req[[1]])
identical(translate(seq),trans1)
#default  genetic code is not correct
identical(translate(seq,numcode=2),trans1)
#genetic code is 2
}
}
\keyword{ manip }

\name{extract.breakpoints}
\alias{extract.breakpoints}
\title{Extraction of breakpoint positions on the
  rearranged nucleotide skews. }
\description{
  Extraction of breakpoint positions on the
  rearranged nucleotide skews. 
  }

\usage{extract.breakpoints(rearr.ori,
type = c("atfw", "atrev", "gcfw", "gcrev"),
 nbreaks, gridsize = 100, it.max = 500)}

\arguments{
\item{rearr.ori}{A data frame obtained with the \code{rearranged.oriloc}
  function.  }
\item{type}{The type of skew for which to extract the breakpoints; must
  be a subset of \code{c("atfw","atrev","gcfw","gcrev")}.}
\item{nbreaks}{The number of breakpoints to extract for each type of
  skew. Provide a vector of the same length as \code{type}.}
\item{gridsize}{To make sure that the best breakpoints are found, and to
avoid finding only a local extremum of the likelihood and residual sum
of square functions, a grid search is performed. The search for
breakpoints is repeated \code{gridsize} times, with different starting
values for the breakpoints. }
\item{it.max}{The maximum number of iterations to be performed when
  searching for the breakpoints. This argument corresponds to the
  \code{it.max} argument in \code{segmented}.}
}
\details{
  This method uses the \code{segmented} function in the \code{segmented}
  package to extract the breakpoints positions in the rearranged
  nucleotide skews obtained with the \code{rearranged.oriloc} function.
To make sure that the best breakpoints are found, and to
avoid finding only a local extremum of the likelihood and residual sum
of square functions, a grid search is performed. The search for
breakpoints is repeated \code{gridsize} times, with different starting
values for the breakpoints. 
  
}

\value{

  This function returns a list, with as many elements as the \code{type}
  argument (for example \code{$gcfw} will contain the results for the
  rearranged GC-skew, for forward-encoded genes). Each element of this list is also a list, containing the
  following information: in  \code{$breaks} the position of the breakpoints on the
  rearranged chromosome; in  \code{$slopes.left} the slopes of the
  segments on the left side of each breakpoint; in  \code{$slopes.right} the slopes of the
  segments on the right side of each breakpoint; in \code{$real.coord},
  the coordinates of the breakpoints on the real chromosome (before rearrangement).

  }

\references{

  \code{citation("segmented")}
  
  Necşulea, A. and Lobry, J.R. (in prep) A novel method for assessing
  the effect of replication on DNA base composition asymmetry.
  \emph{Molecular Biology and Evolution},\bold{24}:2169-2179.

}
\author{A. Necşulea}
\seealso{ \code{\link{oriloc}}, \code{\link{draw.rearranged.oriloc}},
  \code{\link{rearranged.oriloc}}  }

\examples{

### Example for Chlamydia trachomatis ####

### Rearrange the chromosome and compute the nucleotide skews ###

\dontrun{r.ori <- rearranged.oriloc(seq.fasta = system.file("sequences/ct.fasta.gz", package = "seqinr"),
    g2.coord = system.file("sequences/ct.coord",package = "seqinr"))}

### Extract the breakpoints for the rearranged nucleotide skews ###


\dontrun{breaks <- extract.breakpoints(r.ori,type = c("gcfw", "gcrev"),
 nbreaks = c(2, 2), gridsize = 50, it.max = 100)}


### Draw the rearranged nucleotide skews and ###
### place the position of the breakpoints on the graphics ###

\dontrun{draw.rearranged.oriloc(r.ori, breaks.gcfw = breaks$gcfw$breaks,
 breaks.gcrev = breaks$gcrev$breaks)}
}

\keyword{utilities}

\name{c2s}
\alias{c2s}
\title{ conversion of a vector of chars into a string }
\description{
  This is a simple utility function to convert a vector of chars
such as c("m", "e", "r", "g", "e", "d") into a single string such
as "merged".
}
\usage{
c2s(chars = c("m", "e", "r", "g", "e", "d"))
}
\arguments{
  \item{chars}{ a vector of chars }
}
\value{
  a string
}
\author{J.R. Lobry}
\references{
  \code{citation("seqinr")}
}
\seealso{ \code{\link{s2c}} }
\examples{
c2s( c("m","e","r","g","e","d") )
}
\keyword{utilities}

\name{uco}
\alias{uco}
\alias{rscu}
\title{ Codon usage indices }
\description{
  \code{uco} calculates some codon usage indices: the codon counts \code{eff}, the relative frequencies \code{freq} or the Relative Synonymous Codon Usage \code{rscu}.
}
\usage{
uco(seq, frame = 0, index = c("eff", "freq", "rscu"), as.data.frame = FALSE,
NA.rscu = NA)
}
\arguments{
  \item{seq}{ a coding sequence as a vector of chars }
  \item{frame}{ an integer (0, 1, 2) giving the frame of the coding sequence }
  \item{index}{ codon usage index choice, partial matching is allowed.
                \code{eff} for codon counts,
                \code{freq} for codon relative frequencies,
                and \code{rscu} the RSCU index.\cr

                "eff", "freq", and "rscu" correspond to "R0", "R1", and "R3", respectively, in Suzuki et al. (2005) "2.2 Normalization of codon usage data".\cr

                "eff" and "rscu" correspond to "AF" and "RSCU", respectively, in Suzuki et al. (2008) "2.2. Definitions of codon usage data".
                }
  \item{as.data.frame}{ logical. If \code{TRUE}: all indices are returned into a data frame.}
  \item{NA.rscu}{ when an amino-acid is missing, RSCU are no more defined and repported
  as missing values (\code{NA}). You can force them to another value (typically 0 or
  1) with this argument.}
}
\details{
  Codons with ambiguous bases are ignored.\cr

  RSCU is a simple measure of non-uniform usage of synonymous codons in a coding sequence
  (Sharp \emph{et al.} 1986).
  RSCU values are the number of times a particular codon is observed, relative to the number
  of times that the codon would be observed for a uniform synonymous codon usage (i.e. all the
  codons for a given amino-acid have the same probability).
  In the absence of any codon usage bias, the RSCU values would be 1.00 (this is the case
  for sequence \code{cds} in the exemple thereafter). A codon that is used
  less frequently than expected will have an RSCU value of less than 1.00 and vice versa for a codon
  that is used more frequently than expected.\cr

  Do not use correspondence analysis on RSCU tables as this is a source of artifacts
  (Perrière and Thioulouse 2002, Suzuki \emph{et al.} 2008). Within-aminoacid correspondence analysis is a
  simple way to study synonymous codon usage (Charif \emph{et al.} 2005). For an introduction
  to correspondence analysis and within-aminoacid correspondence analysis see the
  chapter titled \emph{Multivariate analyses} in the seqinR manual that ships with the
  seqinR package in the \bold{doc} folder. You can also use internal correspondence
  analysis if you want to analyze simultaneously a row-block structure such as the
  within and between species variability (Lobry and Chessel 2003).\cr

  If \code{as.data.frame} is FALSE, \code{uco} returns one of these:
  \describe{
  \item{ eff }{ a table of codon counts }
  \item{ freq }{ a table of codon relative frequencies }
  \item{ rscu }{ a numeric vector of relative synonymous codon usage values}
  }
  If \code{as.data.frame} is TRUE, \code{uco} returns a data frame with five columns:
  \describe{
  \item{ aa }{ a vector containing the name of amino-acid }
  \item{ codon }{ a vector containing the corresponding codon }
  \item{ eff }{ a numeric vector of codon counts }
  \item{ freq }{ a numeric vector of codon relative frequencies }
  \item{ rscu }{ a numeric vector of RSCU index }
  }
}
\value{
  If \code{as.data.frame} is FALSE, the default, a table for \code{eff} and \code{freq} and
  a numeric vector for \code{rscu}. If \code{as.data.frame} is TRUE,
  a data frame with all indices is returned.
}
\references{
\code{citation("seqinr")} \cr

Sharp, P.M., Tuohy, T.M.F., Mosurski, K.R. (1986) Codon usage in yeast: cluster
analysis clearly differentiates highly and lowly expressed genes.
\emph{Nucl. Acids. Res.}, \bold{14}:5125-5143.\cr

Perrière, G., Thioulouse, J. (2002) Use and misuse of correspondence analysis in
codon usage studies. \emph{Nucl. Acids. Res.}, \bold{30}:4548-4555.\cr

Lobry, J.R., Chessel, D. (2003) Internal correspondence analysis of codon and
amino-acid usage in thermophilic bacteria.
\emph{Journal of Applied Genetics}, \bold{44}:235-261. \url{http://jag.igr.poznan.pl/2003-Volume-44/2/pdf/2003_Volume_44_2-235-261.pdf}.\cr

Charif, D., Thioulouse, J., Lobry, J.R., Perrière, G. (2005) Online
Synonymous Codon Usage Analyses with the ade4 and seqinR packages.
\emph{Bioinformatics}, \bold{21}:545-547. \url{https://pbil.univ-lyon1.fr/members/lobry/repro/bioinfo04/}.\cr

Suzuki, H., Saito, R. Tomita, R. (2005)
A problem in multivariate analysis of codon usage data and a possible solution.
\emph{FEBS Lett.}, \bold{579}:6499-504. \url{https://www.thermofisher.com/de/de/home/brands/applied-biosystems.html}.\cr

Suzuki, H., Brown, C.J., Forney, L.J., Top, E. (2008)
Comparison of Correspondence Analysis Methods for Synonymous Codon Usage in Bacteria.
\emph{DNA Research}, \bold{15}:357-365. \url{https://academic.oup.com/dnaresearch/article/15/6/357/513030}.

}
\author{D. Charif, J.R. Lobry, G. Perrière}
\examples{

## Show all possible codons:
words()

## Make a coding sequence from this:
(cds <- s2c(paste(words(), collapse = "")))

## Get codon counts:
uco(cds, index = "eff")

## Get codon relative frequencies:
uco(cds, index = "freq")

## Get RSCU values:
uco(cds, index = "rscu")

## Show what happens with ambiguous bases:
uco(s2c("aaannnttt"))

## Use a real coding sequence:
rcds <- read.fasta(file = system.file("sequences/malM.fasta", package = "seqinr"))[[1]]
uco( rcds, index = "freq")
uco( rcds, index = "eff")
uco( rcds, index = "rscu")
uco( rcds, as.data.frame = TRUE)

## Show what happens with RSCU when an amino-acid is missing:
ecolicgpe5 <- read.fasta(file = system.file("sequences/ecolicgpe5.fasta",package="seqinr"))[[1]]
uco(ecolicgpe5, index = "rscu")

## Force NA to zero:
uco(ecolicgpe5, index = "rscu", NA.rscu = 0)
}
\keyword{ manip }

\name{count}
\alias{count}
\title{Composition of dimer/trimer/etc oligomers}
\description{
  Counts the number of times dimer/trimer/etc oligomers occur in a
  sequence. Note that the oligomers are overlapping by default.
}
\usage{
count(seq, wordsize, start = 0, by = 1,
 freq = FALSE, alphabet = s2c("acgt"), frame = start)
}
\arguments{
  \item{seq}{a vector of single characters.}
  \item{wordsize}{an integer giving the size of word (n-mer) to count.}
  \item{start}{an integer (0, 1, 2,...) giving the starting
    position to consider in the sequence. The default value 0 means that
    we start at the first nucleotide in the sequence.}
  \item{by}{an integer defaulting to 1 for the window step.}
  \item{freq}{if TRUE, word relative frequencies (summing to 1) are returned instead of counts}
  \item{alphabet}{a vector of single characters used to build the oligomer set.}
  \item{frame}{synonymous for start}
}
\details{
 \code{count} counts the occurence of all words by moving a window of
 length \code{word}. The window step is controlled by the argument \code{by}. 
\code{start} controls the starting position in the sequence for the count.
}
\value{
  This function returns a \code{\link{table}} whose \code{\link{dimnames}} are all the possible
  oligomers. All oligomers are returned, even if absent from
  the sequence.		
}
\author{D. Charif, J.R. Lobry with suggestions from Gabriel Valiente, Stefanie Hartmann and Christian Gautier}
\references{
  \code{citation("seqinr")}
}
\seealso{ \code{\link{table}} for the class of the returned objet. See \code{\link{rho}} and
  \code{\link{zscore}} for dinucleotide statistics.}
\examples{
a <- s2c("acgggtacggtcccatcgaa")
##
## To count dinucleotide occurrences in sequence a:
##
count(a, word = 2)
##
## To count trinucleotide occurrences in sequence a, with start = 2:
##
count(a, word = 3, start = 2)
##
## To count dinucleotide relative frequencies in sequence a:
##
count(a, word = 2, freq = TRUE)
##
## To count dinucleotides in codon positions III-I in a coding sequence:
##
alldinuclIIIpI <- s2c("NNaaNatNttNtgNgtNtcNctNtaNagNggNgcNcgNgaNacNccNcaNN")
resIIIpI <- count(alldinuclIIIpI, word = 2, start = 2, by = 3)
stopifnot(all( resIIIpI == 1))
##
## Simple sanity check:
##
#alldinucl <- "aattgtctaggcgacca"
#stopifnot(all(count(s2c(alldinucl), 2) == 1))
#alldiaa <- "aaxxzxbxvxyxwxtxsxpxfxmxkxlxixhxgxexqxcxdxnxrxazzbzvzyzwztzszpzfzmzkzlzizhzgzezqzczdznz
#rzabbvbybwbtbsbpbfbmbkblbibhbgbebqbcbdbnbrbavvyvwvtvsvpvfvmvkvlvivhvgvevqvcvdvnvrvayywytysypyfymyky
#lyiyhygyeyqycydynyryawwtwswpwfwmwkwlwiwhwgwewqwcwdwnwrwattstptftmtktltithtgtetqtctdtntrtasspsfsmsks
#lsishsgsesqscsdsnsrsappfpmpkplpiphpgpepqpcpdpnprpaffmfkflfifhfgfefqfcfdfnfrfammkmlmimhmgmemqmcmdmnm
#rmakklkikhkgkekqkckdknkrkallilhlglelqlcldlnlrlaiihigieiqicidiniriahhghehqhchdhnhrhaggegqgcgdgngrgae
#eqecedenereaqqcqdqnqrqaccdcncrcaddndrdannrnarra"
#stopifnot(all(count(s2c(alldiaa), 2, alphabet = s2c("arndcqeghilkmfpstwyvbzx")) == 1))
##
## Example with dinucleotide count in the complete Human mitochondrion genome:
##
humanMito <- read.fasta(file = system.file("sequences/humanMito.fasta", package = "seqinr"))
##
## Get the dinucleotide count:
##
dinu <- count(humanMito[[1]], 2)
##
## Put the results in a 4 X 4 array:
##
dinu2 <- dinu
dim(dinu2) <- c(4, 4)
nucl <- s2c("ACGT")
dimnames(dinu2) <- list(paste(nucl, "-3\'", sep = ""), paste("5\'-", nucl, sep = ""))
##
## Show that CpG and GpT dinucleotides are depleted:
##
mosaicplot(t(dinu2), shade = TRUE,
  main = "Dinucleotide XpY frequencies in the Human\nmitochondrion complete genome", 
  xlab = "First nucleotide: Xp", 
  ylab = "Second nucleotide: pY", las = 1, cex = 1)
mtext("Note the depletion in CpG and GpT dinucleotides", side = 1, line = 3)
}
\keyword{ manip }

\name{caitab}
\alias{caitab}
\docType{data}
\title{Codon Adaptation Index (CAI) w tables}
\description{
Information about a preferred set of codons for highly expressed genes
in three species.
}
\usage{data(caitab)}
\format{
  A data frame with 64 rows for the codons and the following 3 columns:
  \describe{
    \item{ec}{\emph{Escherichia coli}}
    \item{bs}{\emph{Bacillus subtilis}}
    \item{sc}{\emph{Saccharomyces cerevisiae}}
  }
}
\details{
  Codons are given by \code{row.names(caitab)}.
}
\source{
The data were hard-encoded in
the C program codonW version 1.4.4 writen by John Peden
available at \url{https://codonw.sourceforge.net/}. The data
are from the file \code{codonW.h}.
According to this source file, there were no reference for
\emph{Escherichia coli} and \emph{Bacillus subtilis} and the
reference for \emph{Saccharomyces cerevisiae} was Sharp
and Cowe (1991).

It turns out that the data for \emph{Escherichia coli} and
\emph{Saccharomyces cerevisiae} are identical to table 1
in Sharp and Li (1987) where the missing values for the stop
codons are represented here by zeros. All codons were documented
by at least one count in both datasets.

The data for \emph{Bacillus subtilis} are from table 2 in Shields
and Sharp (1987). Missing values for stops codons are represented
as previously by zeros, missing values for single-box amino-acids
are represented by 1 here. Note that some codons were undocumented
in this dataset and that a 0.5 value in absolute frequencies was
already forced to avoid zeros. It is therefore impossible to use
directly these data to obtain the exact expected CAI values as documented
in \code{\link{cai}} because of overlapping with documented codons.

}
\references{
  Sharp, P.M., Li, W.-H. (1987) The codon adaptation index - a
  measure of directional synonymous codon usage bias, and its
  potential applications.
  \emph{Nucleic Acids Research}, \bold{15}:1281-1295.

  Shields, D.C., Sharp, P.M. (1987) Synonymous codon usage in \emph{Bacillus subtilis}
  reflects both traditional selection and mutational biases.
  \emph{Nucleic Acids Research}, \bold{15}:8023-8040.

  Sharp, P. M., Cowe, E. (1991).
  Synonymous codon usage in \emph{Saccharomyces cerevisiae}.
  \emph{Yeast}, \bold{7}:657-678.

  Peden, J.F. (1999)
  Analysis of codon usage.
  PhD Thesis, University of Nottingham, UK.

  \code{citation("seqinr")}
}
\seealso{
  \code{\link{cai}} for an example using this dataset to compute CAI values.
}
\examples{
  data(caitab)
}
\keyword{datasets}

\name{seqinr-package}
\alias{seqinr-package}
\alias{seqinr}
\docType{package}
\title{
Biological Sequences Retrieval and Analysis
}
\description{
Exploratory data analysis and data visualization for
biological sequence (DNA and protein) data. Include also
utilities for sequence data management under the ACNUC system.
}
\author{Delphine Charif [aut], Olivier Clerc [ctb], Carolin Frank [ctb], 
  Jean R. Lobry [aut], Anamaria Necşulea [ctb], Leonor Palmeira [ctb], 
  Simon Penel [cre], Guy Perrière [ctb]}
\references{
citation('seqinr')
}
\keyword{ package }

\name{phylip}
     \docType{data}
     \alias{phylip}
     \title{Example of results obtained after a call to read.alignment}
     \description{This data set gives an example of a amino acids alignment obtained after a call to the function read.alignment on an alignment file in "phylip" format.}
     \usage{data(phylip)}
     \format{A List of class alignment}
     \source{http://evolution.genetics.washington.edu/phylip.html}
     \references{http://evolution.genetics.washington.edu/phylip.html}
     \keyword{datasets}

\name{stutterabif}
\Rdversion{1.1}
\alias{stutterabif}
\title{Stutter ratio estimation}
\description{
This function tries to estimate the stutter ratio, either in terms of peak heigth ratios or peak
surface ratio.
}
\usage{
stutterabif(abifdata, chanel, poswild, datapointbefore = 70,
 datapointafter = 20, datapointsigma = 3.5,
 chanel.names = c(1:4, 105), DATA = paste("DATA", chanel.names[chanel], sep = "."),
 maxrfu = 1000, method = "monoH.FC", pms = 6, fig = FALSE)
}
\arguments{
  \item{abifdata}{the result returned by \code{\link{read.abif}}}
  \item{chanel}{the dye number}
  \item{poswild}{the position in datapoint units of the allele at 
    the origin of the stutter product, typically obtained after a call to \code{\link{peakabif}}}
  \item{datapointbefore}{how many datapoints before \code{poswild} to be include in analysis}
  \item{datapointafter}{how many datapoints after \code{poswild} to be include in analysis}
  \item{datapointsigma}{initial guess for the standard deviation of a peak}
  \item{chanel.names}{numbers extensions used for the DATA}
  \item{DATA}{names of the DATA components}
  \item{maxrfu}{argument passed to \code{\link{baselineabif}}}
  \item{method}{method to be used by \code{\link{splinefun}}}
  \item{pms}{how many standard deviations (after gaussian fit) before and after the mean 
  peak values should be considered for spline function interpolation}
  \item{fig}{should a summary plot be produced?}
}

\details{FIXME, See R code for now}

\value{
A list with the following components:
\item{rh}{Stutter ratio computed as the height of the stutter divided by 
 the height of its corresponding allele}
\item{rs}{Stutter ratio computed as the surface of the stutter divided by
 the surface of its corresponding allele}
\item{h1}{The height of the stutter with baseline at 0}
\item{h2}{The height of the allele with baseline at 0}
\item{s1}{The surface of the stutter}
\item{s2}{The surface of the allele}
\item{p}{A list of additional parameter that could be usesfull, see example}
}

\author{J.R. Lobry}

\seealso{\code{\link{JLO}} for a dataset example, 
\code{\link{peakabif}} to get an estimate of peak location.}
\examples{
  #
  # Load pre-defined dataset, same as what would be obtained with read.abif:
  #

data(JLO)

  #
  # Get peak locations in the blue channel:
  #

maxis <- peakabif(JLO, 1, npeak = 6, tmin = 3, fig = FALSE)$maxis

  #
  # Compute stutter ratio for first peak and ask for a figure:
  #

tmp <- stutterabif(JLO, 1, maxis[1], fig = TRUE)

  #
  # Show in addition the normal approximation used at the stutter peak:
  #

xx <- seq(tmp$p$mu1 - 6*tmp$p$sd1, tmp$p$mu1 + 6*tmp$p$sd1, le = 100)
lines(xx, tmp$p$p1*dnorm(xx, tmp$p$mu1, tmp$p$sd1), col = "darkgreen")

  #
  # Show in addition the normal approximation used at allele peak:
  #

xx <- seq(tmp$p$mu2 - 6*tmp$p$sd2, tmp$p$mu2 + 6*tmp$p$sd2, le = 100)
lines(xx, tmp$p$p2*dnorm(xx, tmp$p$mu2, tmp$p$sd2), col = "darkgreen")
}

\name{dist.alignment}
\alias{dist.alignment}
\title{ Pairwise Distances from Aligned Protein or DNA/RNA Sequences }
\description{
  These functions compute a matrix of pairwise distances from aligned sequences
  using similarity (Fitch matrix, for protein sequences only) or identity matrix
  (for protein and DNA sequences).
  The resulting matrix contains the squared root of the pairwise distances.
  For example, if identity between 2 sequences is 80%, the matrix will gives
  the squared root of (1.0 - 0.8) i.e. 0.4472136.
  Note: seqinr::dist.alignment is the square root version of ape::dist.gene (and
  not ape::dist.dna).

}
\usage{
dist.alignment(x, matrix = c("identity", "similarity"),gap)
}
\arguments{
  \item{x}{an object of class \code{alignment}, as returned by
  \code{read.alignment} for instance}
  \item{matrix}{the matrix distance to be used, partial matching allowed }
  \item{gap}{-optional- logical, with identity matrix, if set to \code{TRUE}, gaps will be counted in the identity measure }
}
\value{
  The distance matrix, object of class \code{dist}, computed by using the
  specified distance measure.
}
\references{
The reference for the similarity matrix is :\cr
Fitch, W.M. (1966) An improved method of testing for evolutionary homology.
\emph{J. Mol. Biol.}, \bold{16}:9-16.\cr

\code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{  \code{\link{read.alignment} } }
\examples{
 myseqs <- read.alignment(file = system.file("sequences/test.mase",
 package = "seqinr"), format = "mase")
 dist.alignment(myseqs, matrix = "identity" )
 as.matrix(dist.alignment(myseqs, matrix = "identity" ))
}
\keyword{ manip }

\name{msf}
     \docType{data}
     \alias{msf}
     \title{Example of results obtained after a call to read.alignment}
     \description{This data set gives an example of a protein alignment obtained after a call to the function read.alignment on an alignment file in "msf" format.}
     \usage{data(msf)}
     \format{A List of class alignment}
     \source{http://www.ebi.ac.uk/2can/tutorials/formats.html#MSF/}
     \keyword{datasets}

\name{clustal}
     \docType{data}
     \alias{clustal}
     \title{Example of results obtained after a call to read.alignment}
     \description{This data set gives an example of a protein alignment obtained after a call to the function read.alignment on an alignment file in "clustal" format.}
     \usage{data(clustal)}
     \format{A List of class alignment}
     \source{http://www.clustal.org/}
     \references{
      Thompson, J.D., Higgins D.G., Gibson T.J. (1994) \emph{CLUSTAL W: improving the sensitivity of progressive multiple sequence alignment through sequence weighting, position specific gap penalties and weight matrix choice}.
      Nucleic Acids Res. 22(22):4673-80.
     }
     \keyword{datasets}

\name{extractseqs}
\alias{extractseqs}
\alias{exseq}
\title{To extract the sequences information of a sequence or a list of sequence in different formats}
\description{
 The function allows to extract large amount of data as whole genome sequences,using different output formats and types of extraction.
 This function is not yet available for windows in zlib mode.
}

\usage{
extractseqs(listname,socket = autosocket(), format="fasta",
operation="simple",feature="xx", bounds="xx", minbounds="xx",
 verbose = FALSE, nzlines=1000, zlib = FALSE)
exseq(listname,socket = autosocket(),
 format="fasta",operation="simple", feature="xx",
 bounds="xx", minbounds="xx", verbose = FALSE,  nzlines=1000, zlib = FALSE)
}

\arguments{
  \item{listname}{the name of list on server (may be a virtual list) }
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{format}{the format of output.Can be \code{acnuc}, \code{fasta},\code{flat} or \code{coordinates} }
  \item{operation}{the type of extraction. Can be  \code{simple}, \code{translate}, \code{fragment}, \code{feature} or \code{region}  }
  \item{feature}{-optional- the feature to be extracted (for operations "feature" or "region"): a feature table item (CDS, mRNA,...)}
  \item{bounds}{-optional- the bounds for extraction (for operations "fragment" or "region") }
  \item{minbounds}{-optional- the minimal bounds for extraction (for operations "fragment" or "region") }
  \item{verbose}{if \code{TRUE}, verbose mode is on}
  \item{nzlines}{number of line in zlib mode}
  \item{zlib}{logical. If TRUE sequences are download in zlib compress mode.}
}

\details{
 To extract a list of sequences (lrank argument) or a single sequence (seqnum argument)
using different output formats and types of extraction.
All formats except "coordinates" extract sequence data.
Format "coordinates" extract coordinate data; start > end indicates the complementary strand.
\describe{
	\item{\strong{listname}}{sequence list name.}
	\item{\strong{socket}}{a socket of class connection and sockconn returned by \code{choosebank}. 
		Default value (auto) means that the socket will be set to to the socket component of the banknameSocket variable. }
	\item{\strong{format}}{\code{acnuc}, \code{fasta}, \code{flat} or \code{coordinates}}
	\item{\strong{operation}}{\code{simple}, \code{translate}, \code{fragment}, \code{feature} or \code{region}}
	\item{\strong{feature}}{(for operations "feature" or "region") a feature table item (CDS, mRNA,...).
		\describe{
			\item{\emph{simple}}{each sequence or subsequence is extracted.}
			\item{\emph{translate}}{meaningful only for protein-coding (sub)sequences that are extracted as protein sequences. Nothing is extracted for non-protein coding sequences.}
			\item{\emph{fragment}}{Allows to extract any part of the sequence(s) in list.
			Such part is specified by the bounds and minbounds arguments according to the syntax suggested by these examples:
			\tabular{lll}{
			  \tab 132,1600  \tab to extract from nucl. 132 to nucl 1600 of the sequence. If applied to a subsequence, coordinates are in the parent seq relatively to the subsequence start point.\cr
			  \tab -10,10    \tab to extract from 10 nucl. BEFORE the 5' end of the sequence to nucl. 10 of it. Useful only for subsequences, and produces a fragment extracted from its parent sequence.\cr
			  \tab e-20,e+10 \tab to extract from 20 nucl. BEFORE the 3' end of the sequence to 10 nucl. AFTER its 3' end. Useful only for subsequences, and  produces a fragment extracted from its parent sequence.\cr
			  \tab -20,e+5   \tab to extract from 20 nucl. BEFORE the 5' end of the sequence to 5 nucl. AFTER its 3' end.
			}
			}
			}}
	\item{\strong{bounds}}{(for operations "fragment" or "region") see syntax above.}
	\item{\strong{minbounds}}{same syntax as bounds. When the sequence data is too short for this quantity
		to be extracted, nothing is extracted. When the sequence data is between minbounds and bounds,
		extracted sequence data is extended by N's to the desired length.}
	
}

}

\value{
  Sequence data.
}
\references{ 
\code{citation("seqinr")}
}
\author{S. Penel}
\seealso{
  \code{\link{choosebank}}, 
  \code{\link{query}}
  \code{\link{getlistrank}}
}
\examples{
 \dontrun{# Need internet connection
 choosebank("emblTP")
 mylist <- query("mylist", "k=globin", virtual = TRUE)
 mylist.fasta <- exseq("mylist", verbose = TRUE)
 # 103 lines of FASTA 
 stopifnot(length(mylist.fasta) == 103)
 closebank()
 }
}
\keyword{utilities}

\name{get.ncbi}
\alias{get.ncbi}
\alias{ncbi.fna.url}
\alias{ncbi.ptt.url}
\alias{ncbi.stats}
\alias{ncbi.gbk.url}
\title{ Bacterial complete genome data from ncbi ftp site }
\description{
Try to connect to ncbi ftp site to get a list of complete bacterial genomes.
}
\usage{
get.ncbi(repository = "ftp://ftp.ncbi.nih.gov/genomes/Bacteria/")
}
\arguments{
  \item{repository}{ Where to look for data. The default value is the location of the complete bacterial genome sequences at ncbi ftp repository. }
}
\value{
Returns a data frame which contains the following columns:
    \item{species}{The species name as given by the corresponding folder
    name in the repository (\emph{e.g.} Yersinia\_pestis\_KIM).}
    \item{accession}{The accession number as given by the common prefix
    of file names in the repository (\emph{e.g.} NC\_004088).}
    \item{size.bp}{The size of the sequence in bp (\emph{e.g.} 4600755).}
    \item{type}{A factor with two levels (plasmid or chromosome) temptatively
    deduced from the description of the sequence.}
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\section{WARNING }{
This function is highly dependant on ncbi ftp site conventions
for which we have no control.
The ftp connection apparently does not work when there is a proxy,
this problem is circumvented here in a rather crude way.
}
\examples{
\dontrun{bacteria <- get.ncbi()}
\dontrun{summary(bacteria)}
}
\keyword{utilities}

\name{getLocation}
\alias{getLocation}
\alias{getLocation.default}
\alias{getLocation.list}
\alias{getLocation.SeqAcnucWeb}
\alias{getLocation.qaw}
\alias{getLocation.logical}

\title{Generic function to get the location of subsequences on the parent sequence}
\description{
This function works only with subsequences from an ACNUC server.
}
\usage{
getLocation(object, ...)
\method{getLocation}{SeqAcnucWeb}(object, ..., socket = autosocket())
}
\arguments{
  \item{object}{ an object of the class \code{\link{SeqAcnucWeb}}, or a list of them,
    or an object created by \code{\link{query}} }
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database by \code{\link{choosebank}}).}
  \item{...}{further arguments passed to or from other methods}
}
\value{
  A list giving the positions of the sequence
  on the parent sequence. If the sequence is a subsequence (\emph{e.g.} coding
  sequence), the function returns the position of each exon on the
  parent sequence. NA is returned for parent sequences and a warning
  is isued.}

\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira} 
\seealso{
  \code{\link{SeqAcnucWeb}}
}
\examples{
#
# List all available methods for getLocation generic function:
#
   methods(getLocation)
#
# Example with a subsequence from an ACNUC server:
#
  \dontrun{
  # Need internet connection
  choosebank("emblTP")
  fc <- query("fc", "sp=felis catus et t=cds et o=mitochondrion")
  getLocation(fc$req[[5]])
  closebank()  
}
}
\keyword{ utilities }

\name{mase}
     \docType{data}
     \alias{mase}
     \title{Example of results obtained after a call to read.alignment}
     \description{This data set gives an example of a protein alignment obtained after a call to the function read.alignment on an alignment file in "mase" format.}
     \usage{data(mase)}
     \format{A List of class alignment}
     \source{http://www.clustal.org/}
     \references{Faullcner.D.V. and Jurka,J. (1988) \emph{Multiple sequences alignment editor(MASE).} Trends Biochem. Sa., 13, 321-322.}
     \keyword{datasets}

\name{countsubseqs}
\alias{countsubseqs}
\alias{css}
\title{Number of subsequences in an ACNUC list}
\description{
Returns the number of subsequences in the ACNUC list of rank \code{lrank}.
}
\usage{
countsubseqs(lrank, socket = autosocket())
css(lrank, socket = autosocket())
}
\arguments{
  \item{lrank}{the rank of the ACNUC list to consider.}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}

\value{
Numeric.
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}}, \code{\link{glr}} to
get a list rank from its name.}
\examples{
\dontrun{ # Need internet connection
  choosebank("emblTP")
  mylist<-query("mylist", "N=@", virtual = TRUE) # select all (seqs + subseqs)
  mylist$nelem   # 14138094 seqs + subseqs
  stopifnot(mylist$nelem == 14138094)
  css(glr("mylist")) # 1604500 subsequences only
  stopifnot(css(glr("mylist")) == 1604500)
  closebank()
  }
}
\keyword{ utilities }

\name{col2alpha}
\Rdversion{1.1}
\alias{col2alpha}
\title{To use a standard color with an alpha transparency chanel}
\description{
Takes as input a standard R color and an alpha value to return
its rgb coding.
}
\usage{
col2alpha(color, alpha = 0.5)
}
\arguments{
  \item{color}{A standard R color as in \code{\link{colors}}.}
  \item{alpha}{An alpha transparency value in the interval [0,1].}
}
\value{same as in \code{\link{rgb}}.}
\author{J.R. Lobry}
\seealso{\code{\link{colors}}, \code{\link{col2rgb}}, \code{\link{rgb}}.}
\examples{
#
# Need alpha transparency channel 
#
par(mar = c(0, 0, 2, 2)+0.1, oma = c(0, 0, 2, 0), mfrow = c(3,2))
for(testcol in c("blue", "red", "green", "yellow", "purple", "darkgreen")){
  plot(0,0, type="n", xlim=0:1, ylim = 0:1, axes = FALSE, xlab = "", ylab = "", main = testcol)
  n <- 11
  for(i in seq(0, 1, length = n)){
    col <- col2alpha(testcol, i)
    rect(i, 0, i + 1/n, 1, col = col, border = "black", xpd = NA)
    text(i+0.5/n, 0.5, round(i,2), xpd = NA)
  }
}
mtext("Effect of alpha on some colors\nNote: need alpha transparency channel",
 side = 3, outer = TRUE)
#
# The substractive color scheme:
#
par(mar = c(0,0,3,0))
plot.new()
plot.window(xlim = c(-1.5, 1.5), ylim = c(-1,1.75), asp = 1)
n <- 10
alpha <- 1/n
for(i in 1:(2*n)){
  circle(x = -0.5, y = 0, col = col2alpha("yellow", alpha))
  circle(x = 0.5, y = 0, col = col2alpha("cyan", alpha))
  circle(x = 0, y = 3/4, col = col2alpha("magenta", alpha))
}
title("Substractive color scheme\nNote: need alpha transparency channel")
}

\name{waterabs}
\alias{waterabs}
\docType{data}
\title{Light absorption by the water column}
\description{
The absorption of light by water is highly dependent on the wavelength, this
dataset gives the absorption coefficients from 200 to 700 nm.
}
\usage{data(waterabs)}
\format{
  A data.frame with 2 columns:
  \describe{
    \item{lambda}{wavelength in nm}
    \item{abs}{absorption coefficient in 1/cm}
  }
}

\source{
Data were compiled by Palmeira (2007) from the cited references.

The example section allows to reproduce the left part of figure
2.7 from Palmeira (2007):

\if{html}{\figure{waterabs.jpg}{options: width=400}}
\if{latex}{\figure{waterabs.jpg}{options: width=12cm}}

}
\references{
Palmeira, L. (2007) \emph{Analyse et modélisation des dépendances entre
 sites voisins dans l'évolution des séquences d'ADN}, PhD thesis,
Université Claude Bernard - Lyon I.\cr

Litjens R. A., Quickenden T. I. and Freeman C. G. (1999). Visible and
near-ultraviolet absorption spectrum of liquid water. \emph{Applied Optics}, 
\bold{38}:1216-1223.\cr

Quickenden T. I. & Irvin J. A. (1980). The ultraviolet absorption spectrum
of liquid water. \emph{The Journal of Chemical Physics}, \bold{72}:4416-4428.\cr

\code{citation("seqinr")}
}
\examples{
data(waterabs)

d <- 100*seq(from = 0, to = 150, by = 1) # depth in cm
lambda <- waterabs$lambda                # wavelength in nm
abs <- waterabs$absorption               # absorption coefficient cm-1
#
# Smooth signal with cubic splines
#
  tmp <- spline(lambda, abs, n = 255)
  lambda <- tmp$x
  abs <- tmp$y

  zun <- sapply(abs,function(x) 10^(-x*d))
  z <- sapply(nrow(zun):1, function(x) zun[x,])
#
# Set up world coordinates:
#
  plot.new()
  plot.window(xlim = range(lambda), ylim = range(d), xaxs = "i",  yaxs = "i")
#
# Annotate:
#
  title(ylab = 'Depth under water surface (m)', xlab = "Wavelength (nm)",
  main = "Light absorption by the water column")
  axis(2 , at = seq(0, 15000, l = 7),
      labels = rev(c("0","25","50","75","100","125","150")), las = 1)
  axis(1,at=(3:6)*100,labels= TRUE)
#
# Show me rainbow colors:
#
  alpha <- 1
  coul=c(rep(rgb(1,1,1, alpha = alpha), 181),
    rev(hsv(h=seq(0,5/6,l=320),alpha = alpha)))
  rect(seq(200,699), 0, seq(201,700), 15000 , col = coul, border = coul)
#
# Grey scale:
#
  ngris <- 5
  image(x = lambda, y = d, z = z, col = rgb(1:ngris, 1:ngris, 1:ngris, alpha = 0.7*(ngris:1),
  max = ngris),
  axes = F, add = TRUE,
  breaks = seq(from = min(z), to = max(z), length = ngris + 1))

#
# Contour lines:
#
  contour(x = lambda, y = d, z = z, add = TRUE, drawlabels = TRUE,labcex= 0.75,
  col='black',
  levels = seq(from = min(z), to = max(z), length = ngris + 1))
  box()

}
\keyword{datasets}

\name{knowndbs}
\alias{knowndbs}
\alias{kdb}
\title{Description of databases known by an ACNUC server}
\description{
Returns, for each database known by the server, its name (a valid value for the \code{bank}
argument of \code{\link{choosebank}}), availability (off means temporarily unavailable),
and description.
}
\usage{
knowndbs(tag = c(NA, "TP", "TEST", "DEV"), socket = autosocket())
kdb(tag = c(NA, "TP", "TEST", "DEV"), socket = autosocket())
}
\arguments{
  \item{tag}{default to NA, see details}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}

\details{
When the optional \code{tag}  argument is used, only databases tagged with the given
string are listed;
when this argument is NA (by default), only untagged databases are listed.
The \code{tag} argument thus allows to identify series of special purpose (tagged) databases,
in addition to default (untagged) ones.
}

\value{
A dataframe with 3 columns:
\item{bank}{string. Valid bank values known by the ACNUC server}
\item{status}{string. "on" means available, "off" means temporarily unavailable}
\item{info}{string. short description of the database}
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}

The full list of untagged and tagged databases is here :
\url{https://doua.prabi.fr/databases/acnuc/banques_raa.php}.

}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}} when called without arguments. }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  kdb()
  closebank()
  }
}
\keyword{ utilities }

\name{SeqFastadna}
\alias{SeqFastadna}
\alias{is.SeqFastadna}
\alias{as.SeqFastadna}
\alias{summary.SeqFastadna}
\title{ Class for DNA sequence in Fasta Format}
\description{
  \code{as.SeqFastadna} is called by many functions as \code{read.fasta}. It creates an object of class \code{SeqFastadna}. 
  \code{is.SeqFastadna} returns TRUE if the object is of class \code{SeqFastadna}. 
  \code{summary.SeqFastadna} gives the base composition of an object of class \code{SeqFastadna}.
}
\usage{
as.SeqFastadna(object, name = NULL, Annot = NULL)
is.SeqFastadna(object)
\method{summary}{SeqFastadna}(object, alphabet = s2c("acgt"), ...)
}
\arguments{
  \item{object}{a vector of chars representing a biological sequence} 
  \item{name}{ \code{NULL} a character string specifying a name for the sequence } 
  \item{Annot}{ \code{NULL} a character string specifying some annotations for the sequence }
  \item{...}{additional arguments affecting the summary produced}
    \item{alphabet}{a vector of single characters}
}
\value{
  \code{as.SeqFastadna} returns an object sequence of class \code{SeqFastadna}.
  \code{summary.SeqFastadna} returns a list which the following components:
	\item{length}{ the legth of the sequence}
	\item{compo}{the base counting of the sequence} 
	\item{GC}{the percentage of G+C in the sequence}
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif}
\examples{
 s <- read.fasta(system.file("sequences/malM.fasta",package="seqinr"))
 is.SeqFastadna(s[[1]])
 summary(s[[1]])
 myseq <- s2c("acgttgatgctagctagcatcgat")
 as.SeqFastadna(myseq, name = "myseq", Annot = "blablabla")
 myseq
}
\keyword{utilities}

\name{SeqAcnucWeb}
\alias{SeqAcnucWeb}
\alias{as.SeqAcnucWeb}
\alias{is.SeqAcnucWeb}

\title{Sequence coming from a remote ACNUC data base}
\description{
    \code{as.SeqAcnucWeb} is called by many functions, for instance by \code{query}, 
  and should not be directly called by the user. It creates an object of class \code{SeqAcnucWeb}. 
  \code{is.SeqAcnucWeb} returns TRUE if the object is of class \code{SeqAcnucWeb}. 
}
\usage{
as.SeqAcnucWeb(object, length, frame, ncbigc)
is.SeqAcnucWeb(object)
}
\arguments{
  \item{object}{ a string giving the name of a sequence present in the data base}
  \item{length}{ a string giving the length of the sequence present in the data base}
  \item{frame}{ a string giving the frame of the sequence present in the data base}
  \item{ncbigc}{ a string giving the ncbi genetic code of the sequence present in the data base}
}
\value{
  \code{as.SeqAcnucWeb} returns an object sequence of class \code{SeqAcnucWeb}. Note
  that as from seqinR 1.1-3 the slot socket has been deleted to save space for long lists.
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\examples{
  \dontrun{# Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "sp=felis catus et t=cds et o=mitochondrion")
  stopifnot(is.SeqAcnucWeb(mylist$req[[1]]))
  closebank()
}
}
\keyword{utilities}

\name{dinucl}
\alias{dinucl}
\docType{data}
\title{ Mean zscore on 242 complete bacterial chromosomes }
\encoding{latin1}
\description{
This dataset contains the mean zscores as computed on all intergenic
sequences (intergenic) and on all CDS (coding) from 242
complete bacterial chromosomes (as retrieved from Genome Reviews database on
June 16, 2005).
}
\usage{
data(dinucl)
}
\format{
  List of two dataframes of 242 chromosomes and 16 dinucleotides: one
  for intergenic, one for coding sequences.
\describe{
  \item{intergenic}{the mean of \code{zscore} computed with the \code{base}
   model on each intergenic sequence}
   \item{coding}{the mean of \code{zscore} computed with the \code{codon}
  model on each coding sequence}
}
}
\references{
  Palmeira, L., Guéguen, L. and Lobry JR. (2006) UV-targeted dinucleotides
  are not depleted in light-exposed Prokaryotic genomes.
  \emph{Molecular Biology and Evolution},
  \bold{23}:2214-2219.\cr
  \url{https://academic.oup.com/mbe/article/23/11/2214/1335460}\cr\cr

  \code{citation("seqinr")}
}
\seealso{ \code{\link{zscore}} }
\examples{
data(dinucl)
par(mfrow = c(2, 2), mar = c(4,4,0.5,0.5)+0.1)
myplot <- function(x){
  plot(dinucl$intergenic[, x], dinucl$coding[, x],
  xlab = "intergenic", ylab = "coding", 
  las = 1, ylim = c(-6, 4), 
  xlim = c(-3, 3), cex = 0)
  rect(-10,-10,-1.96,10,col="yellow", border = "yellow")
  rect(1.96,-10,10,10,col="yellow", border = "yellow")
  rect(-10,-10,10,-1.96,col="yellow", border = "yellow")
  rect(-10,1.96,10,10,col="yellow", border = "yellow")
  abline(v=0,lty=3)
  abline(h=0,lty=3)
  abline(h=-1.96,lty=2)
  abline(h=+1.96,lty=2)
  abline(v=-1.96,lty=2)
  abline(v=+1.96,lty=2)
  points(dinucl$intergenic[, x], dinucl$coding[, x], pch = 21,
  col = rgb(.1,.1,.1,.5), bg = rgb(.5,.5,.5,.5))
  legend("bottomright", inset = 0.02,
   legend = paste(substr(x,1,1), "p",
    substr(x,2,2), " bias", sep = ""), cex = 1.25, bg = "white")
  box()
}
myplot("CT")
myplot("TC")
myplot("CC")
myplot("TT")
}
\keyword{ datasets }

\name{savelist}
\alias{savelist}
\title{Save sequence names or accession numbers into a file}
\description{
This function retrieves all sequence names or all accession number from
an ACNUC list and saves them into a file.
}
\usage{
savelist(lrank, type = c("N", "A"),
                     filename = paste(gln(lrank), ifelse(type == "N", "mne", "acc"),
		     sep = "."),socket = autosocket(), warnme = TRUE)
}
\arguments{
  \item{lrank}{the rank of the ACNUC list to consider.}
  \item{type}{use "N" for sequence names (mnemonics) and "A" for accession numbers.
     Default is "N".}
  \item{filename}{a string of character giving the name of the file to save results.}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{warnme}{if TRUE a message is issued on the console when complete.}
}

\value{
none.
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}}, \code{\link{glr}} to
get a list rank from its name, \code{\link{clfcd}} for the inverse operation
of \code{savelist}}
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "sp=felis catus et t=cds", virtual=TRUE)
  savelist(glr("mylist"))
  # 603 sequence mnemonics written into file: MYLIST.mne
  savelist(glr("mylist"), type = "A")
  # 603 sequence accession numbers written into file: MYLIST.acc
  }
}
\keyword{ utilities }

\name{fastacc}
\alias{fastacc}
\title{Fast Allele in Common Count}
\description{
The purpose of this function is to compute as fast as possible the number
of allele in common between a target (typically the genetic profile observed at a
crime scene, possibly a mixture with dropouts) and a database reference (typically
genetic profile of individuals). Both are assumed to be pre-encoded at the bit
level in a consistent way.
}
\usage{
fastacc(target, database)
}
\arguments{
  \item{target}{the \code{\link{raw}} encoding of the target, typically 40 octets for a core-CODIS profile in 2009}
  \item{database}{the \code{\link{raw}} encoding of the database. If there are n entries
in the database, then the database must n times longer than the target.}
}
\details{
This function is an RFC state. Comments are welcome.

Genetic profiles are encoded at the bit level. One bit represents one allele.
Count is based on a logical AND at bit level. Bit count is encoded at C level
using the precomputed approach: one indirection with an auxiliary table
of size 256 called \code{bits_in_char} which is pre-computed at R level and
passed at C level.
}
\value{
A vector of \code{\link{integer}} giving for each entry in the database how many
alleles are in common between the entry and the target.
}
\references{
\code{citation("seqinr")}
}
\author{J.R. Lobry}

\section{Warning }{Experimental, first release schedulded for seqinr  2.0-6 by the end of 2009}

\seealso{
FIXME
}
\examples{
#
# NOTE:
#
# This example section is a proof-of-concept stuff. Most code should be
# enbeded in documented functions to avoid verbosity. But at the RFC stage
# this is perhaps not a too bad idea to show how powerfull R is.
#

#
# Let's start from the 16 loci available in the AmpFLSTR kit:
#

path <- system.file("abif/AmpFLSTR_Bins_v1.txt", package = "seqinr")
resbin <- readBins(path)
codis <- resbin[["Identifiler_CODIS_v1"]]
names(codis)

#
# We count how many different alleles are present per locus:
#

na <- unlist(lapply(codis, function(x) length(x[[1]])))
na

#
# The number of octets required to encode a genetic for each locus is then:
#

ceiling(na/8)

#
# We need then a total of 40 octets to code these profiles:
#

sum(ceiling(na/8))

#
# Let's definene a function to encode a profile at a given locus, and vice versa :
#

prof2raw <- function(profile, alleles) {
  if (!is.ordered(alleles)) stop("ordered factor expected for alleles")
  if (!is.character(profile)) stop("vector of character expected for profile")
  noctets <- ceiling(length(alleles)/8)
  res.b <- rawToBits(raw(noctets))
  for (i in 1:length(profile)) {
    res.b[which(profile[i] == alleles)] <- as.raw(1)
  }
  return(packBits(res.b, type = "raw"))
}

raw2prof <- function(rawdata, alleles) {
  if (!is.ordered(alleles)) stop("ordered factor expected for alleles")
  if (!is.raw(rawdata)) stop("vector of raw expected for rawdata")
  res <- as.character(alleles)[as.logical(rawToBits(rawdata))]
  return(paste(res, collapse = ", "))
}

#
# Let now code all alleles present in codis as ordered factors:
#

allalleles <- lapply(codis, function(x) factor(x[, 1], levels = x[, 1], ordered = TRUE))

#
# Let's play with our encoding/decoding utilities with first locus:
#

allalleles[[1]] #  <8 8 9 10 11 12 13 14 15 16 17 18 19 >19
res <- prof2raw(c("8", "9", "13", "14", ">19"), allalleles[[1]])
res # c6 20
rawToBits(res) # 00 01 01 00 00 00 01 01 00 00 00 00 00 01 00 00
raw2prof(res, allalleles[[1]]) #  "8, 9, 13, 14, >19"

#
# Let define a profile with all possible alleles:
#

ladder <- unlist(lapply(allalleles, function(x) prof2raw(as.character(x),x)))
names(ladder) <- NULL
stopifnot(identical(as.integer(ladder), 
 c(255L, 63L, 255L, 255L, 255L, 63L, 255L, 63L, 255L, 31L, 255L, 
 63L, 255L, 255L, 7L, 255L, 3L, 255L, 63L, 255L, 255L, 255L, 255L, 
 15L, 255L, 127L, 255L, 3L, 255L, 255L, 255L, 255L, 3L, 3L, 255L, 
 15L, 255L, 255L, 255L, 7L))) # simple sanity check

#
# Let's make a simulated database. Here we use a random sampling
# with a uniform distribution between all possible profile possible
# at a given locus. A more realist sampling for an individual database
# would be to sample only two alleles at each locus according to
# observed frequencies in populations. 
#

n <- 10^5 # the number of records in the database
DB <- sapply(ladder, function(x) as.raw(sample(0:as.integer(x), size = n, replace = TRUE)))

#
# Now we make sure that the target is in the database:
#

target <- DB[666, ]
DB <- as.vector(t(DB)) # put DB as a flat database (is it usefull?) 

#
# Now we compute the number of alleles in common between the
# target and all the entries in the DB:
#

system.time(res <- fastacc(target,DB)) # Fast, isn't it ?
stopifnot(which.max(res) == 666) # sanity check

#
# Don't run : too tedious for routine check. We check here that complexity is
# linear in time up to a 10 10^6 database size (roughly the size of individual
# profiles at the EU level)
#

\dontrun{
maxn <- 10^7
DB <- sapply(ladder, function(x) as.raw(sample(0:as.integer(x),
  size = maxn, replace = T)))
target <- DB[666, ]
DB <- as.vector(t(DB))

np <- 10
nseq <- seq(from = 10^5, to = maxn, length = np)
res <- numeric(np)
i <- 1
for (n in nseq) {
  print(i)
  res[i] <- system.time(tmp <- fastacc(target, DB[1:n]))[1]
  stopifnot(which.max(tmp) == 666)
  i <- i + 1
}
dbse <- data.frame(list(nseq = nseq, res = res))

x <- dbse$nseq
y <- dbse$res
plot(x, y, type = "b", xlab = "Number of entries in DB", ylab = "One query time [s]",
las = 1, xlim = c(0, maxn), ylim = c(0, max(y)), main = "Data base size effect on query time")
lm1 <- lm(y ~ x - 1)
abline(lm1, col = "red")
legend("topleft", inset = 0.01, legend = paste("y =", formatC(lm1$coef[1],
digits = 3), "x"), col = "red", lty = 1)

#
# On my laptop the slope is 2.51e-08, that is a 1/4 of second to scan a database
# with 10 10^6 entries.
#
}

## end
}

\name{synsequence}
\alias{synsequence}
\title{Random synonymous coding sequence generation}
\description{
  Generates a random synonymous coding sequence, according to a certain
  codon usage bias
}
\usage{synsequence(sequence, numcode = 1, ucoweight = NULL)}
\arguments{
  \item{sequence}{ A nucleic acids sequence }
  \item{numcode}{ The genetic code number as in \code{translate} }
  \item{ucoweight}{ A list of weights containing the desired codon usage
    bias as generated by \code{ucoweight} }
}
\value{
  a sequence translating to the same protein sequence as the original
  one (cf. \code{translate}), but containing synonymous codons  
}
\references{
  \code{citation("seqinr")}
}
\author{L. Palmeira}
\seealso{ \code{\link{ucoweight}} }
\examples{
  data(ec999)
  sequence=ec999[1][[1]]
  synsequence(sequence,1,ucoweight(sequence))
}
\keyword{ utilities }

\name{plotladder}
\alias{plotladder}
\title{Simple plot of an allelic ladder from ABIF data}
\description{
  Simple representation of an observed allelic ladder.
}
\usage{
plotladder(abifdata, chanel, calibr, allele.names = "identifiler", npeak = NULL, ...)
}
\arguments{
  \item{abifdata}{the result returned by \code{\link{read.abif}}}
  \item{chanel}{the dye number}
  \item{calibr}{a mandatory calibration function to convert time into bp}
  \item{allele.names}{name of the dataset which contains allele names as in \code{link{identifiler}}}
  \item{npeak}{expected number of peaks, deduced from \code{allele.names} by default}
  \item{...}{arguments forwarded to \code{\link{peakabif}}}
}
\value{
  Returns invisibly the location of peaks in bp.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  function \code{\link{read.abif}} to import files in ABIF format, 
  \code{\link{plotabif}} to plot them,
  data \code{\link{gs500liz}} for internal size standards,
  data \code{\link{identifiler}} for allele names in the allelic ladder,
  data \code{\link{JLO}} for an example of an individual sample file,
  data \code{\link{ECH}} for an example of an allelic lader.
}
\examples{
  #
  # load an example of allelic ladder results from an ABIF (*.fsa) file:
  #
data(ECH)
  #
  # Extract from internal size standard chanel number 5 the location 
  # of 14 peaks:
  #
ECH.maxis <- peakabif(ECH, 5, npeak = 14, tmin = 2.7, thres = 0.1, fig = FALSE)$maxis
  #
  # Load data about the expected size of peaks in bp for calibration:
  #
data(gs500liz)
lizbp <- gs500liz$liz # All peaks size in bp
lizbp[!gs500liz$mask1 | !gs500liz$mask2] <- NA # Mark useless peaks
lizbp <- lizbp[-c(1,2)] # The first two peaks are not extracted from ECH
ECH.calibr <- splinefun(ECH.maxis[!is.na(lizbp)], lizbp[!is.na(lizbp)])
  #
  # Show the allelic ladder for the 4 dyes:
  #
plotladder(ECH, 1, ECH.calibr, tmin = 3.1, thres = 0.3, fig = FALSE)
plotladder(ECH, 2, ECH.calibr, tmin = 3.1, thres = 0.35, fig = FALSE)
plotladder(ECH, 3, ECH.calibr, tmin = 3.1, thres = 0.2, fig = FALSE)
plotladder(ECH, 4, ECH.calibr, tmin = 3.1, thres = 0.2, fig = FALSE)
}

\name{JLO}
\alias{JLO}
\docType{data}
\title{Forensic Genetic Profile Raw Data}
\description{
  This is an example of raw data for a human STR genetic profile at 16 loci
  (\emph{viz.} D8S1179, D21S11, D7S820, CSF1PO, D3S1358, TH01, D13S317, D16S539,
  D2S1338, D19S433, vWA, TPOX, D18S51, Amelogenin, D5S818, FGA) which
  are commonly used in forensic sciences for individual identifications.
}
\usage{data(JLO)}
\format{
  A list with 3 components.
  \describe{
    \item{Header}{a list corresponding to the header in the ABIF file}
    \item{Directory}{a data.frame corresponding to the Directory in the ABIF file}
    \item{Data}{a list with all raw data in the ABIF file.}
  }
}
\details{
  This dataset is the expected result when reading the file
  \code{2_FAC321_0000205983_B02_004.fsa} with the
  function \code{\link{read.abif}}. This dataset is used for
  the quality check of this function.
}
\source{
  The DNA source is from the author so that there are no privacy concern.
  Data were kindly provided by the INPS (Institut National de Police Scientifique)
  which is the national forensic sciences institute in France. Experiments
  were done at the LPS (Laboratoire de Police Scientifique de Lyon) in 2008.
}
\references{
  \code{citation("seqinr")}

  Anonymous (2006) Applied Biosystem Genetic Analysis Data File Format.
  Available at \url{https://www.thermofisher.com/de/de/home/brands/applied-biosystems.html}.
  Last visited on 03-NOV-2008.
}
\author{J.R. Lobry}
\seealso{
  function \code{\link{read.abif}} to import files in ABIF format,
  data \code{\link{gs500liz}} for internal size standards,
  data \code{\link{ECH}} for the corresponding allelic ladder,
  data \code{\link{identifiler}} for allele names in the allelic ladder.
}
\examples{
data(JLO)
}

\name{tablecode}
\alias{tablecode}
\title{ to plot genetic code as in textbooks }
\description{
This function plots a genetic code table as in textbooks, that is
following the order \code{T > C > A > G} so that synonymous codons
are almost always in the same boxes.
}
\usage{
tablecode(numcode = 1, urn.rna = s2c("TCAG"), dia = FALSE, latexfile = NULL,
label = latexfile, size = "normalsize", caption = NULL,
preaa = rep("", 64), postaa = rep("", 64), 
precodon = preaa, postcodon = postaa)
}
\arguments{
  \item{numcode}{The genetic code number as in \code{translate} }
  \item{urn.rna}{The letters to display codons, use s2c("UCAG")
  if you want the code in terms of RNA sequence}
  \item{latexfile}{The name of a LaTex file if you want to redirect the output}
  \item{label}{The label for the LaTeX table}
  \item{size}{The LaTex size of characters for the LaTeX table}
  \item{preaa}{A string to insert before the amino-acid in the LaTeX table}
  \item{postaa}{A string to insert after the amino-acid in the LaTeX table}
  \item{precodon}{A string to insert before the codon in the LaTeX table}
  \item{postcodon}{A string to insert after the codon in the LaTeX table}
  \item{caption}{The caption of the LaTeX table}
  \item{dia}{to produce a yellow/blue plot for slides}
}
\details{
The codon order for \code{preaa}, \code{postaa}, \code{precodon}, and
\code{postcodon} should be the same as in
\code{paste(paste(rep(s2c("tcag"), each =16), s2c("tcag"), sep = ""), rep(s2c("tcag"), each = 4), sep = "")}
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{translate}}, \code{\link{syncodons}} }
\examples{
#
# Show me the standard genetic code:
#

 tablecode()
}
\keyword{ utilities }

\name{plot.SeqAcnucWeb}
\alias{plot.SeqAcnucWeb}
\title{To Plot Subsequences on the Parent Sequence}
\description{
  This function plots all the type of subsequences on a parent sequence. Subsequences are represented by colored rectangle on the parent sequence.  For example, types could be CDS, TRNA, RRNA .... In order to get all the types that are available for the selected database, use \code{getType}.
}
\usage{
\method{plot}{SeqAcnucWeb}(x, types = getType()$sname, socket = autosocket(), ...)
}
\arguments{
  \item{x}{A sequence of class \code{SeqAcnucWeb}}
  \item{types}{ The type of subsequences to plot. Default value is to consider
    all possible subsequence types.}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{\dots}{not currently used}
}
\value{
 An invisible list giving, for each subsequence, its position on the parent sequence.
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{\code{\link{getType}}, \code{\link{query}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "AC=AB078009")
  plot(mylist$req[[1]])
  }
}
\keyword{ hplot }

\name{syncodons}
\alias{syncodons}
\title{Synonymous codons}
\description{
  Returns all synonymous codons for each codon given
}
\usage{syncodons(codons, numcode = 1)}
\arguments{
  \item{codons}{ A sequence of codons as generated by \code{splitseq} }
  \item{numcode}{ The genetic code number as in \code{translate} }
}
\value{
  a list containing, for each codon given (list tags), all synonymous
  codons (including the original one)
}
\references{
  \code{citation("seqinr")}
}
\author{L. Palmeira, J.R. Lobry}
\seealso{ \code{\link{synsequence}} }
\examples{
#
# The four synonymous codons for Alanine in the standard genetic code:
#
syncodons("ggg")
#
# With a sequence:
#
toycds <- s2c("tctgagcaaataaatcgg")
syncodons(splitseq(toycds))
#
# Sanity check with the standard genetic code:
#
stdgencode <- structure(list(
  ttt = c("ttc", "ttt"), 
  ttc = c("ttc", "ttt"), 
  tta = c("cta", "ctc", "ctg", "ctt", "tta", "ttg"),
  ttg = c("cta", "ctc", "ctg", "ctt", "tta", "ttg"), 
  tct = c("agc", "agt", "tca", "tcc", "tcg", "tct"), 
  tcc = c("agc", "agt", "tca", "tcc", "tcg", "tct"), 
  tca = c("agc", "agt", "tca", "tcc", "tcg", "tct"), 
  tcg = c("agc", "agt", "tca", "tcc", "tcg", "tct"),
  tat = c("tac", "tat"), 
  tac = c("tac", "tat"), 
  taa = c("taa", "tag", "tga"),
  tag = c("taa", "tag", "tga"),
  tgt = c("tgc", "tgt"),
  tgc = c("tgc", "tgt"),
  tga = c("taa", "tag", "tga"), 
  tgg = "tgg", 
  ctt = c("cta", "ctc", "ctg", "ctt", "tta", "ttg"), 
  ctc = c("cta", "ctc", "ctg", "ctt", "tta", "ttg"), 
  cta = c("cta", "ctc", "ctg", "ctt", "tta", "ttg"),
  ctg = c("cta", "ctc", "ctg", "ctt", "tta", "ttg"), 
  cct = c("cca", "ccc", "ccg", "cct"), 
  ccc = c("cca", "ccc", "ccg", "cct"), 
  cca = c("cca", "ccc", "ccg", "cct"), 
  ccg = c("cca", "ccc", "ccg", "cct"), 
  cat = c("cac", "cat"), 
  cac = c("cac", "cat"), 
  caa = c("caa", "cag"),
  cag = c("caa", "cag"),
  cgt = c("aga", "agg", "cga", "cgc", "cgg", "cgt"),
  cgc = c("aga", "agg", "cga", "cgc", "cgg", "cgt"),
  cga = c("aga", "agg", "cga", "cgc", "cgg", "cgt"),
  cgg = c("aga", "agg", "cga", "cgc", "cgg", "cgt"), 
  att = c("ata", "atc", "att"),
  atc = c("ata", "atc", "att"),
  ata = c("ata", "atc", "att"),
  atg = "atg",
  act = c("aca", "acc", "acg", "act"), 
  acc = c("aca", "acc", "acg", "act"),
  aca = c("aca", "acc", "acg", "act"),
  acg = c("aca", "acc",  "acg", "act"), 
  aat = c("aac", "aat"), 
  aac = c("aac", "aat"), 
  aaa = c("aaa", "aag"),
  aag = c("aaa", "aag"),
  agt = c("agc", "agt", "tca", "tcc", "tcg", "tct"),
  agc = c("agc", "agt", "tca", "tcc", "tcg", "tct"),
  aga = c("aga", "agg", "cga", "cgc", "cgg", "cgt"),
  agg = c("aga", "agg", "cga", "cgc", "cgg", "cgt"),
  gtt = c("gta", "gtc", "gtg", "gtt"),
  gtc = c("gta", "gtc", "gtg", "gtt"),
  gta = c("gta", "gtc", "gtg", "gtt"), 
  gtg = c("gta", "gtc", "gtg", "gtt"),
  gct = c("gca", "gcc", "gcg", "gct"),
  gcc = c("gca", "gcc", "gcg", "gct"),
  gca = c("gca", "gcc", "gcg", "gct"),
  gcg = c("gca", "gcc", "gcg", "gct"), 
  gat = c("gac", "gat"),
  gac = c("gac", "gat"),
  gaa = c("gaa", "gag"),
  gag = c("gaa", "gag"),
  ggt = c("gga", "ggc", "ggg", "ggt"),
  ggc = c("gga", "ggc", "ggg", "ggt"),
  gga = c("gga", "ggc", "ggg", "ggt"),
  ggg = c("gga", "ggc", "ggg", "ggt")),

.Names = c("ttt", "ttc", "tta", "ttg", "tct", "tcc", "tca", "tcg", "tat", "tac", 
"taa", "tag", "tgt", "tgc", "tga", "tgg", "ctt", "ctc", "cta", 
"ctg", "cct", "ccc", "cca", "ccg", "cat", "cac", "caa", "cag", 
"cgt", "cgc", "cga", "cgg", "att", "atc", "ata", "atg", "act", 
"acc", "aca", "acg", "aat", "aac", "aaa", "aag", "agt", "agc", 
"aga", "agg", "gtt", "gtc", "gta", "gtg", "gct", "gcc", "gca", 
"gcg", "gat", "gac", "gaa", "gag", "ggt", "ggc", "gga", "ggg"))
#
# Now the check:
#
currentresult <- syncodons(words(alphabet = s2c("tcag")))
stopifnot(identical(stdgencode, currentresult))
}
\keyword{ utilities }

\name{aaindex}
\alias{aaindex}
\docType{data}
\title{List of 544 physicochemical and biological properties for the 20 amino-acids}
\description{Data were imported from release 9.1 (AUG 2006) of the aaindex1
database. See the reference section to cite this database in a publication.
}
\usage{data(aaindex)}
\format{
  A named list with 544 elements having each the following components:
  \describe{
    \item{H}{String: Accession number in the aaindex database.}
    \item{D}{String: Data description.}
    \item{R}{String: LITDB entry number.}
    \item{A}{String: Author(s).}
    \item{T}{String: Title of the article.}
    \item{J}{String: Journal reference and comments.}
    \item{C}{String: Accession numbers of similar entries with the correlation 
    coefficients of 0.8 (-0.8) or more (less). Notice: The correlation 
    coefficient is calculated with zeros filled for missing values.}
    \item{I}{Numeric named vector: amino acid index data.}
  }
}
\details{
A short description of each entry is available under the D component:\cr

alpha-CH chemical shifts (Andersen et al., 1992)\cr
Hydrophobicity index (Argos et al., 1982)\cr
Signal sequence helical potential (Argos et al., 1982)\cr
Membrane-buried preference parameters (Argos et al., 1982)\cr
Conformational parameter of inner helix (Beghin-Dirkx, 1975)\cr
Conformational parameter of beta-structure (Beghin-Dirkx, 1975)\cr
Conformational parameter of beta-turn (Beghin-Dirkx, 1975)\cr
Average flexibility indices (Bhaskaran-Ponnuswamy, 1988)\cr
Residue volume (Bigelow, 1967)\cr
Information value for accessibility; average fraction 35% (Biou et al., 1988)\cr
Information value for accessibility; average fraction 23% (Biou et al., 1988)\cr
Retention coefficient in TFA (Browne et al., 1982)\cr
Retention coefficient in HFBA (Browne et al., 1982)\cr
Transfer free energy to surface (Bull-Breese, 1974)\cr
Apparent partial specific volume (Bull-Breese, 1974)\cr
alpha-NH chemical shifts (Bundi-Wuthrich, 1979)\cr
alpha-CH chemical shifts (Bundi-Wuthrich, 1979)\cr
Spin-spin coupling constants 3JHalpha-NH (Bundi-Wuthrich, 1979)\cr
Normalized frequency of alpha-helix (Burgess et al., 1974)\cr
Normalized frequency of extended structure (Burgess et al., 1974)\cr
Steric parameter (Charton, 1981)\cr
Polarizability parameter (Charton-Charton, 1982)\cr
Free energy of solution in water, kcal/mole (Charton-Charton, 1982)\cr
The Chou-Fasman parameter of the coil conformation (Charton-Charton, 1983)\cr
A parameter defined from the residuals obtained from the best correlation of the Chou-Fasman parameter of beta-sheet (Charton-Charton, 1983)\cr
The number of atoms in the side chain labelled 1+1 (Charton-Charton, 1983)\cr
The number of atoms in the side chain labelled 2+1 (Charton-Charton, 1983)\cr
The number of atoms in the side chain labelled 3+1 (Charton-Charton, 1983)\cr
The number of bonds in the longest chain (Charton-Charton, 1983)\cr
A parameter of charge transfer capability (Charton-Charton, 1983)\cr
A parameter of charge transfer donor capability (Charton-Charton, 1983)\cr
Average volume of buried residue (Chothia, 1975)\cr
Residue accessible surface area in tripeptide (Chothia, 1976)\cr
Residue accessible surface area in folded protein (Chothia, 1976)\cr
Proportion of residues 95% buried (Chothia, 1976)\cr
Proportion of residues 100% buried (Chothia, 1976)\cr
Normalized frequency of beta-turn (Chou-Fasman, 1978a)\cr
Normalized frequency of alpha-helix (Chou-Fasman, 1978b)\cr
Normalized frequency of beta-sheet (Chou-Fasman, 1978b)\cr
Normalized frequency of beta-turn (Chou-Fasman, 1978b)\cr
Normalized frequency of N-terminal helix (Chou-Fasman, 1978b)\cr
Normalized frequency of C-terminal helix (Chou-Fasman, 1978b)\cr
Normalized frequency of N-terminal non helical region (Chou-Fasman, 1978b)\cr
Normalized frequency of C-terminal non helical region (Chou-Fasman, 1978b)\cr
Normalized frequency of N-terminal beta-sheet (Chou-Fasman, 1978b)\cr
Normalized frequency of C-terminal beta-sheet (Chou-Fasman, 1978b)\cr
Normalized frequency of N-terminal non beta region (Chou-Fasman, 1978b)\cr
Normalized frequency of C-terminal non beta region (Chou-Fasman, 1978b)\cr
Frequency of the 1st residue in turn (Chou-Fasman, 1978b)\cr
Frequency of the 2nd residue in turn (Chou-Fasman, 1978b)\cr
Frequency of the 3rd residue in turn (Chou-Fasman, 1978b)\cr
Frequency of the 4th residue in turn (Chou-Fasman, 1978b)\cr
Normalized frequency of the 2nd and 3rd residues in turn (Chou-Fasman, 1978b)\cr
Normalized hydrophobicity scales for alpha-proteins (Cid et al., 1992)\cr
Normalized hydrophobicity scales for beta-proteins (Cid et al., 1992)\cr
Normalized hydrophobicity scales for alpha+beta-proteins (Cid et al., 1992)\cr
Normalized hydrophobicity scales for alpha/beta-proteins (Cid et al., 1992)\cr
Normalized average hydrophobicity scales (Cid et al., 1992)\cr
Partial specific volume (Cohn-Edsall, 1943)\cr
Normalized frequency of middle helix (Crawford et al., 1973)\cr
Normalized frequency of beta-sheet (Crawford et al., 1973)\cr
Normalized frequency of turn (Crawford et al., 1973)\cr
Size (Dawson, 1972)\cr
Amino acid composition (Dayhoff et al., 1978a)\cr
Relative mutability (Dayhoff et al., 1978b)\cr
Membrane preference for cytochrome b: MPH89 (Degli Esposti et al., 1990)\cr
Average membrane preference: AMP07 (Degli Esposti et al., 1990)\cr
Consensus normalized hydrophobicity scale (Eisenberg, 1984)\cr
Solvation free energy (Eisenberg-McLachlan, 1986)\cr
Atom-based hydrophobic moment (Eisenberg-McLachlan, 1986)\cr
Direction of hydrophobic moment (Eisenberg-McLachlan, 1986)\cr
Molecular weight (Fasman, 1976)\cr
Melting point (Fasman, 1976)\cr
Optical rotation (Fasman, 1976)\cr
pK-N (Fasman, 1976)\cr
pK-C (Fasman, 1976)\cr
Hydrophobic parameter pi (Fauchere-Pliska, 1983)\cr
Graph shape index (Fauchere et al., 1988)\cr
Smoothed upsilon steric parameter (Fauchere et al., 1988)\cr
Normalized van der Waals volume (Fauchere et al., 1988)\cr
STERIMOL length of the side chain (Fauchere et al., 1988)\cr
STERIMOL minimum width of the side chain (Fauchere et al., 1988)\cr
STERIMOL maximum width of the side chain (Fauchere et al., 1988)\cr
N.m.r. chemical shift of alpha-carbon (Fauchere et al., 1988)\cr
Localized electrical effect (Fauchere et al., 1988)\cr
Number of hydrogen bond donors (Fauchere et al., 1988)\cr
Number of full nonbonding orbitals (Fauchere et al., 1988)\cr
Positive charge (Fauchere et al., 1988)\cr
Negative charge (Fauchere et al., 1988)\cr
pK-a(RCOOH) (Fauchere et al., 1988)\cr
Helix-coil equilibrium constant (Finkelstein-Ptitsyn, 1977)\cr
Helix initiation parameter at posision i-1 (Finkelstein et al., 1991)\cr
Helix initiation parameter at posision i,i+1,i+2 (Finkelstein et al., 1991)\cr
Helix termination parameter at posision j-2,j-1,j (Finkelstein et al., 1991)\cr
Helix termination parameter at posision j+1 (Finkelstein et al., 1991)\cr
Partition coefficient (Garel et al., 1973)\cr
Alpha-helix indices (Geisow-Roberts, 1980)\cr
Alpha-helix indices for alpha-proteins (Geisow-Roberts, 1980)\cr
Alpha-helix indices for beta-proteins (Geisow-Roberts, 1980)\cr
Alpha-helix indices for alpha/beta-proteins (Geisow-Roberts, 1980)\cr
Beta-strand indices (Geisow-Roberts, 1980)\cr
Beta-strand indices for beta-proteins (Geisow-Roberts, 1980)\cr
Beta-strand indices for alpha/beta-proteins (Geisow-Roberts, 1980)\cr
Aperiodic indices (Geisow-Roberts, 1980)\cr
Aperiodic indices for alpha-proteins (Geisow-Roberts, 1980)\cr
Aperiodic indices for beta-proteins (Geisow-Roberts, 1980)\cr
Aperiodic indices for alpha/beta-proteins (Geisow-Roberts, 1980)\cr
Hydrophobicity factor (Goldsack-Chalifoux, 1973)\cr
Residue volume (Goldsack-Chalifoux, 1973)\cr
Composition (Grantham, 1974)\cr
Polarity (Grantham, 1974)\cr
Volume (Grantham, 1974)\cr
Partition energy (Guy, 1985)\cr
Hydration number (Hopfinger, 1971), Cited by Charton-Charton (1982)\cr
Hydrophilicity value (Hopp-Woods, 1981)\cr
Heat capacity (Hutchens, 1970)\cr
Absolute entropy (Hutchens, 1970)\cr
Entropy of formation (Hutchens, 1970)\cr
Normalized relative frequency of alpha-helix (Isogai et al., 1980)\cr
Normalized relative frequency of extended structure (Isogai et al., 1980)\cr
Normalized relative frequency of bend (Isogai et al., 1980)\cr
Normalized relative frequency of bend R (Isogai et al., 1980)\cr
Normalized relative frequency of bend S (Isogai et al., 1980)\cr
Normalized relative frequency of helix end (Isogai et al., 1980)\cr
Normalized relative frequency of double bend (Isogai et al., 1980)\cr
Normalized relative frequency of coil (Isogai et al., 1980)\cr
Average accessible surface area (Janin et al., 1978)\cr
Percentage of buried residues (Janin et al., 1978)\cr
Percentage of exposed residues (Janin et al., 1978)\cr
Ratio of buried and accessible molar fractions (Janin, 1979)\cr
Transfer free energy (Janin, 1979)\cr
Hydrophobicity (Jones, 1975)\cr
pK (-COOH) (Jones, 1975)\cr
Relative frequency of occurrence (Jones et al., 1992)\cr
Relative mutability (Jones et al., 1992)\cr
Amino acid distribution (Jukes et al., 1975)\cr
Sequence frequency (Jungck, 1978)\cr
Average relative probability of helix (Kanehisa-Tsong, 1980)\cr
Average relative probability of beta-sheet (Kanehisa-Tsong, 1980)\cr
Average relative probability of inner helix (Kanehisa-Tsong, 1980)\cr
Average relative probability of inner beta-sheet (Kanehisa-Tsong, 1980)\cr
Flexibility parameter for no rigid neighbors (Karplus-Schulz, 1985)\cr
Flexibility parameter for one rigid neighbor (Karplus-Schulz, 1985)\cr
Flexibility parameter for two rigid neighbors (Karplus-Schulz, 1985)\cr
The Kerr-constant increments (Khanarian-Moore, 1980)\cr
Net charge (Klein et al., 1984)\cr
Side chain interaction parameter (Krigbaum-Rubin, 1971)\cr
Side chain interaction parameter (Krigbaum-Komoriya, 1979)\cr
Fraction of site occupied by water (Krigbaum-Komoriya, 1979)\cr
Side chain volume (Krigbaum-Komoriya, 1979)\cr
Hydropathy index (Kyte-Doolittle, 1982)\cr
Transfer free energy, CHP/water (Lawson et al., 1984)\cr
Hydrophobic parameter (Levitt, 1976)\cr
Distance between C-alpha and centroid of side chain (Levitt, 1976)\cr
Side chain angle theta(AAR) (Levitt, 1976)\cr
Side chain torsion angle phi(AAAR) (Levitt, 1976)\cr
Radius of gyration of side chain (Levitt, 1976)\cr
van der Waals parameter R0 (Levitt, 1976)\cr
van der Waals parameter epsilon (Levitt, 1976)\cr
Normalized frequency of alpha-helix, with weights (Levitt, 1978)\cr
Normalized frequency of beta-sheet, with weights (Levitt, 1978)\cr
Normalized frequency of reverse turn, with weights (Levitt, 1978)\cr
Normalized frequency of alpha-helix, unweighted (Levitt, 1978)\cr
Normalized frequency of beta-sheet, unweighted (Levitt, 1978)\cr
Normalized frequency of reverse turn, unweighted (Levitt, 1978)\cr
Frequency of occurrence in beta-bends (Lewis et al., 1971)\cr
Conformational preference for all beta-strands (Lifson-Sander, 1979)\cr
Conformational preference for parallel beta-strands (Lifson-Sander, 1979)\cr
Conformational preference for antiparallel beta-strands (Lifson-Sander, 1979)\cr
Average surrounding hydrophobicity (Manavalan-Ponnuswamy, 1978)\cr
Normalized frequency of alpha-helix (Maxfield-Scheraga, 1976)\cr
Normalized frequency of extended structure (Maxfield-Scheraga, 1976)\cr
Normalized frequency of zeta R (Maxfield-Scheraga, 1976)\cr
Normalized frequency of left-handed alpha-helix (Maxfield-Scheraga, 1976)\cr
Normalized frequency of zeta L (Maxfield-Scheraga, 1976)\cr
Normalized frequency of alpha region (Maxfield-Scheraga, 1976)\cr
Refractivity (McMeekin et al., 1964), Cited by Jones (1975)\cr
Retention coefficient in HPLC, pH7.4 (Meek, 1980)\cr
Retention coefficient in HPLC, pH2.1 (Meek, 1980)\cr
Retention coefficient in NaClO4 (Meek-Rossetti, 1981)\cr
Retention coefficient in NaH2PO4 (Meek-Rossetti, 1981)\cr
Average reduced distance for C-alpha (Meirovitch et al., 1980)\cr
Average reduced distance for side chain (Meirovitch et al., 1980)\cr
Average side chain orientation angle (Meirovitch et al., 1980)\cr
Effective partition energy (Miyazawa-Jernigan, 1985)\cr
Normalized frequency of alpha-helix (Nagano, 1973)\cr
Normalized frequency of bata-structure (Nagano, 1973)\cr
Normalized frequency of coil (Nagano, 1973)\cr
AA composition of total proteins (Nakashima et al., 1990)\cr
SD of AA composition of total proteins (Nakashima et al., 1990)\cr
AA composition of mt-proteins (Nakashima et al., 1990)\cr
Normalized composition of mt-proteins (Nakashima et al., 1990)\cr
AA composition of mt-proteins from animal (Nakashima et al., 1990)\cr
Normalized composition from animal (Nakashima et al., 1990)\cr
AA composition of mt-proteins from fungi and plant (Nakashima et al., 1990)\cr
Normalized composition from fungi and plant (Nakashima et al., 1990)\cr
AA composition of membrane proteins (Nakashima et al., 1990)\cr
Normalized composition of membrane proteins (Nakashima et al., 1990)\cr
Transmembrane regions of non-mt-proteins (Nakashima et al., 1990)\cr
Transmembrane regions of mt-proteins (Nakashima et al., 1990)\cr
Ratio of average and computed composition (Nakashima et al., 1990)\cr
AA composition of CYT of single-spanning proteins (Nakashima-Nishikawa, 1992)\cr
AA composition of CYT2 of single-spanning proteins (Nakashima-Nishikawa, 1992)\cr
AA composition of EXT of single-spanning proteins (Nakashima-Nishikawa, 1992)\cr
AA composition of EXT2 of single-spanning proteins (Nakashima-Nishikawa, 1992)\cr
AA composition of MEM of single-spanning proteins (Nakashima-Nishikawa, 1992)\cr
AA composition of CYT of multi-spanning proteins (Nakashima-Nishikawa, 1992)\cr
AA composition of EXT of multi-spanning proteins (Nakashima-Nishikawa, 1992)\cr
AA composition of MEM of multi-spanning proteins (Nakashima-Nishikawa, 1992)\cr
8 A contact number (Nishikawa-Ooi, 1980)\cr
14 A contact number (Nishikawa-Ooi, 1986)\cr
Transfer energy, organic solvent/water (Nozaki-Tanford, 1971)\cr
Average non-bonded energy per atom (Oobatake-Ooi, 1977)\cr
Short and medium range non-bonded energy per atom (Oobatake-Ooi, 1977)\cr
Long range non-bonded energy per atom (Oobatake-Ooi, 1977)\cr
Average non-bonded energy per residue (Oobatake-Ooi, 1977)\cr
Short and medium range non-bonded energy per residue (Oobatake-Ooi, 1977)\cr
Optimized beta-structure-coil equilibrium constant (Oobatake et al., 1985)\cr
Optimized propensity to form reverse turn (Oobatake et al., 1985)\cr
Optimized transfer energy parameter (Oobatake et al., 1985)\cr
Optimized average non-bonded energy per atom (Oobatake et al., 1985)\cr
Optimized side chain interaction parameter (Oobatake et al., 1985)\cr
Normalized frequency of alpha-helix from LG (Palau et al., 1981)\cr
Normalized frequency of alpha-helix from CF (Palau et al., 1981)\cr
Normalized frequency of beta-sheet from LG (Palau et al., 1981)\cr
Normalized frequency of beta-sheet from CF (Palau et al., 1981)\cr
Normalized frequency of turn from LG (Palau et al., 1981)\cr
Normalized frequency of turn from CF (Palau et al., 1981)\cr
Normalized frequency of alpha-helix in all-alpha class (Palau et al., 1981)\cr
Normalized frequency of alpha-helix in alpha+beta class (Palau et al., 1981)\cr
Normalized frequency of alpha-helix in alpha/beta class (Palau et al., 1981)\cr
Normalized frequency of beta-sheet in all-beta class (Palau et al., 1981)\cr
Normalized frequency of beta-sheet in alpha+beta class (Palau et al., 1981)\cr
Normalized frequency of beta-sheet in alpha/beta class (Palau et al., 1981)\cr
Normalized frequency of turn in all-alpha class (Palau et al., 1981)\cr
Normalized frequency of turn in all-beta class (Palau et al., 1981)\cr
Normalized frequency of turn in alpha+beta class (Palau et al., 1981)\cr
Normalized frequency of turn in alpha/beta class (Palau et al., 1981)\cr
HPLC parameter (Parker et al., 1986)\cr
Partition coefficient (Pliska et al., 1981)\cr
Surrounding hydrophobicity in folded form (Ponnuswamy et al., 1980)\cr
Average gain in surrounding hydrophobicity (Ponnuswamy et al., 1980)\cr
Average gain ratio in surrounding hydrophobicity (Ponnuswamy et al., 1980)\cr
Surrounding hydrophobicity in alpha-helix (Ponnuswamy et al., 1980)\cr
Surrounding hydrophobicity in beta-sheet (Ponnuswamy et al., 1980)\cr
Surrounding hydrophobicity in turn (Ponnuswamy et al., 1980)\cr
Accessibility reduction ratio (Ponnuswamy et al., 1980)\cr
Average number of surrounding residues (Ponnuswamy et al., 1980)\cr
Intercept in regression analysis (Prabhakaran-Ponnuswamy, 1982)\cr
Slope in regression analysis x 1.0E1 (Prabhakaran-Ponnuswamy, 1982)\cr
Correlation coefficient in regression analysis (Prabhakaran-Ponnuswamy, 1982)\cr
Hydrophobicity (Prabhakaran, 1990)\cr
Relative frequency in alpha-helix (Prabhakaran, 1990)\cr
Relative frequency in beta-sheet (Prabhakaran, 1990)\cr
Relative frequency in reverse-turn (Prabhakaran, 1990)\cr
Helix-coil equilibrium constant (Ptitsyn-Finkelstein, 1983)\cr
Beta-coil equilibrium constant (Ptitsyn-Finkelstein, 1983)\cr
Weights for alpha-helix at the window position of -6 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of -5 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of -4 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of -3 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of -2 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of -1 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of 0 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of 1 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of 2 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of 3 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of 4 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of 5 (Qian-Sejnowski, 1988)\cr
Weights for alpha-helix at the window position of 6 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of -6 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of -5 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of -4 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of -3 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of -2 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of -1 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of 0 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of 1 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of 2 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of 3 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of 4 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of 5 (Qian-Sejnowski, 1988)\cr
Weights for beta-sheet at the window position of 6 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of -6 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of -5 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of -4 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of -3 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of -2 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of -1 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of 0 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of 1 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of 2 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of 3 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of 4 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of 5 (Qian-Sejnowski, 1988)\cr
Weights for coil at the window position of 6 (Qian-Sejnowski, 1988)\cr
Average reduced distance for C-alpha (Rackovsky-Scheraga, 1977)\cr
Average reduced distance for side chain (Rackovsky-Scheraga, 1977)\cr
Side chain orientational preference (Rackovsky-Scheraga, 1977)\cr
Average relative fractional occurrence in A0(i) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in AR(i) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in AL(i) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in EL(i) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in E0(i) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in ER(i) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in A0(i-1) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in AR(i-1) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in AL(i-1) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in EL(i-1) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in E0(i-1) (Rackovsky-Scheraga, 1982)\cr
Average relative fractional occurrence in ER(i-1) (Rackovsky-Scheraga, 1982)\cr
Value of theta(i) (Rackovsky-Scheraga, 1982)\cr
Value of theta(i-1) (Rackovsky-Scheraga, 1982)\cr
Transfer free energy from chx to wat (Radzicka-Wolfenden, 1988)\cr
Transfer free energy from oct to wat (Radzicka-Wolfenden, 1988)\cr
Transfer free energy from vap to chx (Radzicka-Wolfenden, 1988)\cr
Transfer free energy from chx to oct (Radzicka-Wolfenden, 1988)\cr
Transfer free energy from vap to oct (Radzicka-Wolfenden, 1988)\cr
Accessible surface area (Radzicka-Wolfenden, 1988)\cr
Energy transfer from out to in(95%buried) (Radzicka-Wolfenden, 1988)\cr
Mean polarity (Radzicka-Wolfenden, 1988)\cr
Relative preference value at N" (Richardson-Richardson, 1988)\cr
Relative preference value at N' (Richardson-Richardson, 1988)\cr
Relative preference value at N-cap (Richardson-Richardson, 1988)\cr
Relative preference value at N1 (Richardson-Richardson, 1988)\cr
Relative preference value at N2 (Richardson-Richardson, 1988)\cr
Relative preference value at N3 (Richardson-Richardson, 1988)\cr
Relative preference value at N4 (Richardson-Richardson, 1988)\cr
Relative preference value at N5 (Richardson-Richardson, 1988)\cr
Relative preference value at Mid (Richardson-Richardson, 1988)\cr
Relative preference value at C5 (Richardson-Richardson, 1988)\cr
Relative preference value at C4 (Richardson-Richardson, 1988)\cr
Relative preference value at C3 (Richardson-Richardson, 1988)\cr
Relative preference value at C2 (Richardson-Richardson, 1988)\cr
Relative preference value at C1 (Richardson-Richardson, 1988)\cr
Relative preference value at C-cap (Richardson-Richardson, 1988)\cr
Relative preference value at C' (Richardson-Richardson, 1988)\cr
Relative preference value at C" (Richardson-Richardson, 1988)\cr
Information measure for alpha-helix (Robson-Suzuki, 1976)\cr
Information measure for N-terminal helix (Robson-Suzuki, 1976)\cr
Information measure for middle helix (Robson-Suzuki, 1976)\cr
Information measure for C-terminal helix (Robson-Suzuki, 1976)\cr
Information measure for extended (Robson-Suzuki, 1976)\cr
Information measure for pleated-sheet (Robson-Suzuki, 1976)\cr
Information measure for extended without H-bond (Robson-Suzuki, 1976)\cr
Information measure for turn (Robson-Suzuki, 1976)\cr
Information measure for N-terminal turn (Robson-Suzuki, 1976)\cr
Information measure for middle turn (Robson-Suzuki, 1976)\cr
Information measure for C-terminal turn (Robson-Suzuki, 1976)\cr
Information measure for coil (Robson-Suzuki, 1976)\cr
Information measure for loop (Robson-Suzuki, 1976)\cr
Hydration free energy (Robson-Osguthorpe, 1979)\cr
Mean area buried on transfer (Rose et al., 1985)\cr
Mean fractional area loss (Rose et al., 1985)\cr
Side chain hydropathy, uncorrected for solvation (Roseman, 1988)\cr
Side chain hydropathy, corrected for solvation (Roseman, 1988)\cr
Loss of Side chain hydropathy by helix formation (Roseman, 1988)\cr
Transfer free energy (Simon, 1976), Cited by Charton-Charton (1982)\cr
Principal component I (Sneath, 1966)\cr
Principal component II (Sneath, 1966)\cr
Principal component III (Sneath, 1966)\cr
Principal component IV (Sneath, 1966)\cr
Zimm-Bragg parameter s at 20 C (Sueki et al., 1984)\cr
Zimm-Bragg parameter sigma x 1.0E4 (Sueki et al., 1984)\cr
Optimal matching hydrophobicity (Sweet-Eisenberg, 1983)\cr
Normalized frequency of alpha-helix (Tanaka-Scheraga, 1977)\cr
Normalized frequency of isolated helix (Tanaka-Scheraga, 1977)\cr
Normalized frequency of extended structure (Tanaka-Scheraga, 1977)\cr
Normalized frequency of chain reversal R (Tanaka-Scheraga, 1977)\cr
Normalized frequency of chain reversal S (Tanaka-Scheraga, 1977)\cr
Normalized frequency of chain reversal D (Tanaka-Scheraga, 1977)\cr
Normalized frequency of left-handed helix (Tanaka-Scheraga, 1977)\cr
Normalized frequency of zeta R (Tanaka-Scheraga, 1977)\cr
Normalized frequency of coil (Tanaka-Scheraga, 1977)\cr
Normalized frequency of chain reversal (Tanaka-Scheraga, 1977)\cr
Relative population of conformational state A (Vasquez et al., 1983)\cr
Relative population of conformational state C (Vasquez et al., 1983)\cr
Relative population of conformational state E (Vasquez et al., 1983)\cr
Electron-ion interaction potential (Veljkovic et al., 1985)\cr
Bitterness (Venanzi, 1984)\cr
Transfer free energy to lipophilic phase (von Heijne-Blomberg, 1979)\cr
Average interactions per side chain atom (Warme-Morgan, 1978)\cr
RF value in high salt chromatography (Weber-Lacey, 1978)\cr
Propensity to be buried inside (Wertz-Scheraga, 1978)\cr
Free energy change of epsilon(i) to epsilon(ex) (Wertz-Scheraga, 1978)\cr
Free energy change of alpha(Ri) to alpha(Rh) (Wertz-Scheraga, 1978)\cr
Free energy change of epsilon(i) to alpha(Rh) (Wertz-Scheraga, 1978)\cr
Polar requirement (Woese, 1973)\cr
Hydration potential (Wolfenden et al., 1981)\cr
Principal property value z1 (Wold et al., 1987)\cr
Principal property value z2 (Wold et al., 1987)\cr
Principal property value z3 (Wold et al., 1987)\cr
Unfolding Gibbs energy in water, pH7.0 (Yutani et al., 1987)\cr
Unfolding Gibbs energy in water, pH9.0 (Yutani et al., 1987)\cr
Activation Gibbs energy of unfolding, pH7.0 (Yutani et al., 1987)\cr
Activation Gibbs energy of unfolding, pH9.0 (Yutani et al., 1987)\cr
Dependence of partition coefficient on ionic strength (Zaslavsky et al., 1982)\cr
Hydrophobicity (Zimmerman et al., 1968)\cr
Bulkiness (Zimmerman et al., 1968)\cr
Polarity (Zimmerman et al., 1968)\cr
Isoelectric point (Zimmerman et al., 1968)\cr
RF rank (Zimmerman et al., 1968)\cr
Normalized positional residue frequency at helix termini N4'(Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N"' (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N" (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N'(Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini Nc (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N1 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N2 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N3 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N4 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini N5 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C5 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C4 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C3 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C2 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C1 (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini Cc (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C' (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C" (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C"' (Aurora-Rose, 1998)\cr
Normalized positional residue frequency at helix termini C4' (Aurora-Rose, 1998)\cr
Delta G values for the peptides extrapolated to 0 M urea (O'Neil-DeGrado, 1990)\cr
Helix formation parameters (delta delta G) (O'Neil-DeGrado, 1990)\cr
Normalized flexibility parameters (B-values), average (Vihinen et al., 1994)\cr
Normalized flexibility parameters (B-values) for each residue surrounded by none rigid neighbours (Vihinen et al., 1994)\cr
Normalized flexibility parameters (B-values) for each residue surrounded by one rigid neighbours (Vihinen et al., 1994)\cr
Normalized flexibility parameters (B-values) for each residue surrounded by two rigid neighbours (Vihinen et al., 1994)\cr
Free energy in alpha-helical conformation (Munoz-Serrano, 1994)\cr
Free energy in alpha-helical region (Munoz-Serrano, 1994)\cr
Free energy in beta-strand conformation (Munoz-Serrano, 1994)\cr
Free energy in beta-strand region (Munoz-Serrano, 1994)\cr
Free energy in beta-strand region (Munoz-Serrano, 1994)\cr
Free energies of transfer of AcWl-X-LL peptides from bilayer interface to water (Wimley-White, 1996)\cr
Thermodynamic beta sheet propensity (Kim-Berg, 1993)\cr
Turn propensity scale for transmembrane helices (Monne et al., 1999)\cr
Alpha helix propensity of position 44 in T4 lysozyme (Blaber et al., 1993)\cr
p-Values of mesophilic proteins based on the distributions of B values (Parthasarathy-Murthy, 2000)\cr
p-Values of thermophilic proteins based on the distributions of B values (Parthasarathy-Murthy, 2000)\cr
Distribution of amino acid residues in the 18 non-redundant families of thermophilic proteins (Kumar et al., 2000)\cr
Distribution of amino acid residues in the 18 non-redundant families of mesophilic proteins (Kumar et al., 2000)\cr
Distribution of amino acid residues in the alpha-helices in thermophilic proteins (Kumar et al., 2000)\cr
Distribution of amino acid residues in the alpha-helices in mesophilic proteins (Kumar et al., 2000)\cr
Side-chain contribution to protein stability (kJ/mol) (Takano-Yutani, 2001)\cr
Propensity of amino acids within pi-helices (Fodje-Al-Karadaghi, 2002)\cr
Hydropathy scale based on self-information values in the two-state model (5% accessibility) (Naderi-Manesh et al., 2001)\cr
Hydropathy scale based on self-information values in the two-state model (9% accessibility) (Naderi-Manesh et al., 2001)\cr
Hydropathy scale based on self-information values in the two-state model (16% accessibility) (Naderi-Manesh et al., 2001)\cr
Hydropathy scale based on self-information values in the two-state model (20% accessibility) (Naderi-Manesh et al., 2001)\cr
Hydropathy scale based on self-information values in the two-state model (25% accessibility) (Naderi-Manesh et al., 2001)\cr
Hydropathy scale based on self-information values in the two-state model (36% accessibility) (Naderi-Manesh et al., 2001)\cr
Hydropathy scale based on self-information values in the two-state model (50% accessibility) (Naderi-Manesh et al., 2001)\cr
Averaged turn propensities in a transmembrane helix (Monne et al., 1999)\cr
Alpha-helix propensity derived from designed sequences (Koehl-Levitt, 1999)\cr
Beta-sheet propensity derived from designed sequences (Koehl-Levitt, 1999)\cr
Composition of amino acids in extracellular proteins (percent) (Cedano et al., 1997)\cr
Composition of amino acids in anchored proteins (percent) (Cedano et al., 1997)\cr
Composition of amino acids in membrane proteins (percent) (Cedano et al., 1997)\cr
Composition of amino acids in intracellular proteins (percent) (Cedano et al., 1997)\cr
Composition of amino acids in nuclear proteins (percent) (Cedano et al., 1997)\cr
Surface composition of amino acids in intracellular proteins of thermophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Surface composition of amino acids in intracellular proteins of mesophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Surface composition of amino acids in extracellular proteins of mesophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Surface composition of amino acids in nuclear proteins (percent) (Fukuchi-Nishikawa, 2001)\cr
Interior composition of amino acids in intracellular proteins of thermophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Interior composition of amino acids in intracellular proteins of mesophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Interior composition of amino acids in extracellular proteins of mesophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Interior composition of amino acids in nuclear proteins (percent) (Fukuchi-Nishikawa, 2001)\cr
Entire chain composition of amino acids in intracellular proteins of thermophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Entire chain composition of amino acids in intracellular proteins of mesophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Entire chain composition of amino acids in extracellular proteins of mesophiles (percent) (Fukuchi-Nishikawa, 2001)\cr
Entire chain compositino of amino acids in nuclear proteins (percent) (Fukuchi-Nishikawa, 2001)\cr
Screening coefficients gamma, local (Avbelj, 2000)\cr
Screening coefficients gamma, non-local (Avbelj, 2000)\cr
Slopes tripeptide, FDPB VFF neutral (Avbelj, 2000)\cr
Slopes tripeptides, LD VFF neutral (Avbelj, 2000)\cr
Slopes tripeptide, FDPB VFF noside (Avbelj, 2000)\cr
Slopes tripeptide FDPB VFF all (Avbelj, 2000)\cr
Slopes tripeptide FDPB PARSE neutral (Avbelj, 2000)\cr
Slopes dekapeptide, FDPB VFF neutral (Avbelj, 2000)\cr
Slopes proteins, FDPB VFF neutral (Avbelj, 2000)\cr
Side-chain conformation by gaussian evolutionary method (Yang et al., 2002)\cr
Amphiphilicity index (Mitaku et al., 2002)\cr
Volumes including the crystallographic waters using the ProtOr (Tsai et al., 1999)\cr
Volumes not including the crystallographic waters using the ProtOr (Tsai et al., 1999)\cr
Electron-ion interaction potential values (Cosic, 1994)\cr
Hydrophobicity scales (Ponnuswamy, 1993)\cr
Hydrophobicity coefficient in RP-HPLC, C18 with 0.1%TFA/MeCN/H2O (Wilce et al. 1995)\cr
Hydrophobicity coefficient in RP-HPLC, C8 with 0.1%TFA/MeCN/H2O (Wilce et al. 1995)\cr
Hydrophobicity coefficient in RP-HPLC, C4 with 0.1%TFA/MeCN/H2O (Wilce et al. 1995)\cr
Hydrophobicity coefficient in RP-HPLC, C18 with 0.1%TFA/2-PrOH/MeCN/H2O (Wilce et al. 1995)\cr
Hydrophilicity scale (Kuhn et al., 1995)\cr
Retention coefficient at pH 2 (Guo et al., 1986)\cr
Modified Kyte-Doolittle hydrophobicity scale (Juretic et al., 1998)\cr
Interactivity scale obtained from the contact matrix (Bastolla et al., 2005)\cr
Interactivity scale obtained by maximizing the mean of correlation coefficient over single-domain globular proteins (Bastolla et al., 2005)\cr
Interactivity scale obtained by maximizing the mean of correlation coefficient over pairs of sequences sharing the TIM barrel fold (Bastolla et al., 2005)\cr
Linker propensity index (Suyama-Ohara, 2003)\cr
Knowledge-based membrane-propensity scale from 1D\_Helix in MPtopo databases (Punta-Maritan, 2003)\cr
Knowledge-based membrane-propensity scale from 3D\_Helix in MPtopo databases (Punta-Maritan, 2003)\cr
Linker propensity from all dataset (George-Heringa, 2003)\cr
Linker propensity from 1-linker dataset (George-Heringa, 2003)\cr
Linker propensity from 2-linker dataset (George-Heringa, 2003)\cr
Linker propensity from 3-linker dataset (George-Heringa, 2003)\cr
Linker propensity from small dataset (linker length is less than six residues) (George-Heringa, 2003)\cr
Linker propensity from medium dataset (linker length is between six and 14 residues) (George-Heringa, 2003)\cr
Linker propensity from long dataset (linker length is greater than 14 residues) (George-Heringa, 2003)\cr
Linker propensity from helical (annotated by DSSP) dataset (George-Heringa, 2003)\cr
Linker propensity from non-helical (annotated by DSSP) dataset (George-Heringa, 2003)\cr
The stability scale from the knowledge-based atom-atom potential (Zhou-Zhou, 2004)\cr
The relative stability scale extracted from mutation experiments (Zhou-Zhou, 2004)\cr
Buriability (Zhou-Zhou, 2004)\cr
Linker index (Bae et al., 2005)\cr
Mean volumes of residues buried in protein interiors (Harpaz et al., 1994)\cr
Average volumes of residues (Pontius et al., 1996)\cr
Hydrostatic pressure asymmetry index, PAI (Di Giulio, 2005)\cr
Hydrophobicity index (Wolfenden et al., 1979)\cr
Average internal preferences (Olsen, 1980)\cr
Hydrophobicity-related index (Kidera et al., 1985)\cr
Apparent partition energies calculated from Wertz-Scheraga index (Guy, 1985)\cr
Apparent partition energies calculated from Robson-Osguthorpe index (Guy, 1985)\cr
Apparent partition energies calculated from Janin index (Guy, 1985)\cr
Apparent partition energies calculated from Chothia index (Guy, 1985)\cr
Hydropathies of amino acid side chains, neutral form (Roseman, 1988)\cr
Hydropathies of amino acid side chains, pi-values in pH 7.0 (Roseman, 1988)\cr
Weights from the IFH scale (Jacobs-White, 1989)\cr
Hydrophobicity index, 3.0 pH (Cowan-Whittaker, 1990)\cr
Scaled side chain hydrophobicity values (Black-Mould, 1991)\cr
Hydrophobicity scale from native protein structures (Casari-Sippl, 1992)\cr
NNEIG index (Cornette et al., 1987)\cr
SWEIG index (Cornette et al., 1987)\cr
PRIFT index (Cornette et al., 1987)\cr
PRILS index (Cornette et al., 1987)\cr
ALTFT index (Cornette et al., 1987)\cr
ALTLS index (Cornette et al., 1987)\cr
TOTFT index (Cornette et al., 1987)\cr
TOTLS index (Cornette et al., 1987)\cr
Relative partition energies derived by the Bethe approximation (Miyazawa-Jernigan, 1999)\cr
Optimized relative partition energies - method A (Miyazawa-Jernigan, 1999)\cr
Optimized relative partition energies - method B (Miyazawa-Jernigan, 1999)\cr
Optimized relative partition energies - method C (Miyazawa-Jernigan, 1999)\cr
Optimized relative partition energies - method D (Miyazawa-Jernigan, 1999)\cr
Hydrophobicity index (Engelman et al., 1986)\cr
Hydrophobicity index (Fasman, 1989)
}
\source{
\url{http://www.genome.jp/aaindex}
}
\references{

From the original aaindex documentation:\cr

Please cite the following references when making use of the database:

Kawashima, S. and Kanehisa, M. (2000) AAindex: amino acid index 
database. \emph{Nucleic Acids Res.}, \bold{28}:374.\cr

Tomii, K. and Kanehisa, M. (1996) Analysis of amino acid indices and
mutation matrices for sequence comparison and structure
prediction of proteins. \emph{Protein Eng.}, \bold{9}:27-36.\cr

Nakai, K., Kidera, A., and Kanehisa, M. (1988) Cluster analysis of
amino acid indices for prediction of protein structure and
function. \emph{Protein Eng.} \bold{2}:93-100.\cr

}
\examples{
#
# Load data:
#

data(aaindex)

#
# Supose that we need the Kyte & Doolittle Hydrophaty index. We first look
# at the entries with Kyte as author:
#

which(sapply(aaindex, function(x) length(grep("Kyte", x$A)) != 0))

#
# This should return that entry number 151 named KYTJ820101 is the only
# one that fit our request. We can access to it by position or by name,
# for instance:
#

aaindex[[151]]$I
aaindex[["KYTJ820101"]]$I
aaindex$KYTJ820101$I

}
\keyword{datasets}

\name{prepgetannots}
\alias{prepgetannots}
\alias{pga}
\title{Select annotation lines in an ACNUC database}
\description{
This function is called before using \code{\link{getAnnot}} or
\code{\link{modifylist}} with a \code{scan} type operation to
select the annotation lines to be returned or scanned.
}

\usage{
prepgetannots(what = "all", setfor = c("scan", "getannots"),
                       socket = autosocket(), verbose = FALSE)
pga(what = "all", setfor = c("scan", "getannots"),
                       socket = autosocket(), verbose = FALSE)
}

\arguments{
  \item{what}{the default "all" means that all annotation lines are selected.
    This can be more specific, see details.}
  \item{setfor}{this is used when \code{what} has its default "all" value.
    The behaviour is different for \code{\link{getAnnot}} and
    \code{\link{modifylist}} with a \code{scan} type operation:
    annotations but not sequences are scanned, but sequences can
    be returned by \code{\link{getAnnot}}. The default value is "scan".}
  \item{socket}{an object of class \code{sockconn} connecting to an ACNUC server}
  \item{verbose}{logical, if TRUE mode verbose is on}
}

\details{
The names of annotation lines in the opened ACNUC database is
returned by \code{\link{countfreelists}}, they are forced to upper
case letters by \code{prepgetannots} when supplied with the
\code{what} argument.

For the EMBL/SWISSPROT format, keys are: ALL, AC, DT, KW, OS, OC, OG, OH, 
RN, RC, RP, RX, RA, RG, RT, RL, DR, AH, AS, CC, FH, FT, SQ, SEQ.

For GenBank: ALL, ACCESSION, VERSION, KEYWORDS, SOURCE, ORGANISM, 
REFERENCE, AUTHORS, CONSRTM, TITLE, JOURNAL, PUBMED, REMARK, COMMENT, 
FEATURES, ORIGIN, SEQUENCE.

For FT (embl, swissprot) and FEATURES (GenBank), one or more specific 
feature keys can be specified using lines with only uppercase and such as

FEATURES|CDS
FT|TRNA

Keys ALL and SEQ/SEQUENCE stand for all annotation and sequence lines, respectively.
For the scan operation, key ALL stand for the DE/DEFINITION lines, 
and SEQ/SEQUENCE cannot be used (annotations but not sequence are scanned).}

\value{
The function returns invisibly the annotation lines names.
}
\references{ 
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  \code{\link{getAnnot}}, \code{\link{modifylist}}, \code{\link{countfreelists}}
}

\examples{
 \dontrun{# Need internet connection
  choosebank("genbank")
  mylist <- query("mylist","n=AQF16SRRN")
  pga() # We want to scan all annotations, including FEATURES
  mylist <- modifylist("mylist", operation = "strain", type = "scan")
  mylist$nelem # should be 1
 }
}
\keyword{utilities}

\name{where.is.this.acc}
\alias{where.is.this.acc}
\title{Scans databases for a given sequence accession number}
\description{
This function loops over all availabale ACNUC databases to look for
a given sequence accession number. This is useful when you have
a sequence accession number and you don't know in which database
it is present. 
}
\usage{
where.is.this.acc(acc,  stopAtFirst = TRUE, ...)
}
\arguments{
  \item{acc}{An accession number as a string of characters such as \code{"NC_001416"}.}
  \item{stopAtFirst}{Logical. If TRUE, the default, the function stops at the first 
     database where the accession number is found.}
  \item{\dots}{Arguments passed to the function \code{\link{choosebank}}.}
}
\value{
The function resturns invisibly a vector of strings of characters for the names of the ACNUC 
databases in which the accession number was found.
}
\references{\code{citation("seqinr")}}
\author{J.R. Lobry}

\seealso{\code{\link{choosebank}} to open a given ACNUC database.}
\examples{
  \dontrun{# Need internet connection
  where.is.this.acc("NC_001416") # first found in phever2dna bank (2016-06-01)
  }
}

\name{toyaa}
\alias{toyaa}
\docType{data}
\title{A toy example of amino-acid counts in three proteins}
\encoding{latin1}
\description{
This is a toy data set to illustrate the importance of metric choice.
}
\usage{data(toyaa)}
\format{
  A data frame with 3 observations on the following 3 variables:
  \describe{
    \item{Ala}{Alanine counts}
    \item{Val}{Valine counts}
    \item{Cys}{Cysteine counts}
  }
}
\source{
This toy example was inspired by Gautier, C:
Analyses statistiques et évolution des séquences d'acides nucléiques.
PhD thesis (1987), Université Claude Bernard - Lyon I.
}
\references{
  \code{citation("seqinr")}
}
\examples{
data(toyaa)
}
\keyword{datasets}

\name{comp}
\alias{comp}
\title{ complements a nucleic acid sequence }
\description{
    Complements a sequence, for instance if the sequence is 
    \code{"a","c","g","t"} it returns \code{"t","g","c","a"}. 
    This is not the reverse complementary strand. This function
    can handle ambiguous bases if required.
}
\usage{
comp(seq, forceToLower = TRUE, ambiguous = FALSE)
}
\arguments{
  \item{seq}{ a DNA sequence as a vector of single chars }
  \item{forceToLower}{ if TRUE characters in \code{seq} are forced to lower case}
  \item{ambiguous}{ if TRUE ambiguous bases in \code{seq} are handled} 
}
\value{
  a vector of characters which is the complement of the sequence,
  not the reverse complementary strand. Undefined values are
  returned as NA.
}
\author{D. Charif, J.R. Lobry}
\references{
  \code{citation("seqinr")}
}
\seealso{ Because ssDNA sequences are always written in the 5'->3'
direction, use rev(comp(seq)) to get the reverse complementary
strand (see \code{\link{rev}}).
}
\examples{
##
## Show that comp() does *not* return the reverve complementary strand:
##

c2s(comp(s2c("aaaattttggggcccc")))

##
## Show how to get the reverse complementary strand:
##

c2s(rev(comp(s2c("aaaattttggggcccc"))))

##
## Show what happens with non allowed values:
##

c2s(rev(comp(s2c("aaaaXttttYggggZcccc"))))

##
## Show what happens with ambiguous bases:
##

allbases <- s2c("abcdghkmstvwn")
comp(allbases) # NA are produced
comp(allbases, ambiguous = TRUE) # No more NA

##
## Routine sanity checks:
##

stopifnot(identical(comp(allbases, ambiguous = TRUE), s2c("tvghcdmksabwn")))
stopifnot(identical(comp(c("A", "C", "G", "T"), forceToLower = FALSE), c("T", "G", "C", "A")))
}

\name{reverse.align}
\alias{reverse.align}
\title{ Reverse alignment - from protein sequence alignment to nucleic sequence alignment }
\description{
  This function produces an alignment of nucleic protein-coding sequences, using as a
  guide the alignment of the corresponding protein sequences. 
}
\usage{
reverse.align(nucl.file, protaln.file, input.format = 'fasta', out.file,
  output.format = 'fasta', align.prot = FALSE, numcode = 1,
  clustal.path = NULL, forceDNAtolower = TRUE, forceAAtolower = FALSE)
}
\arguments{
  \item{nucl.file}{ A character string specifying the name of the FASTA format file containing the nucleotide sequences. }
  \item{protaln.file}{A character string specifying the name of the file containing the aligned
    protein sequences. This argument must be provided if \code{align.prot} is
    set to \code{FALSE}. }
  \item{input.format}{ A character string specifying the format of the
    protein alignment file : 'mase', 'clustal', 'phylip', 'fasta' or 'msf'.  }
  \item{out.file}{A character string specifying the name of the output file. }
  \item{output.format}{ A character string specifying the format of the output file. Currently the only
    implemented format is 'fasta'. }
  \item{align.prot}{Boolean. If TRUE, the nucleic sequences are
    translated and then the protein sequences are aligned with the ClustalW program. The path
    of the ClustalW binary must also be given (\code{clustal.path}) }
  \item{numcode}{The NCBI genetic code number for the translation of the
  nucleic sequences. By default the standard genetic code is used.}
  \item{clustal.path}{ The path of the ClustalW binary. This argument
    only needs to be setif \code{align.prot} is TRUE. }
  \item{forceDNAtolower}{logical passed to \code{\link{read.fasta}} for reading 
     the nucleic acid file.}
  \item{forceAAtolower}{logical passed to \code{\link{read.alignment}} for reading 
     the aligned protein sequence file.}
}
\details{
  This function an alignment of nucleic protein-coding sequences using as a
  guide the alignment of the corresponding protein sequences. The file containing
  the nucleic sequences is given in the compulsory argument 'nucl.file';
  this file must be written in the FASTA format.

  The alignment of the protein sequences can either be provided
  directly, trough the 'protaln.file' parameter, or reconstructed with
  ClustalW, if the parameter 'align.prot' is set to TRUE. In the latter
  case, the pathway of the ClustalW binary must be given in the
  'clustal.path' argument. 
  
  The protein and nucleic sequences must have the same name in the files
  \code{nucl.file} and \code{protaln.file}.

  The reverse-aligned nucleotide sequences are written to the file
  specified in the compulsory 'out.file' argument. For now, the only
  output format implemented is FASTA.

  Warning: the 'align.prot=TRUE' option has only been tested on LINUX
  operating systems. ClustalW must be installed on your system in order
  for this to work.  
}
\value{
 NULL
}
\references{
  \code{citation('seqinr')}
}
\author{A. Necşulea}
\seealso{  \code{\link{read.alignment}}, \code{\link{read.fasta}}, \code{\link{write.fasta}}}

\examples{

#
# Read example 'bordetella.fasta': a triplet of orthologous genes from
# three bacterial species (Bordetella pertussis, B. parapertussis and
# B. bronchiseptica):
#

nucl.file <- system.file('sequences/bordetella.fasta', package = 'seqinr')
triplet <- read.fasta(nucl.file)

# 
# For this example, 'bordetella.pep.aln' contains the aligned protein
# sequences, in the Clustal format:
#

protaln.file <- system.file('sequences/bordetella.pep.aln', package = 'seqinr')
triplet.pep<- read.alignment(protaln.file, format = 'clustal')

#
# Call reverse.align for this example:
#

reverse.align(nucl.file = nucl.file, protaln.file = protaln.file,
                     input.format = 'clustal', out.file = 'test.revalign')

#
# Simple sanity check against expected result:
#

res.new <- read.alignment("test.revalign", format = "fasta")
data(revaligntest)
stopifnot(identical(res.new, revaligntest))

#
# Alternatively, we can use ClustalW to align the translated nucleic
# sequences. Here the ClustalW program is accessible simply by the
# 'clustalw' name.
#

\dontrun{
reverse.align(nucl.file = nucl.file, out.file = 'test.revalign.clustal', 
  align.prot = TRUE, clustal.path = 'clustalw')}
}
\keyword{ manip }

\name{computePI}
\alias{computePI}
\title{To Compute the Theoretical Isoelectric Point}
\description{
  This function calculates the theoretical isoelectric point of a protein. Isoelectric point is the pH at which the protein has a neutral charge.
This estimate does not account for the post-translational modifications.
}
\usage{
computePI(seq)
}
\arguments{
  \item{seq}{ Protein sequence as a vector of single chars in upper case}
}
\value{
  The theoretical isoelectric point (pI) as a numerical vector of length one.
}
\references{ 
The algorithm is the same as the one which is implemented at the following url:  
\url{https://web.expasy.org/compute_pi/pi_tool-doc.html} but with many trials
in case of convergence failure of the non-linear regression procedure.
\code{citation("seqinr")}
 }
\author{D. Charif, J.R. Lobry}
\note{ 
Protein pI is calculated using pK values of amino acids described in  Bjellqvist et al. See also \code{SEQINR.UTIL} for more details.
 }
\seealso{\code{\link{SEQINR.UTIL}} }
\examples{
#
# Simple sanity check with all 20 amino-acids in one-letter code alphabetical order:
#
prot <- s2c("ACDEFGHIKLMNPQRSTVWY")
stopifnot(all.equal(computePI(prot), 6.78454))
#
# Read a protein sequence in a FASTA file and then compute its pI :
#
myProts <- read.fasta(file = system.file("sequences/seqAA.fasta",
 package = "seqinr"), seqtype = "AA")
computePI(myProts[[1]]) # Should be 8.534902
}
\keyword{manip}

\name{prochlo}
\alias{prochlo}
\docType{data}
\title{ Zscore on three strains of Prochlorococcus marinus }
\encoding{latin1}
\description{
This dataset contains the zscores computed with the codon model on all
CDS from 3 strains of Procholorococcus marinus (as retrieved from Genome
Reviews database on June 16, 2005)
}
\usage{
data(prochlo)
}
\format{
  List of three dataframes of the zscore of each of the 16 dinucleotides
  on each CDS retrieved from the specific strain.

\describe{
  \item{BX548174}{strain adapted to living at a depth of 5
  meters (high levels of UV exposure)
  \code{base} model on each intergenic sequence}
  \item{AE017126}{strain adapted to living at a depth of 120
  meters (low levels of UV exposure)}
  \item{BX548175}{strain adapted to living at a depth of 135
  meters (low levels of UV exposure)}
}
}
\references{
  Palmeira, L., Guéguen, L. and Lobry JR. (2006) UV-targeted dinucleotides
  are not depleted in light-exposed Prokaryotic genomes.
  \emph{Molecular Biology and Evolution},
  \bold{23}:2214-2219.\cr
  \url{https://academic.oup.com/mbe/article/23/11/2214/1335460}\cr\cr
  
  \code{citation("seqinr")}
}
\seealso{ \code{\link{zscore}} }
\examples{
#
# Show the four YpY for the three ecotypes:
#
data(prochlo)
oneplot <- function(x){
  plot(density(prochlo$BX548174[, x]),
    ylim = c(0,0.4), xlim = c(-4,4), lty=3,
    main = paste(substr(x,1,1), "p", substr(x,2,2), " bias", sep = ""),
    xlab="",ylab="",las=1, type = "n")
  rect(-10,-1,-1.96,10, col = "yellow", border = "yellow")
  rect(1.96,-1,10,10, col = "yellow", border = "yellow")
  lines(density(prochlo$BX548174[, x]),lty=3)
  lines(density(prochlo$AE017126[, x]),lty=2)
  lines(density(prochlo$BX548175[, x]),lty=1)
  abline(v=c(-1.96,1.96),lty=5)
  box()
}
par(mfrow=c(2,2),mar=c(2,3,2,0.5) + 0.1)
oneplot("CT")
oneplot("TC")
oneplot("CC")
oneplot("TT")
#
# Show YpY biases with respect to light exposure
#
curdev <- getOption("device")
OK <- FALSE
devlist <- c("X11", "windows", "quartz") # interactive with width and height in inches
for(i in devlist){
  if(exists(i) && identical(get(i), curdev)){
    OK <- TRUE
    break
  }
}
if(OK){
  curdev(width = 18, height = 11)
  par(oma = c(0, 0, 3, 0), mfrow = c(1, 2), mar = c(5, 4, 0, 0), cex = 1.5)
  example(waterabs, ask = FALSE) #left figure

  par(mar = c(5, 0, 0, 2))
  plot(seq(-5, 3, by = 1), seq(0, 150, length = 9), col = "white", 
    ann = FALSE, axes = FALSE, xaxs = "i", yaxs = "i")
  axis(1, at = c(-1.96, 0, 1.96), labels = c(-1.96, 0, 1.96))
  lines(rep(-1.96, 2),c(0, 150),lty=2)
  lines(rep(1.96, 2), c(0, 150),lty=2)
  title(xlab = "zscore distribution", cex = 1.5, adj = 0.65)

  selcol <- c(6, 8, 14, 16)
  z5 <- prochlo$BX548174[, selcol]
  z120 <- prochlo$AE017126[, selcol]
  z135 <- prochlo$BX548175[, selcol]

  todo <- function(who, xx, col = "black", bottom, loupe){
  	dst <- density(who[, xx])
  	sel <- which(dst$x >= -3)
    	lines(dst$x[sel], dst$y[sel]*loupe + (bottom), col = col)
  }
  todo2 <- function(who, bottom, loupe){
    todo(who, "CC", "blue", bottom, loupe)
    todo(who, "CT", "red", bottom, loupe)
    todo(who, "TC", "green", bottom, loupe)
    todo(who, "TT", "black", bottom, loupe)
  }
  todo3 <- function(bottom, who, leg, loupe = 90){
    lines(c(-5,-3), c(150 - leg, bottom + 20))
    rect(-3,bottom,3,bottom+40)
    text(-2.6,bottom+38, paste(leg, "m"))
    todo2(who, bottom, loupe)
  }

  todo3(bottom = 110, who = z5, leg = 5)
  todo3(bottom = 50, who = z120, leg = 120)
  todo3(bottom = 5, who = z135, leg = 135)

  legend(-4.5,110,c('CpC','CpT','TpC','TpT'),lty=1,pt.cex=cex,
    col=c('blue','red','green','black'))

  mtext(expression(paste("Dinucleotide composition for three ", 
    italic("Prochlorococcus marinus")," ecotypes")), outer = TRUE, cex = 2, line = 1)
  }
}

\name{write.fasta}
\alias{write.fasta}
\title{ Write sequence(s) into a file in fasta format }
\description{
  Writes one or more sequences into a file in FASTA format.
}

\usage{write.fasta(sequences, names, file.out, open = "w", nbchar = 60, as.string = FALSE)}

\arguments{
  \item{sequences}{ A DNA or protein sequence (in the form of a
    vector of single characters by default) or a list of such sequences. }
  \item{as.string}{ FALSE. When set to TRUE sequences are in the
    form of strings instead of vectors of single characters. }
  \item{names}{ The name(s) of the sequences. }
  \item{nbchar}{ The number of characters per line (default: 60) }
  \item{file.out}{ The name of the output file. }
  \item{open}{ Mode to open the output file, use "w" to write into
  a new file, use "a" to append at the end of an already existing file.}
}
\value{
 none.
}
\references{
  \code{citation("seqinr")}
}
\author{A. Necşulea}
\seealso{ \code{\link{read.fasta}} }
\examples{
## Read 3 sequences from a FASTA file:
ortho <- read.fasta(file = system.file("sequences/ortho.fasta", package =
"seqinr"))

## Select only third codon positions:
ortho3 <- lapply(ortho, function(x) x[seq(from = 3, to = length(x), by = 3)])

## Write the 3 modified sequences to a file:
fname <- tempfile(pattern = "ortho3", tmpdir = tempdir(), fileext = "fasta")
#write.fasta(sequences = ortho3, names = names(ortho3), nbchar = 80, file.out = "ortho3.fasta")
write.fasta(sequences = ortho3, names = names(ortho3), nbchar = 80, file.out = fname)

## Read them again from the same file and check that sequences are preserved:
ortho3bis <- read.fasta(fname, set.attributes = FALSE)
stopifnot(identical(ortho3bis, ortho3))
}
\keyword{ utilities }

\name{read.alignment}
\alias{read.alignment}
\title{Read aligned sequence files in mase, clustal, phylip, fasta or msf format}
\description{
 Read a file in \code{mase}, \code{clustal}, \code{phylip}, \code{fasta} or \code{msf} format.
 These formats are used to store nucleotide or protein multiple alignments.
}
\usage{
read.alignment(file, format, forceToLower = TRUE, seqtype = c("DNA", "AA"), 
    oldclustal = FALSE, ...)
}
\arguments{
  \item{file}{the name of the file which the aligned sequences are to be read from.
    If it does not contain an absolute or relative path, the file name is relative
    to the current working directory, \code{\link{getwd}}. }
  \item{format}{a character string specifying the format of the file : \code{mase},
  \code{clustal}, \code{phylip}, \code{fasta} or \code{msf} }
  \item{seqtype}{ the nature of the sequence: \code{DNA} or \code{AA}, defaulting
    to \code{DNA} }
  \item{forceToLower}{a logical defaulting to TRUE stating whether the returned
    characters in a DNA sequence should be in lower case (introduced in seqinR
    release 1.1-3).}
  \item{oldclustal}{a logical defaulting to FALSE wether to use the old C function to read a clustal file (which is faster but stricter concerning sequence line length.) }
  \item{...}{For the \code{fasta} format, extra arguments are passed to the
    \code{\link{read.fasta}} function.}
}
\details{
  \describe{
   \item{"mase"}{The mase format is used to store nucleotide or protein
   multiple alignments. The beginning of the file must contain a header
   containing at least one line (but the content of this header may be
   empty). The header lines must begin by \code{;;}. The body of the
   file has the following structure: First, each entry must begin by
   one (or more) commentary line. Commentary lines begin by the character
   \code{;}. Again, this commentary line may be empty. After the
   commentaries, the name of the sequence is written on a separate
   line. At last, the sequence itself is written on the following lines.
}
   \item{"clustal"}{The CLUSTAL format (*.aln) is the format of the
   ClustalW multialignment tool output. It can be described as follows.
   The word CLUSTAL is on the first line of the file. The alignment
   is displayed in blocks of a fixed length, each line in the block
   corresponding to one sequence. Each line of each block starts with
   the sequence name (maximum of 10 characters), followed by at least
   one space character. The sequence is then displayed in upper or
   lower cases, '-' denotes gaps. The residue number may be displayed
   at the end of the first line of each block.
}
  \item{"msf"}{ MSF is the multiple sequence alignment format of the
  GCG sequence analysis package. It begins with the line (all
  uppercase) !!NA_MULTIPLE_ALIGNMENT 1.0 for nucleic acid sequences
  or !!AA_MULTIPLE_ALIGNMENT 1.0 for amino acid sequences. Do
  not edit or delete the file type if its present.(optional).
  A description line which contains informative text describing what
  is in the file. You can add this information to the top of the MSF
  file using a text editor.(optional) A dividing line which contains
  the number of bases or residues in the sequence, when the file was
  created, and importantly, two dots (..) which act as a divider
  between the descriptive information and the following sequence
  information.(required) msf files contain some other information:
  the Name/Weight, a Separating Line which must include two slashes
  (//) to divide the name/weight information from the sequence
  alignment.(required) and the multiple sequence alignment.
}
   \item{"phylip"}{ PHYLIP is a tree construction program. The format
   is as follows: the number of sequences and their length (in characters)
   is on the first line of the file. The alignment is displayed in an
   interleaved or sequential format. The sequence names are limited
   to 10 characters and may contain blanks.
}
   \item{"fasta"}{ Sequence in fasta format begins with a single-line
   description (distinguished by a greater-than (>) symbol), followed
   by sequence data on the next line.
}
}
}
\value{
 An object of class \code{alignment} which is a list with the following components:
  \item{nb}{ the number of aligned sequences }
  \item{nam}{ a vector of strings containing the names of the aligned sequences }
  \item{seq}{ a vector of strings containing the aligned sequences}
  \item{com}{ a vector of strings containing the commentaries for each sequence or \code{NA} if there are no comments }
}
\references{
\code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{
To read aligned sequences in NEXUS format, see the function
\code{read.nexus} that was available in the \code{CompPairWise} package
(not sure it is still maintained as of 09/09/09).
The NEXUS format was mainly used by the non-GPL commercial PAUP
software.

Related functions: \code{\link{as.matrix.alignment}}, \code{\link{read.fasta}},
\code{\link{write.fasta}}, \code{\link{reverse.align}}, \code{\link{dist.alignment}}.

 }
\examples{
mase.res   <- read.alignment(file = system.file("sequences/test.mase", package = "seqinr"),
 format = "mase")
clustal.res <- read.alignment(file = system.file("sequences/test.aln", package = "seqinr"),
 format="clustal")
phylip.res  <- read.alignment(file = system.file("sequences/test.phylip", package = "seqinr"),
 format = "phylip")
msf.res      <- read.alignment(file = system.file("sequences/test.msf", package = "seqinr"),
 format = "msf")
fasta.res    <- read.alignment(file = system.file("sequences/Anouk.fasta", package = "seqinr"),
 format = "fasta")

#
# Quality control routine sanity checks:
#

data(mase); stopifnot(identical(mase, mase.res))
data(clustal); stopifnot(identical(clustal, clustal.res))
data(phylip); stopifnot(identical(phylip, phylip.res))
data(msf); stopifnot(identical(msf, msf.res))
data(fasta); stopifnot(identical(fasta, fasta.res))

#
# Example of using extra arguments from the read.fasta function, here to keep
# whole headers for sequences names.
#

whole.header.test <-
 read.alignment(file = system.file("sequences/LTPs128_SSU_aligned_First_Two.fasta",
 package = "seqinr"), format = "fasta", whole.header = TRUE)
whole.header.test$nam

# Sould be:
#
# [1] "D50541\t1\t1411\t1411bp\trna\tAbiotrophia defectiva\tAerococcaceae"
# [2] "KP233895\t1\t1520\t1520bp\trna\tAbyssivirga alkaniphila\tLachnospiraceae"
#
}

\name{m16j}
\alias{m16j}
\docType{data}
\title{Fragment of the E. coli chromosome}
\description{
 A fragment of the \emph{E. coli} chromosome that was used in Lobry (1996) to show the
change in GC skew at the origin of replication (\emph{i.e.} the chirochore structure
of bacterial chromosomes)
}
\usage{data(m16j)}
\format{
  A string of 1,616,539 characters
}
\details{
The sequence used in Lobry (1996) was a 1,616,174 bp fragment obtained from the concatenation
of nine overlapping sequences (U18997, U00039, L10328, M87049, L19201, U00006, U14003,
D10483, D26562. Ambiguities have been resolved since then and its was
a chimeric sequence from K-12 strains MG1655 and W3110, the sequence used here is
from strain MG1655 only (Blattner \emph{et al.} 1997).

The chirochore structure of bacterial genomes is illustrated below by a screenshot
of a part of figure 1 from Lobry (1996). See the example section to reproduce this
figure.

\if{html}{\figure{gcskewmbe96.pdf}{options: width=400}}
\if{latex}{\figure{gcskewmbe96.pdf}{options: width=12cm}}


}
\source{
\emph{Escherichia coli} K-12 strain MG1655. Fragment from U00096 from the
EBI Genome Reviews. Acnuc Release 7. Last Updated: Feb 26, 2007.
XX
DT   18-FEB-2004 (Rel. .1, Created)
DT   09-JAN-2007 (Rel. 65, Last updated, Version 70)
XX
}
\references{
Lobry, J.R. (1996) Asymmetric substitution patterns in the two DNA strands of
bacteria. \emph{Molecular Biology and Evolution}, \bold{13}:660-665.\cr

F.R. Blattner, G. Plunkett III, C.A. Bloch, N.T. Perna, V. Burland, M. Rilley,
J. Collado-Vides, J.D. Glasner, C.K. Rode, G.F. Mayhew, J. Gregor,
N.W. Davis, H.A. Kirkpatrick, M.A. Goeden, D.J. Rose, B. Mau, and
Y. Shao. (1997) The complete genome sequence of \emph{Escherichia coli} K-12. 
\emph{Science}, \bold{277}:1453-1462\cr

\code{citation("seqinr")}
}
\examples{
#
# Load data:
#
data(m16j)
#
# Define a function to compute the GC skew:
#
gcskew <- function(x) {
  if (!is.character(x) || length(x) > 1)
  stop("single string expected")
  tmp <- tolower(s2c(x))
  nC <- sum(tmp == "c")
  nG <- sum(tmp == "g")
  if (nC + nG == 0)
  return(NA)
  return(100 * (nC - nG)/(nC + nG))
}
#
# Moving window along the sequence:
#
step <- 10000
wsize <- 10000
starts <- seq(from = 1, to = nchar(m16j), by = step)
starts <- starts[-length(starts)]
n <- length(starts)
result <- numeric(n)
for (i in seq_len(n)) {
  result[i] <- gcskew(substr(m16j, starts[i], starts[i] + wsize - 1))
}
#
# Plot the result:
#
xx <- starts/1000
yy <- result
n <- length(result)
hline <- 0
plot(yy ~ xx, type = "n", axes = FALSE, ann = FALSE, ylim = c(-10, 10))
polygon(c(xx[1], xx, xx[n]), c(min(yy), yy, min(yy)), col = "black", border = NA)
usr <- par("usr")
rect(usr[1], usr[3], usr[2], hline, col = "white", border = NA)
lines(xx, yy)
abline(h = hline)
box()
axis(1, at = seq(0, 1600, by = 200))
axis(2, las = 1)
title(xlab = "position (Kbp)", ylab = "(C-G)/(C+G) [percent]",
 main = expression(paste("GC skew in ", italic(Escherichia~coli))))
arrows(860, 5.5, 720, 0.5, length = 0.1, lwd = 2)
text(860, 5.5, "origin of replication", pos = 4)
}
\keyword{datasets}

\name{cai}
\alias{cai}
\title{Codon Adaptation Index}
\description{
  The Codon Adaptation Index (Sharp and Li 1987) is the most popular
  index of gene expressivity with about 1000 citations 20 years after its
  publication. Its values range from 0 (low) to 1 (high). The implementation
  here is intended to work exactly as in the program \code{codonW} written by
  by John Peden during his PhD thesis under the supervision of P.M. Sharp.
}
\usage{
  cai(seq, w, numcode = 1, zero.threshold = 0.0001, zero.to = 0.01)
}
\arguments{
  \item{seq}{a coding sequence as a vector of single characters}
  \item{w}{a vector for the relative adaptiveness of each codon}
  \item{numcode}{the genetic code number as in \code{\link{translate}}}
  \item{zero.threshold}{a value in \code{w} below this threshold is
                      considered as zero}
  \item{zero.to}{a value considered as zero in \code{w} is forced to
               this value. The default is from Bulmer (1988).}
}
\details{
Adapted from the documentation of the CAI function in the
program \code{codonW} writen by John Peden:
CAI is a measurement
of the relative adaptiveness of the codon usage of a gene towards the
codon usage of highly expressed genes. The relative adaptiveness (w) of
each codon is the ratio of the usage of each codon, to that of the most
abundant codon for the same amino acid. The CAI
index is defined as the geometric mean of these relative adaptiveness
values. Non-synonymous codons and termination codons (genetic code
dependent) are excluded. To aid computation, the CAI is calculated as
using a natural log summation, To prevent a codon having a relative
adaptiveness value of zero, which could result in a CAI of zero;
these codons have fitness of zero (<.0001) are adjusted to 0.01.
}
\value{
  A single numerical value for the CAI.
}
\references{
  Sharp, P.M., Li, W.-H. (1987) The codon adaptation index - a
  measure of directional synonymous codon usage bias, and its
  potential applications.
  \emph{Nucleic Acids Research}, \bold{15}:1281-1295.

  Bulmer, M. (1988).
  Are codon usage patterns in unicellular organisms determined by
  selection-mutation balance.
  \emph{Journal of Evolutionary Biology}, \bold{1}:15-26.

  Peden, J.F. (1999)
  Analysis of codon usage.
  PhD Thesis, University of Nottingham, UK.

  The program \code{codonW} used here for comparison is available at
  \url{https://codonw.sourceforge.net/} under a GPL licence.

  \code{citation("seqinr")}.

}
\seealso{
  \code{\link{caitab}} for some \code{w} values from \code{codonW}.
  \code{\link{uco}} for codon usage tabulation.
}
\author{J.R. Lobry}
\examples{
#
# How to reproduce the results obtained with the C program codonW
# version 1.4.4 writen by John Peden. We use here the "input.dat"
# test file from codonW (Saccharomyces cerevisiae).
#
  inputdatfile <- system.file("sequences/input.dat", package = "seqinr")
  input <- read.fasta(file = inputdatfile) # read the FASTA file
#
# Import results obtained with codonW
#
  scucofile <- system.file("sequences/scuco.txt", package = "seqinr")
  scuco.res <- read.table(scucofile, header = TRUE) # read codonW result file
#
# Use w for Saccharomyces cerevisiae
#
  data(caitab)
  w <- caitab$sc
#
# Compute CAI and compare results:
#
  cai.res <- sapply(input, cai, w = w)
  plot(cai.res, scuco.res$CAI,
    main = "Comparison of seqinR and codonW results",
    xlab = "CAI from seqinR",
    ylab = "CAI from codonW",
    las = 1)
  abline(c(0,1))
}

\name{getliststate}
\alias{getliststate}
\alias{gls}
\alias{gln}
\title{Asks for information about an ACNUC list of specified rank}
\description{
Reply gives the type of list, its name, the number of elements it contains,
and, for sequence lists, says whether the list contains only parent seqs (locus=T).
}
\usage{
getliststate(lrank, socket = autosocket())
gls(lrank, socket = autosocket())
gln(lrank, ...)
}
\arguments{
  \item{lrank}{the name of the ACNUC list to modify}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{...}{arguments passed to getliststate}
}

\value{
NA in case of problem and an warning is issued. When there is no problem
a list with the following 4 components:

  \item{type}{string. Type of ACNUC list (SQ, KW, SP)}
  \item{name}{string. ACNUC list name}
  \item{count}{numeric. Number of elements in ACNUC list}
  \item{locus}{logical. For ACNUC sequence lists TRUE means that the list
         contains only parent sequences. NA otherwise.}

\code{gln} is a shortcut for \code{getliststate(lrank, ...)$name}
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}}, \code{\link{alr}},
\code{\link{glr}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "sp=felis catus et t=cds", virtual=TRUE)
  getliststate(glr("mylist")) # SQ, MYLIST, 603, FALSE
  gln(glr("mylist")) # MYLIST (upper case letters on server)
  closebank()
  }
}
\keyword{ utilities }

\name{rearranged.oriloc}
\alias{rearranged.oriloc}
\title{Detection of replication-associated effects on base composition asymmetry in
  prokaryotic chromosomes.}
\description{
  Detection of replication-associated effects on base composition asymmetry in
  prokaryotic chromosomes.
  }

\usage{
rearranged.oriloc(seq.fasta = system.file("sequences/ct.fasta.gz", package = "seqinr"),
  g2.coord = system.file("sequences/ct.predict", package = "seqinr"))
}

\arguments{
\item{seq.fasta}{The path of the file containing a FASTA-format
  sequence. Default value: 
  the FASTA sequence of the Chlamydia trachomatis chromosome. }
\item{g2.coord}{The path of the file containing the coordinates of the
  protein coding genes found on this chromosome. This file can be
  obtained using the function \code{gbk2g2}. The format of the file is
  similar to the output of the Glimmer2 program. The first column
  contains the index or the name of the gene, the second one contains
  the start position and the third column contains the end position. For
  reverse transcribed genes, the start position is greater than the end position.}
}
\details{
The purpose of this method is to decouple replication-related
and coding sequence-related  effects on base composition asymmetry. In
order to do so, the analyzed chromosome is artificially rearranged to
obtain a perfect gene orientation bias - all forward transcribed genes
on the first half of the chromosome, and all reverse transcribed genes
on the other half.
This rearrangement conserves the relative order of genes within each of
the two groups  - both forward-encoded and reverse-encoded genes are
placed on the rearranged chromosome in increasing order of their
coordinates on the real chromosome.
If the replication mechanism has a significant effect on base
composition asymmetry, this should be seen as a change of slope in the
nucleotide skews computed on the rearranged chromosome; the change of
slope should take place at the origin or the terminus of replication.
Use \code{extract.breakpoints} to detect the position of the changes in
slope on the rearranged nucleotide skews.
}

\value{
  A data.frame with six columns: \code{meancoord.rearr} contains the
  gene index on the rearranged chromosome; \code{gcskew.rearr} contains
  the normalized GC-skew ((G-C)/(G+C)) computed on the third codon positions of
  protein coding genes, still on the rearranged chromosome;  \code{atskew.rearr} contains
  the normalized AT-skew ((A-T)/(A+T)) computed on the third codon positions of
  protein coding genes; \code{strand.rearr} contains the transcription
  strand of the gene (either "forward" or "reverse"); \code{order}
  contains the permutation that was used to obtain a perfect gene
  orientation bias; \code{meancoord.real} contains the mid-coordinate of
  the genes on the real chromosome (before the rearrangement).
}

\references{
  Necşulea, A. and Lobry, J.R. (2007) A New Method for Assessing the 
  Effect of Replication on DNA Base Composition Asymmetry.
  \emph{Molecular Biology and Evolution}, \bold{24}:2169-2179.
}

\author{A. Necşulea}
\seealso{ \code{\link{oriloc}}, \code{\link{draw.rearranged.oriloc}},
  \code{\link{extract.breakpoints}}  }

\examples{

### Example for Chlamydia trachomatis ####

### Rearrange the chromosome and compute the nucleotide skews ###

\dontrun{r.ori <- rearranged.oriloc(seq.fasta = 
   system.file("sequences/ct.fasta.gz", package = "seqinr"),
    g2.coord =  system.file("sequences/ct.predict", package = "seqinr"))}

### Extract the breakpoints for the rearranged nucleotide skews ###



\dontrun{breaks <- extract.breakpoints(r.ori, type = c("gcfw", "gcrev"), 
 nbreaks =c(2, 2), gridsize = 50, it.max = 100)}



### Draw the rearranged nucleotide skews and place the position of the breakpoints ### 
### on the graphics ###

\dontrun{draw.rearranged.oriloc(r.ori, breaks.gcfw = breaks$gcfw$breaks,
 breaks.gcrev = breaks$gcrev$breaks)}


}

\keyword{utilities}

\name{print.qaw}
\alias{print.qaw}
\title{Print method for objects from class qaw}
\description{
 Print the number of elements, their type and the corresponding query.
}
\usage{
\method{print}{qaw}(x, ...)
}
\arguments{
  \item{x}{A objet of class \code{qaw}}
  \item{\dots}{not used}	
}
\value{
 None.
}
\references{ 
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{print}} }
\examples{
\dontrun{ 
  ### Need internet connection
  choosebank("emblTP")
  list1 <- query("sp=felis catus")	
  list1
  # 4732 SQ for sp=felis catus
  }
}

\name{modifylist}
\alias{modifylist}
\title{Modification of an ACNUC list}
\description{
This function modifies a previously existing ACNUC list by selecting sequences
either by length, either by date, either for the presence of a given string in annotations.
}
\usage{
modifylist(listname, modlistname = listname, operation,
 type = c("length", "date", "scan"), socket = autosocket(),
 virtual = FALSE, verbose = FALSE)
}
\arguments{
  \item{listname}{the name of the ACNUC list to modify}
  \item{modlistname}{the name of the modified ACNUC list. Default is to use the
       same list name so that previous list is lost.}
  \item{operation}{a string of character describing the operation to be done, see details.}
  \item{type}{the type of operation, could be one of \code{ "length", "date", "scan"}.
        Default is \code{"length"}}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{virtual}{if TRUE, no attempt is made to retrieve the information about all the elements of the list. In this case, the \code{req} component of the list is set to NA.}
  \item{verbose}{logical, if TRUE mode verbose is on}
}

\details{
Example of possible values for the argument \code{operation}:

  \describe{
  \item{length}{as in  "> 10000"    or    "< 500"}
  \item{date}{as in   "> 1/jul/2001"   or   "< 30/AUG/98"}
  \item{scan}{specify the string to be searched for}
  }
Character < is to be understood as <= and > likewise.
}

\value{
The result is directly assigned to the object \code{modlistname} in the user workspace.
This is an objet of class \code{qaw}, a list with the following 6 components:

  \item{call}{the original call}
  \item{name}{the ACNUC list name}
  \item{nelem}{the number of elements (for instance sequences) in the ACNUC list}
  \item{typelist}{the type of the elements of the list. Could be SQ for a list of
    sequence names, KW for a list of keywords, SP for a list of species names.}
  \item{req}{a list of sequence names that fit the required criteria or \code{NA} when
    called with parameter \code{virtual} is \code{TRUE}}
  \item{socket}{the socket connection that was used}

}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}} and
  \code{\link{prepgetannots}} to select the annotation lines for scan.}
\examples{
\dontrun{ # Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "sp=felis catus et t=cds", virtual=TRUE)
  mylist$nelem # 603 sequences
  stopifnot(mylist$nelem == 603)

  # select sequences with at least 1000 bp:
  mylist <- modifylist("mylist", operation = ">1000", virtual = TRUE)
  mylist$nelem # now, only 132 sequences
  stopifnot(mylist$nelem == 132)

  # scan for "felis" in annotations:
  mylist <- modifylist("mylist", op = "felis", type = "scan", virtual = TRUE)
  mylist$nelem # now, only 33 sequences
  stopifnot(mylist$nelem == 33)

  # modify by date:
  mylist <-  modifylist("mylist", op = "> 1/jul/2001", type = "date", virtual = TRUE)
  mylist$nelem # now, only 15 sequences
  stopifnot(mylist$nelem == 15)

  # Summary of current ACNUC lists, one list called MYLIST on sever:
  sapply(alr()$rank, getliststate)
  closebank()
  }
}
\keyword{ utilities }

\name{gfrag}
\alias{gfrag}
\title{Extract sequence identified by name or by number from an ACNUC server}
\description{
Get \code{length} characters from sequence identified by name or by number
starting from position \code{start} (counted from 1).
}
\usage{
gfrag(what, start, length, idby = c("name", "number"), socket = autosocket())
}
\arguments{
  \item{what}{A sequence name or number}
  \item{start}{Start position from 1}
  \item{length}{Number of requested characters (answer may be shorter)}
  \item{idby}{Is the sequence identified by name or number? Default to name}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}
\value{
A string of characters with at most \code{length} characters (may be
shorter than asked for). NA is returned and a warning is issued in
case of problem (non existent sequence for instance).
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}} }
\examples{
\dontrun{# Need internet connection
  choosebank("emblTP")
  gfrag("LMFLCHR36", start = 1, length = 3529852) -> myseq
  stopifnot(nchar(myseq) == 3529852)
  closebank()
  }
}

\name{s2c}
\alias{s2c}
\title{ conversion of a string into a vector of chars }
\description{
  This is a simple utility function to convert a single string such
  as \code{"BigBang"} into a vector of chars such as
  \code{c("B", "i", "g", "B", "a", "n", "g")}.
}
\usage{
s2c(string)
}
\arguments{
  \item{string}{ a string of chars }
}
\value{
  a vector of chars. If supplied argument is not a single string, a warning is
  issued and NA returned.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{c2s}} }
\examples{
stopifnot(all(s2c("BigBang") == c("B", "i", "g", "B", "a", "n", "g")))
}
\keyword{utilities}

\name{peakabif}
\alias{peakabif}
\title{Extraction of Peak locations, Heights and Surfaces from ABIF data}
\description{
  Simple peak location for data imported with the \code{\link{read.abif}} function
  using cubic spline interpolation.
}
\usage{
peakabif(abifdata, 
  chanel, 
  npeak, 
  thres = 400/yscale, 
  fig = TRUE,
  chanel.names = c(1:4,105),
  DATA = paste("DATA", chanel.names[chanel], sep = "."),
  tmin = 1/tscale,
  tmax = abifdata$Data[["SCAN.1"]]/tscale,
  tscale = 1000, 
  yscale = 1000,
  irange = (tmin*tscale):(tmax*tscale),
  y = abifdata$Data[[DATA]][irange]/yscale,
  method = "monoH.FC",
  maxrfu = 1000,
  ...)
}
\arguments{
  \item{abifdata}{the result returned by \code{\link{read.abif}}}
  \item{chanel}{the dye number}
  \item{npeak}{the expected number of peaks}
  \item{thres}{scaled threshold value}
  \item{fig}{logical: should localized peaks be plotted}
  \item{chanel.names}{numbers extensions used for the DATA}
  \item{DATA}{names of the DATA components}
  \item{tmin}{scaled starting time for the time axis}
  \item{tmax}{scaled ending time for the time axis}
  \item{tscale}{scale factor for the time axis}
  \item{yscale}{scale factor for the y-axis (RFU)}
  \item{irange}{indices of data to be plotted}
  \item{y}{values used for the y-axis}
  \item{method}{method to be used by \code{\link{splinefun}}}
  \item{maxrfu}{argument passed to \code{\link{baselineabif}}}
  \item{...}{arguments forwarded to \code{\link{plot}}}
}
\value{
  Returns invisibly a list with the unscaled values for the locations of peaks,
  heights of peaks and surfaces of peaks and baseline estimate. The peak
  location are in datapoint units, that is an integer starting at 1 for the
  first experimental point, 2 for the second experimental point, etc. 
  However, due to interpolation between points
  the estimated peak location is usually not an integer.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  function \code{\link{read.abif}} to import files in ABIF format, 
  \code{\link{plotabif}} to plot them,
  data \code{\link{gs500liz}} for internal size standards,
  data \code{\link{identifiler}} for allele names in the allelic ladder,
  data \code{\link{JLO}} for an example of an individual sample file,
  data \code{\link{ECH}} for an example of an allelic lader.
}
\examples{
data(JLO)
JLO.maxis <- peakabif(JLO, 5, npeak = 14, tmin = 2.7, thres = 0.1)$maxis
}

\name{chargaff}
\alias{chargaff}
\docType{data}
\title{Base composition in ssDNA for 7 bacterial DNA}
\description{
Long before the genomic era, it was possible to get some data
for the global composition of single-stranded DNA chromosomes
by direct chemical analyses. These data are from Chargaff's lab
and give the base composition of the L (Ligth) strand for
7 bacterial chromosomes.
}
\usage{data(chargaff)}
\format{
  A data frame with 7 observations on the following 4 variables.
  \describe{
    \item{[A]}{frequencies of A bases in percent}
    \item{[G]}{frequencies of G bases in percent}
    \item{[C]}{frequencies of C bases in percent}
    \item{[T]}{frequencies of T bases in percent}
  }
}
\details{
Data are from Table 2 in Rudner \emph{et al.} (1969) for the
L-strand. Data for \emph{Bacillus subtilis} were taken from
a previous paper: Rudner \emph{et al.} (1968). This is in
fact the average value observed for two different strains
of \emph{B. subtilis}: strain W23 and strain Mu8u5u16.\cr
Denaturated chromosomes can be separated by a technique of
intermitent gradient elution from a column of methylated
albumin kieselguhr (MAK), into two fractions, designated,
by virtue of their buoyant densities, as L (light) and H
(heavy). The fractions can be hydrolyzed and subjected to
chromatography to determined their global base composition.\cr
The surprising result is that we have almost exactly A=T
and C=G in single stranded-DNAs. The second paragraph page
157 in Rudner \emph{et al.} (1969) says: "Our previous
work on the complementary strands of \emph{B. subtilis} DNA
suggested an additional, entirely unexpected regularity,
namely, the equality in either strand of 6-amino and 6-keto
nucleotides ( A + C = G + T). This relationship, which
would normally have been regarded merely as the consequence
of base-pairing in DNA duplex and would not have been predicted
as a likely property of a single strand, is shown here to
apply to all strand specimens isolated from denaturated DNA
of the AT type (Table 2, preps. 1-4). It cannot yet be said
to be established for the DNA specimens from the equimolar
and GC types (nos. 5-7)."

Try \code{example(chargaff)} to mimic figure page 17 in Lobry
(2000) :

\if{html}{\figure{chargaff.png}{options: width=400}}
\if{latex}{\figure{chargaff.png}{options: width=12cm}}


Note that \code{example(chargaff)} gives more details:
the red areas correspond to non-allowed values beause the sum
of the four bases frequencies cannot exceed 100\%.
The white areas correspond to possible values (more exactly
to the projection from \code{R^4} to the corresponding \code{R^2} planes
of the region of allowed values).
The blue lines correspond to the very small subset of allowed
values for which we have in addition PR2 state, that is
\code{[A]=[T]} and \code{[C]=[G]}. Remember, these data are for ssDNA!
}

\source{
Rudner, R., Karkas, J.D., Chargaff, E. (1968) Separation of
\emph{B. subtilis} DNA into complementary strands, III. Direct
Analysis. \emph{Proceedings of the National Academy of Sciences of the United States of America}, \bold{60}:921-922.\cr
Rudner, R., Karkas, J.D., Chargaff, E. (1969) Separation of microbial deoxyribonucleic acids into complementary strands. \emph{Proceedings of the National Academy of Sciences of the United States of America}, \bold{63}:152-159.\cr

}
\references{
Lobry, J.R. (2000) The black hole of symmetric molecular evolution. Habilitation thesis, Université Claude Bernard - Lyon 1. \url{https://pbil.univ-lyon1.fr/members/lobry/articles/HDR.pdf}.

\code{citation("seqinr")}
}

\examples{
data(chargaff)
op <- par(no.readonly = TRUE)
par(mfrow = c(4,4), mai = rep(0,4), xaxs = "i", yaxs = "i")
xlim <- ylim <- c(0, 100)

for( i in 1:4 )
{
  for( j in 1:4 )
  {
    if( i == j )
    {
      plot(chargaff[,i], chargaff[,j],t = "n", xlim = xlim, ylim = ylim,
      xlab = "", ylab = "", xaxt = "n", yaxt = "n")
      polygon(x = c(0, 0, 100, 100), y = c(0, 100, 100, 0), col = "lightgrey")
      for( k in seq(from = 0, to = 100, by = 10) )
      {
        lseg <- 3
        segments(k, 0, k, lseg)
        segments(k, 100 - lseg, k, 100)
        segments(0, k, lseg, k)
        segments(100 - lseg, k, 100, k)
      }
      string <- paste(names(chargaff)[i],"\n\n",xlim[1],"\% -",xlim[2],"\%")
      text(x=mean(xlim),y=mean(ylim), string, cex = 1.5)
    }
    else
    {
      plot(chargaff[,i], chargaff[,j], pch = 1, xlim = xlim, ylim = ylim,
      xlab = "", ylab = "", xaxt = "n", yaxt = "n", cex = 2)
      iname <- names(chargaff)[i]
      jname <- names(chargaff)[j]
      direct <- function() segments(0, 0, 50, 50, col="blue")
      invers <- function() segments(0, 50, 50, 0, col="blue")
      PR2 <- function()
      {
        if( iname == "[A]" & jname == "[T]" ) { direct(); return() }
        if( iname == "[T]" & jname == "[A]" ) { direct(); return() }
        if( iname == "[C]" & jname == "[G]" ) { direct(); return() }
        if( iname == "[G]" & jname == "[C]" ) { direct(); return() }
        invers()
      }
      PR2()
      polygon(x = c(0, 100, 100), y = c(100, 100, 0), col = "pink4")
      polygon(x = c(0, 0, 100), y = c(0, 100, 0))
    }
  }
}
# Clean up
par(op)
}
\keyword{datasets}

\name{toycodon}
\alias{toycodon}
\docType{data}
\title{A toy example of codon counts in three coding sequences}
\description{
This is a toy data set to illustrate synonymous and non-synonymous codon usage analyses.
}
\usage{data(toyaa)}
\format{
  A data frame with 3 observations (coding sequences) for 10 codons.}
\source{
Created for release 1.0-4 of seqinr's vignette.
}
\references{
  \code{citation("seqinr")}
}
\examples{
data(toycodon)
}
\keyword{datasets}

\name{alllistranks}
\alias{alllistranks}
\alias{alr}
\title{To get the count of existing lists and all their ranks on server}
\description{
This is a low level function to get the total number of list and all their
ranks in an opened database.
}

\usage{
alllistranks(socket = autosocket(), verbose = FALSE)
alr(socket = autosocket(), verbose = FALSE)
}

\arguments{
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{verbose}{if \code{TRUE}, verbose mode is on}
}

\details{
  This low level function is usually not used directly by the user.
}

\value{
  A list with two components:
  \item{count}{count of existing lists}	
  \item{rank}{their rank}
}
\references{ 
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  \code{\link{choosebank}}, 
  \code{\link{query}}
}

\examples{
 \dontrun{# Need internet connection
 choosebank("emblTP")
 tmp1 <- query("tmp1", "sp=Borrelia burgdorferi", virtual = TRUE)
 tmp2 <- query("tmp2", "sp=Borrelia burgdorferi", virtual = TRUE)
 tmp3 <- query("tmp3", "sp=Borrelia burgdorferi", virtual = TRUE)
 (result <- alllistranks())
 stopifnot(result$count == 3)   # Three ACNUC lists
 stopifnot(result$ranks == 2:4) # Starting at rank 2
 #
 # Summay of current lists defined on the ACNUC server:
 #
 sapply(result$ranks, getliststate)
 closebank()
 }
}
\keyword{utilities}

\name{get.db.growth}
\alias{get.db.growth}
\alias{dia.db.growth}
\title{ Get the exponential growth of nucleic acid database content }
\description{
  Connects to the embl database to read the last release note about
the number of nucleotides in the DDBJ/EMBL/Genbank database content.
A log-linear fit is represented by dia.bd.gowth() with an estimate of
the doubling time in months.
}
\usage{
get.db.growth(
where = "ftp://ftp.ebi.ac.uk/pub/databases/embl/doc/relnotes.txt")
dia.db.growth( get.db.growth.out = get.db.growth(), Moore = TRUE, ... )
}
\arguments{
  \item{where}{ the file containig the database growth table.}
  \item{get.db.growth.out}{ the output from get.db.growth() }
  \item{Moore}{ logical, if TRUE add lines corresponding to an
exponential growth rate with a doubling time of 18 months, that
is Moore's law.}
  \item{...}{further arguments to plot}
}
\value{
  A dataframe with the statistics from the embl site.
}

\details{
This is a screenshot from fig. 1 in Lobry (2004):

\if{html}{\figure{lncs2004.pdf}{options: width=400}}
\if{latex}{\figure{lncs2004.pdf}{options: width=12cm}}

At that time the doubling time was 16.9 months. This is an
update in 2016 from release 3.1-5 of the seqinr tutorial
\url{https://seqinr.r-forge.r-project.org/seqinr_3_1-5.pdf}:

\if{html}{\figure{introduction-dbg.pdf}{options: width=400}}
\if{latex}{\figure{introduction-dbg.pdf}{options: width=12cm}}

The doubling time was 18.8 monts in this update. The fit to
Moore's law is still striking over such a long period.

}
\references{
\url{https://www.ebi.ac.uk/ena/browser/}

Lobry, J.R. (2004) Life History Traits and Genome Structure:
Aerobiosis and G+C Content in Bacteria. \emph{Lectures Notes in Computer Sciences},
\bold{3039}:679-686.

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\examples{
\dontrun{
  ### Need internet connection
  data <- get.db.growth()
  dia.db.growth(data)
}}
\keyword{utilities}

\name{recstat}
\alias{recstat}
\title{Prediction of Coding DNA Sequences.}
\description{This function aims at predicting the position of Coding DNA Sequences (CDS) through
the use of a Correspondence Analysis (CA) computed on codon composition, this for the three
reading frames of a DNA strand.
}
\usage{recstat(seq, sizewin = 90, shift = 30, seqname = "no name")}
\arguments{
    \item{seq}{a nucleic acid sequence as a vector of characters}
    \item{sizewin}{an integer, multiple of 3,  giving the length of the sliding window}
    \item{shift}{an integer, multiple of 3, giving the length of the steps between two windows}
    \item{seqname}{the name of the sequence}
}
\details{The method is built on the hypothesis that the codon composition of a CDS is biased
while it is not the case outside these regions. In order to detect such bias, a CA on codon
frequencies is computed on the six possible reading frames of a DNA sequence (three from the
direct strand and three from the reverse strand). When there is a CDS in one of the reading
frame, it is expected that the CA factor scores observed in this frame (fot both rows and
columns) will be significantly different from those in the two others.}
\value{This function returns a list containing the following components:\cr
    \item{seq}{a single DNA sequence as a vector of characters}
    \item{sizewin}{length of the sliding window}
    \item{shift}{length of the steps between windows}
    \item{seqsize}{length of the sequence}
    \item{seqname}{name of the sequence}
    \item{vdep}{a vector containing the positions of windows starts}
    \item{vind}{a vector containing the reading frame of each window}
    \item{vstopd}{a vector of stop codons positions in direct strand}
    \item{vstopr}{a vector of stop codons positions in reverse strand}
    \item{vinitd}{a vector of start codons positions in direct strand}
    \item{vinitr}{a vector of start codons positions in reverse strand}
    \item{resd}{a matrix containing codons frequencies for all the windows in the three frames
        of the direct strand}
    \item{resr}{a matrix containing codons frequencies for all the windows in the three frames
        of the reverse strand}
    \item{resd.coa}{list of class \code{coa} and \code{dudi} containing the result of the
        CA computed on the codons frequencies in the direct strand}
    \item{resr.coa}{list of class \code{coa} and \code{dudi} containing the result of the
        CA computed on the codons frequencies in the reverse strand}
}
\note{This method works only with DNA sequences long enough to obtain a sufficient number
of windows. As the optimal windows length has been estimated to be 90 bp by Fichant and
Gautier (1987), the minimal sequence length is around 500 bp. The method can be used on
prokaryotic and eukaryotic sequences. Also, only the four first factors of the CA are kept.
Indeed, most of the time, only the first factor is relevant in order to detect CDS.
}
\author{O. Clerc, G. Perrière}
\references{The original paper describing recstat is:\cr

Fichant, G., Gautier, C. (1987) Statistical method for predicting protein coding
regions in nucleic acid sequences. \emph{Comput. Appl. Biosci.}, \bold{3}, 287--295.\cr
\url{http://bioinformatics.oxfordjournals.org/content/3/4/287.abstract}\cr
}
\seealso{\code{\link{draw.recstat}}, \code{\link{test.li.recstat}}, \code{\link{test.co.recstat}}}
\examples{
ff <- system.file("sequences/ECOUNC.fsa", package = "seqinr")
seq <- read.fasta(ff)
rec <- recstat(seq[[1]], seqname = getName(seq))
}
\keyword{correspondence analysis}
\keyword{sequence}

\name{dotPlot}
\alias{dotPlot}
\title{ Dot Plot Comparison of two sequences }
\description{
  Dot plots are most likely the oldest visual representation used to compare 
  two sequences (see Maizel and Lenk 1981 and references therein). In its
  simplest form, a dot is produced at position (i,j) iff character number
  i in the first sequence is the same as character number j in the
  second sequence. More eleborated forms use sliding windows and a threshold
  value for two windows to be considered as matched.
}
\usage{
dotPlot(seq1, seq2, wsize = 1, wstep = 1, nmatch = 1, shift = 0,
col = c("white", "black"), xlab = deparse(substitute(seq1)),
ylab = deparse(substitute(seq2)), ...)
}
\arguments{
  \item{seq1}{ the first sequence (x-axis) as a vector of single chars.}
  \item{seq2}{ the second sequence (y-axis) as a vector of single char.}
  \item{wsize}{ the size in chars of the moving window.}
  \item{wstep}{ the size in chars for the steps of the moving window.
    Use \code{wstep == wsize} for non-overlapping windows.}
  \item{nmatch}{ if the number of match per window is greater than or equal
    to \code{nmatch} then a dot is produced.}
  \item{shift}{ the number of chars to shift in seq2 when generating the moving window.}   
  \item{col}{ color of points passed to \code{image}.}
  \item{xlab}{ label of x-axis passed to \code{image}.}
  \item{ylab}{ label of y-axis passed to \code{image}.}
  \item{...}{ further arguments passed to \code{image}.}
}

\value{
  NULL. 
}
\references{
Maizel, J.V. and Lenk, R.P. (1981) Enhanced Graphic Matrix Analysis of 
Nucleic Acid and Protein Sequences. 
\emph{Proceedings of the National Academy of Science USA},
\bold{78}:7665-7669.\cr

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{image}} }
\examples{
#
# Identity is on the main diagonal:
#
dotPlot(letters, letters, main = "Direct repeat")
#
# Internal repeats are off the main diagonal:
#
dotPlot(rep(letters, 2), rep(letters, 2), main = "Internal repeats")
#
# Inversions are orthogonal to the main diagonal:
#
dotPlot(letters, rev(letters), main = "Inversion")
#
# Insertion in the second sequence yields a vertical jump:
#
dotPlot(letters, c(letters[1:10], s2c("insertion"), letters[11:26]), 
  main = "Insertion in the second sequence", asp = 1)
#
# Insertion in the first sequence yields an horizontal jump:
#
dotPlot(c(letters[1:10], s2c("insertion"), letters[11:26]), letters,
  main = "Insertion in the first sequence", asp = 1)
#
# Protein sequences have usually a good signal/noise ratio because there
# are 20 possible amino-acids:
#
aafile <- system.file("sequences/seqAA.fasta", package = "seqinr")
protein <- read.fasta(aafile)[[1]]
dotPlot(protein, protein, main = "Dot plot of a protein\nwsize = 1, wstep = 1, nmatch = 1")
#
# Nucleic acid sequences have usually a poor signal/noise ratio because
# there are only 4 different bases:
#
dnafile <- system.file("sequences/malM.fasta", package = "seqinr")
dna <- protein <- read.fasta(dnafile)[[1]]
dotPlot(dna[1:200], dna[1:200],
 main = "Dot plot of a nucleic acid sequence\nwsize = 1, wstep = 1, nmatch = 1")
#
# Play with the wsize, wstep and nmatch arguments to increase the 
# signal/noise ratio:
#
dotPlot(dna[1:200], dna[1:200], wsize = 3, wstep = 3, nmatch = 3,
main = "Dot plot of a nucleic acid sequence\nwsize = 3, wstep = 3, nmatch = 3")
}
\keyword{ utilities }

\name{getLength}
\alias{getLength}
\alias{getLength.default}
\alias{getLength.list}
\alias{getLength.character}
\alias{getLength.SeqFrag}
\alias{getLength.SeqAcnucWeb}
\alias{getLength.SeqFastadna}
\alias{getLength.SeqFastaAA}
\alias{getLength.qaw}
\alias{getLength.logical}

\title{Generic function to get the length of sequences}
\description{
getLength returns the total number of bases or amino-acids in a sequence.
}
\usage{
getLength(object, ...)
}
\arguments{
  \item{object}{ an object of the class \code{\link{SeqAcnucWeb}}
    or \code{\link{SeqFastadna}}, or \code{\link{SeqFastaAA}} or \code{\link{SeqFrag}} or a list of these objects }
  \item{...}{further arguments passed to or from other methods}
}
\value{
  \code{getLength} returns a numeric vector giving the length of the
    sequences.}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira} 
\seealso{
  \code{\link{SeqAcnucWeb}}, \code{\link{SeqFastadna}}, 
  \code{\link{SeqFastaAA}}, \code{\link{SeqFrag}}
}
\examples{
#
# List all available methods for getLength generic function:
#
   methods(getLength)
#
# Example with seven DNA sequences from a FASTA file:
#
  ff <- system.file("sequences/someORF.fsa", package = "seqinr")
  fs <- read.fasta(file = ff)
  stopifnot(all(getLength(fs) == c(5573, 5825, 2987, 3929, 2648, 2597, 2780)))
#
# Example with 49 sequences from an ACNUC server:
#
  \dontrun{
  # Need internet connection
  choosebank("emblTP")
  fc <- query("fc", "sp=felis catus et t=cds et o=mitochondrion")
  getLength(fc)
  closebank()  
}
}
\keyword{ utilities }

\name{dinucleotides}
\alias{rho}
\alias{zscore}
\title{Statistical over- and under- representation of dinucleotides in a
  sequence}
\encoding{UTF-8}
\description{
  These two functions compute two different types of statistics for the
  measure of statistical dinculeotide over- and under-representation :
  the rho statistic, and the z-score, each computed for all 16 dinucleotides.
}
\usage{
rho(sequence, wordsize = 2, alphabet = s2c("acgt"))
zscore(sequence, simulations = NULL, modele, exact = FALSE, alphabet = s2c("acgt"), ... )
}
\arguments{
  \item{sequence}{a vector of single characters.}
  \item{wordsize}{an integer giving the size of word (n-mer) to consider.}
  \item{simulations}{ If \code{NULL}, analytical solution is computed
    when available (models \code{base} and \code{codon}). Otherwise, it
    should be the number of permutations for the z-score computation }
  \item{modele}{ A string of characters describing the model chosen for
    the random generation }
  \item{exact}{ Whether exact analytical calculation or an
  approximation should be used }
  \item{alphabet}{ A vector of single characters. }
  \item{...}{ Optional parameters for specific model permutations are
    passed on to \code{\link{permutation}} function. }
}
\details{
  The \code{rho} statistic, as presented in Karlin S., Cardon LR. (1994), can
  be computed on each of the 16 dinucleotides. It is the frequence of
  dinucleotide \emph{xy} divided by the product of frequencies of
  nucleotide \emph{x} and nucleotide \emph{y}. It is equal to 1.00 when
  dinucleotide \emph{xy} is formed by pure chance, and it is superior
  (respectively inferior) to 1.00 when dinucleotide \emph{xy} is over-
  (respectively under-) represented. Note that if you want to reproduce
  Karlin's results you have to compute the statistic from the sequence 
  concatenated with its inverted complement that is with something 
  like \code{rho(c(myseq, rev(comp(myseq))))}.

  The \code{zscore} statistic, as presented in Palmeira, L., Guéguen, L.
  and Lobry JR. (2006). The statistic is the normalization of the
  \code{rho} statistic by its expectation and variance according to a
  given random sequence generation model, and follows the
  standard normal distribution. This statistic can be computed
  with several models (cf. \code{\link{permutation}} for the description
  of each of the models). We provide analytical calculus for two of
  them: the \code{base} permutations model and the  \code{codon}
  permutations model.
  
  The \code{base} model allows for random sequence generation by
  shuffling (with/without replacement) of all bases in the sequence.
  Analytical computations are available for this model: either as an 
  approximation for large sequences (cf. Palmeira, L., Guéguen, L.
  and Lobry JR. (2006)), either as the exact analytical formulae
  (cf. Schbath, S. (1995)).

  The \code{position} model allows for random sequence generation
  by shuffling (with/without replacement) of bases within their
  position in the codon (bases in position I, II or III stay in
  position I, II or III in the new sequence.

  The \code{codon} model allows for random sequence generation by
  shuffling (with/without replacement) of codons. Analytical
  computation is available for this model (Gautier, C., Gouy, M. and
  Louail, S. (1985)).

  The \code{syncodon} model allows for random sequence generation
  by shuffling (with/without replacement) of synonymous codons.
}
\value{
  a table containing the computed statistic for each dinucleotide
}
\references{
  Gautier, C., Gouy, M. and Louail, S. (1985) Non-parametric statistics
  for nucleic acid sequence study. \emph{Biochimie}, \bold{67}:449-453.
  
  Karlin S. and Cardon LR. (1994) Computational DNA sequence analysis.
  \emph{Annu Rev Microbiol}, \bold{48}:619-654.

  Schbath, S. (1995) Étude asymptotique du nombre d'occurrences d'un
  mot dans une chaîne de Markov et application à la recherche de mots
  de fréquence exceptionnelle dans les séquences d'ADN.
  \emph{Thèse de l'Université René Descartes, Paris V}

  Palmeira, L., Guéguen, L. and Lobry, J.R. (2006) UV-targeted dinucleotides
  are not depleted in light-exposed Prokaryotic genomes.
  \emph{Molecular Biology and Evolution},
  \bold{23}:2214-2219.
  \url{https://academic.oup.com/mbe/article/23/11/2214/1335460}

  \code{citation("seqinr")}
}
\author{L. Palmeira, J.R. Lobry with suggestions from A. Coghlan.}
\seealso{ \code{\link{permutation}} }
\examples{
\dontrun{
sequence <- sample(x = s2c("acgt"), size = 6000, replace = TRUE)
rho(sequence)
zscore(sequence, modele = "base")
zscore(sequence, modele = "base", exact = TRUE)
zscore(sequence, modele = "codon")
zscore(sequence, simulations = 1000, modele = "syncodon")
}
}

\name{rot13}
\alias{rot13}
\title{Ergheaf gur EBG-13 pvcurevat bs n fgevat}
\description{
    rot13 applied to the above title returns the string
    "Returns the ROT-13 ciphering of a string".
}
\usage{
rot13(string)
}
\arguments{
  \item{string}{a string of characters.}
}
\value{
  a string of characters.
}
\author{J.R. Lobry}
\references{
  \code{citation("seqinr")}
}
\seealso{\code{\link{chartr}}
}
\examples{
##
## Simple ciphering of a string:
##

message <- "Hello, world!"
rot13(message) # "Uryyb, jbeyq!"

##
## Routine sanity check:
##

stopifnot(identical(rot13(rot13(message)), message))
}
\keyword{ manip }

\name{print.SeqAcnucWeb}
\alias{print.SeqAcnucWeb}
\title{Print method for objects from class SeqAcnucWeb}
\description{
 Print the name, length, frame and genetic code number.
}
\usage{
\method{print}{SeqAcnucWeb}(x, ...)
}
\arguments{
  \item{x}{A sequence of class \code{SeqAcnucWeb}}
  \item{\dots}{Arguments passed to \code{print}}
}
\value{
 None.
}
\references{
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{print}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "sp=felis catus")
  mylist$req[[1]]
  #      name   length    frame   ncbigc 
  # "A06937"     "34"      "0"      "1"
  }
}
\keyword{ manip }

\name{as.alignment}
\alias{as.alignment}
\title{Constructor for class alignment}
\description{
Returns an object of (S3) class alignment. 
}
\usage{
as.alignment(nb = NULL, nam = NULL, seq = NULL, com = NULL)
}
\arguments{
  \item{nb}{integer. The number of sequences in the alignment.}
  \item{nam}{vector of \code{nb} character strings. The sequence names. }
  \item{seq}{vector of \code{nb} character strings. The aligned sequences.}
  \item{com}{vector of \code{nb} character strings. The comments about sequences.}
}

\value{
 An object of class \code{alignment} which is a list with the following components:
  \item{nb}{ the number of aligned sequences }
  \item{nam}{ a vector of strings containing the names of the aligned sequences } 
  \item{seq}{ a vector of strings containing the aligned sequences} 
  \item{com}{ a vector of strings containing the commentaries for each sequence or \code{NA} if there are no comments }
}
\references{ 
\code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{
\code{\link{read.alignment}},
\code{\link{as.matrix.alignment}}, \code{\link{read.fasta}}, 
\code{\link{write.fasta}}, \code{\link{reverse.align}}, \code{\link{dist.alignment}}.

 }
\examples{
as.alignment(nb = 2, nam = c("one", "two"), 
  seq = c("-ACGT", "GACG-"), com = c("un", "deux"))
}

\name{consensus}
\alias{consensus}
\alias{con}
\title{Consensus and profiles for sequence alignments}
\description{
  This function returns a consensus using variuous methods (see details)
  or a profile from a sequence alignment.
}
\usage{
consensus(matali, method = c( "majority", "threshold", "IUPAC", "profile"),
  threshold = 0.60, warn.non.IUPAC = FALSE, threshold.IUPAC = FALSE,
  type = c("DNA", "RNA"))
con(matali, method = c( "majority", "threshold", "IUPAC", "profile"),
  threshold = 0.60, warn.non.IUPAC = FALSE, threshold.IUPAC = FALSE,
  type = c("DNA", "RNA"))
}
\arguments{
  \item{matali}{an object of class \code{alignment} as returned by
    \code{\link{read.alignment}}, or a matrix of characters.}
  \item{method}{select the method to use, see details.}
  \item{threshold}{for the \code{threshold} method, a numeric value beteen 0 and 1
    indicating the minimum relative frequency for a character to be returned
    as the consensus character. If none, NA is returned.}
  \item{warn.non.IUPAC}{for the \code{IUPAC} method this argument is passed
   to \code{\link{bma}} with a default value set to FALSE to avoid warnings due
   to gap characters in the alignment.}
   \item{threshold.IUPAC}{with the \code{threshold} method, if set to TRUE
   display the IUPAC code instead NA when the frequency of the most frequent
   character is lower than the threshold.}
  \item{type}{for the \code{IUPAC} method this argument is passed
   to \code{\link{bma}}.}
}
\details{
  \describe{
  \item{"majority"}{The character with the higher frequency is returned as the
  consensus character.}

  \item{"threshold"}{As above but in addition the character relative frequency
  must be higher than the value controled by the \code{threshold} argument.
  If none, NA is returned if threshold.IUPAC is set to FALSE and the IUPAC code
  otherwise.}

  \item{"IUPAC"}{Make sense only for nucleic acid sequences (DNA or RNA).
  The consensus character is defined if possible by an IUPAC symbol by
  function \code{\link{bma}}. If this is not possible, when there is a gap
  character for instance, NA is returned.}

  \item{"profile"}{With this method a matrix with the count of each possible
  character at each position is returned.}
  }
\code{con} is a short form for \code{consensus}.

}
\value{
  Either a vector of single characters with possible NA or a matrix with
  the method \code{profile}.
}
\references{
\code{citation("seqinr")}
}
\author{J.R. Lobry}

\seealso{See \code{\link{read.alignment}} to import alignment from files.}

\examples{
#
# Read 5 aligned DNA sequences at 42 sites:
#
  phylip <- read.alignment(file = system.file("sequences/test.phylip",
    package = "seqinr"), format = "phylip")
#
# Show data in a matrix form:
#
  (matali <- as.matrix(phylip))
#
# With the majority rule:
#
  res <- consensus(phylip)
  stopifnot(c2s(res) == "aaaccctggccgttcagggtaaaccgtggccgggcagggtat")
#
# With a threshold:
#
  res.thr <- consensus(phylip, method = "threshold")
  res.thr[is.na(res.thr)] <- "." # change NA into dots
# stopifnot(c2s(res.thr) == "aa.c..t.gc.gtt..g..t.a.cc..ggccg.......ta.")
  stopifnot(c2s(res.thr) == "aa.cc.tggccgttcagggtaaacc.tggccgg.cagggtat")
#
# With a threshold and threshold.IUPAC set to TRUE:
#
  res.thr <- consensus(phylip, method = "threshold",threshold.IUPAC =TRUE )
  stopifnot(c2s(res.thr) == "aavccntggccgttcagggtaaaccntggccggdcagggtat")
#

# With an IUPAC summary:
#
  res.iup <- consensus(phylip, method = "IUPAC")
  stopifnot(c2s(res.iup) == "amvsbnkkgcmkkkmmgsktrmrssndkgcmrkdmmvskyaw")
  # replace 3 and 4-fold symbols by dots:
  res.iup[match(res.iup, s2c("bdhvn"), nomatch = 0) > 0] <- "."
  stopifnot(c2s(res.iup) == "am.s..kkgcmkkkmmgsktrmrss..kgcmrk.mm.skyaw")
#
# With a profile method:
#
  (res <- consensus(phylip, method = "profile"))
#
# Show the connection between the profile and some consensus:
#
  bxc <- barplot(res, col = c("green", "blue", "orange", "white", "red"), border = NA,
  space = 0, las = 2, ylab = "Base count",
  main = "Profile of a DNA sequence alignment",
  xlab = "sequence position", xaxs = "i")

  text(x = bxc, y = par("usr")[4],lab = res.thr, pos = 3, xpd = NA)
  text(x = bxc, y = par("usr")[1],lab = res.iup, pos = 1, xpd = NA)
}

\name{isenum}
\alias{isenum}
\alias{isn}
\alias{getNumber.socket}
\alias{getAttributsocket}
\title{Get the ACNUC number of a sequence from its name or accession number}
\description{
Gives the ACNUC number of a sequence in the \code{number} element of the returned list.
More informations are returned for subsequences corresponding to coding sequences.
}
\usage{
isenum(what, idby = c("name", "access"), socket = autosocket())
isn(what, ...)
getNumber.socket(socket, name)
getAttributsocket(socket, name)
}
\arguments{
  \item{what}{a sequence name or a sequence accession number}
  \item{idby}{is the sequence identified by name or by accession number? Default to name}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{...}{arguments passed to \code{isenum}.}
  \item{name}{a sequence name.}
}
\value{
A list whith the following 6 components:

  \item{number}{numeric. The ACNUC number of the sequence.}
  \item{length}{numeric. The length of the sequence.}
  \item{frame}{numeric. The reading frame (0, 1, or 2) of the sequence for CDS.}
  \item{gencode}{numeric. ACNUC's genetic code (0 means universal) of the sequence for CDS.}
  \item{ncbigc}{numeric. NCBI's genetic code (0 means universal) of the sequence for CDS.}
  \item{otheraccessmatches}{logical. If TRUE it means that several sequences are attached
    to the given accession nunmber, and that only the ACNUC number of the first attached
   sequence is returned in the \code{number} component of the list.}

\code{isn(what, ...)} is a shortcut for \code{isenum(what, ...)$number}.\cr

As from seqinR 1.1-3 \code{getNumber.socket} and
\code{getAttributsocket} are deprecated (a warning is issued).
}


\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  isenum("LMFLCHR36")
  isn("LMFLCHR36")
  stopifnot(isn("LMFLCHR36") == 13682678)
  # Example with CDS:
  isenum("AB004237")
  }
}
\keyword{ utilities }

\name{readBins}
\alias{readBins}
\title{Import GenMapper Bins configuration file}
\description{
In a Bins configuration file there is a description for a given identification
kit of the expected allele sizes for all the markers available in the kit.
}
\usage{
readBins(file, 
  colnames = c("allele.name", "size.bp", "minus.bp", "plus.bp"))}
\arguments{
  \item{file}{The name of the Bins configuration file.}
  \item{colnames}{The names to be used for the columns of the data.frames.}
}
\value{
A list whose first element is the file header info and following elements
are lists, one for each kit encountered in the file. For each kit we have
a list of data.frames, one per marker.
}
\details{
The expected allele sizes are typically plus or minus 0.5 bp.
}
\references{ 
\code{citation("seqinR")}
}
\author{J.R. Lobry}
\seealso{\code{\link{readPanels}}.}
\examples{
#
# Check that we can read the 2 exemple files in the seqinR package:
#
path1 <- system.file("abif/AmpFLSTR_Bins_v1.txt", package = "seqinr")
resbin1 <- readBins(path1)
path2 <- system.file("abif/Promega_Bins_v1.txt", package = "seqinr")
resbin2 <- readBins(path2)
#
# Show the kits described in resbin1:
#
names(resbin1)
#
# Show the markers in a given kit:
#
names(resbin1[["Identifiler_v1"]])
#
# Show alleles expected sizes for a given marker:
#
resbin1[["Identifiler_v1"]][["D8S1179"]]
#
# Simple quality check since seqinr 2.0-4 with a configuration file
# containing trailling tabulations:
#
path3 <- system.file("abif/Prototype_PowerPlex_EP01_Bins.txt", package = "seqinr")
resbin3 <- readBins(path3)
ncols <- sapply(resbin3[[2]], ncol)
stopifnot(all(ncols == 4))
}

\name{draw.rearranged.oriloc}
\alias{draw.rearranged.oriloc}
\title{Graphical representation for rearranged nucleotide skews in
  prokaryotic chromosomes.}
\description{
  Graphical representation for rearranged nucleotide skews in
  prokaryotic chromosomes.}

\usage{draw.rearranged.oriloc(rearr.ori, breaks.gcfw = NA,
 breaks.gcrev = NA, breaks.atfw = NA, breaks.atrev = NA)}

\arguments{

\item{rearr.ori}{A data frame obtained with the \code{rearranged.oriloc}
  function. }

\item{breaks.gcfw}{The coordinates of the breakpoints in the GC-skew,
  for forward transcribed protein coding sequences. These coordinates
  can be obtained with the \code{extract.breakpoints} function. }
\item{breaks.gcrev}{The coordinates of the breakpoints in the GC-skew,
  for reverse transcribed protein coding sequences. These coordinates
  can be obtained with the \code{extract.breakpoints} function. }
\item{breaks.atfw}{The coordinates of the breakpoints in the AT-skew,
  for forward transcribed protein coding sequences. These coordinates
  can be obtained with the \code{extract.breakpoints} function. }
\item{breaks.atrev}{The coordinates of the breakpoints in the AT-skew,
  for reverse transcribed protein coding sequences. These coordinates
  can be obtained with the \code{extract.breakpoints} function. }

}

\references{
  Necşulea, A. and Lobry, J.R. (2007) A New Method for Assessing the 
  Effect of Replication on DNA Base Composition Asymmetry.
  \emph{Molecular Biology and Evolution}, \bold{24}:2169-2179.
}
\author{J.R. Lobry, A. Necşulea}
\seealso{ \code{\link{rearranged.oriloc}},
  \code{\link{extract.breakpoints}}  }

\examples{

\dontrun{
### Example for Chlamydia trachomatis ####

### Rearrange the chromosome and compute the nucleotide skews ###

#r.ori <- rearranged.oriloc(seq.fasta = system.file("sequences/ct.fasta.gz", package = "seqinr"),
#    g2.coord = system.file("sequences/ct.coord", package = "seqinr"))

r.ori <- rearranged.oriloc(seq.fasta = system.file("sequences/ct.fasta.gz", package = "seqinr"),
    g2.coord = system.file("sequences/ct.coord", package = "seqinr"))



### Extract the breakpoints for the rearranged nucleotide skews ###

breaks <- extract.breakpoints(r.ori, type = c("gcfw", "gcrev"),
 nbreaks = c(2, 2), gridsize = 50, it.max = 100)

### Draw the rearranged nucleotide skews and  ###
### place the position of the breakpoints on the graphics ###

draw.rearranged.oriloc(r.ori, breaks.gcfw = breaks$gcfw$breaks,
 breaks.gcrev = breaks$gcrev$breaks)}
}

\name{ECH}
\alias{ECH}
\docType{data}
\title{Forensic Genetic Profile Allelic Ladder Raw Data}
\description{
  This is an example of allelic ladder raw data for a human STR genetic profile at 16 loci
  (\emph{viz.} D8S1179, D21S11, D7S820, CSF1PO, D3S1358, TH01, D13S317, D16S539,
  D2S1338, D19S433, vWA, TPOX, D18S51, Amelogenin, D5S818, FGA) which
  are commonly used in forensic sciences for individual identifications.
}
\usage{data(ECH)}
\format{
  A list with 3 components as in \code{\link{JLO}}
}
\source{
  Data were kindly provided by the INPS (Institut National de Police Scientifique)
  which is the national forensic sciences institute in France. Experiments
  were done at the LPS (Laboratoire de Police Scientifique de Lyon) in 2008.
}
\references{
  \code{citation("seqinr")}

  Anonymous (2006) Applied Biosystem Genetic Analysis Data File Format.
  Available at \url{https://www.thermofisher.com/de/de/home/brands/applied-biosystems.html}.
  Last visited on 03-NOV-2008.
}
\author{J.R. Lobry}
\seealso{
  function \code{\link{read.abif}} to import files in ABIF format,
  data \code{\link{gs500liz}} for internal size standards,
  data \code{\link{identifiler}} for allele names in the allelic ladder,
  data \code{\link{JLO}} for an example of an individual sample file.
}
\examples{
data(JLO)
}

\name{crelistfromclientdata}
\alias{crelistfromclientdata}
\alias{clfcd}
\title{To create on server an ACNUC list from data lines sent by client}
\description{
This function is usefull if you have a local file with sequence names
(sequence ID), or sequence accession numbers, or species names, or
keywords. This allows you to create on the server a list with the
corresponding items.
}
\usage{
crelistfromclientdata(listname, file, type,
 socket = autosocket(), invisible = TRUE,
 verbose = FALSE, virtual = FALSE)
clfcd(listname, file, type, socket = autosocket(),
 invisible = TRUE, verbose = FALSE, virtual = FALSE)
}

\arguments{
  \item{listname}{The name of the list as a quoted string of chars}
  \item{file}{The local file name}
  \item{type}{Could be one of "SQ", "AC", "SP", "KW", see examples}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{invisible}{if \code{FALSE}, the result is returned visibly.}
  \item{verbose}{if \code{TRUE}, verbose mode is on}
  \item{virtual}{if \code{TRUE}, no attempt is made to retrieve the information about
    all the elements of the list. In this case, the \code{req} component of the list is set to 
    \code{NA}.}
}
\details{
\code{clfcd} is a shortcut for \code{crelistfromclientdata}.
}

\value{
The result is directly assigned to the object \code{listname} in the user workspace.
This is an objet of class \code{qaw}, a list with the following 6 components:

  \item{call}{the original call}
  \item{name}{the ACNUC list name}
  \item{nelem}{the number of elements (for instance sequences) in the ACNUC list}
  \item{typelist}{the type of the elements of the list. Could be SQ for a list of
    sequence names, KW for a list of keywords, SP for a list of species names.}
  \item{req}{a list of sequence names that fit the required criteria or \code{NA} when
    called with parameter \code{virtual} is \code{TRUE}}
  \item{socket}{the socket connection that was used}
}
\references{ 

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  \code{\link{choosebank}}, 
  \code{\link{query}}, \code{\link{savelist}} for the reverse operation with
an ACNUC list of sequences.
}

\examples{
 \dontrun{ # Need internet connection
 choosebank("emblTP")
 #
 # Example with a file that contains sequence names:
 #
 fileSQ <- system.file("sequences/bb.mne", package = "seqinr")
 listSQ <- crelistfromclientdata("listSQ", file = fileSQ, type = "SQ")
 sapply(listSQ$req, getName)
 #
 # Example with a file that contains sequence accession numbers:
 #
 fileAC <- system.file("sequences/bb.acc", package = "seqinr")
 listAC <- crelistfromclientdata("listAC", file = fileAC, type = "AC")
 sapply(listAC$req, getName) 
 #
 # Example with a file that contains species names:
 #
 fileSP <- system.file("sequences/bb.sp", package = "seqinr")
 listSP <- crelistfromclientdata("listSP", file = fileSP, type = "SP")
 sapply(listSP$req, getName) 
 #
 # Example with a file that contains keywords:
 #
 fileKW <- system.file("sequences/bb.kwd", package = "seqinr")
 listKW <- crelistfromclientdata("listKW", file = fileKW, type = "KW")
 sapply(listKW$req, getName)
 #
 # Summary of ACNUC lists:
 #
 sapply(alr()$rank, getliststate)
 closebank() 
 }
}
\keyword{utilities}

\name{dia.bactgensize}
\alias{dia.bactgensize}
\title{ Distribution of bacterial genome size from GOLD }
\description{
This function tries to download the last update of the GOLD
(Genomes OnLine Database) to extract bacterial genomes sizes
when available. The histogram and the default density()
output is produced. Optionally, a maximum likelihood estimate
of a superposition of two or three normal distributions is
also represented.
}
\usage{
dia.bactgensize(fit = 2, p = 0.5, m1 = 2000, sd1 = 600, m2 = 4500,
       sd2 = 1000, p3 = 0.05, m3 = 9000, sd3 = 1000, maxgensize = 20000,
       source = c("https://pbil.univ-lyon1.fr/datasets/seqinr/data/goldtable15Dec07.txt"))
}
\arguments{
  \item{fit}{ integer value. If \code{fit == O} no normal fit
is produced, if \code{fit == 2} try to fit a superposition of
two normal distributions, if \code{fit == 3} try to fit a
superposition of three normal distributions.
             }
  \item{p}{ initial guess for the proportion of the first population. }
  \item{m1}{ initial guess for the mean of the first population. }
  \item{sd1}{ initial guess for the standard deviation of the first population. }
  \item{m2}{ initial guess for the mean of the second population. }
  \item{sd2}{initial guess for the standard deviation of the second population. }
  \item{p3}{ initial guess for the proportion of the third population. }
  \item{m3}{ initial guess for the mean of the third population. }
  \item{sd3}{initial guess for the standard deviation of the third population. }
  \item{maxgensize}{maximum admissive value in bp for a bacterial genome size:
     only value less or equal to this threshold are considrered.}
  \item{source}{ the file with raw data. By default a local (outdated) copy is used.}
}
\value{
  An invisible dataframe with three components:

  \item{genus }{genus name}
  \item{species }{species names}
  \item{gs }{genome size in Kb}

}
\references{
Please cite the following references when using data from GOLD:

Kyrpides, N.C. (1999) Genomes OnLine Database (GOLD 1.0): a monitor
of complete and ongoing genome projects world-wide.
\emph{Bioinformatics}, \bold{15}:773-774.\cr

Bernal, A., Ear, U., Kyrpides, N. (2001) Genomes OnLine Database (GOLD):
a monitor of genome projects world-wide.
\emph{Nucleic Acids Research}, \bold{29}:126-127.\cr

Liolios, K., Tavernarakis, N., Hugenholtz, P., Kyrpides, N.C. (2006)
The Genomes On Line Database (GOLD) v.2: a monitor of genome
projects worldwide.
\emph{Nucleic Acids Research}, \bold{34}:D332-D334.\cr

Liolios, K., Mavrommatis, K., Tavernarakis, N., Kyrpides, N.C. (2008)
The Genomes On Line Database (GOLD) in 2007: status of genomic
and metagenomic projects and their associated metadata.
\emph{Nucleic Acids Research},
\bold{in press}:D000-D000.\cr

  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{density}} }
\examples{
  \dontrun{# Need internet connection
#
# With a local outdated copy from GOLD:
#
   dia.bactgensize()
#
# With last GOLD data:
#
  # The URL is no more accessible.
  # dia.bactgensize(source = "http://www.genomesonline.org/DBs/goldtable.txt")
  }
}
\keyword{ utilities }

\name{countfreelists}
\alias{countfreelists}
\alias{cfl}
\title{The number of free lists available and annotation lines in an ACNUC server}
\description{
Returns the number of free lists available list of names of annotation lines in the
opened ACNUC database.
}
\usage{
countfreelists(socket = autosocket())
cfl(socket = autosocket())
}
\arguments{
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}

\value{
a list with the following 2 components:

  \item{free}{numeric. The number of free lists}
  \item{annotlines}{vector of strings. Names of annotation lines}
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}} }
\examples{
\dontrun{ # Need internet connection
  choosebank("emblTP")
  (rescountfreelists <- countfreelists())
  stopifnot(all(rescountfreelists$annotlines ==
   c("ALL", "AC",  "PR",  "DT",  "KW",  "OS",  "OC",
   "OG",  "RN",  "RC",  "RP",  "RX", "RG",  "RA",  "RT",  "RL",  "DR",
   "CC",  "AH",  "AS",  "FH",  "FT",  "CO",  "SQ", "SEQ")))
  closebank()
  }
}
\keyword{ utilities }

\name{getTrans}
\alias{getTrans}
\alias{getTrans.default}
\alias{getTrans.list}
\alias{getTrans.character}
\alias{getTrans.SeqFrag}
\alias{getTrans.SeqAcnucWeb}
\alias{getTrans.SeqFastadna}
\alias{getTrans.qaw}
\alias{getTrans.logical}

\title{Generic function to translate coding sequences into proteins}
\description{
This function translates nucleic acid sequences into the corresponding peptide sequence. It can translate in any of the 3 forward or three reverse sense frames. In the case of reverse sense, the reverse-complement of the sequence is taken. It can translate using the standard (universal) genetic code and also with non-standard codes. Ambiguous bases can also be handled.
}
\usage{
getTrans(object, sens = "F", NAstring = "X", ambiguous = FALSE, 
         force.first.aa.to.Met = FALSE, ...)
\method{getTrans}{SeqAcnucWeb}(object, sens = "F", NAstring = "X", ambiguous = FALSE, 
 force.first.aa.to.Met = FALSE, ..., frame = "auto", numcode = "auto")
\method{getTrans}{SeqFastadna}(object, sens = "F", NAstring = "X", ambiguous = FALSE,
 force.first.aa.to.Met = FALSE, ..., frame = 0, numcode = 1)
\method{getTrans}{SeqFrag}(object, sens = "F", NAstring = "X", ambiguous = FALSE,
 force.first.aa.to.Met = FALSE, ..., frame = 0, numcode = 1)
}
\arguments{
  \item{object}{ an object of the class \code{\link{SeqAcnucWeb}}
    or \code{\link{SeqFastadna}}, or \code{\link{SeqFrag}} or a list of these objects, or an object of class \code{qaw} created by \code{\link{query}} }
  \item{numcode}{ The ncbi genetic code number for translation. By default the standard genetic code is used, and for sequences
    coming from an ACNUC server the relevant genetic code is used by default. }
  \item{NAstring}{ How to translate amino-acids when there are ambiguous bases in codons. }
  \item{ambiguous}{ If TRUE, ambiguous bases are taken into account so that for instance
  GGN is translated to Gly in the standard genetic code. }
  \item{force.first.aa.to.Met}{ If TRUE, the first codon in the sequence will be translated to
  Methionine regardless of the codon in order to treat rare start codons like TTG. }
  \item{frame}{ Frame(s) (0,1,2) to translate. By default the frame \code{0} is used. }
  \item{sens}{ Direction for translation: \code{F} for the direct strand e and \code{R} for the reverse complementary strand. }
  \item{...}{further arguments passed to or from other methods}
}
\details{
 The following genetic codes are described here. The number preceding each code
 corresponds to \code{numcode}.
  \describe{
  \item{1}{ standard }
  \item{2}{ vertebrate.mitochondrial }
  \item{3}{ yeast.mitochondrial }
  \item{4}{ protozoan.mitochondrial+mycoplasma }
  \item{5}{ invertebrate.mitochondrial }
  \item{6}{ ciliate+dasycladaceal }
  \item{9}{ echinoderm+flatworm.mitochondrial }
  \item{10}{ euplotid }
  \item{11}{ bacterial+plantplastid }
  \item{12}{ alternativeyeast }
  \item{13}{ ascidian.mitochondrial }
  \item{14}{ alternativeflatworm.mitochondrial }
  \item{15}{ blepharism }
  \item{16}{ chlorophycean.mitochondrial }
  \item{21}{ trematode.mitochondrial }
  \item{22}{ scenedesmus.mitochondrial }
  \item{23}{ hraustochytrium.mitochondria }
  }
}
\value{
  For a single sequence an object of class \code{character} containing the characters
  of the sequence, either of length 1 when \code{as.string} is TRUE, or of the length
  of the sequence when \code{as.string} is FALSE. For many sequences, a list of these.}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira}
\seealso{
  \code{\link{SeqAcnucWeb}}, \code{\link{SeqFastadna}}, \code{\link{SeqFrag}}\cr
  The genetic codes are given in the object \code{\link{SEQINR.UTIL}}, a more
  human readable form is given by the function \code{\link{tablecode}}.
  Use \code{\link{aaa}} to get the three-letter code for amino-acids.
}
\examples{
#
# List all available methods for getTrans generic function:
#
   methods(getTrans)
#
# Toy CDS example invented by Leonor Palmeira:
#
  toycds <- s2c("tctgagcaaataaatcgg")
  getTrans(toycds) # should be c("S", "E", "Q", "I", "N", "R")
  getTrans(toycds, force.first.aa.to.Met = TRUE) # should be c("M", "E", "Q", "I", "N", "R")
#
# Toy CDS example with ambiguous bases:
#
  toycds2 <- s2c("tcngarcarathaaycgn")
  getTrans(toycds2) # should be c("X", "X", "X", "X", "X", "X")
  getTrans(toycds2, ambiguous = TRUE) # should be c("S", "E", "Q", "I", "N", "R")
  getTrans(toycds2, ambiguous = TRUE, numcode = 2) # should be c("S", "E", "Q", "X", "N", "R")
#
# Real CDS example:
#
  realcds <- read.fasta(file = system.file("sequences/malM.fasta", package ="seqinr"))[[1]]
  getTrans(realcds)
# Biologically correct, only one stop codon at the end
  getTrans(realcds, frame = 3, sens = "R", numcode = 6)
# Biologically meaningless, note the in-frame stop codons

# Read from an alignment as suggested by Dr. H. Suzuki
fasta.res    <- read.alignment(file = system.file("sequences/Anouk.fasta", package = "seqinr"),
 format = "fasta")

AA1 <- seqinr::getTrans(s2c(fasta.res$seq[[1]]))
AA2 <- seqinr::translate(s2c(fasta.res$seq[[1]]))
identical(AA1, AA2)

AA1 <- lapply(fasta.res$seq, function(x) seqinr::getTrans(s2c(x)))
AA2 <- lapply(fasta.res$seq, function(x) seqinr::translate(s2c(x)))
identical(AA1, AA2)

#
# Complex transsplicing operations, the correct frame and the correct
# genetic code are automatically used for translation into protein for
# sequences coming from an ACNUC server:
#
\dontrun{
  # Need internet connection.
  # Translation of the following EMBL entry:
  #
  # FT   CDS             join(complement(153944..154157),complement(153727..153866),
  # FT                   complement(152185..153037),138523..138735,138795..138955)
  # FT                   /codon_start=1
  choosebank("emblTP")
  trans <- query("trans", "N=AE003734.PE35")
  getTrans(trans$req[[1]])
}
}
\keyword{ utilities }

\name{draw.oriloc}
\alias{draw.oriloc}
\title{Graphical representation for nucleotide skews in
  prokaryotic chromosomes.}
\description{
  Graphical representation for nucleotide skews in
  prokaryotic chromosomes.}

\usage{draw.oriloc(ori, main = "Title",
  xlab = "Map position in Kb",
  ylab = "Cumulated combined skew in Kb", las = 1, las.right = 3,
  ta.mtext = "Cumul. T-A skew", ta.col = "pink", ta.lwd = 1,
  cg.mtext = "Cumul. C-G skew", cg.col = "lightblue", cg.lwd = 1,
  cds.mtext = "Cumul. CDS skew", cds.col = "lightgreen", cds.lwd = 1,
  sk.col = "black", sk.lwd = 2,
  add.grid = TRUE, ...)}

\arguments{

\item{ori}{A data frame obtained with the \code{oriloc} function.}
\item{main}{The main title of the plot.}
\item{xlab}{The x-axis title.}
\item{ylab}{The y-axis title.}
\item{las}{The style of axis labels for the bottom and left axes.}
\item{las.right}{The style of axis labels for the right axis.}
\item{ta.mtext}{The marginal legend for the TA skew.}
\item{ta.col}{The color for the TA skew.}
\item{ta.lwd}{The line width for the TA skew.}
\item{cg.mtext}{The marginal legend for the CG skew.}
\item{cg.col}{The color for the CG skew.}
\item{cg.lwd}{The line width for the CG skew.}
\item{cds.mtext}{The marginal legend for the CDS skew.}
\item{cds.col}{The color for the CDS skew.}
\item{cds.lwd}{The line width for the CDS skew.}
\item{sk.col}{The color for the cumulated combined skew.}
\item{sk.lwd}{The line width for the cumulated combined skew.}
\item{add.grid}{Logical, if \code{TRUE} a vertical grid is added to the plot.}
\item{...}{Further arguments are passed to the function \code{plot}.}
}

\references{
\code{citation("seqinr")}
}

\author{J.R. Lobry}

\seealso{ \code{\link{oriloc}}, \code{\link{rearranged.oriloc}},
  \code{\link{extract.breakpoints}}  }

\examples{
\dontrun{ # need internet connection
#
# Example with Chlamydia trachomatis complete genome
#
  ori <- oriloc()
  draw.oriloc(ori)
#
# The same, using more options from function draw.oriloc()
#
draw.oriloc(ori, 
  main = expression(italic(Chlamydia~~trachomatis)~~complete~~genome),
  ta.mtext = "TA skew", ta.col = "red",
  cg.mtext = "CG skew", cg.col = "blue",
  cds.mtext = "CDS skew", cds.col = "seagreen",
  add.grid = FALSE)
}
}

\keyword{hplot}

\name{draw.recstat}
\alias{draw.recstat}
\title{Graphical representation of a recstat analysis.}
\description{This function displays the results returned by \code{recstat} with two plots. The
first one shows the factor scores of a CA computed on the codon composition of a DNA sequence.
The second one shows the locations of all Start and Stop codons in this sequence.}
\usage{draw.recstat(rec, fac = 1, direct  = TRUE, xlim = c(1, seqsize),
    col = c("red", "blue", "purple"))}
\arguments{
    \item{rec}{list of elements returned by \code{recstat} function.}
    \item{fac}{axis of the CA to use for display (4 \eqn{\ge} \code{fac}
    \eqn{\ge} 1).}
    \item{direct}{a logical for the choice of direct or reverse strand.}
    \item{xlim}{starting and ending positions in the sequence for the plot.}
    \item{col}{vector of colour codes for the three frames of the sequence.}
}
\details{The first plot shows the factor scores of the sliding windows, this for the three
possible frames of the strand selected by the user. The second shows the Start (filled grey
triangles pointing up) and Stop (solid black triangles pointing down) codons positions. Note
that the standard genetic code is used for that purpose. Visual detection of putative CDS is
performed through the simultaneous use of these two graphics. If a CDS is located within the
sequence, the factor scores for the windows located in the corresponding reading frame will be
significantly separated from the two others. Moreover, the region where this separation is seen
should be located between a Start and a Stop codon.}
\author{O. Clerc, G. Perrière}
\seealso{\code{\link{test.li.recstat}}, \code{\link{test.co.recstat}}}
\examples{
ff <- system.file("sequences/ECOUNC.fsa", package = "seqinr")
seq <- read.fasta(ff)
rec <- recstat(seq[[1]], seqname = getName(seq))
draw.recstat(rec)
}
\keyword{correspondence analysis}
\keyword{sequence}

\name{pK}
\alias{pK}
\docType{data}
\title{pK values for the side chain of charged amino acids from various sources}
\description{
This compilation of pK values is from Joanna Kiraga (2008).
}
\usage{data(pK)}
\format{
  A data frame with the seven charged amino-acid in row and
  six sources in column. The rownames are the one-letter code
  for amino-acids.
}
\source{
Table 2 in Kiraga (2008).
}
\references{
Kiraga, J. (2008) Analysis and computer simulations of variability of
isoelectric point of proteins in the proteomes. PhD thesis, University
of Wroclaw, Poland.

Bjellqvist, B., Hughes, G.J., Pasquali, Ch., Paquet, N., Ravier, F., Sanchez,  J.Ch.,
Frutige,r S., Hochstrasser D. (1993) The focusing positions of polypeptides in
immobilized pH gradients can be predicted from their amino acid sequences.
\emph{Electrophoresis}, \bold{14}:1023-1031.

EMBOSS data were from release 5.0 and were still the same in release 6.6
\url{https://emboss.sourceforge.net/apps/release/6.6/emboss/apps/iep.html}
last visited 2016-06-03.

Murray, R.K., Granner, D.K., Rodwell, V.W. (2006)
\emph{Harper's illustrated Biochemistry.}
27th edition. Published by The McGraw-Hill Companies.

Sillero, A., Maldonado, A. (2006) Isoelectric point determination of proteins
and other macromolecules: oscillating method.
\emph{Comput Biol Med.}, \bold{36}:157-166.

Solomon, T.W.G. (1998) \emph{Fundamentals of Organic Chemistry}, 5th edition.
Published by Wiley.

Stryer L. (1999) \emph{Biochemia}. czwarta edycja. Wydawnictwo Naukowe PWN.

\code{citation("seqinr")}
}

\examples{
data(pK)
data(SEQINR.UTIL) # for N and C terminal pK values
prot <- s2c("ACDEFGHIKLMNPQRSTVWY")
compoAA <- table(factor(prot, levels = LETTERS))
nTermR <- which(LETTERS == prot[1])
cTermR <- which(LETTERS == prot[length(seq)])

computeCharge <- function(pH, compoAA, pK, nTermResidue, cTermResidue){
  cter <- 10^(-SEQINR.UTIL$pk[cTermResidue,1]) /
     (10^(-SEQINR.UTIL$pk[cTermResidue,1]) + 10^(-pH))
  nter <- 10^(-pH) / (10^(-SEQINR.UTIL$pk[nTermResidue,2]) + 10^(-pH))
  carg <- as.vector(compoAA['R'] * 10^(-pH) / (10^(-pK['R']) + 10^(-pH)))
  chis <- as.vector(compoAA['H'] * 10^(-pH) / (10^(-pK['H']) + 10^(-pH)))
  clys <- as.vector(compoAA['K'] * 10^(-pH) / (10^(-pK['K']) + 10^(-pH)))
  casp <- as.vector(compoAA['D'] * 10^(-pK['D']) /(10^(-pK['D']) + 10^(-pH)))
  cglu <- as.vector(compoAA['E'] * 10^(-pK['E']) / (10^(-pK['E']) + 10^(-pH)))
  ccys <- as.vector(compoAA['C'] * 10^(-pK['C']) / (10^(-pK['C']) + 10^(-pH)))
  ctyr <- as.vector(compoAA['Y'] * 10^(-pK['Y']) / (10^(-pK['Y']) + 10^(-pH)))
  charge <- carg + clys + chis + nter - (casp + cglu + ctyr + ccys + cter)
  return(charge)
}

pHseq <- seq(from = 0, to = 14, by = 0.1)
Bje <- pK$Bjellqvist
names(Bje) <- rownames(pK)
res <- computeCharge(pHseq, compoAA, Bje, nTermR, cTermR)
plot(pHseq, res, type = "l", ylab = "Charge", las = 1,
  main = paste("Charge of protein\n",c2s(prot)),
  xlab = "pH")
for(j in 2:ncol(pK)){
  src <- pK[,j]
  names(src) <- rownames(pK)
  res <- computeCharge(pHseq, compoAA, src, nTermR, cTermR)
  lines(pHseq, res, lty = j, col = rainbow(5)[j])
}

abline(h=0)
abline(v=computePI(prot))
legend("bottomleft", inset = 0.01, colnames(pK), lty = 1:6, col = c("black", rainbow(5)))
}
\keyword{datasets}

\name{AAstat}
\alias{AAstat}
\title{ To Get Some Protein Statistics }
\description{
  Returns simple protein sequence information including the number of residues,
  the percentage physico-chemical classes and the theoretical isoelectric point.
  The functions ignore ambiguous amino acids (e.g. "B", "Z", "X", "J").
}
\usage{
AAstat(seq, plot = TRUE)
}
\arguments{
  \item{seq}{ a protein sequence as a vector of upper-case chars }
  \item{plot}{ if \code{TRUE}, plots the presence of residues splited by
  physico-chemical classes along the sequence. }
}
\value{
  A list with the three following components:
  \item{Compo}{A factor giving the amino acid counts.}
  \item{Prop}{A list giving the percentage of each physico-chemical classes
  (Tiny, Small, Aliphatic, Aromatic, Non-polar, Polar, Charged, Positive, Negative).}
  \item{Pi}{The theoretical isoelectric point}
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{ \code{\link{computePI}}, \code{\link{SEQINR.UTIL}}, \code{\link{SeqFastaAA}}}
\examples{
  seqAA <- read.fasta(file = system.file("sequences/seqAA.fasta", package = "seqinr"),
   seqtype = "AA")
  AAstat(seqAA[[1]])
}
\keyword{utilities}

\name{test.co.recstat}
\alias{test.co.recstat}
\title{Tests if regions located between Stop codons contain putative CDSs.}
\description{This test uses columns (codons) factor scores computed by \code{recstat} in order
to determine if the regions located between two Stop codons correspond to putative CDSs.}
\usage{test.co.recstat(rec, fac = 1, length.min = 150, stop.max = 0.2, win.lim = 0.8,
    direct = TRUE, level = 0.01)}
\arguments{
    \item{rec}{list of elements returned by \code{recstat} function.}
    \item{fac}{axis of the CA to use for test (4 \eqn{\ge} \code{fac}
    \eqn{\ge} 1).}
	\item{length.min}{minimal length between two Stop codons.}
	\item{stop.max}{threshold for Stop codons relative position in a window to determine if this
	    window can be used for test computation.}
	\item{win.lim}{minimum proportion of windows inside a region showing a p-value below the
	    threshold for Kruskal-Wallis test.}
    \item{direct}{a logical for the choice of direct or reverse strand.}
	\item{level}{p-value threshold for Kruskal-Wallis test.}
}
\details{The test is computed for all windows located between two Stop codons separated by at least
\code{length.min} nucleotides. For each window inside a region considered, a Kruskal-Wallis test
is computed on the factor scores of the codons found in this window, this for the three possible
reading frames. If a proportion of at least \code{win.lim} windows in the region reject the null
hypothesis of means equality between the reading frames, then, there is a good probability that
a CDS is located in the region.\cr

Inside the first and the last windows of a region submitted to the test, the relative position of
the two Stop codons is used to determine if those windows can be used in the analysis. If the
first Stop is located within the \code{stop.max} fraction of the 5' end of the window, then this
window is kept in the analysis. In the same way, if the second Stop is located within the
\code{stop.max} fraction of the 3' end of the window, this window is also kept in the analysis.
}
\value{The result is returned as a list containing three matrices (one for each reading frame).
All matrices have the same structure, with rows corresponding to the regions between
two Stop codons. Columns \code{Start} and \code{End} give the location of starting and ending
positions of the region; and \code{CDS} is a binary indicator equal to 1 if a putative CDS is
predicted, and to 0 if not.
}
\author{O. Clerc, G. Perrière}
\seealso{\code{\link{test.li.recstat}}}
\examples{
ff <- system.file("sequences/ECOUNC.fsa", package = "seqinr")
seq <- read.fasta(ff)
rec <- recstat(seq[[1]], seqname = getName(seq))
test.co.recstat(rec)
}
\keyword{sequence}
\keyword{correspondence analysis}

\name{aacost}
\alias{aacost}
\docType{data}
\title{Aerobic cost of amino-acids in Escherichia coli and G+C classes}
\description{
The metabolic cost of amino-acid biosynthesis in \emph{E. coli} under aerobic conditions
from table 1 in Akashi and Gojobori (2002). The G+C classes are from Lobry (1997).
}
\usage{data(aacost)}
\format{
  A data frame with 20 rows for the amino-acids and the following 7 columns:
  \describe{
    \item{aaa}{amino-acid (three-letters code).}
    \item{a}{amino-acid (one-letter code).}
    \item{prec}{precursor metabolites (see details).}
    \item{p}{number of high-energy phosphate bonds contained in ATP and GTP molecules.}
    \item{h}{number of available hydrogen atoms carried in NADH, NADPH,
    and FADH2 molcules.}
    \item{tot}{total metabolic cost assuming 2 high-energy phosphate bonds
    per hydrogen atom.}
    \item{gc}{an ordered factor (l<m<h) for the G+C class of the amino-acid (see details)}
  }
}
\details{Precursor metabolites are: penP, ribose 5-phosphate; PRPP,
5-phosphoribosyl pyrophosphate; eryP, erythrose 4-phosphate; 3pg,
3-phosphoglycerate; pep, phospho\emph{enol}pyruvate; pyr, pyruvate;
acCoA, acetyl-CoA; akg, alpha-ketoglutarate; oaa, oxaloacetate. Negative
signs on precursor metabolites indicate chemicals \emph{gained} through
biosynthetic pathways. Costs of precursors reflect averages for growth on
glucose, acetate, and malate (see Table 6 in the supporting information
from Akashi and Gojobori 2002).\cr

The levels l<m<h for the \code{gc} ordered factor stand for Low G+C, Middle G+C,
High G+C amino-acid, respectively. The frequencies of Low G+C amino-acids
monotonously decrease with G+C content. The frequencies of High G+C amino-
acids monotonously increase with G+C content. The frequencies of Middle G+C
amino-acids first increase and then decrease with G+C content. These G+C classes 
are from Lobry (1997).\cr

\code{example(aacost)} reproduces figure 2 from Lobry (2004).

\if{html}{\figure{aka.pdf}{options: width=400}}
\if{latex}{\figure{aka.pdf}{options: width=12cm}}

}
\source{
Akashi, H, Gojobori, T. (2002) Metabolic efficiency and amino acid composition
in the proteomes of \emph{Escherichia coli} and \emph{Bacillus subtilis}.
\emph{Proceedings of the National Academy of Sciences of the United States of America}, 
\bold{99}:3695-3700.\cr

Lobry, J.R. (1997) Influence of genomic G+C content on average amino-acid composition 
of proteins from 59 bacterial species. \emph{Gene}, \bold{205}:309-316.\cr

Lobry, J.R. (2004) Life history traits and genome structure: aerobiosis and G+C content in bacteria. 
\emph{Lecture Notes in Computer Sciences}, \bold{3039}:679-686.
}
\references{
\code{citation("seqinr")}
}
\examples{
data(aacost)
levels(aacost$gc) <- c("low G+C", "mid G+C", "high G+C")
stripchart(aacost$tot~aacost$gc, pch = 19, ylim = c(0.5,3.5),
     xlim = c(0, max(aacost$tot)),
     xlab = "Metabolic cost (high-energy phosphate bonds equivalent)",
     main = "Metabolic cost of the 20 amino-acids\nas function of their G+C class" )
boxplot(aacost$tot~aacost$gc, horizontal = TRUE, add = TRUE)   
}
\keyword{datasets}

\name{EXP}
\alias{EXP}
\docType{data}
\title{Vectors of coefficients to compute linear forms.}
\description{
This dataset is used to compute linear forms on codon frequencies:
if \code{codfreq} is a vector of codon frequencies then
\code{drop(freq \%*\% EXP$CG3)} will return for instance the G+C content
in third codon positions. Base order is the lexical order: a,
c, g, t (or u).
}
\usage{data(EXP)}
\format{List of 24 vectors of coefficients
\describe{
  \item{A}{num [1:4] 1 0 0 0}
  \item{A3}{num [1:64] 1 0 0 0 1 0 0 0 1 0 ...}
  \item{AGZ}{num [1:64] 0 0 0 0 0 0 0 0 1 0 ...}
  \item{ARG}{num [1:64] 0 0 0 0 0 0 0 0 1 0 ...}
  \item{AU3}{num [1:64] 1 0 0 1 1 0 0 1 1 0 ...}
  \item{BC}{num [1:64] 0 1 0 0 0 0 0 0 0 0 ...}
  \item{C}{num [1:4] 0 1 0 0}
  \item{C3}{num [1:64] 0 1 0 0 0 1 0 0 0 1 ...}
  \item{CAI}{num [1:64]  0.00  0.00 -1.37 -2.98 -2.58 ...}
  \item{CG}{num [1:4] 0 1 1 0}
  \item{CG1}{num [1:64] 0 0 0 0 0 0 0 0 0 0 ...}
  \item{CG12}{num [1:64] 0 0 0 0 0.5 0.5 0.5 0.5 0.5 0.5 ...}
  \item{CG2}{num [1:64] 0 0 0 0 1 1 1 1 1 1 ...}
  \item{CG3}{num [1:64] 0 1 1 0 0 1 1 0 0 1 ...}
  \item{CGN}{num [1:64] 0 0 0 0 0 0 0 0 0 0 ...}
  \item{F1}{num [1:64]  1.026  0.239  1.026  0.239 -0.097 ...}
  \item{G}{num [1:4] 0 0 1 0}
  \item{G3}{num [1:64] 0 0 1 0 0 0 1 0 0 0 ...}
  \item{KD}{num [1:64] -3.9 -3.5 -3.9 -3.5 -0.7 -0.7 -0.7 -0.7 -4.5 -0.8 ...}
  \item{Q}{num [1:64] 0 0 0 0 1 1 1 1 0 0 ...}
  \item{QA3}{num [1:64] 0 0 0 0 1 0 0 0 0 0 ...}
  \item{QC3}{num [1:64] 0 0 0 0 0 1 0 0 0 0 ...}
  \item{U}{num [1:4] 0 0 0 1}
  \item{U3}{num [1:64] 0 0 0 1 0 0 0 1 0 0 ...}
}
}
\details{
It's better to work directly at the amino-acid level
when computing linear forms on amino-acid frequencies so as to have
a single coefficient vector. For instance \code{EXP$KD} to compute the Kyte
and Doolittle hydrophaty index from codon frequencies is valid only
for the standard genetic code.\cr
\cr
An alternative for \code{drop(freq \%*\% EXP$CG3)} is \code{
sum( freq * EXP$CG3 )}, but this is less efficient in terms of CPU
time. The advantage of the latter, however, is that thanks to
recycling rules you can use either \code{sum( freq * EXP$A )}
or \code{sum( freq * EXP$A3 )}. To do the same with the \%*\%
operator you have to explicit the recycling rule as in \code{
drop( freq \%*\% rep(EXP$A, 16))}.
}
\references{
  \code{citation("seqinr")}
  \describe{
  \item{A}{content in A nucleotide}
  \item{A3}{content in A nucleotide in third position of codon}	
  \item{AGZ}{Arg content (aga and agg codons)}
  \item{ARG}{Arg content}
  \item{AU3}{content in A and U nucleotides in third position of codon}
  \item{BC}{Good choice (Bon choix). Gouy M., Gautier C. (1982)
 codon usage in bacteria : Correlation with gene expressivity. \emph{Nucleic Acids Research},\bold{10(22)}:7055-7074.}
  \item{C}{content in C nucleotides}
  \item{C3}{content in A nucleotides in third position of codon}
  \item{CAI}{Codon adaptation index for E. coli. Sharp, P.M., Li, W.-H. (1987) The codon adaptation index -
a measure of directionam synonymous codon usage bias, and its potential
applications. \emph{Nucleic Acids Research},\bold{15}:1281-1295.}
  \item{CG}{content in G + C nucleotides}
  \item{CG1}{content in G + C nucleotides in first position of codon}
  \item{CG12}{content in G + C nucleotides in first and second position of codon}
  \item{CG2}{content in G + C nucleotides in second position of codon}
  \item{CG3}{content in G + C nucleotides in third position of codon}
  \item{CGN}{content in CGA + CGU + CGA + CGG}
  \item{F1}{From Table 2 in Lobry, J.R., Gautier, C. (1994) Hydrophobicity,
expressivity and aromaticity are the major trends of amino-acid usage in
999 \emph{Escherichia coli} chromosome-encode genes. \emph{Nucleic Acids
Research},\bold{22}:3174-3180.}
  \item{G3}{content in G nucleotides in third position of codon}
  \item{KD}{Kyte, J., Doolittle, R.F. (1982) A simple method for displaying
the hydropathic character of a protein. \emph{J. Mol. Biol.},\bold{157}
:105-132.}
  \item{Q}{content in quartet}
  \item{QA3}{content in quartet with the A nucleotide in third position}
  \item{QC3}{content in quartet with the A nucleotide in third position}
  \item{U}{content in U nucleotide}
  \item{U3}{content in U nucleotides in third position of codon}
}
}
\examples{
data(EXP)
}
\keyword{datasets}

\name{move}
\alias{move}
\alias{mv}
\title{Rename an R object}
\description{
Rename object \code{from} into \code{to}.
}
\usage{
move(from, to)
mv(from, to)
}
\arguments{
  \item{from}{an R object name}
  \item{to}{the new R object name}
}
\value{
none.
}
\references{ 
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{swap}} }

\examples{
#
# Example in a new empty environment:
#
local({
  zefplock <- pi
  print(ls())
  print(zefplock)
  mv(zefplock, toto)
  print(ls())
  print(toto)
  stopifnot(identical(toto, pi)) # Sanity check
})
#
# Check that self-affectation is possible:
#
mv(mv, mv) # force self-affectation for the function itself
mv(mv, mv) # OK, function mv() still exists
}

\name{revaligntest}
\alias{revaligntest}
\docType{data}
\title{ Three aligned nucleic acid sequences }
\encoding{latin1}
\description{
This dataset is used as a sanity check in \code{\link{reverse.align}}.
}
\usage{
data(revaligntest)
}
\format{
  An object of class alignment with 3 sequences.
}
\references{
  \code{citation("seqinr")}
}
\seealso{ \code{\link{reverse.align}} }
\examples{
data(revaligntest)
}
\keyword{ datasets }

\name{getName}
\alias{getName}
\alias{getName.default}
\alias{getName.list}
\alias{getName.SeqFrag}
\alias{getName.SeqAcnucWeb}
\alias{getName.SeqFastadna}
\alias{getName.SeqFastaAA}
\alias{getName.qaw}
\alias{getName.logical}

\title{Generic function to get the names of sequences}
\description{
GetName returns the sequence names.
}
\usage{
getName(object, ...)
}
\arguments{
  \item{object}{ an object of the class \code{\link{SeqAcnucWeb}}
    or \code{\link{SeqFastadna}}, or \code{\link{SeqFastaAA}} or \code{\link{SeqFrag}} or a list of these objects }
  \item{...}{further arguments passed to or from other methods}
}
\value{
  an object of class \code{character} containing the names of the sequences}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira} 
\seealso{
  \code{\link{SeqAcnucWeb}}, \code{\link{SeqFastadna}}, 
  \code{\link{SeqFastaAA}}, \code{\link{SeqFrag}}
}
\examples{
#
# List all available methods for getName generic function:
#
   methods(getName)
#
# Example with seven DNA sequences from a FASTA file:
#
  ff <- system.file("sequences/someORF.fsa", package = "seqinr")
  fs <- read.fasta(file = ff)
  stopifnot(all(getName(fs) == c("YAL001C", "YAL002W", "YAL003W",
    "YAL005C", "YAL007C", "YAL008W", "YAL009W")))
#
# Example with 49 sequences from an ACNUC server:
#
  \dontrun{
  # Need internet connection
  choosebank("emblTP")
  fc <- query("fc", "sp=felis catus et t=cds et o=mitochondrion")
  getName(fc)
  closebank()  
}
}
\keyword{ utilities }

\name{splitseq}
\alias{splitseq}
\title{ split a sequence into sub-sequences }
\description{
 Split a sequence into sub-sequences of 3 (the default size) with no overlap between the sub-sequences. 
}
\usage{
splitseq(seq, frame = 0, word = 3)
}
\arguments{
  \item{seq}{ a vector of chars }
  \item{frame}{ an integer (0, 1, 2) giving the starting position to split the sequence }
  \item{word}{ an integer giving the size of the sub-sequences }
}
\value{
  This function returns a vector which contains the sub-sequences.
}
\references{
\code{citation("seqinr")}
\cr
}
\author{J.R. Lobry}
\seealso{ \code{\link{split}} }
\examples{
cds <- s2c("aacgttgcaggtcgctcgctacgtagctactgttt")
#
# To obtain the codon sequence in frame 0:
#
stopifnot(identical(splitseq(cds), 
  c("aac", "gtt", "gca", "ggt", "cgc", "tcg", "cta", "cgt", "agc", "tac", "tgt")))
#
# Show the effect of frame and word with a ten char sequence:
#
(tenchar <- s2c("1234567890"))
splitseq(tenchar, frame = 0)
splitseq(tenchar, frame = 1)
splitseq(tenchar, frame = 2)
splitseq(tenchar, frame = 0, word = 2)
splitseq(tenchar, frame = 0, word = 1)
}
\keyword{ manip }

\name{words}
\alias{words}
\title{ To get all words from an alphabet.}
\description{
Generates a vectors of all the words from a given alphabet,
with right positions varying faster, for instance if the
\code{alphabet} is \code{(c("0","1")} and the \code{length}
is 2 you will obtain \code{c("00", "01", "10", "11")}
}
\usage{
words(length = 3, alphabet = s2c("acgt"))
}
\arguments{
  \item{length}{ the number of characters in the words }
  \item{alphabet}{ a vector of characters }
}
\value{
A vector of string whith \code{length} characters. 
}
\author{J.R. Lobry}
\references{
  \code{citation("seqinr")}
}
\seealso{ \code{\link{kronecker}}, \code{\link{outer}} }
\examples{
#
# Get all 64 codons:
#
stopifnot(all(words() ==
c("aaa", "aac", "aag", "aat", "aca", "acc", "acg", "act", "aga", "agc", "agg", 
   "agt", "ata", "atc", "atg", "att","caa", "cac", "cag", "cat", "cca", "ccc", 
   "ccg", "cct", "cga", "cgc", "cgg", "cgt", "cta", "ctc", "ctg", "ctt", "gaa",
   "gac", "gag", "gat", "gca", "gcc", "gcg", "gct", "gga", "ggc", "ggg", "ggt", 
   "gta", "gtc", "gtg", "gtt", "taa", "tac", "tag", "tat", "tca", "tcc", "tcg", 
   "tct", "tga", "tgc", "tgg", "tgt", "tta", "ttc", "ttg", "ttt")))
#
# Get all codons with u c a g for bases:
#
words(alphabet = s2c("ucag"))
#
# Get all tetranucleotides:
#
words(length = 4)
#
# Get all dipeptides:
#
words(length = 2, alphabet = a()[-1])
}
\keyword{ utilities }

\name{SEQINR.UTIL}
\alias{SEQINR.UTIL}
\docType{data}
\title{utility data for seqinr}
\description{
  This data set gives the genetics code, the name of each codon, the IUPAC one-letter code for amino acids and the physico-chemical class of amino acid and the pK values of amino acids described in Bjellqvist \emph{et al.} (1993).
}
\format{
 	\code{SEQINR.UTIL} is a list containing the 4 following objects:
	\describe{
 	\item{CODES.NCBI}{is a data frame containing the genetics code : The standard ('Universal') genetic code with a selection of non-standard codes. }
 	\item{CODON.AA}{is a three columns data frame. The first column is a factor containing the codon. The second column is a factor giving the aminoacids names for each codon. The last column is a factor giving the IUPAC one-letter code for aminoacids}
 	\item{AA.PROPERTY}{is a list giving the physico-chemical class of amino acid. The differents classes are the following one : Tiny, Small, Aliphatic, Aromatic, Non.polar, Polar, Charged, Basic, Acidic }
	\item{pK}{is a data frame. It gives the pK values of amino acids described in  Bjellqvist \emph{et al.} (1993) , which were defined by examining polypeptide migration between pH 4.5 to 7.3 in an immobilised pH gradient gel environment with 9.2M and 9.8M urea at 15 degree or 25 degree}
  }
}
\source{
Data prepared by D. Charif.\cr The genetic codes have been taken from the ncbi  database: \url{https://www.ncbi.nlm.nih.gov/Taxonomy/Utils/wprintgc.cgi}. Last visited on 2016-10-05 corresponding to last update of the Genetic Codes: April 30, 2013.\cr The IUPAC one-letter code for aminoacids is descibed at: \url{https://www.bioinformatics.org/sms/iupac.html}.
 pK values of amino acids were taken from Bjellqvist et al.\cr
Bjellqvist, B.,Hughes, G.J., Pasquali, Ch., Paquet, N., Ravier, F., Sanchez, J.-Ch., Frutiger, S. & Hochstrasser, D.F.(1993)  The focusing positions of polypeptides in immobilized pH gradients can be predicted from their amino acid sequences.\emph{ Electrophoresis}, \bold{14}, 1023-1031.
}
\references{
  \code{citation("seqinr")}
}
\examples{
data(SEQINR.UTIL)
}

\name{swap}
\alias{swap}
\title{Exchange two R objects}
\description{
Exchange object \code{x} with object \code{y}.
}
\usage{
swap(x, y)
}
\arguments{
  \item{x}{an R object}
  \item{y}{an R object}
}
\value{
none.
}
\references{ 
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{move}} }

\examples{
#
# Example in a new empty environment:
#
local({
  x <- 0:9
  y <- 10:19
  print(x)
  print(y)
  swap(x[1], y[2])
  print(x)
  print(y)
})
#
# Sanity check with a bubble sort:
#
bubble.sort <- function(tab, n = length(tab)){
  i <- 1
  while(i < n){
    if(tab[i + 1] < tab[i]){
      swap(tab[i], tab[i+1])
      i <- 1
    } else {
      i <- i+1
    }
  }
  return(tab)
}
set.seed(1)
x <- rnorm(10)
stopifnot(identical(sort(x), bubble.sort(x)))
}

\name{test.li.recstat}
\alias{test.li.recstat}
\title{Tests if regions located between Stop codons contain putative CDSs.}
\description{This test uses rows (windows) factor scores computed by \code{recstat} in order to
determine if the regions located between two Stop codons correspond to putative CDSs.}
\usage{test.li.recstat(rec, fac = 1, length.min = 150, stop.max = 0.2,
    direct = TRUE, level = 0.05)}
\arguments{
    \item{rec}{list of elements returned by \code{recstat} function.}
    \item{fac}{axis of the CA to use for test (4 \eqn{\ge} \code{fac}
    \eqn{\ge} 1).}
	\item{length.min}{minimal length between two Stop codons.}
	\item{stop.max}{threshold for Stop codons relative position in a window to determine if this
	    window can be used for test computation.}
    \item{direct}{a logical for the choice of direct or reverse strand.}
	\item{level}{p-value threshold for t-test.}
}
\details{The test is computed for all regions between two Stop codons separated by at least
\code{length.min} nucleotides, this for the three possible reading frames of a DNA strand. For
each region considered, two t-tests are computed for comparing the mean of the factor scores of
the windows from the reading frame in which the region is located with the means of the factor
scores from the corresponding windows in the two other reading frames. If both t-tests reject
the null hypothesis of means equality, then there is a good probability that a CDS is located in
the region.\cr

Inside the first and the last windows of a region submitted to the test, the relative position of
the two Stop codons is used to determine if those windows can be used in the analysis. If the
first Stop is located within the \code{stop.max} fraction of the 5' end of the window, then this
window is kept in the analysis. In the same way, if the second Stop is located within the
\code{stop.max} fraction of the 3' end of the window, this window is also kept in the analysis.
}
\value{The result is returned as a list containing three matrices (one for each reading frame).
All matrices have the same structure, with rows corresponding to the regions between two Stop
codons. Columns \code{Start} and \code{End}  give the location of starting and ending positions
of the region; \code{Mean i} gives the mean of the factor scores for the windows located in the
region, this for reading frame \code{i}; \code{t(i,j)} gives the p-value of the t-test computed
between the means from reading frames \code{i} and \code{j}; and \code{CDS} is a binary
indicator equal to 1 if a putative CDS is predicted, and to 0 if not.
}
\author{O. Clerc, G. Perrière}
\seealso{\code{\link{test.co.recstat}}}
\examples{
ff <- system.file("sequences/ECOUNC.fsa", package = "seqinr")
seq <- read.fasta(ff)
rec <- recstat(seq[[1]], seqname = getName(seq))
test.li.recstat(rec)
}
\keyword{sequence}
\keyword{correspondence analysis}

\name{readsmj}
\alias{readsmj}
\title{Low level function to read ACNUC SMJYT index files}
\description{
 Extract informations from the SMJYT index file for status, molecule, journal,
 year, type, organelle, division, and db structure information.
}
\usage{
readsmj(socket = autosocket(), num = 2, nl = 10, recnum.add = FALSE, nature.add = TRUE,
plong.add = FALSE, libel.add = FALSE, sname.add = FALSE, all.add = FALSE)
}
\arguments{
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{num}{rank number of first record.}
  \item{nl}{number of records to read.}
  \item{recnum.add}{to extract record numbers.}
  \item{nature.add}{to extract as a factor with human understandable levels
      the nature of the name. Unordered levels are: status, molecule, journal,
      year, type, organelle, division and dbstrucinfo.}
  \item{plong.add}{to extract the plong.}
  \item{libel.add}{to extract the label of the name.}
  \item{sname.add}{to extract the short version of the name, that is without
                   the first two characters.}
  \item{all.add}{to extract all (all flags set to TRUE).}
}

\value{
  A data.frame with requested columns.
}
\references{
  See ACNUC physical structure at:
  \url{https://doua.prabi.fr/databases/acnuc/structure.html}.\cr

  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{choosebank}} to start a session and
\code{\link{readfirstrec}} to get the total number of records.}
\keyword{utilities}

\name{autosocket}
\alias{autosocket}
\title{Returns a socket to the last opened database}
\description{
This is a low level function that is mainly used to select automatically
the last opened ACNUC database for functions using sockets.
}
\usage{
autosocket()
}

\value{
An object of class sockconn.
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{connections}}.}
\examples{
\dontrun{ #Need internet connection
  choosebank("emblTP")
  autosocket()
  closebank()
  }
}
\keyword{ utilities }

\name{n2s}
\alias{n2s}
\title{ function to convert the numeric encoding of a DNA sequence
into a vector of characters }
\description{
By default, if no `levels' arguments is provided, this function
will just transform your vector of integer into a DNA sequence 
according to the lexical order: \code{0 -> "a"}, \code{1 -> "c"}, \code{ 2 -> "g"},
\code{3 -> "t"}, \code{others -> NA}.
}
\usage{
n2s(nseq, levels = c("a", "c", "g", "t"), base4 = TRUE)
}
\arguments{
  \item{nseq}{A vector of integers }
  \item{levels}{the translation vector }
  \item{base4}{when this logical is true, the numerical encoding of
\code{levels} starts at 0, when it is false the numerical encoding of 
\code{levels} starts at 1.}
}
\value{
a vector of characters
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{s2n}} }
\examples{
##example of the default behaviour:
nseq <- sample(x = 0:3, size = 100, replace = TRUE)
n2s(nseq) 
# Show what happens with out-of-range and NA values:
nseq[1] <- NA
nseq[2] <- 777
n2s(nseq)[1:10]
# How to get an RNA instead:
n2s(nseq, levels = c("a", "c", "g", "u"))
}
\keyword{ utilities }

\name{ec999}
\alias{ec999}
\docType{data}
\title{ 999 coding sequences from E. coli }
\description{
This dataset contains 999 coding sequences from the Escherichia
coli chromosome}
\usage{data(ec999)}
\format{ List of 999 vectors of characters, one for each coding
sequence.
\describe{
 \item{ECFOLE.FOLE    }{chr [1:672] "A" "T" "G" "C" ...}
 \item{ECMSBAG.MSBA   }{chr [1:1749] "A" "T" "G" "C" ...}
 \item{ECNARZYW-C.NARV}{chr [1:681] "A" "T" "G" "A" ...}
 \item{...            }{ ... TRUNCATED ... }
 \item{XYLEECOM.MALK  }{chr [1:1116] "A" "T" "G" "G" ...}
 \item{XYLEECOM.LAMB  }{chr [1:1341] "A" "T" "G" "A" ...}
 \item{XYLEECOM.MALM  }{chr [1:921] "A" "T" "G" "A" ...}
}
}
\references{
Lobry, J.R., Gautier, C. (1994) Hydrophobicity,
expressivity and aromaticity are the major trends of amino-acid usage in
999 \emph{Escherichia coli} chromosome-encode genes. \emph{Nucleic Acids
  Research},\bold{22}:3174-3180.

\code{citation("seqinr")}
}
\examples{
data(ec999)
#
# How to export sequences in a FASTA file:
#
fname <- tempfile(pattern = "ecc999", tmpdir = tempdir(), fileext = "ffn")
tempdir(check = FALSE)
write.fasta(ec999, names(ec999), file = fname)
}
\keyword{datasets}

\name{read.abif}
\alias{read.abif}
\title{Read ABIF formatted files}
\description{
ABIF stands for Applied Biosystem Inc. Format, a binary fromat modeled after TIFF format.
Corresponding files usually have an \code{*.ab1} or \code{*.fsa} extension.
}
\usage{
read.abif(filename, max.bytes.in.file = file.info(filename)$size,
 pied.de.pilote = 1.2, verbose = FALSE)
}
\arguments{
  \item{filename}{The name of the file.}
  \item{max.bytes.in.file}{The size in bytes of the file, defaulting to what is returned by \code{\link{file.info}}}
  \item{pied.de.pilote}{Safety factor: the argument \code{n} to \code{\link{readBin}} is set as \code{pied.de.pilote*max.bytes.in.file}.}
  \item{verbose}{logical [FALSE]. If TRUE verbose mode is on.}
}
\details{
All data are imported into memory, there is no attempt to read items on the fly.
}
\value{
A list with three components: \code{Header} which is a list that contains various low-level information,
among which \code{numelements} is the number of elements in the directory and \code{dataoffset}
the offset to find the location of the directory. \code{Directory} is a data.frame for the directory
of the file with the number of row being the number of elements in the directory and the 7
columns describing various low-level information about the elements. \code{Data} is a list
with the number of components equal to the number of elements in the directory.
}
\references{
\code{citation("seqinR")}

Anonymous (2006) Applied Biosystem Genetic Analysis Data File Format.
Available at \url{https://www.thermofisher.com/de/de/home/brands/applied-biosystems.html}.
Last visited on 03-NOV-2008.

The figure in the example section is an attempt to reproduce figure 1A from:

Krawczyk, J.,  Goesmann, A., Nolte, R., Werber, M., Weisshaar, B. (2009)
Trace2PS and FSA2PS: two software toolkits for converting trace and fsa files to PostScript format.
\emph{Source Code for Biology and Medicine}, \bold{4}:4.

}
\author{J.R. Lobry}

\seealso{
\code{\link{readBin}} which is used here to import the binary file and \code{\link{file.info}} to
get the size of the file. See \code{\link{JLO}} for the files used in quality check.
}

\examples{
#
# Quality check:
#

data(JLO)
JLO.check <- read.abif(system.file("abif/2_FAC321_0000205983_B02_004.fsa",
  package = "seqinr"))
stopifnot(identical(JLO, JLO.check))

#
# Try to reproduce figure 1A from Krawczyk et al. 2009:
#

Krawczyk <- read.abif(system.file("abif/samplefsa2ps.fsa",
  package = "seqinr"))$Data
x <- 1:length(Krawczyk[["DATA.1"]])
par(mar = c(2,4,2,0)+0.1, cex = 0.5)
plot(x, Krawczyk[["DATA.1"]], type = "l", col = "blue",
  ylab = "", xlab = "",
  ylim = c(-2000, 10000), cex = 0.5,
  main = "Figure 1A from Krawczyk et al. 2009",
  xaxs = "i", yaxs = "i",
  xaxt = "n", yaxt = "n")
axis(1, at = seq(2000, 24000, by = 2000))
axis(2, at = seq(-1000, 10000, by = 1000), las = 1)
lines(x, Krawczyk[["DATA.2"]], col = "green")
lines(x, Krawczyk[["DATA.3"]], col = "black")
lines(x, Krawczyk[["DATA.4"]], col = "red")

}

\name{gs500liz}
\alias{gs500liz}
\docType{data}
\title{GS500LIZ size standards}
\description{
GS500LIZ is an internal size standard often used in capillary electrophoresis.
It contains 16 fragments ranging in size from 35 to 500 bp. Note that they are not
all used for calibration : fragments at 250 and 340 bp may migrate anomalously 
(most likey because of secondary structure formation).
}
\usage{data(gs500liz)}
\format{
  A list with 3 components.
  \describe{
    \item{liz}{a vector of 16 values for the fragment sizes in bp.}
    \item{mask1}{a vector of 16 logicals to remove fragments whose
  migration may be anomalous (250 and 340 bp).}
    \item{mask2}{a vector of 16 logicals to remove extreme fragments (35, 50,
  490, 500 bp) so that the resulting fragments are in the 75-450 bp range.}
  }
}

\examples{
data(gs500liz)
op <- par(no.readonly = TRUE)
par(lend = "butt", mar = c(5,0,4,0)+0.1)
x <- gs500liz$liz
n <- length(x)
y <- rep(1, n)
plot(x, y, type = "h", yaxt = "n", xlab = "Fragment size [bp]",
  main = "GS500LIZ size standard", lwd = 2)
x1 <- x[!gs500liz$mask1]
segments(x1, 0, x1, 1, col = "red", lwd = 2)
x2 <- x[!gs500liz$mask2]
segments(x2, 0, x2, 1, col = "blue", lwd = 2)
col <- rep("black", n)
col[!gs500liz$mask1] <- "red"
col[!gs500liz$mask2] <- "blue"
text(x,1.05,paste(x, "bp"), srt = 90, col = col)
legend("top", inset = 0.1, legend = c("regular", "imprecise (mask1)", "extreme (mask2)"),
  lwd = 2, col = c("black","red","blue"))
par(op)
}

\name{getAnnot}
\alias{getAnnot}
\alias{getAnnot.default}
\alias{getAnnot.list}
\alias{getAnnot.SeqAcnucWeb}
\alias{getAnnot.SeqFastadna}
\alias{getAnnot.SeqFastaAA}
\alias{getAnnot.qaw}
\alias{getAnnot.logical}
\alias{readAnnots.socket}

\title{Generic Function to get sequence annotations}
\description{
Annotations are taken from the \code{Annot} attribute for sequences
imported from a FASTA file and retrieved from an ACNUC server for
objects of the \code{SeqAcnucWeb} class.
}
\usage{
getAnnot(object, ...)
\method{getAnnot}{SeqAcnucWeb}(object, ..., nbl = 100, socket = autosocket())
}
\arguments{
  \item{object}{ an object of the class \code{SeqAcnucWeb}
    or \code{SeqFastadna}, or \code{SeqFastaAA} or a list of these objects }
  \item{nbl}{ the maximum number of line of annotation to read. Reading of 
     lines stops when nbl lines have been transmitted or at the last annotation 
     line of the sequence (SQ or ORIGIN line). }
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{...}{further arguments passed to or from other methods}
}
\value{
  \code{getAnnot} returns a vector of string of characters containing the
  annotations for the sequences.
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry, L. Palmeira} 
\seealso{
  \code{\link{query}}, \code{\link{SeqAcnucWeb}}, \code{\link{c2s}}, \code{\link{translate}} and \code{\link{prepgetannots}} to select the annotation lines.
}
\examples{
#
# List all available methods for getAnnot generic function:
#
   methods(getAnnot)
#
# SeqAcnucWeb class example:
#
  \dontrun{
  # Need internet connection
  choosebank("emblTP")
  fc<-query("fc", "sp=felis catus et t=cds et O=mitochondrion et Y>2001 et no k=partial")
  # get the first 5 lines annotating the first sequence:
  annots <- getAnnot(fc$req[[1]], nbl = 5)
  cat(annots, sep = "\n")
  # or use the list method to get them all at once:
  annots <- getAnnot(fc$req, nbl = 5)
  cat(annots, sep = "\n")
  closebank()
  }
#
# SeqFastaAA class example:
#
   aafile <- system.file("sequences/seqAA.fasta", package = "seqinr")
   sfaa <- read.fasta(aafile, seqtype = "AA")
   getAnnot(sfaa[[1]])
#
# SeqFastadna class example:
#
   dnafile <- system.file("sequences/malM.fasta", package = "seqinr")
   sfdna <- read.fasta(file = dnafile)
   getAnnot(sfdna[[1]])
#
# Example with a FASTA file with multiple entries:
#
  ff <- system.file("sequences/someORF.fsa", package = "seqinr")
  fs <- read.fasta(ff)
  getAnnot(fs) # the list method is used here to get them all at once
#
# Default getAnnot method example. An error is produced because 
# there are no annotations by default:
#
   result <- try(getAnnot(letters))
   stopifnot(!inherits("result", "try-error"))
}
\keyword{ utilities }

\name{closebank}
\alias{closebank}
\title{ To close a remote ACNUC database }
\description{
 This function tries to close a remote ACNUC database.
}
\usage{
closebank(socket = autosocket(), verbose = FALSE)
}
\arguments{
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{verbose}{ Logical. If TRUE, verbose mode is on }
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry }

\seealso{ \code{\link{choosebank}}}
\examples{
  \dontrun{# Need internet connection
   choosebank("emblTP")
   closebank()
  }
}
\keyword{ manip }

\name{gb2fasta}
\alias{gb2fasta}
\title{Conversion of GenBank file into fasta file}
\description{
Converts a single entry in GenBank format into a fasta file.
}
\usage{
gb2fasta(source.file, destination.file)
}
\arguments{
  \item{source.file}{ GenBank file }
  \item{destination.file}{ Fasta file }
}
\details{
Multiple entries in GenBank file are not supported.
}
\value{
  none
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{oriloc}} }
\examples{
  myGenBankFile <- system.file("sequences/ct.gbk.gz", package = "seqinr")
  #myFastaFileName <- "Acinetobacter_ADP1_uid61597.fasta"
  myFastaFileName <-tempfile(pattern = "Acinetobacter_ADP1_uid61597", 
   tmpdir = tempdir(), fileext = "fasta")
  tempdir(check = FALSE)
  gb2fasta(myGenBankFile, myFastaFileName)
  readLines(myFastaFileName)[1:5]
  #
  # Should be :
  #
  # [1] ">CHLTCG 1042519 bp"                                          
  # [2] "gcggccgcccgggaaattgctaaaagatgggagcaaagagttagagatctacaagataaa"
  # [3] "ggtgctgcacgaaaattattaaatgatcctttaggccgacgaacacctaattatcagagc"
  # [4] "aaaaatccaggtgagtatactgtagggaattccatgttttacgatggtcctcaggtagcg"
  # [5] "aatctccagaacgtcgacactggtttttggctggacatgagcaatctctcagacgttgta"
  #
}
\keyword{utilities}

\name{baselineabif}
\Rdversion{1.1}
\alias{baselineabif}
\title{Estimation of baseline value}
\description{
This function tries to estimate the baseline value for RFU data from
capillary electrophoresis whith the heuristic that the most common
value is the baseline.
}
\usage{
baselineabif(rfu, maxrfu = 1000)
}
\arguments{
  \item{rfu}{a numeric vector of signal value}
  \item{maxrfu}{signal values greater or equal to maxrfu are forced to NA}
}
\value{A single numeric value for the estimated baseline.}

\author{J.R. Lobry}

\seealso{
\code{\link{JLO}} for a dataset example, \code{\link{plotabif}} to plot this kind of data, 
\code{\link{peakabif}} to estimate peak parameters.
}

\examples{
data(JLO)
rfu <- JLO$Data$DATA.1
bl <- baselineabif(rfu)
plot(1:length(rfu), rfu, type = "l", 
  xlab = "Time [datapoint units]",
  ylab = "Signal [RFU]",
  main = "Example of baseline estimates")
abline(h = bl, col="red", lty = 2)
legend("topright", inset = 0.02, "Baseline estimate", lty = 2, col = "red")
}

\name{gbk2g2}
\alias{gbk2g2}
\title{ Conversion of a GenBank format file into a glimmer-like one }
\description{
This function reads a file in GenBank format and converts the features
corresponding to CDS (Coding Sequences) into a format similar to
glimmer program output.
}
\usage{
gbk2g2(gbkfile =  "https://pbil.univ-lyon1.fr/datasets/seqinr/data/ct.gbk",
g2.coord = "g2.coord")
}

\arguments{
  \item{gbkfile}{ The name of the GenBank file }
  \item{g2.coord}{ The name of the output file in glimmer-like format }
}
\details{
Partial CDS (either 5' or 3') and join in features are discarded.
}
\value{
The input file is returned invisibly.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{oriloc}} which uses glimmer-like files,
  \code{\link{gbk2g2.euk}} for eukaryotic sequences with introns.}
\examples{
  \dontrun{ # need internet connection
  	suppressWarnings(gbk2g2(g2.coord = "gbk2g2.test"))
  	res <- read.table("gbk2g2.test")
  	head(res)
  	stopifnot(nrow(res) == 892)
  }
}
\keyword{utilities}

\name{bma}
\alias{bma}
\title{Computing an IUPAC nucleotide symbol}
\description{
  This function returns the IUPAC symbol for a nucleotide sequence, for instance
 \code{c("c", "c", "g")} is coded by \code{"s"}.
}
\usage{
bma(nucl, warn.non.IUPAC = TRUE, type = c("DNA", "RNA"))
}
\arguments{
  \item{nucl}{a nucleotide sequence as a vector of single chars}
  \item{warn.non.IUPAC}{if TRUE warns when no IUPAC symbol is possible}
  \item{type}{whether this is a DNA or a RNA sequence}
}
\details{
  The sequence is forced in lower case letters and ambiguous bases
  are expanded before trying to find an IUPAC symbol.
}
\value{
  A single IUPAC symbol in lower case, or NA when this is not possible.
}
\references{ 

The nomenclature for incompletely specified bases in nucleic acid sequences
at: \url{https://pmc.ncbi.nlm.nih.gov/articles/PMC341218/}

\code{citation("seqinr")}
}
\author{J.R. Lobry}

\seealso{See \code{\link{amb}} for the reverse operation. 
Use \code{\link{toupper}} to change lower case letters into
upper case letters.}

\examples{

stopifnot(bma(s2c("atatattttata")) == "w")
stopifnot(bma(s2c("gcggcgcgcggc")) == "s")
stopifnot(bma(s2c("ACGT")) == "n")
stopifnot(is.na(bma(s2c("atatttt---tatat")))) # a warning is issued
}

\name{kaks}
\alias{kaks}
\title{Ka and Ks, also known as dn and ds, computation}
\description{ Ks and Ka  are, respectively, the number of substitutions per synonymous site and per non-synonymous site between two protein-coding genes. They are also denoted as ds and dn in the literature. The ratio of nonsynonymous (Ka) to synonymous (Ks) nucleotide substitution rates is an indicator of selective pressures on genes. A ratio significantly greater than 1 indicates positive selective pressure. A ratio around 1 indicates either neutral evolution at the protein level or an averaging of sites under positive and negative selective pressures. A ratio less than 1 indicates pressures to conserve protein sequence (\emph{i.e.} purifying selection). This function estimates the Ka and Ks values for a set of aligned sequences using the method published by Li (1993) and gives the associated variance matrix. 
}
\usage{
kaks(x, verbose = FALSE, debug = FALSE, forceUpperCase = TRUE, rmgap = TRUE)
}
\arguments{
  \item{x}{ An object of class \code{alignment}, obtained for instance by importing into R the data from an alignment file with the \code{\link{read.alignment}} function. This is typically a set of coding sequences aligned at the protein level, see \code{\link{reverse.align}}.}
  \item{verbose}{ If TRUE add to the results  the value of L0, L2, L4 (respectively the frequency of non-synonymous sites, of 2-fold synonymous sites, of 4-fold synonymous sites), A0, A2, A4 (respectively the number of transitional changes at non-synonymous, 2-fold, and 4-fold synonymous sites ) and B0, B2, B4 (respectively the number of transversional changes at non-synonymous, 2-fold, and 4-fold synonymous sites).}
  \item{debug}{ If TRUE turns debug mode on.}
  \item{forceUpperCase}{ If TRUE, the default value, all character in sequences are forced to the upper case
  if at least one 'a', 'c', 'g', or 't' is found in the sequences. 
  Turning it to FALSE if the sequences are already in upper case will save time.}
  \item{rmgap}{ If TRUE all positions with at least one gap are removed. If FALSE only positions with nothing else than gaps are removed.}
}
\value{
  \item{ ks }{ matrix of Ks values }
  \item{ ka }{ matrix of Ka values }
  \item{ vks }{ variance matrix of Ks }
  \item{ vka }{ variance matrix of Ka }	
}
\references{
Li, W.-H., Wu, C.-I., Luo, C.-C. (1985) A new method for estimating synonymous and nonsynonymous rates of nucleotide substitution considering the relative likelihood of nucleotide and codon changes. \emph{Mol. Biol. Evol}, \bold{2}:150-174\cr

Li, W.-H. (1993) Unbiased estimation of the rates of synonymous and nonsynonymous substitution. \emph{J. Mol. Evol.}, \bold{36}:96-99.\cr 

Pamilo, P., Bianchi, N.O. (1993) Evolution of the \emph{Zfx} and \emph{Zfy} genes: Rates and interdependence between genes. \emph{Mol. Biol. Evol}, \bold{10}:271-281\cr

Hurst, L.D. (2002) The Ka/Ks ratio: diagnosing the form of sequence evolution.
\emph{Trends Genet.}, \bold{18}:486-486.\cr  

The C programm implementing this method was provided by Manolo Gouy. More info is
needed here to trace back the original C source so as to credit correct source.
The original FORTRAN-77 code by Chung-I Wu modified by Ken Wolfe was available
here \url{http://wolfe.gen.tcd.ie/lab/pub/li93/} but this is no more true as 2017-07-01.\cr

For a more recent discussion about the estimation of Ka and Ks see:\cr

Tzeng, Y.H., Pan, R., Li, W.-H. (2004) Comparison of three methods for estimating 
rates of synonymous and nonsynonymous nucleotide substitutions.
\emph{Mol. Biol. Evol}, \bold{21}:2290-2298.\cr

The method implemented here is noted LWL85 in the above paper.\cr

The cite this package in a publication, as any R package, try something as \code{citation("seqinr")} 
at your R prompt.
}
\note{ 
Computing Ka and Ks makes sense for coding sequences that have been aligned at the amino-acid level before retro-translating the alignement at the nucleic acid level to ensure that sequences are compared on a codon-by-codon basis. Function \code{\link{reverse.align}} may help for this.

As from seqinR 2.0-3, when there is at least one non ACGT base in a codon, this codon is considered as a gap-codon (\code{---}). This makes the computation more robust with respect to alignments with out-of-frame gaps, see example section.

Gap-codons (\code{---}) are not used for computations. 

When the alignment does not contain enough information (\emph{i.e.} close to saturation), the Ka and Ks values are forced to 10 (more exactly to 9.999999).

Negative values indicate that Ka and Ks can not be computed.

According to Li (1993) and Pamilo and Bianchi (1993),
the rate of synonymous substitutions Ks is computed as:
Ks = (L2.A2 + L4.A4) / (L2 + L4)  +  B4

and the rate of non-synonymous substitutions Ka is computed as:
Ka =  A0 + (L0.B0 + L2.B2) / (L0 + L2) 

}
\author{D. Charif, J.R. Lobry}
\seealso{\code{\link{read.alignment}} to import alignments from files, \code{\link{reverse.align}} to align CDS at the aa level,
\code{\link{kaksTorture}} for test on one-codon CDS.}
\examples{
 #
 # Simple Toy example:
 #
 s <- read.alignment(file = system.file("sequences/test.phylip", package = "seqinr"),
  format = "phylip")
 kaks(s)
 #
 # Check numeric results on an simple test example:
 #
 data(AnoukResult)
 Anouk <- read.alignment(file = system.file("sequences/Anouk.fasta", package = "seqinr"),
  format = "fasta")	
 if( ! all.equal(kaks(Anouk), AnoukResult) ) {
   warning("Poor numeric results with respect to AnoukResult standard")
 } else {
   print("Results are consistent with AnoukResult standard")
 }
#
# As from seqinR 2.0-3 the following alignment with out-of-frame gaps
# should return a zero Ka value.
#
# >Reference
# ATGTGGTCGAGATATCGAAAGCTAGGGATATCGATTATATATAGCAAGATCGATAGAGGA
# TCGATGATCGATCGGGATCGACAGCTG
# >With out-of-frame gaps
# AT-TGGTCCAGGTATCGTAAGCTAGGGATATCGATTATATATAGCAAGATCGATAGGGGA
# TCGATGATCGATCGGGA--GACAGCTG
#
# This test example provided by Darren Obbard is now used as a routine check: 
#
 Darren <- read.alignment(file = system.file("sequences/DarrenObbard.fasta", package = "seqinr"),
  format = "fasta")
 stopifnot( all.equal(kaks(Darren)$ka[1], 0) )
#
# As from seqinR 3.4-0, non-finite values should never be returned for
# Ka and Ks even for small sequences. The following test checks that this
# is true for an alignement of the 64 codons, so that we compute Ka and
# Ks for all possible pairs of codons.
#
wrd <- as.alignment(nb = 64, nam = words(), seq = words())
res <- kaks(wrd)
if(any(!is.finite(res$ka))) stop("Non finite value returned for Ka")
if(any(!is.finite(res$ks))) stop("Non finite value returned for Ks")

}

\name{gbk2g2.euk}
\alias{gbk2g2.euk}
\title{ Conversion of a GenBank format file into a glimmer-like
  one. Eukaryotic version.}
\description{
This function reads a file in GenBank format and converts the features
corresponding to CDS (Coding Sequences) into a format similar to
glimmer program output. This function is specifically made for
eukaryotic sequences, i.e. with introns. 
}
\usage{
gbk2g2.euk(gbkfile = system.file("sequences/ame1.gbk", package ="seqinr"),
g2.coord = "g2.coord")
}

\arguments{
  \item{gbkfile}{ The name of the GenBank file }
  \item{g2.coord}{ The name of the output file }
}
\details{
This function returns the coordinates of the exons annotated in the
GenBank format file. 
}
\value{
A data frame with three columns will be written to the \code{g2.coord}
file. The first column corresponds to the name of the gene, given in the
GenBank file through the \code{/gene} feature. The second and third
column contain the start and the stop position of the exon.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry, A. Necşulea}
\seealso{ \code{\link{oriloc}}, \code{\link{gbk2g2}} }
\examples{
 \dontrun{ gbk2g2.euk() }
}
\keyword{utilities}

\name{circle}
\alias{circle}
\title{Draws a circle}
\description{Draws a circle or an arc-circle on the current graphic device}
\usage{
circle(x = 0, y = 0, r = 1, theta = c(0, 360), n = 100, ...)
}
\arguments{
  \item{x}{x coordinate for the center of the circle}
  \item{y}{y coordinate for the center of the circle}
  \item{r}{radius of the circle}
  \item{theta}{start and stop angle}
  \item{n}{number of points for polygon object}
  \item{\dots}{arguments passed to \code{\link{polygon}}}
}
\value{none}
\author{J.R. Lobry}

\seealso{\code{\link{polygon}}}
\examples{
par(mfrow = c(2, 2), mar = c(0,0,2,0))
setup <- function(){
  plot.new()
  plot.window(xlim = c(-1,1), ylim = c(-1,1), asp = 1)
}

setup()
circle(col = "lightblue")
title(main = "theta = c(0, 360)")

setup()
circle(col = "lightblue", theta = c(0, 270))
title(main = "theta = c(0, 270)")

setup()
circle(col = "lightblue", theta = c(-90, 180))
title(main = "theta = c(-90, 180)")

setup()
n <- 20
for(i in seq(0, 360, length = n)){
  circle(col = "lightblue", theta = c(i, i+360/(2*n)))
}
title(main = "many thetas")
}

\name{read.fasta}
\alias{read.fasta}
\alias{readfasta}
\alias{FASTA}
\title{ read FASTA formatted files }
\description{
  Read nucleic or amino-acid sequences from a file in FASTA format.
}
\usage{
read.fasta(file = system.file("sequences/ct.fasta.gz", package = "seqinr"), 
  seqtype = c("DNA", "AA"), as.string = FALSE, forceDNAtolower = TRUE,
  set.attributes = TRUE, legacy.mode = TRUE, seqonly = FALSE, strip.desc = FALSE,
  bfa = FALSE, sizeof.longlong = .Machine$sizeof.longlong,
  endian = .Platform$endian, apply.mask = TRUE)
}
\arguments{
  \item{file}{ The name of the file which the sequences in fasta format are to be 
  read from. If it does not contain an absolute or relative path, the file name is relative 
    to the current working directory, \code{\link{getwd}}. The default here is to
    read the \code{ct.fasta.gz} file which is present in the \code{sequences} folder
   of the seqinR package.}
  \item{seqtype}{ the nature of the sequence: \code{DNA} or \code{AA}, defaulting
    to \code{DNA} }
  \item{as.string}{ if TRUE sequences are returned as a string instead of a
  vector of single characters}
  \item{forceDNAtolower}{ whether sequences with \code{seqtype == "DNA"} should be
  returned as lower case letters }
  \item{set.attributes}{ whether sequence attributes should be set}
  \item{legacy.mode}{if TRUE lines starting with a semicolon ';' are ignored}
  \item{seqonly}{if TRUE, only sequences as returned without attempt to modify
    them or to get their names and annotations (execution time is divided approximately
   by a factor 3)}
  \item{strip.desc}{if TRUE the '>' at the beginning of the description lines is removed
  in the annotations of the sequences}
  \item{bfa}{logical. If TRUE the fasta file is in MAQ binary format (see details). 
    Only for DNA sequences.}
  \item{sizeof.longlong}{the number of bytes in a C \code{long long} type.
    Only relevant for \code{bfa = TRUE}. See \code{\link{.Machine}}}
  \item{endian}{character string, \code{"big"} or \code{"little"}, giving the 
    endianness of the processor in use. Only relevant for \code{bfa = TRUE}.
     See \code{\link{.Platform}}}
  \item{apply.mask}{logical defaulting to \code{TRUE}. Only relevant for 
  \code{bfa = TRUE}. When this flag is \code{TRUE} the mask in the MAQ
  binary format is used to replace non acgt characters in the sequence
  by the n character. For pure acgt sequences (without gaps or ambiguous
  bases) turning this to \code{FALSE} will save time.}
}
\details{
  FASTA is a widely used format in biology, some FASTA files are distributed
  with the seqinr package, see the examples section below.
  Sequence in FASTA format begins with a single-line 
  description (distinguished by a greater-than '>' symbol), followed 
  by sequence data on the next lines. Lines starting by a semicolon ';'
  are ignored, as in the original FASTA program (Pearson and Lipman 1988).
  The sequence name is just after the '>' up to the next space ' ' character,
  trailling infos are ignored for the name but saved in the annotations.
  
  There is no standard file extension name for a FASTA file. Commonly
  found values are .fasta, .fas, .fa and .seq for generic FASTA files.
  More specific file extension names are also used for fasta sequence
  alignement (.fsa), fasta nucleic acid (.fna), fasta functional
  nucleotide (.ffn), fasta amino acid (.faa), multiple protein
  fasta (.mpfa), fasta RNA non-coding (.frn).

  The MAQ fasta binary format was introduced in seqinR 1.1-7 and has not
  been extensively tested. This format is used in the MAQ (Mapping and 
  Assembly with Qualities) software (\url{http://maq.sourceforge.net/}).
  In this format the four nucleotides are coded with two bits and the
  sequence is stored as a vector of C \code{unsigned long long}. There
  is in addition a mask to locate non-acgt characters.
}
\note{
The old argument \code{File} that was deprecated since seqinR >= 1.1-3 is
no more valid since seqinR >= 2.0-6. Just use \code{file} instead.
}
\value{
  By default \code{read.fasta} return a list of vector of chars. Each element 
  is a sequence object of the class \code{SeqFastadna} or \code{SeqFastaAA}.
}
\references{

  Pearson, W.R. and Lipman, D.J. (1988) Improved tools for biological 
  sequence comparison. \emph{Proceedings of the National Academy 
  of Sciences of the United States of America}, \bold{85}:2444-2448

  According to MAQ's FAQ page \url{http://maq.sourceforge.net/faq.shtml}
  last consulted 2016-06-07 the MAQ manuscript has not been published.

  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{
  \code{\link{write.fasta}} to write sequences in a FASTA file, 
  \code{\link{gb2fasta}} to convert a GenBank file into a FASTA file,
  \code{\link{read.alignment}} to read aligned sequences,
  \code{\link{reverse.align}} to get an alignment at the nucleic level from the
  one at the amino-acid level }
\examples{
#
# Simple sanity check with a small FASTA file:
#
  smallFastaFile <- system.file("sequences/smallAA.fasta", package = "seqinr")
  mySmallProtein <- read.fasta(file = smallFastaFile, as.string = TRUE, seqtype = "AA")[[1]]
  stopifnot(mySmallProtein == "SEQINRSEQINRSEQINRSEQINR*")
#
# Simple sanity check with the gzipped version of the same small FASTA file:
#
  smallFastaFile <- system.file("sequences/smallAA.fasta.gz", package = "seqinr")
  mySmallProtein <- read.fasta(file = smallFastaFile, as.string = TRUE, seqtype = "AA")[[1]]
  stopifnot(mySmallProtein == "SEQINRSEQINRSEQINRSEQINR*")
#
# Example of a DNA file in FASTA format:
#
  dnafile <- system.file("sequences/malM.fasta", package = "seqinr")
#
# Read with defaults arguments, looks like:
#
# $XYLEECOM.MALM
# [1] "a" "t" "g" "a" "a" "a" "a" "t" "g" "a" "a" "t" "a" "a" "a" "a" "g" "t"
# ...
  read.fasta(file = dnafile)
#
# The same but do not turn the sequence into a vector of single characters, looks like:
#
# $XYLEECOM.MALM
# [1] "atgaaaatgaataaaagtctcatcgtcctctgtttatcagcagggttactggcaagcgc 
# ...
  read.fasta(file = dnafile, as.string = TRUE)
#
# The same but do not force lower case letters, looks like:
#
# $XYLEECOM.MALM
# [1] "ATGAAAATGAATAAAAGTCTCATCGTCCTCTGTTTATCAGCAGGGTTACTGGCAAGC
# ...
  read.fasta(file = dnafile, as.string = TRUE, forceDNAtolower = FALSE)
#
# Example of a protein file in FASTA format:
#
  aafile <- system.file("sequences/seqAA.fasta", package = "seqinr")
#
# Read the protein sequence file, looks like:
#
# $A06852
# [1] "M" "P" "R" "L" "F" "S" "Y" "L" "L" "G" "V" "W" "L" "L" "L" "S" "Q" "L"
# ...
  read.fasta(aafile, seqtype = "AA")
#
# The same, but as string and without attributes, looks like:
#
# $A06852
# [1] "MPRLFSYLLGVWLLLSQLPREIPGQSTNDFIKACGRELVRLWVEICGSVSWGRTALSLEEP
# QLETGPPAETMPSSITKDAEILKMMLEFVPNLPQELKATLSERQPSLRELQQSASKDSNLNFEEFK
# KIILNRQNEAEDKSLLELKNLGLDKHSRKKRLFRMTLSEKCCQVGCIRKDIARLC*"
#
  read.fasta(aafile, seqtype = "AA", as.string = TRUE, set.attributes = FALSE)
#
# Example with a FASTA file that contains comment lines starting with
# a semicolon character ';'
#
  legacyfile <- system.file("sequences/legacy.fasta", package = "seqinr")
  legacyseq <- read.fasta(file = legacyfile, as.string = TRUE)
  stopifnot( nchar(legacyseq) == 921 )
#
# Example of a MAQ binary fasta file produced with maq fasta2bfa ct.fasta ct.bfa
# on a platform where .Platform$endian == "little" and .Machine$sizeof.longlong == 8
#
  fastafile <- system.file("sequences/ct.fasta.gz", package = "seqinr")
  bfafile <- system.file("sequences/ct.bfa", package = "seqinr")

  original <- read.fasta(fastafile, as.string = TRUE, set.att = FALSE)
  bfavers <- read.fasta(bfafile, as.string = TRUE, set.att = FALSE, bfa = TRUE,
    endian = "little", sizeof.longlong = 8)
  if(!identical(original, bfavers)){
     warning(paste("trouble reading bfa file on a platform with endian =", 
     .Platform$endian, "and sizeof.longlong =", .Machine$sizeof.longlong))
  }
}

\name{residuecount}
\alias{residuecount}
\title{Total number of residues in an ACNUC list}
\description{
Computes the total number of residues (nucleotides or aminoacids) in
all sequences of the list of specified rank.
}
\usage{
residuecount(lrank, socket = autosocket())
}
\arguments{
  \item{lrank}{the list rank on the ACNUC server}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}
\value{
A single numeric value corresponding to  the total number of residues or
NA in case of problem.
}

\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}}, \code{\link{glr}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  mylist <- query("mylist", "t=CDS", virtual = TRUE)
  stopifnot(residuecount(glr("mylist")) == 1611439240)
  stopifnot(is.na(residuecount(glr("unknowlist")))) # A warning is issued
  }
}
\keyword{ utilities }

\name{getType}
\alias{getType}
\title{To get available subsequence types in an opened ACNUC database}
\description{
 This function returns all subsequence types (e.g. CDS, TRNA) present 
 in an opened ACNUC database, using default database if no socket is
 provided.
}
\usage{
getType(socket = autosocket())
}
\arguments{
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}
\value{
  a list containing a short description for each subsequence type.
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif, J.R. Lobry}
\seealso{ \code{\link{choosebank}}, \code{\link{query}} }
\examples{
\dontrun{
# Need internet connection
  choosebank("emblTP")
  getType()}
}
\keyword{utilities}

\name{prettyseq}
\alias{prettyseq}
\title{Text representation of a sequence from an ACNUC server}
\description{
To get a text representation of sequence of rank \code{num} and of its subsequences,
with \code{bpl} bases per line (default = 60), and with optional translation of
protein-coding subsequences
}
\usage{
prettyseq(num, bpl = 60, translate = TRUE, socket = autosocket())
}
\arguments{
  \item{num}{rank of the sequence in the ACNUC database}
  \item{bpl}{number of base per line}
  \item{translate}{should coding sequences be translated?}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
}
\value{
An invisible vector of string. The output is redirected to the console.
}
\references{ \url{https://doua.prabi.fr/databases/acnuc.html}

\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{choosebank}}, \code{\link{query}} }
\examples{
\dontrun{
  ### Need internet connection
  choosebank("emblTP")
  prettyseq(111)
  }
}
\keyword{ utilities }

\name{aaa}
\alias{aaa}
\title{Converts amino-acid one-letter code into the three-letter one}
\description{
This is a vectorized function to convert one-letter amino-acid code
into the three-letter one, for instance "A" into "Ala".}
\usage{
aaa(aa)
}
\arguments{
  \item{aa}{ A vector of single characters.}
}
\details{
Allowed character values for \code{aa} are given by \code{a()}.
All other values will generate a warning and return NA.
Called without arguments, \code{aaa()} returns the list of
all possible output values.}
\value{
A vector of char string. All strings are 3 chars long.
}
\references{
The IUPAC one-letter code for aminoacids is described at: 
\url{https://www.bioinformatics.org/sms/iupac.html}
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{\code{\link{a}}, \code{\link{translate}} }
\examples{
  #
  # Show all possible input values:
  #
  
  a()
  
  #
  # Convert them in one letter-code:
  #
  
  aaa(a())
  
  #
  # Check consistency of results:
  #
  
  stopifnot(a(aaa(a())) == a())
  
  #
  # Show what happens with non-allowed values:
  #
  
  aaa("Z") # should be NA and a warning is generated
}
\keyword{ utilities }

\name{stresc}
\alias{stresc}
\title{Utility function to escape LaTeX special characters present in a string}
\description{
 This function returns a vector of strings in which LaTeX special characters are
 escaped, this was useful in conjunction with xtable.
}
\usage{
stresc(strings)
}
\arguments{
  \item{strings}{A vector of strings to deal with.}
}
\value{
  Returns a vector of strings with escaped characters within each string.
}
\references{
  \code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{s2c}} }
\examples{
  stresc("MISC_RNA")
  stresc(c("BB_0001","BB_0002"))
}

\name{permutation}
\alias{permutation}
\title{Sequence permutation according to several different models}
\description{
  Generates a random permutation of a given sequence, according to a
  given model. Available models are : \code{base}, \code{position},
  \code{codon}, \code{syncodon}.
}
\usage{permutation(sequence,modele='base',frame=0,
 replace=FALSE,prot=FALSE,numcode=1,ucoweight = NULL)}
\arguments{
  \item{sequence}{ A nucleic acids sequence }
  \item{modele}{ A string of characters describing the model chosen for
    the random generation }
  \item{frame}{ Only active for the \code{position}, \code{codon},
    \code{syncodon} models: starting position of CDS as in \code{splitseq} }
  \item{replace}{ This option is not active for the \code{syncodon}
    model: if \code{TRUE}, sampling is done with replacement }
  \item{prot}{ Only available for the \code{codon} model: if \code{TRUE}, the first and last codons are preserved, and only intern codons are shuffled }
  \item{numcode}{ Only available for the \code{syncodon} model: the
    genetic code number as in \code{translate}. }
  \item{ucoweight}{ A list of weights containing the desired codon usage
    bias as generated by \code{ucoweight}. If none is specified, the
    codon usage of the given sequence is used. }
}
\value{
  a sequence generated from the original one by a given model
}
\details{
  The \code{base} model allows for random sequence generation by
  shuffling (with/without replacement) of all bases in the sequence.

  The \code{position} model allows for random sequence generation
  by shuffling (with/without replacement) of bases within their
  position in the codon (bases in position I, II or III stay in
  position I, II or III in the new sequence.

  The \code{codon} model allows for random sequence generation by
  shuffling (with/without replacement) of codons.

  The \code{syncodon} model allows for random sequence generation
  by shuffling (with/without replacement) of synonymous codons.
  }
\references{
  \code{citation("seqinr")}
}
\author{L. Palmeira}
\seealso{ \code{\link{synsequence}} }
\examples{
  data(ec999)
  sequence=ec999[1][[1]]

  new=permutation(sequence,modele='base')
  identical(all.equal(count(new,1),count(sequence,1)),TRUE)

  new=permutation(sequence,modele='position')
  identical(all.equal(GC(new),GC(sequence)),TRUE)
  identical(all.equal(GC2(new),GC2(sequence)),TRUE)
  identical(all.equal(GC3(new),GC3(sequence)),TRUE)

  new=permutation(sequence,modele='codon')
  identical(all.equal(uco(new),uco(sequence)),TRUE)

  new=permutation(sequence,modele='syncodon',numcode=1)
  identical(all.equal(translate(new),translate(sequence)),TRUE)
}
\keyword{ utilities }

\name{getlistrank}
\alias{getlistrank}
\alias{glr}
\title{To get the rank of a list from its name}
\description{
This is a low level function to get the rank of a list on server from its name.
}

\usage{
getlistrank(listname, socket = autosocket(), verbose = FALSE)
glr(listname, socket = autosocket(), verbose = FALSE)
}

\arguments{
  \item{listname}{the name of list on server}
  \item{socket}{an object of class \code{sockconn} connecting to a remote ACNUC
                        database (default is a socket to the last opened database).}
  \item{verbose}{if \code{TRUE}, verbose mode is on}
}

\details{
  This low level function is usually not used directly by the user.
}

\value{
  The rank of list named \code{listname} on server, or 0 if no list with this name exists.
}
\references{ 
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{
  \code{\link{choosebank}}, \code{\link{query}}
}

\examples{
 \dontrun{
 # Need internet connection
 choosebank("emblTP")
 MyListName <- query("MyListName", "sp=Borrelia burgdorferi", virtual = TRUE)
 (result <- getlistrank("MyListName"))
 stopifnot(result == 2)
 closebank()
 }
}
\keyword{utilities}

\name{AnoukResult}
\alias{AnoukResult}
\docType{data}
\title{Expected numeric results for Ka and Ks computation}
\description{
This data set is what should be obtained when runing \code{kaks()}
on the test file Anouk.fasta in the sequences directory of the
seqinR package.
}
\usage{data(AnoukResult)}
\format{
  A list with 4 components of class dist.
  \describe{
    \item{ka}{Ka}
    \item{ks}{Ks}
    \item{vka}{variance for Ka}
    \item{vks}{variance for Ks}
  }
}
\details{
See the example in \code{\link{kaks}}.
}
\source{
The fasta test file was provided by Anamaria Necşulea.
}
\references{
\code{citation("seqinr")}
}
\keyword{datasets}

\name{dotchart.uco}
\alias{dotchart.uco}
\title{Cleveland plot for codon usage tables }
\description{
Draw a Cleveland dot plot for codon usage tables
}
\usage{
dotchart.uco(x, numcode = 1, aa3 = TRUE, pt.cex = 0.7, alphabet =
                 s2c("tcag"), pch = 21, gpch = 20, bg = par("bg"), cex
                 = 0.7, color = "black", gcolor = "black", lcolor =
                 grey(0.9), xlim, offset = 0.4, ...)
}
\arguments{
  \item{x}{table of codon usage as computed by \code{uco}. }
  \item{numcode}{the number of the code to be used by \code{translate}.}
  \item{aa3}{logical. If TRUE use the three-letter code for amino-
acids. If FALSE use the one-letter code for amino-acids. }
  \item{pt.cex}{the character size to be used for points. }
  \item{alphabet}{character for codons labels}
  \item{pch}{the plotting character or symbol to be used.}
  \item{gpch}{the plotting character or symbol to be used for group values. }
  \item{bg}{the background color to be used. }
  \item{cex}{the character expansion size passed to \code{\link{dotchart}}. }
  \item{color}{the color(s) to be used for points an labels. }
  \item{gcolor}{the single color to be used for group labels and values.}
  \item{lcolor}{the color(s) to be used for the horizontal lines.}
  \item{xlim}{horizontal range for the plot }
  \item{offset}{offset in inches of ylab and labels; was hardwired to 0.4 before R 4.0.0}
  \item{\dots}{graphical parameters can also be specified as arguments}
}
\value{
An invisible list with components:
\item{x}{table of codon usage}
\item{labels}{codon names}
\item{groups}{amino acid factor}
\item{gdata}{sums by amino acid}
\item{ypg}{the y-axis coordinates for amino acids}
\item{ypi}{the y-axis coordinates for codons}
}
\references{ Cleveland, W. S. (1985) The Elements of Graphing Data.
Monterey, CA: Wadsworth.
\code{citation("seqinr")}
}
\author{J.R. Lobry}
\seealso{ \code{\link{dotchart}}, \code{\link{uco}}, \code{\link{aaa}},
\code{\link{translate}} }
\examples{
# Load dataset:
data(ec999)
# Compute codon usage for all coding sequences:
ec999.uco <- lapply(ec999, uco, index="eff")
# Put it in a dataframe:
df <- as.data.frame(lapply(ec999.uco, as.vector))
# Add codon names:
row.names(df) <- names(ec999.uco[[1]])
# Compute global codon usage:
global <- rowSums(df)
# Choose a title for the graph:
title <- "Codon usage in 999 E. coli coding sequences"
# Plot data:
dotchart.uco(global, main = title)
}
\keyword{hplot}

\name{SeqFrag}
\alias{SeqFrag}
\alias{is.SeqFrag}
\alias{as.SeqFrag}
\title{Class for sub-sequences}
\description{
  \code{as.SeqFrag} is called by all methods of \code{\link{getFrag}}, but not directly by the users. It creates an object sequence of class \code{SeqFrag}. 
}
\usage{
 as.SeqFrag(object, begin, end, name)
 is.SeqFrag(object)
}
\arguments{
  \item{object}{ an object sequence of class \code{seqFastadna}, \code{seqFastaAA}, \code{seqAcnucWeb} or \code{seqFrag} }
  \item{begin}{ the first base of the fragment to get }
  \item{end}{ the last base of the fragment to get }
  \item{name}{ the name of the sequence }
}
\value{
  \code{as.SeqFrag} returns a biological sequence with the following attributes:
  \item{seqMother}{ the name of the sequence from which the sequence comes}
  \item{begin}{ the position of the first base of the fragment on the mother sequence}
  \item{end}{ the position of the last base of the fragment on the mother sequence }
  \item{class}{ \code{SeqFrag} which is the classfor sub-sequence } 
  \code{is.SeqFrag} returns TRUE if the object is of class Seqfrag. 
}
\author{D. Charif, J.R. Lobry}
\references{
  \code{citation("seqinr")}
}
\seealso{\code{\link{getFrag}}, \code{\link{getLength}}, \code{\link{getName}},
  \code{\link{getSequence}}, \code{\link{getTrans}} }
\examples{
 s <- read.fasta(file = system.file("sequences/malM.fasta", package = "seqinr"))
 getFrag(s[[1]], 1, 10) 	
}
\keyword{utilities}

\name{SeqFastaAA}
\alias{SeqFastaAA}
\alias{is.SeqFastaAA}
\alias{as.SeqFastaAA}
\alias{summary.SeqFastaAA}
\title{AA sequence in Fasta Format}
\description{
  \code{as.SeqFastaAA} is called by the function as \code{read.fasta}. It creates an object of class \code{SeqFastaAA}. 
  \code{is.SeqFastaAA} returns TRUE if the object is of class \code{SeqFastaAA}. 
  \code{summary.SeqFastaAA} gives the AA composition of an object of class \code{SeqFastaAA}.
}
\usage{
as.SeqFastaAA(object, name = NULL, Annot = NULL)
is.SeqFastaAA(object)
\method{summary}{SeqFastaAA}(object,...)
}
\arguments{
  \item{object}{ a vector of chars representing a biological sequence }
  \item{name}{ \code{NULL} a character string specifying a name for the sequence } 
  \item{Annot}{ \code{NULL} a character string specifying some annotations for the sequence }	
  \item{...}{ additional arguments affecting the summary produced }
}
\value{
  \code{as.SeqFastaAA} returns an object sequence of class \code{SeqFastaAA}.
  \code{summary.SeqFastaAA} returns a list which the following components:
	\item{composition}{ the AA counting of the sequence} 
	\item{AA.Property}{ the percentage of each group of amino acid in the sequence. By example, the groups are small, tiny, aliphatic, aromatic ... }
}
\references{
  \code{citation("seqinr")}
}
\author{D. Charif}
\examples{
  s <- read.fasta(file = system.file("sequences/seqAA.fasta", package = "seqinr"), seqtype="AA")
  is.SeqFastaAA(s[[1]])
  summary(s[[1]])
  myseq <- s2c("MSPTAYRRGSPAFLV*")
  as.SeqFastaAA(myseq, name = "myseq", Annot = "blablabla")
  myseq
}
\keyword{ utilities }

\name{al2bp}
\alias{al2bp}
\title{To Convert a forensic microsatellite allele name into its length in base pairs}
\description{
Conventions used to name forensic microsatellite alleles (STR) are described
in Bar \emph{et al.} (1994). The name "9.3" means for instance that there are
9 repetitions of the complete base oligomer and an incomplete repeat with 3 bp.
}
\usage{
al2bp(allele.name, repeat.bp = 4, offLadderChars = "><", split = "\\\\.")
}
\arguments{
  \item{allele.name}{The name of the allele, coerced to a string type.}
  \item{repeat.bp}{The length in bp of the microsatellite base repeat, most of them
are tetranucleotides so that it defaults to 4. Do not forget to change this to 5
for loci based on pentanucleotides such as Penta D or Penta E.}	
  \item{offLadderChars}{\code{\link{NA}} is returned when at least one of 
  these characters are found in the allele name. Off ladder alleles are typically
  reported as "<8" or ">19" }
  \item{split}{The convention is to use a dot, as in "9.3", between the number of repeats
and the number of bases in the incomplete repeat. On some locales where the
decimal separator is a comma this could be a source of problem, try to use
"," instead for this argument which is forwarded to \code{\link{strsplit}}.}
}
\value{
A single numeric value corresponding to the size in bp of the allele, or NA
when characters spoting off ladder alleles are encountedred or when numeric
conversion is impossible (\emph{e.g.} with "X" or "Y" allele names at Amelogenin locus).
}
\details{
Warnings generated by faulty numeric conversions are suppressed here.
}
\references{ 
Bar, W. and Brinkmann, B. and Lincoln, P. and Mayr, W.R. and Rossi, U. (1994)
DNA recommendations. 1994 report concerning further recommendations 
of the DNA Commission of the ISFH regarding PCR-based polymorphisms 
in STR (short tandem repeat) systems.
\emph{Int. J. Leg. Med.}, \bold{107}:159-160.

\code{citation("seqinR")}
}
\author{J.R. Lobry}
\seealso{\code{\link{identifiler}} for forensic microsatellite allele name examples.}
\examples{
#
#   Quality check and examples:
#
stopifnot( al2bp("9") == 36 )   # 9 repeats of a tetranucleotide is 36 bp
stopifnot( al2bp(9) == 36 )      # also OK with numerical argument
stopifnot( al2bp(9, 5) == 45 )  # 9 repeats of a pentanucleotide is 45 bp
stopifnot( al2bp("9.3") == 39 ) # microvariant case
stopifnot( is.na(al2bp("<8")) )   # off ladder case 
stopifnot( is.na(al2bp(">19")) ) # off ladder case
stopifnot( is.na(al2bp("X")) )     # non STR case
#
# Application to the alleles names in the identifiler data set where all loci are 
# tetranucleotide repeats:
#
data(identifiler)
al.names <- unlist(identifiler)
al.length <- sapply(al.names, al2bp)
loc.names <- unlist(lapply(identifiler, names))
loc.nall  <-unlist(lapply(identifiler, function(x) lapply(x,length)))
loc.fac <- factor(rep(loc.names, loc.nall))
par(lend = "butt", mar = c(5,6,4,1)+0.1)
boxplot(al.length~loc.fac, las = 1, col = "lightblue",
  horizontal = TRUE, main = "Range of allele lengths at forensic loci",
  xlab = "Length (bp)", ylim = c(0, max(al.length, na.rm = TRUE)))
}

\name{trimSpace}
\alias{trimSpace}
\title{Trim leading and/or trailing spaces in strings}
\description{
  This function removes from a character vector the longest successive run
  of space characters starting at the begining of the strings (leading space),
  or the longest successive run of space characters at the end of the strings
  (trailing space), or both (and this is the default behaviour).
}
\usage{
trimSpace(x, leading = TRUE, trailing = TRUE, space = "[:space:]")
}
\arguments{
  \item{x}{a character vector}
  \item{leading}{logical defaulting to \code{TRUE}: should leading spaces be trimed off?}
  \item{trailing}{logical defaulting to \code{TRUE}: should trailing spaces be trimed off?}
  \item{space}{an extended regular expression defining space characters}
}
\details{
  The default value for the space character definition is large: in addition to the
  usual space, other character such as the tabulation and newline character are
  considered as space characters. See extended regular expression for a complete list.
}
\value{
  a character vector with the same length as x.
}
\references{
  \code{citation("seqinr")}.
}
\seealso{Extended regular expressionsare described in \link{regular expression} 
 (aka \code{\link{regexp}}).
}
\author{J.R. Lobry}
\examples{
  #
  # Simple use:
  #
stopifnot( trimSpace("   seqinR   ") == "seqinR" )

  #
  # Basic use, remove space at both ends:
  #
testspace <- c("   with leading space", "with trailing space   ", "   with both   ")
stopifnot(all( trimSpace(testspace) == c("with leading space", 
                                         "with trailing space", 
					 "with both")))

  #
  # Remove only leading space:
  #
stopifnot(all( trimSpace(testspace, trailing = FALSE) == c("with leading space",
                                                           "with trailing space   ",  
							   "with both   ")))

  #
  # Remove only trailing space:
  #
stopifnot(all( trimSpace(testspace, leading = FALSE) == c("   with leading space", 
                                                          "with trailing space",  
							  "   with both")))

  #
  # This should do nothing:
  #
stopifnot(all( trimSpace(testspace, leading = FALSE, trailing = FALSE) == testspace))

  #
  # How to use alternative space characters:
  #
allspaces <- "\t\n\f\r seqinR \t\n\f\r"
stopifnot(trimSpace(allspaces) == "seqinR")
stopifnot(trimSpace(allspaces, space = "\t\n") == "\f\r seqinR \t\n\f\r")
}
\keyword{manip}
